
(* ::Subsection::Closed:: *)
(* 8.5 Hyperbolic integral functions *)
Int[SinhIntegral[a_. + b_.*x_], x_Symbol] := (a + b*x)*SinhIntegral[a + b*x]/b - Cosh[a + b*x]/b /; FreeQ[{a, b}, x]
Int[CoshIntegral[a_. + b_.*x_], x_Symbol] := (a + b*x)*CoshIntegral[a + b*x]/b - Sinh[a + b*x]/b /; FreeQ[{a, b}, x]
Int[SinhIntegral[b_.*x_]/x_, x_Symbol] := 1/2*b*x*HypergeometricPFQ[{1, 1, 1}, {2, 2, 2}, -b*x] + 1/2*b*x*HypergeometricPFQ[{1, 1, 1}, {2, 2, 2}, b*x] /; FreeQ[b, x]
Int[CoshIntegral[b_.*x_]/x_, x_Symbol] := -1/2*b*x* HypergeometricPFQ[{1, 1, 1}, {2, 2, 2}, -b*x] + 1/2*b*x*HypergeometricPFQ[{1, 1, 1}, {2, 2, 2}, b*x] + EulerGamma*Log[x] + 1/2*Log[b*x]^2 /; FreeQ[b, x]
Int[(c_. + d_.*x_)^m_.*SinhIntegral[a_. + b_.*x_], x_Symbol] := (c + d*x)^(m + 1)* SinhIntegral[a + b*x]/(d*(m + 1)) - b/(d*(m + 1))*Int[(c + d*x)^(m + 1)*Sinh[a + b*x]/(a + b*x), x] /; FreeQ[{a, b, c, d, m}, x] && NeQ[m, -1]
Int[(c_. + d_.*x_)^m_.*CoshIntegral[a_. + b_.*x_], x_Symbol] := (c + d*x)^(m + 1)* CoshIntegral[a + b*x]/(d*(m + 1)) - b/(d*(m + 1))*Int[(c + d*x)^(m + 1)*Cosh[a + b*x]/(a + b*x), x] /; FreeQ[{a, b, c, d, m}, x] && NeQ[m, -1]
Int[SinhIntegral[a_. + b_.*x_]^2, x_Symbol] := (a + b*x)*SinhIntegral[a + b*x]^2/b - 2*Int[Sinh[a + b*x]*SinhIntegral[a + b*x], x] /; FreeQ[{a, b}, x]
Int[CoshIntegral[a_. + b_.*x_]^2, x_Symbol] := (a + b*x)*CoshIntegral[a + b*x]^2/b - 2*Int[Cosh[a + b*x]*CoshIntegral[a + b*x], x] /; FreeQ[{a, b}, x]
Int[x_^m_.*SinhIntegral[b_.*x_]^2, x_Symbol] := x^(m + 1)*SinhIntegral[b*x]^2/(m + 1) - 2/(m + 1)*Int[x^m*Sinh[b*x]*SinhIntegral[b*x], x] /; FreeQ[b, x] && IGtQ[m, 0]
Int[x_^m_.*CoshIntegral[b_.*x_]^2, x_Symbol] := x^(m + 1)*CoshIntegral[b*x]^2/(m + 1) - 2/(m + 1)*Int[x^m*Cosh[b*x]*CoshIntegral[b*x], x] /; FreeQ[b, x] && IGtQ[m, 0]
Int[(c_. + d_.*x_)^m_.*SinhIntegral[a_ + b_.*x_]^2, x_Symbol] := (a + b*x)*(c + d*x)^m* SinhIntegral[a + b*x]^2/(b*(m + 1)) - 2/(m + 1)* Int[(c + d*x)^m*Sinh[a + b*x]*SinhIntegral[a + b*x], x] + (b*c - a*d)*m/(b*(m + 1))* Int[(c + d*x)^(m - 1)*SinhIntegral[a + b*x]^2, x] /; FreeQ[{a, b, c, d}, x] && IGtQ[m, 0]
Int[(c_. + d_.*x_)^m_.*CoshIntegral[a_ + b_.*x_]^2, x_Symbol] := (a + b*x)*(c + d*x)^m* CoshIntegral[a + b*x]^2/(b*(m + 1)) - 2/(m + 1)* Int[(c + d*x)^m*Cosh[a + b*x]*CoshIntegral[a + b*x], x] + (b*c - a*d)*m/(b*(m + 1))* Int[(c + d*x)^(m - 1)*CoshIntegral[a + b*x]^2, x] /; FreeQ[{a, b, c, d}, x] && IGtQ[m, 0]
(* Int[x_^m_.*SinhIntegral[a_+b_.*x_]^2,x_Symbol] :=  b*x^(m+2)*SinhIntegral[a+b*x]^2/(a*(m+1)) + x^(m+1)*SinhIntegral[a+b*x]^2/(m+1) - 2*b/(a*(m+1))*Int[x^(m+1)*Sinh[a+b*x]*SinhIntegral[a+b*x],x] - b*(m+2)/(a*(m+1))*Int[x^(m+1)*SinhIntegral[a+b*x]^2,x] /;  FreeQ[{a,b},x] && ILtQ[m,-2] *)
(* Int[x_^m_.*CoshIntegral[a_+b_.*x_]^2,x_Symbol] :=  b*x^(m+2)*CoshIntegral[a+b*x]^2/(a*(m+1)) + x^(m+1)*CoshIntegral[a+b*x]^2/(m+1) - 2*b/(a*(m+1))*Int[x^(m+1)*Cosh[a+b*x]*CoshIntegral[a+b*x],x] - b*(m+2)/(a*(m+1))*Int[x^(m+1)*CoshIntegral[a+b*x]^2,x] /;  FreeQ[{a,b},x] && ILtQ[m,-2] *)
Int[Sinh[a_. + b_.*x_]*SinhIntegral[c_. + d_.*x_], x_Symbol] := Cosh[a + b*x]*SinhIntegral[c + d*x]/b - d/b*Int[Cosh[a + b*x]*Sinh[c + d*x]/(c + d*x), x] /; FreeQ[{a, b, c, d}, x]
Int[Cosh[a_. + b_.*x_]*CoshIntegral[c_. + d_.*x_], x_Symbol] := Sinh[a + b*x]*CoshIntegral[c + d*x]/b - d/b*Int[Sinh[a + b*x]*Cosh[c + d*x]/(c + d*x), x] /; FreeQ[{a, b, c, d}, x]
Int[(e_. + f_.*x_)^m_.*Sinh[a_. + b_.*x_]*SinhIntegral[c_. + d_.*x_], x_Symbol] := (e + f*x)^m*Cosh[a + b*x]* SinhIntegral[c + d*x]/b - d/b*Int[(e + f*x)^m*Cosh[a + b*x]*Sinh[c + d*x]/(c + d*x), x] - f*m/b* Int[(e + f*x)^(m - 1)*Cosh[a + b*x]*SinhIntegral[c + d*x], x] /; FreeQ[{a, b, c, d, e, f}, x] && IGtQ[m, 0]
Int[(e_. + f_.*x_)^m_.*Cosh[a_. + b_.*x_]*CoshIntegral[c_. + d_.*x_], x_Symbol] := (e + f*x)^m*Sinh[a + b*x]* CoshIntegral[c + d*x]/b - d/b*Int[(e + f*x)^m*Sinh[a + b*x]*Cosh[c + d*x]/(c + d*x), x] - f*m/b* Int[(e + f*x)^(m - 1)*Sinh[a + b*x]*CoshIntegral[c + d*x], x] /; FreeQ[{a, b, c, d, e, f}, x] && IGtQ[m, 0]
Int[(e_. + f_.*x_)^m_*Sinh[a_. + b_.*x_]*SinhIntegral[c_. + d_.*x_], x_Symbol] := (e + f*x)^(m + 1)*Sinh[a + b*x]* SinhIntegral[c + d*x]/(f*(m + 1)) - d/(f*(m + 1))* Int[(e + f*x)^(m + 1)*Sinh[a + b*x]*Sinh[c + d*x]/(c + d*x), x] - b/(f*(m + 1))* Int[(e + f*x)^(m + 1)*Cosh[a + b*x]*SinhIntegral[c + d*x], x] /; FreeQ[{a, b, c, d, e, f}, x] && ILtQ[m, -1]
Int[(e_. + f_.*x_)^m_.*Cosh[a_. + b_.*x_]*CoshIntegral[c_. + d_.*x_], x_Symbol] := (e + f*x)^(m + 1)*Cosh[a + b*x]* CoshIntegral[c + d*x]/(f*(m + 1)) - d/(f*(m + 1))* Int[(e + f*x)^(m + 1)*Cosh[a + b*x]*Cosh[c + d*x]/(c + d*x), x] - b/(f*(m + 1))* Int[(e + f*x)^(m + 1)*Sinh[a + b*x]*CoshIntegral[c + d*x], x] /; FreeQ[{a, b, c, d, e, f}, x] && ILtQ[m, -1]
Int[Cosh[a_. + b_.*x_]*SinhIntegral[c_. + d_.*x_], x_Symbol] := Sinh[a + b*x]*SinhIntegral[c + d*x]/b - d/b*Int[Sinh[a + b*x]*Sinh[c + d*x]/(c + d*x), x] /; FreeQ[{a, b, c, d}, x]
Int[Sinh[a_. + b_.*x_]*CoshIntegral[c_. + d_.*x_], x_Symbol] := Cosh[a + b*x]*CoshIntegral[c + d*x]/b - d/b*Int[Cosh[a + b*x]*Cosh[c + d*x]/(c + d*x), x] /; FreeQ[{a, b, c, d}, x]
Int[(e_. + f_.*x_)^m_.*Cosh[a_. + b_.*x_]*SinhIntegral[c_. + d_.*x_], x_Symbol] := (e + f*x)^m*Sinh[a + b*x]*SinhIntegral[c + d*x]/b - d/b*Int[(e + f*x)^m*Sinh[a + b*x]*Sinh[c + d*x]/(c + d*x), x] - f*m/b* Int[(e + f*x)^(m - 1)*Sinh[a + b*x]*SinhIntegral[c + d*x], x] /; FreeQ[{a, b, c, d, e, f}, x] && IGtQ[m, 0]
Int[(e_. + f_.*x_)^m_.*Sinh[a_. + b_.*x_]*CoshIntegral[c_. + d_.*x_], x_Symbol] := (e + f*x)^m*Cosh[a + b*x]*CoshIntegral[c + d*x]/b - d/b*Int[(e + f*x)^m*Cosh[a + b*x]*Cosh[c + d*x]/(c + d*x), x] - f*m/b* Int[(e + f*x)^(m - 1)*Cosh[a + b*x]*CoshIntegral[c + d*x], x] /; FreeQ[{a, b, c, d, e, f}, x] && IGtQ[m, 0]
Int[(e_. + f_.*x_)^m_.*Cosh[a_. + b_.*x_]*SinhIntegral[c_. + d_.*x_], x_Symbol] := (e + f*x)^(m + 1)*Cosh[a + b*x]* SinhIntegral[c + d*x]/(f*(m + 1)) - d/(f*(m + 1))* Int[(e + f*x)^(m + 1)*Cosh[a + b*x]*Sinh[c + d*x]/(c + d*x), x] - b/(f*(m + 1))* Int[(e + f*x)^(m + 1)*Sinh[a + b*x]*SinhIntegral[c + d*x], x] /; FreeQ[{a, b, c, d, e, f}, x] && ILtQ[m, -1]
Int[(e_. + f_.*x_)^m_*Sinh[a_. + b_.*x_]*CoshIntegral[c_. + d_.*x_], x_Symbol] := (e + f*x)^(m + 1)*Sinh[a + b*x]* CoshIntegral[c + d*x]/(f*(m + 1)) - d/(f*(m + 1))* Int[(e + f*x)^(m + 1)*Sinh[a + b*x]*Cosh[c + d*x]/(c + d*x), x] - b/(f*(m + 1))* Int[(e + f*x)^(m + 1)*Cosh[a + b*x]*CoshIntegral[c + d*x], x] /; FreeQ[{a, b, c, d, e, f}, x] && ILtQ[m, -1]
Int[SinhIntegral[d_.*(a_. + b_.*Log[c_.*x_^n_.])], x_Symbol] := x*SinhIntegral[d*(a + b*Log[c*x^n])] - b*d*n*Int[Sinh[d*(a + b*Log[c*x^n])]/(d*(a + b*Log[c*x^n])), x] /; FreeQ[{a, b, c, d, n}, x]
Int[CoshIntegral[d_.*(a_. + b_.*Log[c_.*x_^n_.])], x_Symbol] := x*CoshIntegral[d*(a + b*Log[c*x^n])] - b*d*n*Int[Cosh[d*(a + b*Log[c*x^n])]/(d*(a + b*Log[c*x^n])), x] /; FreeQ[{a, b, c, d, n}, x]
Int[F_[d_.*(a_. + b_.*Log[c_.*x_^n_.])]/x_, x_Symbol] := 1/n*Subst[F[d*(a + b*x)], x, Log[c*x^n]] /; FreeQ[{a, b, c, d, n}, x] && MemberQ[{SinhIntegral, CoshIntegral}, x]
Int[(e_.*x_)^m_.*SinhIntegral[d_.*(a_. + b_.*Log[c_.*x_^n_.])], x_Symbol] := (e*x)^(m + 1)* SinhIntegral[d*(a + b*Log[c*x^n])]/(e*(m + 1)) - b*d*n/(m + 1)* Int[(e*x)^m*Sinh[d*(a + b*Log[c*x^n])]/(d*(a + b*Log[c*x^n])), x] /; FreeQ[{a, b, c, d, e, m, n}, x] && NeQ[m, -1]
Int[(e_.*x_)^m_.*CoshIntegral[d_.*(a_. + b_.*Log[c_.*x_^n_.])], x_Symbol] := (e*x)^(m + 1)* CoshIntegral[d*(a + b*Log[c*x^n])]/(e*(m + 1)) - b*d*n/(m + 1)* Int[(e*x)^m*Cosh[d*(a + b*Log[c*x^n])]/(d*(a + b*Log[c*x^n])), x] /; FreeQ[{a, b, c, d, e, m, n}, x] && NeQ[m, -1]
