(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   1237610,      25919]
NotebookOptionsPosition[   1215826,      25389]
NotebookOutlinePosition[   1217601,      25443]
CellTagsIndexPosition[   1217558,      25440]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 StyleBox[
  RowBox[{Cell[TextData[StyleBox["Rules for integrands of the form",
    FontFamily->"Arial",
    FontSize->16]], "None"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"a", "+", 
      RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"e", "+", 
      RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], "q"]}],
  FontSize->16], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     StyleBox["when",
      FontFamily->"Arial",
      FontSize->14], 
     StyleBox[" ",
      FontFamily->"Arial",
      FontSize->16], 
     StyleBox["b",
      FontSize->14], 
     StyleBox[" ",
      FontSize->14], 
     StyleBox["c",
      FontSize->14]}], 
    StyleBox["-",
     FontSize->14], 
    StyleBox[
     RowBox[{"a", " ", "d"}],
     FontSize->14]}], 
   StyleBox["\[NotEqual]",
    FontSize->14], 
   StyleBox["0",
    FontSize->14]}], 
  StyleBox[" ",
   FontSize->16], 
  StyleBox["\[And]",
   FontSize->16], 
  StyleBox[" ",
   FontSize->16], 
  StyleBox[
   RowBox[{
    RowBox[{
     RowBox[{"b", " ", "e"}], "-", 
     RowBox[{"a", " ", "f"}]}], "\[NotEqual]", "0"}],
   FontSize->16], 
  StyleBox[" ",
   FontSize->16], 
  StyleBox["\[And]",
   FontSize->16], 
  StyleBox[" ",
   FontSize->16], 
  StyleBox[
   RowBox[{
    RowBox[{
     RowBox[{"b", " ", "g"}], "-", 
     RowBox[{"a", " ", "h"}]}], "\[NotEqual]", "0"}],
   FontSize->16], 
  StyleBox[" ",
   FontSize->16], 
  StyleBox["\[And]",
   FontSize->16], 
  StyleBox[" ",
   FontSize->16], 
  StyleBox[
   RowBox[{
    RowBox[{
     RowBox[{"d", " ", "e"}], "-", 
     RowBox[{"c", " ", "f"}]}], "\[NotEqual]", "0"}],
   FontSize->16], 
  StyleBox[" ",
   FontSize->16], 
  StyleBox["\[And]",
   FontSize->16], 
  StyleBox[" ",
   FontSize->16], 
  StyleBox[
   RowBox[{
    RowBox[{
     RowBox[{"d", " ", "g"}], "-", 
     RowBox[{"c", " ", "h"}]}], "\[NotEqual]", "0"}],
   FontSize->16], 
  StyleBox[" ",
   FontSize->16], 
  StyleBox["\[And]",
   FontSize->16], 
  StyleBox[" ",
   FontSize->16], 
  StyleBox[
   RowBox[{
    RowBox[{
     RowBox[{"f", " ", "g"}], "-", 
     RowBox[{"e", " ", "h"}]}], "\[NotEqual]", "0"}],
   FontSize->16]}]}], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, {3.5233155055329347`*^9, 3.523315506402936*^9}, {
   3.523318726949605*^9, 3.5233187276796064`*^9}, {3.523920400879534*^9, 
   3.5239204094439487`*^9}, 3.52392096260852*^9, 3.523921038171853*^9, 
   3.5340477459008017`*^9, 3.5340515540554085`*^9, {3.536542511100503*^9, 
   3.53654251626051*^9}, {3.536775961244521*^9, 3.5367759616145215`*^9}, {
   3.544373142375139*^9, 3.5443731599851637`*^9}, {3.5721095751430073`*^9, 
   3.5721095751430073`*^9}, {3.57578648209792*^9, 3.575786503859958*^9}, 
   3.575786540270422*^9, {3.5757866379421935`*^9, 3.5757866609522343`*^9}, 
   3.5758298890420465`*^9, 3.5758300610323486`*^9, 3.575830332613226*^9, 
   3.575830509377136*^9, {3.6343218027393775`*^9, 3.6343218080186796`*^9}, {
   3.634684934180332*^9, 3.634684950884288*^9}, 3.6353563928995934`*^9, {
   3.6353568667056932`*^9, 3.6353569109942265`*^9}, 3.650739000214118*^9, {
   3.6507390957005796`*^9, 3.6507391875088305`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{Cell[TextData[StyleBox["1.",
   FontFamily->"Arial"]], "None"], "  ", 
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], 
    RowBox[{"\[DifferentialD]", "x"}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.539393717282713*^9, 3.5393937175197268`*^9}, {3.5393939972431717`*^9, 
   3.5393939972431717`*^9}, {3.54976183300485*^9, 3.549761843369443*^9}, 
   3.5497618783514433`*^9, {3.5498272575323367`*^9, 3.5498272577023373`*^9}, {
   3.5498590820409126`*^9, 3.549859083098973*^9}, {3.549861971973207*^9, 
   3.549861974052326*^9}, {3.5499239781513543`*^9, 3.5499239781513543`*^9}, {
   3.5716376069321833`*^9, 3.5716376095821867`*^9}, 3.571704053418295*^9, {
   3.571705098009757*^9, 3.5717051012397614`*^9}, 3.5717051920898886`*^9, 
   3.5758229151368937`*^9, 3.61151142537963*^9, {3.637958339855831*^9, 
   3.637958342273835*^9}, {3.732992087311748*^9, 3.732992089859894*^9}, {
   3.733334037140961*^9, 3.733334040254139*^9}, {3.7333340772422547`*^9, 
   3.7333340775402718`*^9}, {3.733336855917186*^9, 3.7333368562382045`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{Cell[TextData[StyleBox["1.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.534118429444058*^9, 3.534118443920883*^9}, {3.5341185894379387`*^9, 
   3.5341185897187395`*^9}, {3.534126368193774*^9, 3.534126368483775*^9}, {
   3.5347073427604*^9, 3.5347073430411997`*^9}, {3.535151711347787*^9, 
   3.5351517116277876`*^9}, {3.535151925298087*^9, 3.5351519255180874`*^9}, {
   3.5356775304977665`*^9, 3.535677530762967*^9}, {3.539393935916008*^9, 
   3.5393939361497617`*^9}, {3.5498214781142454`*^9, 3.54982148130425*^9}, {
   3.5498223076054068`*^9, 3.549822311385412*^9}, {3.549823219676684*^9, 
   3.549823219676684*^9}, {3.5498234629870243`*^9, 3.5498234851170554`*^9}, {
   3.549852537380123*^9, 3.549852537590123*^9}, 3.5717051167397833`*^9, 
   3.5758229243469067`*^9, {3.6113489203222485`*^9, 3.611348923219753*^9}, {
   3.6113491920426655`*^9, 3.611349194465169*^9}, {3.611349323642867*^9, 
   3.611349323855367*^9}, {3.6113556961469336`*^9, 3.6113556961469336`*^9}, {
   3.6379354061225767`*^9, 3.6379354228526*^9}, {3.637935463570658*^9, 
   3.637935479870681*^9}, 3.644433007676035*^9, {3.648954270416812*^9, 
   3.648954270639825*^9}, {3.6489558231536236`*^9, 3.6489558234126387`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{Cell[TextData[StyleBox["1:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"m", "\[Element]", 
        SuperscriptBox["\[DoubleStruckCapitalZ]", "+"]}], " ", "\[Or]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "|", "n"}], ")"}], "\[Element]", 
        "\[DoubleStruckCapitalZ]"}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, 
   3.5239334940268483`*^9, {3.524105742828332*^9, 3.524105745433536*^9}, {
   3.524105783326003*^9, 3.5241058043704395`*^9}, {3.524167197804468*^9, 
   3.524167275274576*^9}, {3.5241673584446926`*^9, 3.5241673584446926`*^9}, {
   3.5241684217861814`*^9, 3.5241684663262434`*^9}, {3.5241684966162863`*^9, 
   3.5241685133463097`*^9}, {3.524168558706373*^9, 3.524168575716397*^9}, {
   3.5242542194504414`*^9, 3.5242543397578526`*^9}, {3.5242543718471093`*^9, 
   3.5242544424216332`*^9}, {3.524254478910097*^9, 3.5242545759266677`*^9}, {
   3.5242546436307864`*^9, 3.5242546436307864`*^9}, {3.5242547267009325`*^9, 
   3.5242547400857563`*^9}, {3.5242771462350645`*^9, 
   3.5242771465938654`*^9}, {3.5304877376854625`*^9, 3.530487831775594*^9}, {
   3.5305002113339696`*^9, 3.53050021156397*^9}, {3.531256229526664*^9, 
   3.5312562621635933`*^9}, 3.5312563043041887`*^9, 3.5312565353964834`*^9, 
   3.5312718541780033`*^9, {3.531272022680298*^9, 3.531272043970912*^9}, 
   3.5312721159644337`*^9, {3.531286527477171*^9, 3.53128654727564*^9}, {
   3.53133653657067*^9, 3.5313365374719667`*^9}, {3.5332481026588316`*^9, 
   3.5332481046588345`*^9}, {3.533940608115779*^9, 3.5339406083757796`*^9}, {
   3.533940643135828*^9, 3.533940671755868*^9}, {3.53394080166605*^9, 
   3.53394080166605*^9}, {3.5339408897661734`*^9, 3.5339408897661734`*^9}, {
   3.5340308298369713`*^9, 3.534030830046972*^9}, {3.5346431179954567`*^9, 
   3.534643118292474*^9}, {3.5347066963108644`*^9, 3.5347066964980645`*^9}, {
   3.534708277732442*^9, 3.5347082781536427`*^9}, {3.535151707447782*^9, 
   3.5351517076977825`*^9}, 3.535151798067909*^9, {3.5351519292380924`*^9, 
   3.535151929478093*^9}, {3.5351519735681543`*^9, 3.5351519759881577`*^9}, {
   3.5356775270969605`*^9, 3.5356775274089613`*^9}, {3.539393933879423*^9, 
   3.539393934044432*^9}, 3.5498225109556913`*^9, {3.549822628955857*^9, 
   3.549822647825883*^9}, {3.549822827116134*^9, 3.549822827116134*^9}, {
   3.549823176416623*^9, 3.549823176416623*^9}, 3.5717051161597824`*^9, 
   3.5758229236569057`*^9, {3.6113490147698927`*^9, 3.6113490183148985`*^9}, {
   3.6113493223303647`*^9, 3.6113493225328655`*^9}, {3.6113566796183105`*^9, 
   3.6113566796183105`*^9}, {3.637938371372247*^9, 3.6379383732122498`*^9}, 
   3.6379583928531237`*^9, 3.637958492262499*^9, {3.637968021790884*^9, 
   3.637968031608445*^9}, {3.63796807994221*^9, 3.6379681142001696`*^9}, {
   3.6379757088485584`*^9, 3.6379757510569725`*^9}, {3.637975807853221*^9, 
   3.6379758104153676`*^9}, {3.637975932619357*^9, 3.637975993840859*^9}, {
   3.6379760305939612`*^9, 3.6379760428056593`*^9}, {3.637976507646247*^9, 
   3.6379765078642597`*^9}, {3.64443302402197*^9, 3.64443302402197*^9}, 
   3.6489530552303076`*^9, 3.648955880763919*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic expansion", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9}],

Cell[TextData[{
 "Rule 1.1.1.4",
 ".1.1.1: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"m", "\[Element]", 
    SuperscriptBox["\[DoubleStruckCapitalZ]", "+"]}], " ", "\[Or]", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"m", "|", "n"}], ")"}], "\[Element]", 
    "\[DoubleStruckCapitalZ]"}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4957339078770905`*^9, 
   3.495733966267172*^9}, {3.495734148157427*^9, 3.4957341584974413`*^9}, {
   3.4957346698781567`*^9, 3.495734670108157*^9}, {3.4957347778783083`*^9, 
   3.4957348688784356`*^9}, {3.5182850739057484`*^9, 
   3.5182850817837625`*^9}, {3.5193219410789022`*^9, 
   3.5193219437309074`*^9}, {3.5193301726195183`*^9, 
   3.5193301738595195`*^9}, {3.5199710233740273`*^9, 3.519971026084031*^9}, {
   3.519971058314076*^9, 3.519971083934112*^9}, {3.523219270157716*^9, 
   3.523219270157716*^9}, {3.523924231484662*^9, 3.523924232592264*^9}, {
   3.523930223132303*^9, 3.5239302243647056`*^9}, {3.523933687825989*^9, 
   3.523933687825989*^9}, {3.5241691044427414`*^9, 3.5241691044427414`*^9}, {
   3.530487866440643*^9, 3.530487866440643*^9}, 3.5312563413574686`*^9, 
   3.531272069487603*^9, 3.531272113390733*^9, {3.5339408766961555`*^9, 
   3.5339408833261642`*^9}, {3.535151983378168*^9, 3.535151983378168*^9}, {
   3.549822632795862*^9, 3.5498226330958624`*^9}, {3.549822682015931*^9, 
   3.54982272404599*^9}, {3.5498232150566773`*^9, 3.5498232150566773`*^9}, {
   3.6113567210183687`*^9, 3.6113567210183687`*^9}, {3.637968130367094*^9, 
   3.637968130367094*^9}, {3.6379757457626696`*^9, 3.6379757457626696`*^9}, {
   3.6444327581477623`*^9, 3.6444327581477623`*^9}, {3.6444330285472283`*^9, 
   3.6444330285472283`*^9}, {3.650160596221449*^9, 3.6501606246960773`*^9}, 
   3.698684023571454*^9}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"a", "+", 
      RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
   RowBox[{"(", 
    RowBox[{"e", "+", 
     RowBox[{"f", " ", "x"}]}], ")"}], 
   RowBox[{"(", 
    RowBox[{"g", "+", 
     RowBox[{"h", " ", "x"}]}], ")"}], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
     RowBox[{"\[Integral]", 
      RowBox[{
       RowBox[{"ExpandIntegrand", "[", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"c", "+", 
             RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
          RowBox[{"(", 
           RowBox[{"e", "+", 
            RowBox[{"f", " ", "x"}]}], ")"}], 
          RowBox[{"(", 
           RowBox[{"g", "+", 
            RowBox[{"h", " ", "x"}]}], ")"}]}], ",", "x"}], "]"}], 
       RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, {3.4954224033621993`*^9, 3.495422429782236*^9}, {
   3.4962830099393682`*^9, 3.496283015729377*^9}, {3.5241060284804335`*^9, 
   3.5241060764193172`*^9}, {3.524167368204706*^9, 3.5241674428548107`*^9}, {
   3.524168833516758*^9, 3.5241688560167894`*^9}, {3.53038360604578*^9, 
   3.530383613747221*^9}, 3.530383659086814*^9, {3.5312563478167567`*^9, 
   3.5312563530442734`*^9}, {3.531271888617525*^9, 3.5312718914516*^9}, {
   3.533940690055894*^9, 3.533940693145898*^9}, 3.535151793377902*^9, 
   3.5351518250179462`*^9, 3.536688185927653*^9, {3.549822542075735*^9, 
   3.54982254557574*^9}, {3.611349020822402*^9, 3.611349049822447*^9}, {
   3.6379584020883403`*^9, 3.6379584029151416`*^9}, {3.6379584929957004`*^9, 
   3.637958493588501*^9}, {3.637968139350608*^9, 3.6379681420397615`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_."}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_."}], "*", 
     RowBox[{"(", 
      RowBox[{"e_", "+", 
       RowBox[{"f_.", "*", "x_"}]}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{"Int", "[", 
    RowBox[{
     RowBox[{"ExpandIntegrand", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", "m"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", "*", "x"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"g", "+", 
          RowBox[{"h", "*", "x"}]}], ")"}]}], ",", "x"}], "]"}], ",", "x"}], 
    "]"}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"IGtQ", "[", 
       RowBox[{"m", ",", "0"}], "]"}], " ", "||", " ", 
      RowBox[{"IntegersQ", "[", 
       RowBox[{"m", ",", "n"}], "]"}]}], ")"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495422238811969*^9, 3.5239327382679205`*^9, {3.5241061049829674`*^9, 
   3.5241061158093867`*^9}, {3.5241061634986706`*^9, 3.524106178100296*^9}, {
   3.5241522039971824`*^9, 3.5241522138657465`*^9}, {3.524167459434834*^9, 
   3.524167501524893*^9}, 3.5241675598849745`*^9, {3.5241689646025457`*^9, 
   3.524169057582676*^9}, {3.5241694886052837`*^9, 3.5241694922252893`*^9}, {
   3.5241697349256287`*^9, 3.524169770915679*^9}, {3.524169890175846*^9, 
   3.52416989278585*^9}, {3.5241699517859325`*^9, 3.524169977745969*^9}, {
   3.5241702075262904`*^9, 3.5241702284463196`*^9}, {3.5241703474164867`*^9, 
   3.5241703535564947`*^9}, {3.5241704168565836`*^9, 
   3.5241704281665993`*^9}, {3.5241707090069923`*^9, 3.5241707118469963`*^9}, 
   3.5241707660170727`*^9, {3.5241735897163877`*^9, 3.524173666646496*^9}, {
   3.524173777586651*^9, 3.5241738523767557`*^9}, {3.5241739428768826`*^9, 
   3.524173979156933*^9}, 3.524174297647379*^9, {3.524185483815135*^9, 
   3.524185485365137*^9}, {3.524185602895302*^9, 3.5241856035153027`*^9}, {
   3.5241856771854057`*^9, 3.5241856830554132`*^9}, {3.524185838105631*^9, 
   3.5241858734356804`*^9}, {3.5241859285057573`*^9, 3.524185944045779*^9}, {
   3.524186003185862*^9, 3.524186038265911*^9}, {3.52418611602602*^9, 
   3.5241861192260246`*^9}, 3.524186217346162*^9, 3.5241863019362803`*^9, {
   3.5241863667163706`*^9, 3.5241863784563875`*^9}, {3.52418651596658*^9, 
   3.5241865406766143`*^9}, {3.5241867699369354`*^9, 
   3.5241868085469894`*^9}, {3.5241868836270943`*^9, 3.5241869237971506`*^9}, 
   3.5241869873472395`*^9, {3.5241870885173817`*^9, 3.524187101037399*^9}, {
   3.5241871740575013`*^9, 3.5241871912575254`*^9}, {3.524187306817687*^9, 
   3.5241873162877*^9}, {3.5241873622777643`*^9, 3.524187409757831*^9}, 
   3.524187460357902*^9, {3.5241874977879543`*^9, 3.524187498347955*^9}, {
   3.524187557468038*^9, 3.5241875586680393`*^9}, {3.524187589468083*^9, 
   3.5241875901780834`*^9}, {3.5241876610181828`*^9, 
   3.5241876929782276`*^9}, {3.524187781768352*^9, 3.524187783788355*^9}, {
   3.5241896786382575`*^9, 3.524189683318266*^9}, {3.524234559451813*^9, 
   3.5242346007294855`*^9}, {3.524238368588504*^9, 3.5242383752965155`*^9}, {
   3.5242384122217803`*^9, 3.524238419928194*^9}, {3.5242393344018*^9, 
   3.524239346819422*^9}, {3.5242394127451377`*^9, 3.5242394565500145`*^9}, {
   3.52423959033585*^9, 3.524239629803919*^9}, {3.524239671487192*^9, 
   3.5242397220468807`*^9}, {3.524239788190997*^9, 3.5242398647715316`*^9}, {
   3.5242437175850987`*^9, 3.5242437668343854`*^9}, {3.524244465247612*^9, 
   3.5242444873372507`*^9}, {3.524244751882516*^9, 3.524244753208518*^9}, {
   3.524245115768755*^9, 3.524245137000392*^9}, {3.5242452528149953`*^9, 
   3.5242452554826*^9}, {3.5242456723777323`*^9, 3.5242456731889334`*^9}, {
   3.524245869936479*^9, 3.5242459980595045`*^9}, {3.5242461068384953`*^9, 
   3.5242461450273623`*^9}, {3.524246187958638*^9, 3.52424618922224*^9}, {
   3.5242462316543145`*^9, 3.524246267690378*^9}, {3.5242463181564665`*^9, 
   3.5242463224620743`*^9}, {3.5242485499936485`*^9, 3.524248561823665*^9}, {
   3.524248621593749*^9, 3.5242486251937537`*^9}, {3.5242487642059507`*^9, 
   3.5242487732359633`*^9}, {3.5242532845563993`*^9, 
   3.5242532909524107`*^9}, {3.52425347849594*^9, 3.5242535106475964`*^9}, {
   3.524253596868948*^9, 3.5242536191613874`*^9}, {3.5242537436028056`*^9, 
   3.5242537593588333`*^9}, 3.5242539276207285`*^9, {3.524254113276655*^9, 
   3.5242541142126565`*^9}, {3.5242547334245443`*^9, 3.5242547363105493`*^9}, 
   3.5249480328482866`*^9, 3.5249480870383625`*^9, 3.530383624409831*^9, 
   3.5303836572717104`*^9, {3.5304855821174417`*^9, 3.5304855869274483`*^9}, {
   3.530486056548106*^9, 3.530486059638111*^9}, {3.5304860949231606`*^9, 
   3.5304860971731634`*^9}, {3.530486238303361*^9, 3.530486240243364*^9}, {
   3.530486952589362*^9, 3.5304870139844484`*^9}, {3.5304870692495255`*^9, 
   3.5304871419796276`*^9}, 3.530487215744731*^9, {3.530487355799927*^9, 
   3.5304873566799283`*^9}, {3.5304874052599964`*^9, 3.530487445625053*^9}, {
   3.530487479950101*^9, 3.5304874842801075`*^9}, {3.5304875702952275`*^9, 
   3.5304875724102306`*^9}, {3.5304876163102922`*^9, 
   3.5304876315153136`*^9}, {3.5312563706495886`*^9, 3.531256451626027*^9}, 
   3.531256559250784*^9, {3.5312719121413507`*^9, 3.5312719878001423`*^9}, {
   3.5312755920427885`*^9, 3.5312755952874546`*^9}, {3.5312856302770605`*^9, 
   3.531285654712197*^9}, {3.53128571933512*^9, 3.531285787002421*^9}, {
   3.5312858245464067`*^9, 3.53128595057763*^9}, {3.5312865586519985`*^9, 
   3.5312865654417615`*^9}, 3.5312884106750765`*^9, 3.5312884470173345`*^9, {
   3.5312884901092978`*^9, 3.5312885050908403`*^9}, {3.5312897715218782`*^9, 
   3.531289778872448*^9}, {3.531289921757907*^9, 3.531289929969715*^9}, {
   3.5312899831061215`*^9, 3.531289984918728*^9}, {3.5312906523184013`*^9, 
   3.5312906554428945`*^9}, {3.5313272051827936`*^9, 
   3.5313272099296193`*^9}, {3.531327286489707*^9, 3.5313272948817744`*^9}, {
   3.531328437394627*^9, 3.5313284476694016`*^9}, {3.531328488668355*^9, 
   3.5313284899702272`*^9}, {3.5313285673514957`*^9, 
   3.5313285721283646`*^9}, {3.531328972333832*^9, 3.5313290468309536`*^9}, 
   3.5313291984689984`*^9, 3.5313298886113744`*^9, {3.5313316869672832`*^9, 
   3.5313316871876*^9}, {3.531333470732211*^9, 3.531333473936819*^9}, {
   3.531334503567355*^9, 3.5313345333702097`*^9}, {3.531334712117235*^9, 
   3.531334724334803*^9}, {3.5313353872780685`*^9, 3.531335388289523*^9}, 
   3.531335434696253*^9, {3.5313387527874336`*^9, 3.5313387613597603`*^9}, {
   3.531339025249214*^9, 3.5313390434353647`*^9}, 3.531341876639312*^9, {
   3.5313421989627905`*^9, 3.531342251227944*^9}, {3.531346616364702*^9, 
   3.531346616715206*^9}, {3.5313466656655936`*^9, 3.5313466801764593`*^9}, {
   3.5315136290734544`*^9, 3.531513629934693*^9}, {3.531605034435397*^9, 
   3.5316050365784783`*^9}, {3.5316052098275986`*^9, 
   3.5316052120307665`*^9}, {3.531605458364978*^9, 3.531605459536662*^9}, {
   3.531699937927347*^9, 3.531699949764368*^9}, {3.531700346314579*^9, 
   3.531700368586605*^9}, {3.533937757524288*^9, 3.5339377669843016`*^9}, {
   3.5339377979043446`*^9, 3.533937819634375*^9}, {3.533938179374879*^9, 
   3.5339381969849033`*^9}, {3.5339382401149635`*^9, 3.533938297835045*^9}, {
   3.533938343125108*^9, 3.53393834467511*^9}, {3.533940711115923*^9, 
   3.533940734385956*^9}, {3.533940828086087*^9, 3.533940838736102*^9}, {
   3.5339509493977776`*^9, 3.533950953016984*^9}, {3.5339537404454803`*^9, 
   3.533953741022681*^9}, {3.535149061766073*^9, 3.5351490873961086`*^9}, 
   3.53515177762788*^9, {3.535151835707961*^9, 3.535151875438017*^9}, 
   3.536688185946654*^9, {3.5498225630257645`*^9, 3.549822615605838*^9}, {
   3.5498226665359097`*^9, 3.549822670285915*^9}, {3.5498227309059997`*^9, 
   3.549822731346*^9}, 3.549823269906754*^9, 3.5498566016258125`*^9, {
   3.6113490321349196`*^9, 3.6113490577574587`*^9}, 3.611356704238345*^9, {
   3.6379382656630964`*^9, 3.637938316392169*^9}, {3.637958403695143*^9, 
   3.637958405239546*^9}, {3.6379584942281027`*^9, 3.6379584957569056`*^9}, {
   3.637968154270461*^9, 3.6379681911655717`*^9}, {3.637968222224348*^9, 
   3.637968233112971*^9}, 3.6379683341237483`*^9, {3.637968393456142*^9, 
   3.6379684077169576`*^9}, {3.637975760020485*^9, 3.637975760172494*^9}, {
   3.6379759967510257`*^9, 3.6379760039034348`*^9}, {3.6379760547693443`*^9, 
   3.6379760713842945`*^9}, 3.644433036684694*^9, {3.7075934628096952`*^9, 
   3.707593468521022*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{Cell[TextData[StyleBox["2:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], " ", Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"m", "+", "n", "+", "2"}], "\[Equal]", "0"}], " ", "\[And]", 
       " ", 
       RowBox[{"m", "\[NotEqual]", 
        RowBox[{"-", "1"}]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.5192504337891226`*^9, 3.5192504707812386`*^9}, 3.5192506717957726`*^9, {
   3.519250720795459*^9, 3.5192507409818945`*^9}, 3.519258420209427*^9, 
   3.519258489779525*^9, {3.519320786305674*^9, 3.519320803294104*^9}, {
   3.519329422708468*^9, 3.5193294257984724`*^9}, 3.5193294706485353`*^9, {
   3.5193302883925123`*^9, 3.519330307237345*^9}, {3.5193303440378103`*^9, 
   3.5193303650666466`*^9}, 3.5193341918281684`*^9, {3.5193346196121197`*^9, 
   3.519334632840943*^9}, {3.519341922663512*^9, 3.5193419232095127`*^9}, 
   3.5193423494490614`*^9, {3.5193456600396833`*^9, 3.519345660273684*^9}, 
   3.519410696547495*^9, {3.519793559756592*^9, 3.5197935600217924`*^9}, {
   3.5210541942272606`*^9, 3.5210542323693275`*^9}, {3.521054705798959*^9, 
   3.5210547345342093`*^9}, {3.521055431683834*^9, 3.5210554455522585`*^9}, {
   3.5210554827427235`*^9, 3.5210555031319594`*^9}, {3.521056059772137*^9, 
   3.521056075652965*^9}, {3.521057417664521*^9, 3.521057417867322*^9}, {
   3.5210574854778404`*^9, 3.5210574857586412`*^9}, {3.5210575212175035`*^9, 
   3.521057540483537*^9}, {3.5210598942936716`*^9, 3.5210599092384977`*^9}, {
   3.521063276214819*^9, 3.521063298928458*^9}, {3.5210639991824884`*^9, 
   3.5210640343449497`*^9}, {3.5210641665551825`*^9, 
   3.5210641665551825`*^9}, {3.521072868148899*^9, 3.521072868148899*^9}, {
   3.5210824253375397`*^9, 3.5210824255559406`*^9}, {3.5211479965711794`*^9, 
   3.521148020673222*^9}, {3.5211480693453074`*^9, 3.5211480699537086`*^9}, {
   3.521148148187846*^9, 3.5211481489366474`*^9}, {3.5211482363436007`*^9, 
   3.5211482363436007`*^9}, {3.521148269556059*^9, 3.521148269556059*^9}, {
   3.521346368187188*^9, 3.521346368421189*^9}, {3.5214702809911447`*^9, 
   3.5214702811783447`*^9}, {3.5216579052539043`*^9, 3.521657905453904*^9}, {
   3.5223485259619713`*^9, 3.522348534381983*^9}, {3.5233208394702005`*^9, 
   3.5233208394702005`*^9}, {3.523320922845537*^9, 3.523320922845537*^9}, 
   3.523747250675035*^9, {3.5237670269856477`*^9, 3.5237670269856477`*^9}, {
   3.523831184179017*^9, 3.523831184179017*^9}, 3.5247720382710953`*^9, {
   3.524772397491598*^9, 3.524772397491598*^9}, {3.524774194324114*^9, 
   3.524774228794162*^9}, {3.526945238644486*^9, 3.526945238644486*^9}, {
   3.5279098167721815`*^9, 3.5279098172421827`*^9}, {3.5296282016140704`*^9, 
   3.5296282019130874`*^9}, 3.530384384323295*^9, {3.5303845765632906`*^9, 
   3.530384576766302*^9}, {3.530412765574172*^9, 3.530412765724172*^9}, {
   3.5304133134449387`*^9, 3.530413327614959*^9}, {3.5304133632650084`*^9, 
   3.5304133653750114`*^9}, {3.5304685359612284`*^9, 
   3.5304685362112293`*^9}, {3.5306637757276535`*^9, 3.530663775992854*^9}, 
   3.531940972073534*^9, {3.531941135920622*^9, 3.531941136887823*^9}, {
   3.531941292685297*^9, 3.5319412934028983`*^9}, {3.531941412696308*^9, 
   3.53194141378831*^9}, {3.531941540834933*^9, 3.531941542176535*^9}, {
   3.531941747348096*^9, 3.5319417604365187`*^9}, {3.5319419776265*^9, 
   3.531941978453302*^9}, {3.5319420524598317`*^9, 3.5319420537078342`*^9}, {
   3.5319437460612063`*^9, 3.5319437460612063`*^9}, {3.531945368214856*^9, 
   3.531945368214856*^9}, {3.5339235218280125`*^9, 3.533923522848014*^9}, {
   3.5340030836026883`*^9, 3.534003084035713*^9}, 3.534118752423112*^9, {
   3.5341190488235273`*^9, 3.534119049053528*^9}, {3.534119148303666*^9, 
   3.534119148303666*^9}, {3.534119453664094*^9, 3.5341194538540945`*^9}, {
   3.534119930854762*^9, 3.534119930854762*^9}, {3.53412041503544*^9, 
   3.53412041503544*^9}, {3.5498208478733635`*^9, 3.5498208478733635`*^9}, {
   3.549821170423815*^9, 3.549821170423815*^9}, {3.5498212022838593`*^9, 
   3.5498212022838593`*^9}, {3.5498220687050724`*^9, 
   3.5498220687050724`*^9}, {3.5498232312167*^9, 3.5498232312167*^9}, {
   3.5498234766870437`*^9, 3.5498234777570453`*^9}, {3.54985254227013*^9, 
   3.5498525425001297`*^9}, 3.5717051188897867`*^9, 3.5758229263769093`*^9, {
   3.6113489510122957`*^9, 3.6113489537697997`*^9}, {3.6113491101575394`*^9, 
   3.6113491196025534`*^9}, {3.6113491544876075`*^9, 
   3.6113491546901073`*^9}, {3.6113492430927434`*^9, 
   3.6113492640427756`*^9}, {3.6113556049368057`*^9, 
   3.6113556049368057`*^9}, {3.6379354926806993`*^9, 3.637935501570712*^9}, {
   3.637935984384406*^9, 3.637936011086444*^9}, {3.637936713196576*^9, 
   3.6379367381516113`*^9}, {3.6379380597968035`*^9, 
   3.6379380597968035`*^9}, {3.637955093083811*^9, 3.6379550934914117`*^9}, {
   3.63795638639141*^9, 3.6379563872962112`*^9}, {3.637956670791031*^9, 
   3.63795667595464*^9}, {3.637956707564296*^9, 3.6379567102943006`*^9}, {
   3.6379567450999618`*^9, 3.6379567527771754`*^9}, {3.637957721680006*^9, 
   3.63795772409801*^9}, {3.6379580063083076`*^9, 3.637958008071111*^9}, {
   3.6379582096592693`*^9, 3.637958217833683*^9}, {3.6379708823304977`*^9, 
   3.637970882540509*^9}, {3.6379710278478203`*^9, 3.6379710278478203`*^9}, {
   3.637976726489764*^9, 3.6379767266327724`*^9}, {3.63798141042267*^9, 
   3.63798141060468*^9}, {3.6444331829660606`*^9, 3.6444331829660606`*^9}, 
   3.648953058619501*^9, {3.648953135086875*^9, 3.6489531679987574`*^9}, {
   3.648954364033167*^9, 3.648954365267237*^9}, {3.648956072492885*^9, 
   3.6489560727258987`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: ???", "Subsubsection",
 CellChangeTimes->{
  3.496441803031353*^9, 3.4965396318089237`*^9, {3.4966002562016735`*^9, 
   3.4966002624716825`*^9}, 3.496600707442305*^9, 3.4966008475725017`*^9, {
   3.4966070255131593`*^9, 3.496607032413169*^9}, 3.518279406700592*^9, {
   3.51840552316576*^9, 3.5184055392257824`*^9}, 3.5184690414436746`*^9, 
   3.518469651844529*^9, 3.5184700043450227`*^9, 3.518474659316563*^9, 
   3.5237473322319784`*^9, 3.5247722814214354`*^9, {3.5260660236439*^9, 
   3.526066024233901*^9}, {3.530413463335149*^9, 3.5304134989751987`*^9}, {
   3.5339258909313297`*^9, 3.533925894241334*^9}, {3.5341187688231354`*^9, 
   3.534118769443136*^9}, {3.534119456044097*^9, 3.5341194563640976`*^9}, 
   3.6113471326280394`*^9, {3.6379360318244734`*^9, 3.6379360322144737`*^9}}],

Cell[TextData[{
 "Rule 1.1.1.4",
 ".1.1.2: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"m", "+", "n", "+", "2"}], "\[Equal]", "0"}], " ", "\[And]", " ", 
   RowBox[{"m", "\[NotEqual]", 
    RowBox[{"-", "1"}]}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.4964417379912624`*^9, 3.4964417471112747`*^9}, {
   3.496441910111503*^9, 3.4964419275315275`*^9}, 3.496451213764926*^9, {
   3.496539487018721*^9, 3.4965395223187704`*^9}, {3.4966001213614845`*^9, 
   3.4966001362815056`*^9}, {3.4966047635399923`*^9, 
   3.4966048329500895`*^9}, {3.496604896730179*^9, 3.496605019710351*^9}, {
   3.496605050490394*^9, 3.4966050527103972`*^9}, {3.4966066606926484`*^9, 
   3.496606694832696*^9}, 3.496606873362946*^9, {3.4966081836347804`*^9, 
   3.496608250534874*^9}, {3.496608418375109*^9, 3.496608441025141*^9}, {
   3.4966322809467688`*^9, 3.4966322818867702`*^9}, {3.4968592460220995`*^9, 
   3.4968592640557313`*^9}, {3.4968593076422076`*^9, 
   3.4968593113862143`*^9}, {3.496859384233942*^9, 3.496859384233942*^9}, {
   3.518223900967896*^9, 3.518223909467908*^9}, 3.5182817155426493`*^9, {
   3.518285874431555*^9, 3.518285899625599*^9}, {3.5182860969191456`*^9, 
   3.518286138321618*^9}, {3.518286898517355*^9, 3.518286898517355*^9}, {
   3.5182870794776726`*^9, 3.5182870794776726`*^9}, {3.518469568024412*^9, 
   3.518469584774435*^9}, {3.518469921924907*^9, 3.5184699227449083`*^9}, {
   3.51847035958552*^9, 3.518470374475541*^9}, {3.518474847889694*^9, 
   3.518474854394906*^9}, {3.518475351645779*^9, 3.51847535181738*^9}, {
   3.518476861483632*^9, 3.5184768701416473`*^9}, {3.5184769318709555`*^9, 
   3.518476937876966*^9}, {3.5185837532117095`*^9, 3.51858375372651*^9}, {
   3.5211482838768845`*^9, 3.5211482838768845`*^9}, {3.5223485487820034`*^9, 
   3.5223485487820034`*^9}, {3.5237580782402368`*^9, 
   3.5237580830402436`*^9}, {3.524772390921589*^9, 3.524772390921589*^9}, {
   3.524774159434065*^9, 3.5247741821040964`*^9}, {3.526945226804065*^9, 
   3.5269452323576756`*^9}, {3.530413508385212*^9, 3.530413508385212*^9}, {
   3.5319411411622305`*^9, 3.5319411411622305`*^9}, {3.5319412943077*^9, 
   3.5319412943077*^9}, {3.531941415098712*^9, 3.531941415098712*^9}, {
   3.531941547106144*^9, 3.531941547776945*^9}, {3.5319417707481365`*^9, 
   3.531941771746538*^9}, {3.5319419851613135`*^9, 3.5319419851613135`*^9}, {
   3.5319420546594353`*^9, 3.5319420546594353`*^9}, {3.531943749524412*^9, 
   3.531943749820813*^9}, {3.531945371147661*^9, 3.531945371147661*^9}, {
   3.5341190906435857`*^9, 3.5341191318936434`*^9}, {3.5341199134547377`*^9, 
   3.5341199250547543`*^9}, {3.5341202922652683`*^9, 
   3.5341202922652683`*^9}, {3.5498208700933943`*^9, 
   3.5498208700933943`*^9}, {3.549821171293816*^9, 3.549821171293816*^9}, {
   3.54982120282386*^9, 3.54982120282386*^9}, {3.549822071815077*^9, 
   3.549822071815077*^9}, {3.549823244226718*^9, 3.549823244226718*^9}, {
   3.6113556232768316`*^9, 3.6113556232768316`*^9}, {3.6379360252744646`*^9, 
   3.6379360252744646`*^9}, {3.6379367466056232`*^9, 
   3.6379367466056232`*^9}, {3.637938047252784*^9, 3.637938053482793*^9}, {
   3.6379577579696703`*^9, 3.6379577579696703`*^9}, {3.637959828010975*^9, 
   3.637959828010975*^9}, {3.637971030866993*^9, 3.6379710308679934`*^9}, {
   3.64443318802335*^9, 3.644433188530379*^9}, {3.6489531785783625`*^9, 
   3.6489531785783625`*^9}, 3.650160596803482*^9, {3.6501606291813335`*^9, 
   3.6501606300383825`*^9}, 3.698684023641454*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    RowBox[{"(", 
     RowBox[{"e", "+", 
      RowBox[{"f", " ", "x"}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{
     "x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox["b", "2"], " ", "d", " ", "e", " ", "g"}], "-", 
          RowBox[{
           SuperscriptBox["a", "2"], " ", "d", " ", "f", " ", "h", " ", "m"}],
           "-", 
          RowBox[{"a", " ", "b", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"f", " ", "g"}], "+", 
                RowBox[{"e", " ", "h"}]}], ")"}]}], "-", 
             RowBox[{"c", " ", "f", " ", "h", " ", 
              RowBox[{"(", 
               RowBox[{"m", "+", "1"}], ")"}]}]}], ")"}]}], "+", 
          RowBox[{"b", " ", "f", " ", "h", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"b", " ", "c"}], "-", 
             RowBox[{"a", " ", "d"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"m", "+", "1"}], ")"}], " ", "x"}]}], ")"}], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}], 
         RowBox[{"m", "+", "1"}]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}], ")"}], 
         RowBox[{"n", "+", "1"}]]}], 
       RowBox[{
        SuperscriptBox["b", "2"], " ", "d", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "c"}], "-", 
          RowBox[{"a", " ", "d"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}]}]]}]}]}]}], "+", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"a", " ", "d", " ", "f", " ", "h", " ", "m"}], "+", 
     RowBox[{"b", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", " ", "g"}], "+", 
           RowBox[{"e", " ", "h"}]}], ")"}]}], "-", 
        RowBox[{"c", " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "2"}], ")"}]}]}], ")"}]}]}], 
    RowBox[{
     SuperscriptBox["b", "2"], " ", "d"}]], 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"m", "+", "1"}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, 3.4958399855843487`*^9, 3.495840155344586*^9, 
   3.495840624735243*^9, {3.4958474296047697`*^9, 3.495847433754776*^9}, {
   3.4958476539050837`*^9, 3.495847660315093*^9}, {3.4958482220958796`*^9, 
   3.4958482231858807`*^9}, {3.495848257515929*^9, 3.4958482607459335`*^9}, 
   3.4959261390123196`*^9, 3.4959262745925093`*^9, 3.4959264909328117`*^9, 
   3.4959265843129425`*^9, 3.495926967463479*^9, {3.496184978535224*^9, 
   3.496185020185282*^9}, {3.4961873840085917`*^9, 3.496187409278627*^9}, {
   3.4961890232008867`*^9, 3.4961890250708895`*^9}, 3.4961956176127515`*^9, {
   3.4961956815728407`*^9, 3.496195696542862*^9}, {3.4961957791729774`*^9, 
   3.4961957920929956`*^9}, 3.496195845773071*^9, 3.518405474905692*^9, {
   3.51840566597596*^9, 3.5184056974360037`*^9}, {3.518405737026059*^9, 
   3.5184057718861084`*^9}, {3.5184058668262415`*^9, 3.518405869606245*^9}, {
   3.5184688792534475`*^9, 3.518468891673465*^9}, 3.5184689356235266`*^9, {
   3.5184691371938086`*^9, 3.5184691450938196`*^9}, {3.51846968832458*^9, 
   3.5184697035846014`*^9}, {3.518470060915102*^9, 3.518470082885133*^9}, {
   3.5184747044318423`*^9, 3.5184747207338715`*^9}, 3.518475002735566*^9, {
   3.5188842113796167`*^9, 3.518884228949641*^9}, {3.518890960739066*^9, 
   3.5188909798390923`*^9}, {3.520101172685255*^9, 3.520101193979293*^9}, 
   3.520101537866297*^9, {3.520101583012776*^9, 3.520101592138792*^9}, 
   3.5237473966912913`*^9, {3.523747635309311*^9, 3.523747662094558*^9}, 
   3.523747693201012*^9, {3.5237589154214087`*^9, 3.523758920041415*^9}, {
   3.523835091963359*^9, 3.523835095403364*^9}, 3.5247720424111013`*^9, {
   3.5247722402213783`*^9, 3.524772242541381*^9}, {3.5247723065014706`*^9, 
   3.524772310491476*^9}, {3.5247724101316156`*^9, 3.5247725806518545`*^9}, {
   3.5247726200519094`*^9, 3.5247727072220316`*^9}, {3.5247728848022804`*^9, 
   3.5247728894922867`*^9}, {3.5247737712335215`*^9, 
   3.5247738023335648`*^9}, {3.5279824084921894`*^9, 
   3.5279824453238535`*^9}, {3.5304116139925594`*^9, 
   3.5304117038726854`*^9}, {3.530411918742986*^9, 3.53041197123306*^9}, 
   3.531941036782448*^9, {3.5319411448594375`*^9, 3.5319411488686447`*^9}, {
   3.531941294947301*^9, 3.531941298394907*^9}, {3.5319414162219143`*^9, 
   3.5319414182655177`*^9}, {3.531941548510146*^9, 3.5319415504133496`*^9}, {
   3.5319417755685453`*^9, 3.5319417799833527`*^9}, {3.5319419862689157`*^9, 
   3.531941989685322*^9}, {3.531942055798238*^9, 3.5319420566406393`*^9}, {
   3.5319437006495266`*^9, 3.5319437038787327`*^9}, {3.5340026346818047`*^9, 
   3.534002637453963*^9}, {3.5340030209706793`*^9, 3.5340030293451586`*^9}, {
   3.534118784243157*^9, 3.5341188511132507`*^9}, {3.534119170853698*^9, 
   3.534119179923711*^9}, {3.534119497584155*^9, 3.5341195421742177`*^9}, {
   3.5498221970752525`*^9, 3.5498221995452557`*^9}, {3.611348176827039*^9, 
   3.61134819860707*^9}, {3.6113489579198065`*^9, 3.61134896037731*^9}, {
   3.63793554203277*^9, 3.6379355918848414`*^9}, {3.6379356258428917`*^9, 
   3.6379358643252325`*^9}, {3.637937535652889*^9, 3.6379375648399315`*^9}, 
   3.637937610196997*^9, {3.6379376404560404`*^9, 3.637937642837044*^9}, {
   3.6379378484063406`*^9, 3.637937885606394*^9}, 3.637955117172253*^9, {
   3.637955266638517*^9, 3.6379552741909304`*^9}, {3.637955498900527*^9, 
   3.637955547316331*^9}, 3.637955868108096*^9, {3.6379559067749643`*^9, 
   3.6379560664124455`*^9}, {3.6379565217775693`*^9, 3.637956524039573*^9}, {
   3.63795719781996*^9, 3.63795722615361*^9}, 3.637957355605961*^9, {
   3.637957410582458*^9, 3.637957472612167*^9}, {3.637957800813346*^9, 
   3.63795783704161*^9}, {3.6379578842814927`*^9, 3.637957921912759*^9}, {
   3.637970083271794*^9, 3.6379702941858573`*^9}, {3.6379704504387946`*^9, 
   3.6379704526239195`*^9}, {3.648953206659969*^9, 3.6489533090058227`*^9}, {
   3.648953602558613*^9, 3.6489536185045247`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.520101787997136*^9, 3.5201017908831415`*^9}, 
   3.534119660884384*^9, 3.5341197024044423`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_."}], "*", 
     RowBox[{"(", 
      RowBox[{"e_", "+", 
       RowBox[{"f_.", "*", "x_"}]}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"b", "^", "2"}], "*", "d", "*", "e", "*", "g"}], "-", 
       RowBox[{
        RowBox[{"a", "^", "2"}], "*", "d", "*", "f", "*", "h", "*", "m"}], 
       "-", 
       RowBox[{"a", "*", "b", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"d", "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"f", "*", "g"}], "+", 
             RowBox[{"e", "*", "h"}]}], ")"}]}], "-", 
          RowBox[{"c", "*", "f", "*", "h", "*", 
           RowBox[{"(", 
            RowBox[{"m", "+", "1"}], ")"}]}]}], ")"}]}], "+", 
       RowBox[{"b", "*", "f", "*", "h", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "c"}], "-", 
          RowBox[{"a", "*", "d"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", "x"}]}], ")"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", "*", "x"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"n", "+", "1"}], ")"}]}], "/", "\[IndentingNewLine]", "    ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "^", "2"}], "*", "d", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "c"}], "-", 
          RowBox[{"a", "*", "d"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}]}], ")"}]}]}], " ", "+", " ", 
    "\[IndentingNewLine]", "  ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"a", "*", "d", "*", "f", "*", "h", "*", "m"}], "+", 
        RowBox[{"b", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "+", 
              RowBox[{"e", "*", "h"}]}], ")"}]}], "-", 
           RowBox[{"c", "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "2"}], ")"}]}]}], ")"}]}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "^", "2"}], "*", "d"}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m", ",", "n"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"EqQ", "[", 
     RowBox[{
      RowBox[{"m", "+", "n", "+", "2"}], ",", "0"}], "]"}], " ", "&&", " ", 
    RowBox[{"NeQ", "[", 
     RowBox[{"m", ",", 
      RowBox[{"-", "1"}]}], "]"}], " ", "&&", " ", 
    RowBox[{"Not", "[", 
     RowBox[{
      RowBox[{"SumSimplerQ", "[", 
       RowBox[{"n", ",", "1"}], "]"}], " ", "&&", " ", 
      RowBox[{"Not", "[", 
       RowBox[{"SumSimplerQ", "[", 
        RowBox[{"m", ",", "1"}], "]"}], "]"}]}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495839738475589*^9, 3.4958405008250694`*^9, {3.495847490784856*^9, 
   3.4958474999948683`*^9}, {3.4958477172451725`*^9, 3.495847721615179*^9}, {
   3.495848224085882*^9, 3.4958482277058873`*^9}, {3.4958482626259365`*^9, 
   3.4958482686359444`*^9}, 3.4959261054722724`*^9, {3.4959262905725317`*^9, 
   3.4959262958725395`*^9}, 3.495926443222745*^9, 3.4961849395451694`*^9, 
   3.496185884976493*^9, 3.4961888731806765`*^9, {3.4961890260508904`*^9, 
   3.4961890290708947`*^9}, {3.496191957967628*^9, 3.4961919600576305`*^9}, 
   3.49619205250776*^9, 3.4961952203321953`*^9, {3.496195426482484*^9, 
   3.496195433172493*^9}, {3.496195586822708*^9, 3.496195595732721*^9}, 
   3.496195754542943*^9, 3.4966189754082823`*^9, {3.4966198797795486`*^9, 
   3.496619907439587*^9}, {3.4968579645422487`*^9, 3.4968579680210547`*^9}, 
   3.5171911044266214`*^9, 3.518211198418105*^9, 3.5182420941409807`*^9, {
   3.518281849687285*^9, 3.518281849874485*^9}, {3.5182861978669233`*^9, 
   3.518286207226939*^9}, 3.518286893072945*^9, 3.518287077449669*^9, {
   3.518405919376315*^9, 3.5184059327163334`*^9}, 3.518406000866429*^9, {
   3.5184061023365707`*^9, 3.518406115016588*^9}, {3.5184065135071464`*^9, 
   3.518406515547149*^9}, {3.518406800569559*^9, 3.5184068071395683`*^9}, {
   3.518455696848171*^9, 3.518455715349804*^9}, {3.518469305994045*^9, 
   3.518469310354051*^9}, {3.5184693414340944`*^9, 3.5184693641841264`*^9}, {
   3.518469461554263*^9, 3.518469497814314*^9}, {3.5184698199647646`*^9, 
   3.5184698496348057`*^9}, {3.5184698834448533`*^9, 3.5184698844848547`*^9}, 
   3.5184701704452553`*^9, {3.518470248195364*^9, 3.518470287395419*^9}, {
   3.51847032361547*^9, 3.518470324325471*^9}, {3.518474812134432*^9, 
   3.5184748359088736`*^9}, {3.5184748784969482`*^9, 3.51847487927695*^9}, 
   3.518475395747057*^9, {3.5184754745583954`*^9, 3.518475478770403*^9}, {
   3.5184759352008047`*^9, 3.518475938726411*^9}, {3.5184760887674747`*^9, 
   3.5184761024174986`*^9}, {3.518476247310553*^9, 3.5184762483245544`*^9}, {
   3.518476459611326*^9, 3.518476460235327*^9}, {3.5185837600757217`*^9, 
   3.518583760356522*^9}, {3.5188842541996765`*^9, 3.5188842747997055`*^9}, {
   3.518890955169058*^9, 3.5188909696490784`*^9}, {3.5188914772697887`*^9, 
   3.518891482339796*^9}, {3.520102006257119*^9, 3.5201020069591208`*^9}, 
   3.5201020756928415`*^9, {3.5202847653043165`*^9, 3.520284765308317*^9}, {
   3.5202851424268866`*^9, 3.520285144721018*^9}, {3.520899838877209*^9, 
   3.5208998429572153`*^9}, {3.521131441309245*^9, 3.521131443849249*^9}, 
   3.521148390206671*^9, {3.5223485088319473`*^9, 3.5223485168319583`*^9}, {
   3.5224420691492205`*^9, 3.522442069414421*^9}, 3.5237568920485764`*^9, 
   3.523757219519035*^9, 3.523757259739091*^9, {3.5237580436701884`*^9, 
   3.523758059720211*^9}, {3.523758936761439*^9, 3.523758939721443*^9}, 
   3.523810558420226*^9, 3.523818931362772*^9, {3.523835156403449*^9, 
   3.5238351582934523`*^9}, 3.5247721246012163`*^9, {3.5247739098537154`*^9, 
   3.5247740062738504`*^9}, {3.524774046163906*^9, 3.524774061003927*^9}, {
   3.5269452650085325`*^9, 3.526945270312542*^9}, {3.527188364001113*^9, 
   3.5271883677139196`*^9}, {3.5271888173223095`*^9, 3.527188823843121*^9}, {
   3.5271899878391657`*^9, 3.5271900376656528`*^9}, {3.527190166287879*^9, 
   3.5271901716698885`*^9}, {3.527190278608076*^9, 3.5271902902768965`*^9}, {
   3.527982424123417*^9, 3.5279824278986235`*^9}, {3.5279825248995934`*^9, 
   3.5279825340568094`*^9}, {3.5304120848332186`*^9, 3.530412106123248*^9}, {
   3.5304130055745077`*^9, 3.530413008634512*^9}, {3.530413043314561*^9, 
   3.530413055224577*^9}, {3.530413087314622*^9, 3.5304130884346237`*^9}, {
   3.5304131472647057`*^9, 3.5304131483447075`*^9}, 3.53046311973864*^9, {
   3.5304888886920757`*^9, 3.530488894767084*^9}, {3.531941152706251*^9, 
   3.531941162830669*^9}, {3.531941299455709*^9, 3.531941306974922*^9}, {
   3.5319414191859193`*^9, 3.5319414225243254`*^9}, {3.531941554079356*^9, 
   3.531941559040165*^9}, {3.531941786394964*^9, 3.531941805174197*^9}, {
   3.5319419942717295`*^9, 3.531941998764538*^9}, {3.5319420576234407`*^9, 
   3.531942059916645*^9}, {3.531943420348234*^9, 3.5319434261514444`*^9}, {
   3.5319437080127397`*^9, 3.53194372535997*^9}, {3.531943778727664*^9, 
   3.531943779960066*^9}, {3.5319453490892224`*^9, 3.5319453522092276`*^9}, {
   3.5339415241170616`*^9, 3.533941538197081*^9}, {3.5339415789871387`*^9, 
   3.533941604107174*^9}, {3.5339512902895765`*^9, 3.5339512946731844`*^9}, 
   3.533951351067283*^9, {3.5340027757635803`*^9, 3.534002812286766*^9}, {
   3.5341190049334655`*^9, 3.5341190294735003`*^9}, {3.5341191883437223`*^9, 
   3.534119195643733*^9}, {3.5341193695439763`*^9, 3.53411941511404*^9}, 
   3.5341196611243844`*^9, {3.5341196955644326`*^9, 3.5341197132044573`*^9}, {
   3.53411976495453*^9, 3.5341197859645596`*^9}, {3.5341198161046014`*^9, 
   3.5341198333046255`*^9}, 3.5341199475947857`*^9, 3.5341203626853666`*^9, {
   3.5345320463388095`*^9, 3.5345320520621367`*^9}, {3.5400017308272676`*^9, 
   3.540001736107275*^9}, {3.542249989006481*^9, 3.5422499957078643`*^9}, {
   3.542250036073081*^9, 3.542250039670287*^9}, 3.5498209379134893`*^9, 
   3.5498210856636963`*^9, 3.549821116193739*^9, 3.5498220886751003`*^9, {
   3.5498222071852665`*^9, 3.54982220976527*^9}, 3.5498232774067645`*^9, {
   3.6113482525721474`*^9, 3.611348275997181*^9}, {3.611348965777318*^9, 
   3.611348970487325*^9}, 3.6113556452168617`*^9, 3.611383619514218*^9, {
   3.637936083407548*^9, 3.637936110206587*^9}, 3.637936274310949*^9, {
   3.6379363084159966`*^9, 3.637936320439014*^9}, {3.6379363628310733`*^9, 
   3.637936404716133*^9}, 3.6379364350531764`*^9, {3.6379364697612257`*^9, 
   3.637936471099228*^9}, {3.637937776010236*^9, 3.6379378355253215`*^9}, {
   3.637937910986431*^9, 3.637937922436447*^9}, {3.637938068086815*^9, 
   3.6379380952038536`*^9}, {3.6379562370187464`*^9, 
   3.6379563212376947`*^9}, {3.637956406909446*^9, 3.6379564217093897`*^9}, {
   3.6379564588002586`*^9, 3.6379564777542915`*^9}, {3.6379565591084347`*^9, 
   3.6379565603408365`*^9}, {3.63795659060489*^9, 3.6379566159705343`*^9}, {
   3.637959792390112*^9, 3.637959800567527*^9}, {3.6379598362789893`*^9, 
   3.6379598364817896`*^9}, {3.637960245216427*^9, 3.6379602578544493`*^9}, 
   3.6379603117877445`*^9, 3.6379703973217564`*^9, {3.6379707078965206`*^9, 
   3.63797074968591*^9}, {3.637970815706687*^9, 3.637970843180258*^9}, {
   3.6379712525816746`*^9, 3.6379712879997005`*^9}, 3.644433197301881*^9, 
   3.6489537340881357`*^9, {3.6489539222728996`*^9, 3.648953950934539*^9}, {
   3.706112960375875*^9, 3.7061130085246286`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{Cell[TextData[StyleBox["3.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{"m", "<", 
       RowBox[{"-", "1"}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.534118429444058*^9, 3.534118443920883*^9}, {3.5341185894379387`*^9, 
   3.5341185897187395`*^9}, {3.534126368193774*^9, 3.534126368483775*^9}, {
   3.5347073427604*^9, 3.5347073430411997`*^9}, {3.535151711347787*^9, 
   3.5351517116277876`*^9}, {3.535151925298087*^9, 3.5351519255180874`*^9}, {
   3.5356775304977665`*^9, 3.535677530762967*^9}, {3.539393935916008*^9, 
   3.5393939361497617`*^9}, {3.5498214781142454`*^9, 3.54982148130425*^9}, {
   3.5498223076054068`*^9, 3.549822311385412*^9}, {3.549823219676684*^9, 
   3.549823219676684*^9}, {3.5498234629870243`*^9, 3.5498234851170554`*^9}, {
   3.549852537380123*^9, 3.549852537590123*^9}, 3.5717051167397833`*^9, 
   3.5758229243469067`*^9, {3.6113489203222485`*^9, 3.611348923219753*^9}, {
   3.6113491920426655`*^9, 3.611349194465169*^9}, {3.611349323642867*^9, 
   3.611349323855367*^9}, {3.6113556961469336`*^9, 3.6113556961469336`*^9}, {
   3.6379354061225767`*^9, 3.6379354228526*^9}, {3.637935463570658*^9, 
   3.637935479870681*^9}, {3.6379566948034735`*^9, 3.6379567035706887`*^9}, {
   3.637976519201908*^9, 3.637976519431921*^9}, {3.6444330550567446`*^9, 
   3.644433055057745*^9}, 3.6489529519183984`*^9, 3.6489530560753555`*^9, 
   3.6489558822610044`*^9, {3.648956076240099*^9, 3.648956076447111*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["1:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], " ", Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"m", "<", 
        RowBox[{"-", "1"}]}], " ", "\[And]", " ", 
       RowBox[{"n", "<", 
        RowBox[{"-", "1"}]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.5192504337891226`*^9, 3.5192504707812386`*^9}, 3.5192506717957726`*^9, {
   3.519250720795459*^9, 3.5192507409818945`*^9}, 3.519258420209427*^9, 
   3.519258489779525*^9, {3.519320786305674*^9, 3.519320803294104*^9}, {
   3.519329422708468*^9, 3.5193294257984724`*^9}, 3.5193294706485353`*^9, {
   3.5193302883925123`*^9, 3.519330307237345*^9}, {3.5193303440378103`*^9, 
   3.5193303650666466`*^9}, 3.5193341918281684`*^9, {3.5193346196121197`*^9, 
   3.519334632840943*^9}, {3.519341922663512*^9, 3.5193419232095127`*^9}, 
   3.5193423494490614`*^9, {3.5193456600396833`*^9, 3.519345660273684*^9}, 
   3.519410696547495*^9, {3.519793559756592*^9, 3.5197935600217924`*^9}, {
   3.5210541942272606`*^9, 3.5210542323693275`*^9}, {3.521054705798959*^9, 
   3.5210547345342093`*^9}, {3.521055431683834*^9, 3.5210554455522585`*^9}, {
   3.5210554827427235`*^9, 3.5210555031319594`*^9}, {3.521056059772137*^9, 
   3.521056075652965*^9}, {3.521057417664521*^9, 3.521057417867322*^9}, {
   3.5210574854778404`*^9, 3.5210574857586412`*^9}, {3.5210575212175035`*^9, 
   3.521057540483537*^9}, {3.5210598942936716`*^9, 3.5210599092384977`*^9}, {
   3.521063276214819*^9, 3.521063298928458*^9}, {3.5210639991824884`*^9, 
   3.5210640343449497`*^9}, {3.5210641665551825`*^9, 
   3.5210641665551825`*^9}, {3.521072868148899*^9, 3.521072868148899*^9}, {
   3.5210824253375397`*^9, 3.5210824255559406`*^9}, {3.5211479965711794`*^9, 
   3.521148020673222*^9}, {3.5211480693453074`*^9, 3.5211480699537086`*^9}, {
   3.521148148187846*^9, 3.5211481489366474`*^9}, {3.5211482363436007`*^9, 
   3.5211482363436007`*^9}, {3.521148269556059*^9, 3.521148269556059*^9}, {
   3.521346368187188*^9, 3.521346368421189*^9}, {3.5214702809911447`*^9, 
   3.5214702811783447`*^9}, {3.5216579052539043`*^9, 3.521657905453904*^9}, {
   3.5223485259619713`*^9, 3.522348534381983*^9}, {3.5233208394702005`*^9, 
   3.5233208394702005`*^9}, {3.523320922845537*^9, 3.523320922845537*^9}, 
   3.523747250675035*^9, {3.5237670269856477`*^9, 3.5237670269856477`*^9}, {
   3.523831184179017*^9, 3.523831184179017*^9}, 3.5247720382710953`*^9, {
   3.524772397491598*^9, 3.524772397491598*^9}, {3.524774194324114*^9, 
   3.524774228794162*^9}, {3.526945238644486*^9, 3.526945238644486*^9}, {
   3.5279098167721815`*^9, 3.5279098172421827`*^9}, {3.5296282016140704`*^9, 
   3.5296282019130874`*^9}, 3.530384384323295*^9, {3.5303845765632906`*^9, 
   3.530384576766302*^9}, {3.530412765574172*^9, 3.530412765724172*^9}, {
   3.5304133134449387`*^9, 3.530413327614959*^9}, {3.5304133632650084`*^9, 
   3.5304133653750114`*^9}, {3.5304685359612284`*^9, 
   3.5304685362112293`*^9}, {3.5306637757276535`*^9, 3.530663775992854*^9}, 
   3.531940972073534*^9, {3.531941135920622*^9, 3.531941136887823*^9}, {
   3.531941292685297*^9, 3.5319412934028983`*^9}, {3.531941412696308*^9, 
   3.53194141378831*^9}, {3.531941540834933*^9, 3.531941542176535*^9}, {
   3.531941747348096*^9, 3.5319417604365187`*^9}, {3.5319419776265*^9, 
   3.531941978453302*^9}, {3.5319420524598317`*^9, 3.5319420537078342`*^9}, {
   3.5319437460612063`*^9, 3.5319437460612063`*^9}, {3.531945368214856*^9, 
   3.531945368214856*^9}, {3.5339235218280125`*^9, 3.533923522848014*^9}, {
   3.5340030836026883`*^9, 3.534003084035713*^9}, 3.534118752423112*^9, {
   3.5341190488235273`*^9, 3.534119049053528*^9}, {3.534119148303666*^9, 
   3.534119148303666*^9}, {3.534119453664094*^9, 3.5341194538540945`*^9}, {
   3.534119930854762*^9, 3.534119930854762*^9}, {3.53412041503544*^9, 
   3.53412041503544*^9}, {3.5498208478733635`*^9, 3.5498208478733635`*^9}, {
   3.549821170423815*^9, 3.549821170423815*^9}, {3.5498212022838593`*^9, 
   3.5498212022838593`*^9}, {3.5498220687050724`*^9, 
   3.5498220687050724`*^9}, {3.5498232312167*^9, 3.5498232312167*^9}, {
   3.5498234766870437`*^9, 3.5498234777570453`*^9}, {3.54985254227013*^9, 
   3.5498525425001297`*^9}, 3.5717051188897867`*^9, 3.5758229263769093`*^9, {
   3.6113489510122957`*^9, 3.6113489537697997`*^9}, {3.6113491101575394`*^9, 
   3.6113491196025534`*^9}, {3.6113491544876075`*^9, 
   3.6113491546901073`*^9}, {3.6113492430927434`*^9, 
   3.6113492640427756`*^9}, {3.6113556049368057`*^9, 
   3.6113556049368057`*^9}, {3.6379354926806993`*^9, 3.637935501570712*^9}, {
   3.637935984384406*^9, 3.637936011086444*^9}, {3.637936713196576*^9, 
   3.6379367381516113`*^9}, {3.6379380597968035`*^9, 3.6379380597968035`*^9}, 
   3.6379567064566936`*^9, {3.644433073560803*^9, 3.6444330752849016`*^9}, 
   3.6489530567323933`*^9, 3.6489558846831427`*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: ???", "Subsubsection",
 CellChangeTimes->{
  3.496441803031353*^9, 3.4965396318089237`*^9, {3.4966002562016735`*^9, 
   3.4966002624716825`*^9}, 3.496600707442305*^9, 3.4966008475725017`*^9, {
   3.4966070255131593`*^9, 3.496607032413169*^9}, 3.518279406700592*^9, {
   3.51840552316576*^9, 3.5184055392257824`*^9}, 3.5184690414436746`*^9, 
   3.518469651844529*^9, 3.5184700043450227`*^9, 3.518474659316563*^9, 
   3.5237473322319784`*^9, 3.5247722814214354`*^9, {3.5260660236439*^9, 
   3.526066024233901*^9}, {3.530413463335149*^9, 3.5304134989751987`*^9}, {
   3.5339258909313297`*^9, 3.533925894241334*^9}, {3.5341187688231354`*^9, 
   3.534118769443136*^9}, {3.534119456044097*^9, 3.5341194563640976`*^9}, 
   3.6113471326280394`*^9, {3.6379360318244734`*^9, 3.6379360322144737`*^9}}],

Cell[TextData[{
 "Rule 1.1.1.4",
 ".1.1.3.1: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"m", "<", 
    RowBox[{"-", "1"}]}], " ", "\[And]", " ", 
   RowBox[{"n", "<", 
    RowBox[{"-", "1"}]}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.4964417379912624`*^9, 3.4964417471112747`*^9}, {
   3.496441910111503*^9, 3.4964419275315275`*^9}, 3.496451213764926*^9, {
   3.496539487018721*^9, 3.4965395223187704`*^9}, {3.4966001213614845`*^9, 
   3.4966001362815056`*^9}, {3.4966047635399923`*^9, 
   3.4966048329500895`*^9}, {3.496604896730179*^9, 3.496605019710351*^9}, {
   3.496605050490394*^9, 3.4966050527103972`*^9}, {3.4966066606926484`*^9, 
   3.496606694832696*^9}, 3.496606873362946*^9, {3.4966081836347804`*^9, 
   3.496608250534874*^9}, {3.496608418375109*^9, 3.496608441025141*^9}, {
   3.4966322809467688`*^9, 3.4966322818867702`*^9}, {3.4968592460220995`*^9, 
   3.4968592640557313`*^9}, {3.4968593076422076`*^9, 
   3.4968593113862143`*^9}, {3.496859384233942*^9, 3.496859384233942*^9}, {
   3.518223900967896*^9, 3.518223909467908*^9}, 3.5182817155426493`*^9, {
   3.518285874431555*^9, 3.518285899625599*^9}, {3.5182860969191456`*^9, 
   3.518286138321618*^9}, {3.518286898517355*^9, 3.518286898517355*^9}, {
   3.5182870794776726`*^9, 3.5182870794776726`*^9}, {3.518469568024412*^9, 
   3.518469584774435*^9}, {3.518469921924907*^9, 3.5184699227449083`*^9}, {
   3.51847035958552*^9, 3.518470374475541*^9}, {3.518474847889694*^9, 
   3.518474854394906*^9}, {3.518475351645779*^9, 3.51847535181738*^9}, {
   3.518476861483632*^9, 3.5184768701416473`*^9}, {3.5184769318709555`*^9, 
   3.518476937876966*^9}, {3.5185837532117095`*^9, 3.51858375372651*^9}, {
   3.5211482838768845`*^9, 3.5211482838768845`*^9}, {3.5223485487820034`*^9, 
   3.5223485487820034`*^9}, {3.5237580782402368`*^9, 
   3.5237580830402436`*^9}, {3.524772390921589*^9, 3.524772390921589*^9}, {
   3.524774159434065*^9, 3.5247741821040964`*^9}, {3.526945226804065*^9, 
   3.5269452323576756`*^9}, {3.530413508385212*^9, 3.530413508385212*^9}, {
   3.5319411411622305`*^9, 3.5319411411622305`*^9}, {3.5319412943077*^9, 
   3.5319412943077*^9}, {3.531941415098712*^9, 3.531941415098712*^9}, {
   3.531941547106144*^9, 3.531941547776945*^9}, {3.5319417707481365`*^9, 
   3.531941771746538*^9}, {3.5319419851613135`*^9, 3.5319419851613135`*^9}, {
   3.5319420546594353`*^9, 3.5319420546594353`*^9}, {3.531943749524412*^9, 
   3.531943749820813*^9}, {3.531945371147661*^9, 3.531945371147661*^9}, {
   3.5341190906435857`*^9, 3.5341191318936434`*^9}, {3.5341199134547377`*^9, 
   3.5341199250547543`*^9}, {3.5341202922652683`*^9, 
   3.5341202922652683`*^9}, {3.5498208700933943`*^9, 
   3.5498208700933943`*^9}, {3.549821171293816*^9, 3.549821171293816*^9}, {
   3.54982120282386*^9, 3.54982120282386*^9}, {3.549822071815077*^9, 
   3.549822071815077*^9}, {3.549823244226718*^9, 3.549823244226718*^9}, {
   3.6113556232768316`*^9, 3.6113556232768316`*^9}, {3.6379360252744646`*^9, 
   3.6379360252744646`*^9}, {3.6379367466056232`*^9, 
   3.6379367466056232`*^9}, {3.637938047252784*^9, 3.637938053482793*^9}, {
   3.6444330837203836`*^9, 3.6444330837203836`*^9}, 3.6501605973695145`*^9, {
   3.65016063681577*^9, 3.6501606383408575`*^9}, 3.6986840237234545`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    RowBox[{"(", 
     RowBox[{"e", "+", 
      RowBox[{"f", " ", "x"}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{
     "x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{
        RowBox[{
         SuperscriptBox["b", "2"], " ", "c", " ", "d", " ", "e", " ", "g", 
         " ", 
         RowBox[{"(", 
          RowBox[{"n", "+", "1"}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["a", "2"], " ", "c", " ", "d", " ", "f", " ", "h", 
         " ", 
         RowBox[{"(", 
          RowBox[{"n", "+", "1"}], ")"}]}], "+", 
        RowBox[{"a", " ", "b", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox["d", "2"], " ", "e", " ", "g", " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["c", "2"], " ", "f", " ", "h", " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "-", 
           RowBox[{"c", " ", "d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", " ", "g"}], "+", 
              RowBox[{"e", " ", "h"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "2"}], ")"}]}]}], ")"}]}], "+", 
        "\[IndentingNewLine]", "     ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["d", "2"], " ", "f", " ", "h", " ", 
            RowBox[{"(", 
             RowBox[{"n", "+", "1"}], ")"}]}], "-", 
           RowBox[{"a", " ", "b", " ", 
            SuperscriptBox["d", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", " ", "g"}], "+", 
              RowBox[{"e", " ", "h"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"n", "+", "1"}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SuperscriptBox["c", "2"], " ", "f", " ", "h", " ", 
               RowBox[{"(", 
                RowBox[{"m", "+", "1"}], ")"}]}], "-", 
              RowBox[{"c", " ", "d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", " ", "g"}], "+", 
                 RowBox[{"e", " ", "h"}]}], ")"}], " ", 
               RowBox[{"(", 
                RowBox[{"m", "+", "1"}], ")"}]}], "+", 
              RowBox[{
               SuperscriptBox["d", "2"], " ", "e", " ", "g", " ", 
               RowBox[{"(", 
                RowBox[{"m", "+", "n", "+", "2"}], ")"}]}]}], ")"}]}]}], 
          ")"}], " ", "x"}]}], 
       RowBox[{"b", " ", "d", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "c"}], "-", 
           RowBox[{"a", " ", "d"}]}], ")"}], "2"], " ", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"n", "+", "1"}], ")"}]}]]}]}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], 
     RowBox[{"m", "+", "1"}]], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], 
     RowBox[{"n", "+", "1"}]]}]}], "-", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{
      SuperscriptBox["a", "2"], " ", 
      SuperscriptBox["d", "2"], " ", "f", " ", "h", " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", 
        RowBox[{"3", " ", "n"}], "+", 
        SuperscriptBox["n", "2"]}], ")"}]}], "+", 
     RowBox[{"a", " ", "b", " ", "d", " ", 
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "c", " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "-", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", " ", "g"}], "+", 
           RowBox[{"e", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]}], ")"}]}], "+", 
     "\[IndentingNewLine]", "     ", 
     RowBox[{
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["c", "2"], " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{"2", "+", 
           RowBox[{"3", " ", "m"}], "+", 
           SuperscriptBox["m", "2"]}], ")"}]}], "-", 
        RowBox[{"c", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", " ", "g"}], "+", 
           RowBox[{"e", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "3"}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["d", "2"], " ", "e", " ", "g", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           SuperscriptBox["m", "2"], "+", 
           RowBox[{"5", " ", "n"}], "+", 
           SuperscriptBox["n", "2"], "+", 
           RowBox[{"m", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "n"}], "+", "5"}], ")"}]}]}], ")"}]}]}], 
       ")"}]}]}], 
    RowBox[{"b", " ", "d", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "c"}], "-", 
        RowBox[{"a", " ", "d"}]}], ")"}], "2"], " ", 
     RowBox[{"(", 
      RowBox[{"m", "+", "1"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"n", "+", "1"}], ")"}]}]], "\[CenterDot]", 
   "\[IndentingNewLine]", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"m", "+", "1"}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], 
      RowBox[{"n", "+", "1"}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, 3.4958399855843487`*^9, 3.495840155344586*^9, 
   3.495840624735243*^9, {3.4958474296047697`*^9, 3.495847433754776*^9}, {
   3.4958476539050837`*^9, 3.495847660315093*^9}, {3.4958482220958796`*^9, 
   3.4958482231858807`*^9}, {3.495848257515929*^9, 3.4958482607459335`*^9}, 
   3.4959261390123196`*^9, 3.4959262745925093`*^9, 3.4959264909328117`*^9, 
   3.4959265843129425`*^9, 3.495926967463479*^9, {3.496184978535224*^9, 
   3.496185020185282*^9}, {3.4961873840085917`*^9, 3.496187409278627*^9}, {
   3.4961890232008867`*^9, 3.4961890250708895`*^9}, 3.4961956176127515`*^9, {
   3.4961956815728407`*^9, 3.496195696542862*^9}, {3.4961957791729774`*^9, 
   3.4961957920929956`*^9}, 3.496195845773071*^9, 3.518405474905692*^9, {
   3.51840566597596*^9, 3.5184056974360037`*^9}, {3.518405737026059*^9, 
   3.5184057718861084`*^9}, {3.5184058668262415`*^9, 3.518405869606245*^9}, {
   3.5184688792534475`*^9, 3.518468891673465*^9}, 3.5184689356235266`*^9, {
   3.5184691371938086`*^9, 3.5184691450938196`*^9}, {3.51846968832458*^9, 
   3.5184697035846014`*^9}, {3.518470060915102*^9, 3.518470082885133*^9}, {
   3.5184747044318423`*^9, 3.5184747207338715`*^9}, 3.518475002735566*^9, {
   3.5188842113796167`*^9, 3.518884228949641*^9}, {3.518890960739066*^9, 
   3.5188909798390923`*^9}, {3.520101172685255*^9, 3.520101193979293*^9}, 
   3.520101537866297*^9, {3.520101583012776*^9, 3.520101592138792*^9}, 
   3.5237473966912913`*^9, {3.523747635309311*^9, 3.523747662094558*^9}, 
   3.523747693201012*^9, {3.5237589154214087`*^9, 3.523758920041415*^9}, {
   3.523835091963359*^9, 3.523835095403364*^9}, 3.5247720424111013`*^9, {
   3.5247722402213783`*^9, 3.524772242541381*^9}, {3.5247723065014706`*^9, 
   3.524772310491476*^9}, {3.5247724101316156`*^9, 3.5247725806518545`*^9}, {
   3.5247726200519094`*^9, 3.5247727072220316`*^9}, {3.5247728848022804`*^9, 
   3.5247728894922867`*^9}, {3.5247737712335215`*^9, 
   3.5247738023335648`*^9}, {3.5279824084921894`*^9, 
   3.5279824453238535`*^9}, {3.5304116139925594`*^9, 
   3.5304117038726854`*^9}, {3.530411918742986*^9, 3.53041197123306*^9}, 
   3.531941036782448*^9, {3.5319411448594375`*^9, 3.5319411488686447`*^9}, {
   3.531941294947301*^9, 3.531941298394907*^9}, {3.5319414162219143`*^9, 
   3.5319414182655177`*^9}, {3.531941548510146*^9, 3.5319415504133496`*^9}, {
   3.5319417755685453`*^9, 3.5319417799833527`*^9}, {3.5319419862689157`*^9, 
   3.531941989685322*^9}, {3.531942055798238*^9, 3.5319420566406393`*^9}, {
   3.5319437006495266`*^9, 3.5319437038787327`*^9}, {3.5340026346818047`*^9, 
   3.534002637453963*^9}, {3.5340030209706793`*^9, 3.5340030293451586`*^9}, {
   3.534118784243157*^9, 3.5341188511132507`*^9}, {3.534119170853698*^9, 
   3.534119179923711*^9}, {3.534119497584155*^9, 3.5341195421742177`*^9}, {
   3.5498221970752525`*^9, 3.5498221995452557`*^9}, {3.611348176827039*^9, 
   3.61134819860707*^9}, {3.6113489579198065`*^9, 3.61134896037731*^9}, {
   3.63793554203277*^9, 3.6379355918848414`*^9}, {3.6379356258428917`*^9, 
   3.6379358643252325`*^9}, {3.637937535652889*^9, 3.6379375648399315`*^9}, 
   3.637937610196997*^9, {3.6379376404560404`*^9, 3.637937642837044*^9}, {
   3.6379378484063406`*^9, 3.637937885606394*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.520101787997136*^9, 3.5201017908831415`*^9}, 
   3.534119660884384*^9, 3.5341197024044423`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "*", 
     RowBox[{"(", 
      RowBox[{"e_", "+", 
       RowBox[{"f_.", "*", "x_"}]}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"b", "^", "2"}], "*", "c", "*", "d", "*", "e", "*", "g", "*", 
         RowBox[{"(", 
          RowBox[{"n", "+", "1"}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"a", "^", "2"}], "*", "c", "*", "d", "*", "f", "*", "h", "*", 
         RowBox[{"(", 
          RowBox[{"n", "+", "1"}], ")"}]}], "+", 
        RowBox[{"a", "*", "b", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"d", "^", "2"}], "*", "e", "*", "g", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "+", 
           RowBox[{
            RowBox[{"c", "^", "2"}], "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "-", 
           RowBox[{"c", "*", "d", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "+", 
              RowBox[{"e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "2"}], ")"}]}]}], ")"}]}], "+", "\n",
         "      ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"a", "^", "2"}], "*", 
            RowBox[{"d", "^", "2"}], "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{"n", "+", "1"}], ")"}]}], "-", 
           RowBox[{"a", "*", "b", "*", 
            RowBox[{"d", "^", "2"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "+", 
              RowBox[{"e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"n", "+", "1"}], ")"}]}], "+", 
           RowBox[{
            RowBox[{"b", "^", "2"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"c", "^", "2"}], "*", "f", "*", "h", "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "1"}], ")"}]}], "-", 
              RowBox[{"c", "*", "d", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", "*", "g"}], "+", 
                 RowBox[{"e", "*", "h"}]}], ")"}], "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "1"}], ")"}]}], "+", 
              RowBox[{
               RowBox[{"d", "^", "2"}], "*", "e", "*", "g", "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "n", "+", "2"}], ")"}]}]}], ")"}]}]}], 
          ")"}], "*", "x"}]}], ")"}], "/", "\n", "    ", 
      RowBox[{"(", 
       RowBox[{"b", "*", "d", "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", "*", "c"}], "-", 
           RowBox[{"a", "*", "d"}]}], ")"}], "^", "2"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"n", "+", "1"}], ")"}]}], ")"}]}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}]}]}], " ", "-", " ", "\n", "  ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"a", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "f", "*", "h", "*", 
         RowBox[{"(", 
          RowBox[{"2", "+", 
           RowBox[{"3", "*", "n"}], "+", 
           RowBox[{"n", "^", "2"}]}], ")"}]}], "+", 
        RowBox[{"a", "*", "b", "*", "d", "*", 
         RowBox[{"(", 
          RowBox[{"n", "+", "1"}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "*", "c", "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "-", 
           RowBox[{"d", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "+", 
              RowBox[{"e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]}], ")"}]}], "+", "\n",
         "      ", 
        RowBox[{
         RowBox[{"b", "^", "2"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"c", "^", "2"}], "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{"2", "+", 
              RowBox[{"3", "*", "m"}], "+", 
              RowBox[{"m", "^", "2"}]}], ")"}]}], "-", 
           RowBox[{"c", "*", "d", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "+", 
              RowBox[{"e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "3"}], ")"}]}], "+", 
           RowBox[{
            RowBox[{"d", "^", "2"}], "*", "e", "*", "g", "*", 
            RowBox[{"(", 
             RowBox[{"6", "+", 
              RowBox[{"m", "^", "2"}], "+", 
              RowBox[{"5", "*", "n"}], "+", 
              RowBox[{"n", "^", "2"}], "+", 
              RowBox[{"m", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", "*", "n"}], "+", "5"}], ")"}]}]}], ")"}]}]}], 
          ")"}]}]}], ")"}], "/", "\n", "    ", 
      RowBox[{"(", 
       RowBox[{"b", "*", "d", "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", "*", "c"}], "-", 
           RowBox[{"a", "*", "d"}]}], ")"}], "^", "2"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"n", "+", "1"}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"n", "+", "1"}], ")"}]}]}], ",", "x"}], "]"}]}]}], " ", "/;",
    "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"LtQ", "[", 
     RowBox[{"m", ",", 
      RowBox[{"-", "1"}]}], "]"}], " ", "&&", " ", 
    RowBox[{"LtQ", "[", 
     RowBox[{"n", ",", 
      RowBox[{"-", "1"}]}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495839738475589*^9, 3.4958405008250694`*^9, {3.495847490784856*^9, 
   3.4958474999948683`*^9}, {3.4958477172451725`*^9, 3.495847721615179*^9}, {
   3.495848224085882*^9, 3.4958482277058873`*^9}, {3.4958482626259365`*^9, 
   3.4958482686359444`*^9}, 3.4959261054722724`*^9, {3.4959262905725317`*^9, 
   3.4959262958725395`*^9}, 3.495926443222745*^9, 3.4961849395451694`*^9, 
   3.496185884976493*^9, 3.4961888731806765`*^9, {3.4961890260508904`*^9, 
   3.4961890290708947`*^9}, {3.496191957967628*^9, 3.4961919600576305`*^9}, 
   3.49619205250776*^9, 3.4961952203321953`*^9, {3.496195426482484*^9, 
   3.496195433172493*^9}, {3.496195586822708*^9, 3.496195595732721*^9}, 
   3.496195754542943*^9, 3.4966189754082823`*^9, {3.4966198797795486`*^9, 
   3.496619907439587*^9}, {3.4968579645422487`*^9, 3.4968579680210547`*^9}, 
   3.5171911044266214`*^9, 3.518211198418105*^9, 3.5182420941409807`*^9, {
   3.518281849687285*^9, 3.518281849874485*^9}, {3.5182861978669233`*^9, 
   3.518286207226939*^9}, 3.518286893072945*^9, 3.518287077449669*^9, {
   3.518405919376315*^9, 3.5184059327163334`*^9}, 3.518406000866429*^9, {
   3.5184061023365707`*^9, 3.518406115016588*^9}, {3.5184065135071464`*^9, 
   3.518406515547149*^9}, {3.518406800569559*^9, 3.5184068071395683`*^9}, {
   3.518455696848171*^9, 3.518455715349804*^9}, {3.518469305994045*^9, 
   3.518469310354051*^9}, {3.5184693414340944`*^9, 3.5184693641841264`*^9}, {
   3.518469461554263*^9, 3.518469497814314*^9}, {3.5184698199647646`*^9, 
   3.5184698496348057`*^9}, {3.5184698834448533`*^9, 3.5184698844848547`*^9}, 
   3.5184701704452553`*^9, {3.518470248195364*^9, 3.518470287395419*^9}, {
   3.51847032361547*^9, 3.518470324325471*^9}, {3.518474812134432*^9, 
   3.5184748359088736`*^9}, {3.5184748784969482`*^9, 3.51847487927695*^9}, 
   3.518475395747057*^9, {3.5184754745583954`*^9, 3.518475478770403*^9}, {
   3.5184759352008047`*^9, 3.518475938726411*^9}, {3.5184760887674747`*^9, 
   3.5184761024174986`*^9}, {3.518476247310553*^9, 3.5184762483245544`*^9}, {
   3.518476459611326*^9, 3.518476460235327*^9}, {3.5185837600757217`*^9, 
   3.518583760356522*^9}, {3.5188842541996765`*^9, 3.5188842747997055`*^9}, {
   3.518890955169058*^9, 3.5188909696490784`*^9}, {3.5188914772697887`*^9, 
   3.518891482339796*^9}, {3.520102006257119*^9, 3.5201020069591208`*^9}, 
   3.5201020756928415`*^9, {3.5202847653043165`*^9, 3.520284765308317*^9}, {
   3.5202851424268866`*^9, 3.520285144721018*^9}, {3.520899838877209*^9, 
   3.5208998429572153`*^9}, {3.521131441309245*^9, 3.521131443849249*^9}, 
   3.521148390206671*^9, {3.5223485088319473`*^9, 3.5223485168319583`*^9}, {
   3.5224420691492205`*^9, 3.522442069414421*^9}, 3.5237568920485764`*^9, 
   3.523757219519035*^9, 3.523757259739091*^9, {3.5237580436701884`*^9, 
   3.523758059720211*^9}, {3.523758936761439*^9, 3.523758939721443*^9}, 
   3.523810558420226*^9, 3.523818931362772*^9, {3.523835156403449*^9, 
   3.5238351582934523`*^9}, 3.5247721246012163`*^9, {3.5247739098537154`*^9, 
   3.5247740062738504`*^9}, {3.524774046163906*^9, 3.524774061003927*^9}, {
   3.5269452650085325`*^9, 3.526945270312542*^9}, {3.527188364001113*^9, 
   3.5271883677139196`*^9}, {3.5271888173223095`*^9, 3.527188823843121*^9}, {
   3.5271899878391657`*^9, 3.5271900376656528`*^9}, {3.527190166287879*^9, 
   3.5271901716698885`*^9}, {3.527190278608076*^9, 3.5271902902768965`*^9}, {
   3.527982424123417*^9, 3.5279824278986235`*^9}, {3.5279825248995934`*^9, 
   3.5279825340568094`*^9}, {3.5304120848332186`*^9, 3.530412106123248*^9}, {
   3.5304130055745077`*^9, 3.530413008634512*^9}, {3.530413043314561*^9, 
   3.530413055224577*^9}, {3.530413087314622*^9, 3.5304130884346237`*^9}, {
   3.5304131472647057`*^9, 3.5304131483447075`*^9}, 3.53046311973864*^9, {
   3.5304888886920757`*^9, 3.530488894767084*^9}, {3.531941152706251*^9, 
   3.531941162830669*^9}, {3.531941299455709*^9, 3.531941306974922*^9}, {
   3.5319414191859193`*^9, 3.5319414225243254`*^9}, {3.531941554079356*^9, 
   3.531941559040165*^9}, {3.531941786394964*^9, 3.531941805174197*^9}, {
   3.5319419942717295`*^9, 3.531941998764538*^9}, {3.5319420576234407`*^9, 
   3.531942059916645*^9}, {3.531943420348234*^9, 3.5319434261514444`*^9}, {
   3.5319437080127397`*^9, 3.53194372535997*^9}, {3.531943778727664*^9, 
   3.531943779960066*^9}, {3.5319453490892224`*^9, 3.5319453522092276`*^9}, {
   3.5339415241170616`*^9, 3.533941538197081*^9}, {3.5339415789871387`*^9, 
   3.533941604107174*^9}, {3.5339512902895765`*^9, 3.5339512946731844`*^9}, 
   3.533951351067283*^9, {3.5340027757635803`*^9, 3.534002812286766*^9}, {
   3.5341190049334655`*^9, 3.5341190294735003`*^9}, {3.5341191883437223`*^9, 
   3.534119195643733*^9}, {3.5341193695439763`*^9, 3.53411941511404*^9}, 
   3.5341196611243844`*^9, {3.5341196955644326`*^9, 3.5341197132044573`*^9}, {
   3.53411976495453*^9, 3.5341197859645596`*^9}, {3.5341198161046014`*^9, 
   3.5341198333046255`*^9}, 3.5341199475947857`*^9, 3.5341203626853666`*^9, {
   3.5345320463388095`*^9, 3.5345320520621367`*^9}, {3.5400017308272676`*^9, 
   3.540001736107275*^9}, {3.542249989006481*^9, 3.5422499957078643`*^9}, {
   3.542250036073081*^9, 3.542250039670287*^9}, 3.5498209379134893`*^9, 
   3.5498210856636963`*^9, 3.549821116193739*^9, 3.5498220886751003`*^9, {
   3.5498222071852665`*^9, 3.54982220976527*^9}, 3.5498232774067645`*^9, {
   3.6113482525721474`*^9, 3.611348275997181*^9}, {3.611348965777318*^9, 
   3.611348970487325*^9}, 3.6113556452168617`*^9, 3.611383619514218*^9, {
   3.637936083407548*^9, 3.637936110206587*^9}, 3.637936274310949*^9, {
   3.6379363084159966`*^9, 3.637936320439014*^9}, {3.6379363628310733`*^9, 
   3.637936404716133*^9}, 3.6379364350531764`*^9, {3.6379364697612257`*^9, 
   3.637936471099228*^9}, {3.637937776010236*^9, 3.6379378355253215`*^9}, {
   3.637937910986431*^9, 3.637937922436447*^9}, {3.637938068086815*^9, 
   3.6379380952038536`*^9}, {3.6379564002930346`*^9, 3.637956401231036*^9}, 
   3.6444330985042295`*^9, {3.707703037546301*^9, 3.70770305388153*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["2.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}], " ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"m", "<", 
        RowBox[{"-", "1"}]}], " ", "\[And]", " ", 
       RowBox[{"n", "\[NotLess]", 
        RowBox[{"-", "1"}]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.534118429444058*^9, 3.534118443920883*^9}, {3.5341185894379387`*^9, 
   3.5341185897187395`*^9}, {3.534126368193774*^9, 3.534126368483775*^9}, {
   3.5347073427604*^9, 3.5347073430411997`*^9}, {3.535151711347787*^9, 
   3.5351517116277876`*^9}, {3.535151925298087*^9, 3.5351519255180874`*^9}, {
   3.5356775304977665`*^9, 3.535677530762967*^9}, {3.539393935916008*^9, 
   3.5393939361497617`*^9}, {3.5498214781142454`*^9, 3.54982148130425*^9}, {
   3.5498223076054068`*^9, 3.549822311385412*^9}, {3.549823219676684*^9, 
   3.549823219676684*^9}, {3.5498234629870243`*^9, 3.5498234851170554`*^9}, {
   3.549852537380123*^9, 3.549852537590123*^9}, 3.5717051167397833`*^9, 
   3.5758229243469067`*^9, {3.6113489203222485`*^9, 3.611348923219753*^9}, {
   3.6113491920426655`*^9, 3.611349194465169*^9}, {3.611349323642867*^9, 
   3.611349323855367*^9}, {3.6113556961469336`*^9, 3.6113556961469336`*^9}, {
   3.6379354061225767`*^9, 3.6379354228526*^9}, {3.637935463570658*^9, 
   3.637935479870681*^9}, {3.6379566948034735`*^9, 3.6379567035706887`*^9}, {
   3.6379580037811036`*^9, 3.6379580052787066`*^9}, {3.637958244050062*^9, 
   3.637958245688065*^9}, {3.6444331136970987`*^9, 3.6444331136970987`*^9}, 
   3.64895305737543*^9, 3.64895588620823*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["1:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], " ", Cell[TextData[Cell[BoxData[
      RowBox[{"m", "<", 
       RowBox[{"-", "2"}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.5192504337891226`*^9, 3.5192504707812386`*^9}, 3.5192506717957726`*^9, {
   3.519250720795459*^9, 3.5192507409818945`*^9}, 3.519258420209427*^9, 
   3.519258489779525*^9, {3.519320786305674*^9, 3.519320803294104*^9}, {
   3.519329422708468*^9, 3.5193294257984724`*^9}, 3.5193294706485353`*^9, {
   3.5193302883925123`*^9, 3.519330307237345*^9}, {3.5193303440378103`*^9, 
   3.5193303650666466`*^9}, 3.5193341918281684`*^9, {3.5193346196121197`*^9, 
   3.519334632840943*^9}, {3.519341922663512*^9, 3.5193419232095127`*^9}, 
   3.5193423494490614`*^9, {3.5193456600396833`*^9, 3.519345660273684*^9}, 
   3.519410696547495*^9, {3.519793559756592*^9, 3.5197935600217924`*^9}, {
   3.5210541942272606`*^9, 3.5210542323693275`*^9}, {3.521054705798959*^9, 
   3.5210547345342093`*^9}, {3.521055431683834*^9, 3.5210554455522585`*^9}, {
   3.5210554827427235`*^9, 3.5210555031319594`*^9}, {3.521056059772137*^9, 
   3.521056075652965*^9}, {3.521057417664521*^9, 3.521057417867322*^9}, {
   3.5210574854778404`*^9, 3.5210574857586412`*^9}, {3.5210575212175035`*^9, 
   3.521057540483537*^9}, {3.5210598942936716`*^9, 3.5210599092384977`*^9}, {
   3.521063276214819*^9, 3.521063298928458*^9}, {3.5210639991824884`*^9, 
   3.5210640343449497`*^9}, {3.5210641665551825`*^9, 
   3.5210641665551825`*^9}, {3.521072868148899*^9, 3.521072868148899*^9}, {
   3.5210824253375397`*^9, 3.5210824255559406`*^9}, {3.5211479965711794`*^9, 
   3.521148020673222*^9}, {3.5211480693453074`*^9, 3.5211480699537086`*^9}, {
   3.521148148187846*^9, 3.5211481489366474`*^9}, {3.5211482363436007`*^9, 
   3.5211482363436007`*^9}, {3.521148269556059*^9, 3.521148269556059*^9}, {
   3.521346368187188*^9, 3.521346368421189*^9}, {3.5214702809911447`*^9, 
   3.5214702811783447`*^9}, {3.5216579052539043`*^9, 3.521657905453904*^9}, {
   3.5223485259619713`*^9, 3.522348534381983*^9}, {3.5233208394702005`*^9, 
   3.5233208394702005`*^9}, {3.523320922845537*^9, 3.523320922845537*^9}, 
   3.523747250675035*^9, {3.5237670269856477`*^9, 3.5237670269856477`*^9}, {
   3.523831184179017*^9, 3.523831184179017*^9}, 3.5247720382710953`*^9, {
   3.524772397491598*^9, 3.524772397491598*^9}, {3.524774194324114*^9, 
   3.524774228794162*^9}, {3.526945238644486*^9, 3.526945238644486*^9}, {
   3.5279098167721815`*^9, 3.5279098172421827`*^9}, {3.5296282016140704`*^9, 
   3.5296282019130874`*^9}, 3.530384384323295*^9, {3.5303845765632906`*^9, 
   3.530384576766302*^9}, {3.530412765574172*^9, 3.530412765724172*^9}, {
   3.5304133134449387`*^9, 3.530413327614959*^9}, {3.5304133632650084`*^9, 
   3.5304133653750114`*^9}, {3.5304685359612284`*^9, 
   3.5304685362112293`*^9}, {3.5306637757276535`*^9, 3.530663775992854*^9}, 
   3.531940972073534*^9, {3.531941135920622*^9, 3.531941136887823*^9}, {
   3.531941292685297*^9, 3.5319412934028983`*^9}, {3.531941412696308*^9, 
   3.53194141378831*^9}, {3.531941540834933*^9, 3.531941542176535*^9}, {
   3.531941747348096*^9, 3.5319417604365187`*^9}, {3.5319419776265*^9, 
   3.531941978453302*^9}, {3.5319420524598317`*^9, 3.5319420537078342`*^9}, {
   3.5319437460612063`*^9, 3.5319437460612063`*^9}, {3.531945368214856*^9, 
   3.531945368214856*^9}, {3.5339235218280125`*^9, 3.533923522848014*^9}, {
   3.5340030836026883`*^9, 3.534003084035713*^9}, 3.534118752423112*^9, {
   3.5341190488235273`*^9, 3.534119049053528*^9}, {3.534119148303666*^9, 
   3.534119148303666*^9}, {3.534119453664094*^9, 3.5341194538540945`*^9}, {
   3.534119930854762*^9, 3.534119930854762*^9}, {3.53412041503544*^9, 
   3.53412041503544*^9}, {3.5498208478733635`*^9, 3.5498208478733635`*^9}, {
   3.549821170423815*^9, 3.549821170423815*^9}, {3.5498212022838593`*^9, 
   3.5498212022838593`*^9}, {3.5498220687050724`*^9, 
   3.5498220687050724`*^9}, {3.5498232312167*^9, 3.5498232312167*^9}, {
   3.5498234766870437`*^9, 3.5498234777570453`*^9}, {3.54985254227013*^9, 
   3.5498525425001297`*^9}, 3.5717051188897867`*^9, 3.5758229263769093`*^9, {
   3.6113489510122957`*^9, 3.6113489537697997`*^9}, {3.6113491101575394`*^9, 
   3.6113491196025534`*^9}, {3.6113491544876075`*^9, 
   3.6113491546901073`*^9}, {3.6113492430927434`*^9, 
   3.6113492640427756`*^9}, {3.6113556049368057`*^9, 
   3.6113556049368057`*^9}, {3.6379354926806993`*^9, 3.637935501570712*^9}, {
   3.637935984384406*^9, 3.637936011086444*^9}, {3.637936713196576*^9, 
   3.6379367381516113`*^9}, {3.6379380597968035`*^9, 
   3.6379380597968035`*^9}, {3.637955093083811*^9, 3.6379550934914117`*^9}, {
   3.63795638639141*^9, 3.6379563872962112`*^9}, {3.637956670791031*^9, 
   3.63795667595464*^9}, {3.637956707564296*^9, 3.6379567102943006`*^9}, {
   3.6379567450999618`*^9, 3.6379567527771754`*^9}, {3.6379577660524845`*^9, 
   3.637957767113286*^9}, {3.6379580122363186`*^9, 3.6379580138743215`*^9}, {
   3.6379581850414257`*^9, 3.6379581881770315`*^9}, {3.6379698382487793`*^9, 
   3.637969838469792*^9}, {3.6379709867394695`*^9, 3.6379709867394695`*^9}, {
   3.637976727837841*^9, 3.6379767280078506`*^9}, {3.6379814090985937`*^9, 
   3.6379814092826047`*^9}, {3.6444331254047685`*^9, 3.6444331254047685`*^9}, 
   3.6489530579884653`*^9, 3.648956110044033*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: ???", "Subsubsection",
 CellChangeTimes->{
  3.496441803031353*^9, 3.4965396318089237`*^9, {3.4966002562016735`*^9, 
   3.4966002624716825`*^9}, 3.496600707442305*^9, 3.4966008475725017`*^9, {
   3.4966070255131593`*^9, 3.496607032413169*^9}, 3.518279406700592*^9, {
   3.51840552316576*^9, 3.5184055392257824`*^9}, 3.5184690414436746`*^9, 
   3.518469651844529*^9, 3.5184700043450227`*^9, 3.518474659316563*^9, 
   3.5237473322319784`*^9, 3.5247722814214354`*^9, {3.5260660236439*^9, 
   3.526066024233901*^9}, {3.530413463335149*^9, 3.5304134989751987`*^9}, {
   3.5339258909313297`*^9, 3.533925894241334*^9}, {3.5341187688231354`*^9, 
   3.534118769443136*^9}, {3.534119456044097*^9, 3.5341194563640976`*^9}, 
   3.6113471326280394`*^9, {3.6379360318244734`*^9, 3.6379360322144737`*^9}}],

Cell[TextData[{
 "Rule 1.1.1.4",
 ".1.1.3.2.1: If  ",
 Cell[BoxData[
  RowBox[{"m", "<", 
   RowBox[{"-", "2"}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.4964417379912624`*^9, 3.4964417471112747`*^9}, {
   3.496441910111503*^9, 3.4964419275315275`*^9}, 3.496451213764926*^9, {
   3.496539487018721*^9, 3.4965395223187704`*^9}, {3.4966001213614845`*^9, 
   3.4966001362815056`*^9}, {3.4966047635399923`*^9, 
   3.4966048329500895`*^9}, {3.496604896730179*^9, 3.496605019710351*^9}, {
   3.496605050490394*^9, 3.4966050527103972`*^9}, {3.4966066606926484`*^9, 
   3.496606694832696*^9}, 3.496606873362946*^9, {3.4966081836347804`*^9, 
   3.496608250534874*^9}, {3.496608418375109*^9, 3.496608441025141*^9}, {
   3.4966322809467688`*^9, 3.4966322818867702`*^9}, {3.4968592460220995`*^9, 
   3.4968592640557313`*^9}, {3.4968593076422076`*^9, 
   3.4968593113862143`*^9}, {3.496859384233942*^9, 3.496859384233942*^9}, {
   3.518223900967896*^9, 3.518223909467908*^9}, 3.5182817155426493`*^9, {
   3.518285874431555*^9, 3.518285899625599*^9}, {3.5182860969191456`*^9, 
   3.518286138321618*^9}, {3.518286898517355*^9, 3.518286898517355*^9}, {
   3.5182870794776726`*^9, 3.5182870794776726`*^9}, {3.518469568024412*^9, 
   3.518469584774435*^9}, {3.518469921924907*^9, 3.5184699227449083`*^9}, {
   3.51847035958552*^9, 3.518470374475541*^9}, {3.518474847889694*^9, 
   3.518474854394906*^9}, {3.518475351645779*^9, 3.51847535181738*^9}, {
   3.518476861483632*^9, 3.5184768701416473`*^9}, {3.5184769318709555`*^9, 
   3.518476937876966*^9}, {3.5185837532117095`*^9, 3.51858375372651*^9}, {
   3.5211482838768845`*^9, 3.5211482838768845`*^9}, {3.5223485487820034`*^9, 
   3.5223485487820034`*^9}, {3.5237580782402368`*^9, 
   3.5237580830402436`*^9}, {3.524772390921589*^9, 3.524772390921589*^9}, {
   3.524774159434065*^9, 3.5247741821040964`*^9}, {3.526945226804065*^9, 
   3.5269452323576756`*^9}, {3.530413508385212*^9, 3.530413508385212*^9}, {
   3.5319411411622305`*^9, 3.5319411411622305`*^9}, {3.5319412943077*^9, 
   3.5319412943077*^9}, {3.531941415098712*^9, 3.531941415098712*^9}, {
   3.531941547106144*^9, 3.531941547776945*^9}, {3.5319417707481365`*^9, 
   3.531941771746538*^9}, {3.5319419851613135`*^9, 3.5319419851613135`*^9}, {
   3.5319420546594353`*^9, 3.5319420546594353`*^9}, {3.531943749524412*^9, 
   3.531943749820813*^9}, {3.531945371147661*^9, 3.531945371147661*^9}, {
   3.5341190906435857`*^9, 3.5341191318936434`*^9}, {3.5341199134547377`*^9, 
   3.5341199250547543`*^9}, {3.5341202922652683`*^9, 
   3.5341202922652683`*^9}, {3.5498208700933943`*^9, 
   3.5498208700933943`*^9}, {3.549821171293816*^9, 3.549821171293816*^9}, {
   3.54982120282386*^9, 3.54982120282386*^9}, {3.549822071815077*^9, 
   3.549822071815077*^9}, {3.549823244226718*^9, 3.549823244226718*^9}, {
   3.6113556232768316`*^9, 3.6113556232768316`*^9}, {3.6379360252744646`*^9, 
   3.6379360252744646`*^9}, {3.6379367466056232`*^9, 
   3.6379367466056232`*^9}, {3.637938047252784*^9, 3.637938053482793*^9}, {
   3.6379598783074636`*^9, 3.6379598783074636`*^9}, {3.637970989775643*^9, 
   3.637970989775643*^9}, {3.644433152936343*^9, 3.644433152936343*^9}, 
   3.650160597958548*^9, {3.6501606717857704`*^9, 3.6501606742979145`*^9}, 
   3.698684023793454*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    RowBox[{"(", 
     RowBox[{"e", "+", 
      RowBox[{"f", " ", "x"}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{
     "x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{
        RowBox[{
         SuperscriptBox["b", "3"], " ", "c", " ", "e", " ", "g", " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "2"}], ")"}]}], "-", 
        RowBox[{
         SuperscriptBox["a", "3"], " ", "d", " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{"n", "+", "2"}], ")"}]}], "-", 
        RowBox[{
         SuperscriptBox["a", "2"], " ", "b", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"c", " ", "f", " ", "h", " ", "m"}], "-", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", " ", "g"}], "+", 
              RowBox[{"e", " ", "h"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]}], ")"}]}], "-", 
        RowBox[{"a", " ", 
         SuperscriptBox["b", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"c", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", " ", "g"}], "+", 
              RowBox[{"e", " ", "h"}]}], ")"}]}], "+", 
           RowBox[{"d", " ", "e", " ", "g", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "m"}], "+", "n", "+", "4"}], ")"}]}]}], 
          ")"}]}], "+", "\[IndentingNewLine]", "    ", 
        RowBox[{"b", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox["a", "2"], " ", "d", " ", "f", " ", "h", " ", 
            RowBox[{"(", 
             RowBox[{"m", "-", "n"}], ")"}]}], "-", 
           RowBox[{"a", " ", "b", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "c", " ", "f", " ", "h", " ", 
               RowBox[{"(", 
                RowBox[{"m", "+", "1"}], ")"}]}], "-", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", " ", "g"}], "+", 
                 RowBox[{"e", " ", "h"}]}], ")"}], " ", 
               RowBox[{"(", 
                RowBox[{"n", "+", "1"}], ")"}]}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"c", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", " ", "g"}], "+", 
                 RowBox[{"e", " ", "h"}]}], ")"}], " ", 
               RowBox[{"(", 
                RowBox[{"m", "+", "1"}], ")"}]}], "-", 
              RowBox[{"d", " ", "e", " ", "g", " ", 
               RowBox[{"(", 
                RowBox[{"m", "+", "n", "+", "2"}], ")"}]}]}], ")"}]}]}], 
          ")"}], " ", "x"}]}], 
       RowBox[{
        SuperscriptBox["b", "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "c"}], "-", 
           RowBox[{"a", " ", "d"}]}], ")"}], "2"], " ", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"m", "+", "2"}], ")"}]}]]}]}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], 
     RowBox[{"m", "+", "1"}]], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], 
     RowBox[{"n", "+", "1"}]]}]}], "+", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"f", " ", "h"}], 
      SuperscriptBox["b", "2"]], "-", 
     FractionBox[
      RowBox[{"d", " ", 
       RowBox[{"(", 
        RowBox[{"m", "+", "n", "+", "3"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox["a", "2"], " ", "d", " ", "f", " ", "h", " ", 
          RowBox[{"(", 
           RowBox[{"m", "-", "n"}], ")"}]}], "-", 
         RowBox[{"a", " ", "b", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "c", " ", "f", " ", "h", " ", 
             RowBox[{"(", 
              RowBox[{"m", "+", "1"}], ")"}]}], "-", 
            RowBox[{"d", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"f", " ", "g"}], "+", 
               RowBox[{"e", " ", "h"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{"n", "+", "1"}], ")"}]}]}], ")"}]}], "+", 
         RowBox[{
          SuperscriptBox["b", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"c", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"f", " ", "g"}], "+", 
               RowBox[{"e", " ", "h"}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{"m", "+", "1"}], ")"}]}], "-", 
            RowBox[{"d", " ", "e", " ", "g", " ", 
             RowBox[{"(", 
              RowBox[{"m", "+", "n", "+", "2"}], ")"}]}]}], ")"}]}]}], 
        ")"}]}], 
      RowBox[{
       SuperscriptBox["b", "2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "c"}], "-", 
          RowBox[{"a", " ", "d"}]}], ")"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{"m", "+", "1"}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"m", "+", "2"}], ")"}]}]]}], ")"}], 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"m", "+", "2"}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, 3.4958399855843487`*^9, 3.495840155344586*^9, 
   3.495840624735243*^9, {3.4958474296047697`*^9, 3.495847433754776*^9}, {
   3.4958476539050837`*^9, 3.495847660315093*^9}, {3.4958482220958796`*^9, 
   3.4958482231858807`*^9}, {3.495848257515929*^9, 3.4958482607459335`*^9}, 
   3.4959261390123196`*^9, 3.4959262745925093`*^9, 3.4959264909328117`*^9, 
   3.4959265843129425`*^9, 3.495926967463479*^9, {3.496184978535224*^9, 
   3.496185020185282*^9}, {3.4961873840085917`*^9, 3.496187409278627*^9}, {
   3.4961890232008867`*^9, 3.4961890250708895`*^9}, 3.4961956176127515`*^9, {
   3.4961956815728407`*^9, 3.496195696542862*^9}, {3.4961957791729774`*^9, 
   3.4961957920929956`*^9}, 3.496195845773071*^9, 3.518405474905692*^9, {
   3.51840566597596*^9, 3.5184056974360037`*^9}, {3.518405737026059*^9, 
   3.5184057718861084`*^9}, {3.5184058668262415`*^9, 3.518405869606245*^9}, {
   3.5184688792534475`*^9, 3.518468891673465*^9}, 3.5184689356235266`*^9, {
   3.5184691371938086`*^9, 3.5184691450938196`*^9}, {3.51846968832458*^9, 
   3.5184697035846014`*^9}, {3.518470060915102*^9, 3.518470082885133*^9}, {
   3.5184747044318423`*^9, 3.5184747207338715`*^9}, 3.518475002735566*^9, {
   3.5188842113796167`*^9, 3.518884228949641*^9}, {3.518890960739066*^9, 
   3.5188909798390923`*^9}, {3.520101172685255*^9, 3.520101193979293*^9}, 
   3.520101537866297*^9, {3.520101583012776*^9, 3.520101592138792*^9}, 
   3.5237473966912913`*^9, {3.523747635309311*^9, 3.523747662094558*^9}, 
   3.523747693201012*^9, {3.5237589154214087`*^9, 3.523758920041415*^9}, {
   3.523835091963359*^9, 3.523835095403364*^9}, 3.5247720424111013`*^9, {
   3.5247722402213783`*^9, 3.524772242541381*^9}, {3.5247723065014706`*^9, 
   3.524772310491476*^9}, {3.5247724101316156`*^9, 3.5247725806518545`*^9}, {
   3.5247726200519094`*^9, 3.5247727072220316`*^9}, {3.5247728848022804`*^9, 
   3.5247728894922867`*^9}, {3.5247737712335215`*^9, 
   3.5247738023335648`*^9}, {3.5279824084921894`*^9, 
   3.5279824453238535`*^9}, {3.5304116139925594`*^9, 
   3.5304117038726854`*^9}, {3.530411918742986*^9, 3.53041197123306*^9}, 
   3.531941036782448*^9, {3.5319411448594375`*^9, 3.5319411488686447`*^9}, {
   3.531941294947301*^9, 3.531941298394907*^9}, {3.5319414162219143`*^9, 
   3.5319414182655177`*^9}, {3.531941548510146*^9, 3.5319415504133496`*^9}, {
   3.5319417755685453`*^9, 3.5319417799833527`*^9}, {3.5319419862689157`*^9, 
   3.531941989685322*^9}, {3.531942055798238*^9, 3.5319420566406393`*^9}, {
   3.5319437006495266`*^9, 3.5319437038787327`*^9}, {3.5340026346818047`*^9, 
   3.534002637453963*^9}, {3.5340030209706793`*^9, 3.5340030293451586`*^9}, {
   3.534118784243157*^9, 3.5341188511132507`*^9}, {3.534119170853698*^9, 
   3.534119179923711*^9}, {3.534119497584155*^9, 3.5341195421742177`*^9}, {
   3.5498221970752525`*^9, 3.5498221995452557`*^9}, {3.611348176827039*^9, 
   3.61134819860707*^9}, {3.6113489579198065`*^9, 3.61134896037731*^9}, {
   3.63793554203277*^9, 3.6379355918848414`*^9}, {3.6379356258428917`*^9, 
   3.6379358643252325`*^9}, {3.637937535652889*^9, 3.6379375648399315`*^9}, 
   3.637937610196997*^9, {3.6379376404560404`*^9, 3.637937642837044*^9}, {
   3.6379378484063406`*^9, 3.637937885606394*^9}, 3.637955117172253*^9, {
   3.637955266638517*^9, 3.6379552741909304`*^9}, {3.637955498900527*^9, 
   3.637955547316331*^9}, 3.637955868108096*^9, {3.6379559067749643`*^9, 
   3.6379560664124455`*^9}, {3.6379565217775693`*^9, 3.637956524039573*^9}, {
   3.63795719781996*^9, 3.63795722615361*^9}, 3.637957355605961*^9, {
   3.637957410582458*^9, 3.637957472612167*^9}, {3.6379576419402657`*^9, 
   3.6379576574466925`*^9}, {3.6379580950096674`*^9, 3.63795811939251*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.520101787997136*^9, 3.5201017908831415`*^9}, 
   3.534119660884384*^9, 3.5341197024044423`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_."}], "*", 
     RowBox[{"(", 
      RowBox[{"e_", "+", 
       RowBox[{"f_.", "*", "x_"}]}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"b", "^", "3"}], "*", "c", "*", "e", "*", "g", "*", 
         RowBox[{"(", 
          RowBox[{"m", "+", "2"}], ")"}]}], "-", 
        RowBox[{
         RowBox[{"a", "^", "3"}], "*", "d", "*", "f", "*", "h", "*", 
         RowBox[{"(", 
          RowBox[{"n", "+", "2"}], ")"}]}], "-", 
        RowBox[{
         RowBox[{"a", "^", "2"}], "*", "b", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"c", "*", "f", "*", "h", "*", "m"}], "-", 
           RowBox[{"d", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "+", 
              RowBox[{"e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]}], ")"}]}], "-", 
        RowBox[{"a", "*", 
         RowBox[{"b", "^", "2"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"c", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "+", 
              RowBox[{"e", "*", "h"}]}], ")"}]}], "+", 
           RowBox[{"d", "*", "e", "*", "g", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "*", "m"}], "+", "n", "+", "4"}], ")"}]}]}], 
          ")"}]}], "+", "\n", "      ", 
        RowBox[{"b", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"a", "^", "2"}], "*", "d", "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{"m", "-", "n"}], ")"}]}], "-", 
           RowBox[{"a", "*", "b", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "*", "c", "*", "f", "*", "h", "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "1"}], ")"}]}], "-", 
              RowBox[{"d", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", "*", "g"}], "+", 
                 RowBox[{"e", "*", "h"}]}], ")"}], "*", 
               RowBox[{"(", 
                RowBox[{"n", "+", "1"}], ")"}]}]}], ")"}]}], "+", 
           RowBox[{
            RowBox[{"b", "^", "2"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"c", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", "*", "g"}], "+", 
                 RowBox[{"e", "*", "h"}]}], ")"}], "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "1"}], ")"}]}], "-", 
              RowBox[{"d", "*", "e", "*", "g", "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "n", "+", "2"}], ")"}]}]}], ")"}]}]}], 
          ")"}], "*", "x"}]}], ")"}], "/", "\n", "    ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "^", "2"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", "*", "c"}], "-", 
           RowBox[{"a", "*", "d"}]}], ")"}], "^", "2"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "2"}], ")"}]}], ")"}]}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}]}]}], " ", "+", " ", 
    "\[IndentingNewLine]", "  ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"f", "*", 
        RowBox[{"h", "/", 
         RowBox[{"b", "^", "2"}]}]}], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"d", "*", 
          RowBox[{"(", 
           RowBox[{"m", "+", "n", "+", "3"}], ")"}], "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"a", "^", "2"}], "*", "d", "*", "f", "*", "h", "*", 
             RowBox[{"(", 
              RowBox[{"m", "-", "n"}], ")"}]}], "-", 
            RowBox[{"a", "*", "b", "*", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", "*", "c", "*", "f", "*", "h", "*", 
                RowBox[{"(", 
                 RowBox[{"m", "+", "1"}], ")"}]}], "-", 
               RowBox[{"d", "*", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"f", "*", "g"}], "+", 
                  RowBox[{"e", "*", "h"}]}], ")"}], "*", 
                RowBox[{"(", 
                 RowBox[{"n", "+", "1"}], ")"}]}]}], ")"}]}], "+", 
            RowBox[{
             RowBox[{"b", "^", "2"}], "*", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"c", "*", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"f", "*", "g"}], "+", 
                  RowBox[{"e", "*", "h"}]}], ")"}], "*", 
                RowBox[{"(", 
                 RowBox[{"m", "+", "1"}], ")"}]}], "-", 
               RowBox[{"d", "*", "e", "*", "g", "*", 
                RowBox[{"(", 
                 RowBox[{"m", "+", "n", "+", "2"}], ")"}]}]}], ")"}]}]}], 
           ")"}]}], ")"}], "/", "\n", "      ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "^", "2"}], "*", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"b", "*", "c"}], "-", 
             RowBox[{"a", "*", "d"}]}], ")"}], "^", "2"}], "*", 
          RowBox[{"(", 
           RowBox[{"m", "+", "1"}], ")"}], "*", 
          RowBox[{"(", 
           RowBox[{"m", "+", "2"}], ")"}]}], ")"}]}]}], ")"}], "*", "\n", 
     "    ", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"m", "+", "2"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m", ",", "n"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"LtQ", "[", 
       RowBox[{"m", ",", 
        RowBox[{"-", "2"}]}], "]"}], " ", "||", " ", 
      RowBox[{
       RowBox[{"EqQ", "[", 
        RowBox[{
         RowBox[{"m", "+", "n", "+", "3"}], ",", "0"}], "]"}], " ", "&&", " ", 
       RowBox[{"Not", "[", 
        RowBox[{"LtQ", "[", 
         RowBox[{"n", ",", 
          RowBox[{"-", "2"}]}], "]"}], "]"}]}]}], ")"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495839738475589*^9, 3.4958405008250694`*^9, {3.495847490784856*^9, 
   3.4958474999948683`*^9}, {3.4958477172451725`*^9, 3.495847721615179*^9}, {
   3.495848224085882*^9, 3.4958482277058873`*^9}, {3.4958482626259365`*^9, 
   3.4958482686359444`*^9}, 3.4959261054722724`*^9, {3.4959262905725317`*^9, 
   3.4959262958725395`*^9}, 3.495926443222745*^9, 3.4961849395451694`*^9, 
   3.496185884976493*^9, 3.4961888731806765`*^9, {3.4961890260508904`*^9, 
   3.4961890290708947`*^9}, {3.496191957967628*^9, 3.4961919600576305`*^9}, 
   3.49619205250776*^9, 3.4961952203321953`*^9, {3.496195426482484*^9, 
   3.496195433172493*^9}, {3.496195586822708*^9, 3.496195595732721*^9}, 
   3.496195754542943*^9, 3.4966189754082823`*^9, {3.4966198797795486`*^9, 
   3.496619907439587*^9}, {3.4968579645422487`*^9, 3.4968579680210547`*^9}, 
   3.5171911044266214`*^9, 3.518211198418105*^9, 3.5182420941409807`*^9, {
   3.518281849687285*^9, 3.518281849874485*^9}, {3.5182861978669233`*^9, 
   3.518286207226939*^9}, 3.518286893072945*^9, 3.518287077449669*^9, {
   3.518405919376315*^9, 3.5184059327163334`*^9}, 3.518406000866429*^9, {
   3.5184061023365707`*^9, 3.518406115016588*^9}, {3.5184065135071464`*^9, 
   3.518406515547149*^9}, {3.518406800569559*^9, 3.5184068071395683`*^9}, {
   3.518455696848171*^9, 3.518455715349804*^9}, {3.518469305994045*^9, 
   3.518469310354051*^9}, {3.5184693414340944`*^9, 3.5184693641841264`*^9}, {
   3.518469461554263*^9, 3.518469497814314*^9}, {3.5184698199647646`*^9, 
   3.5184698496348057`*^9}, {3.5184698834448533`*^9, 3.5184698844848547`*^9}, 
   3.5184701704452553`*^9, {3.518470248195364*^9, 3.518470287395419*^9}, {
   3.51847032361547*^9, 3.518470324325471*^9}, {3.518474812134432*^9, 
   3.5184748359088736`*^9}, {3.5184748784969482`*^9, 3.51847487927695*^9}, 
   3.518475395747057*^9, {3.5184754745583954`*^9, 3.518475478770403*^9}, {
   3.5184759352008047`*^9, 3.518475938726411*^9}, {3.5184760887674747`*^9, 
   3.5184761024174986`*^9}, {3.518476247310553*^9, 3.5184762483245544`*^9}, {
   3.518476459611326*^9, 3.518476460235327*^9}, {3.5185837600757217`*^9, 
   3.518583760356522*^9}, {3.5188842541996765`*^9, 3.5188842747997055`*^9}, {
   3.518890955169058*^9, 3.5188909696490784`*^9}, {3.5188914772697887`*^9, 
   3.518891482339796*^9}, {3.520102006257119*^9, 3.5201020069591208`*^9}, 
   3.5201020756928415`*^9, {3.5202847653043165`*^9, 3.520284765308317*^9}, {
   3.5202851424268866`*^9, 3.520285144721018*^9}, {3.520899838877209*^9, 
   3.5208998429572153`*^9}, {3.521131441309245*^9, 3.521131443849249*^9}, 
   3.521148390206671*^9, {3.5223485088319473`*^9, 3.5223485168319583`*^9}, {
   3.5224420691492205`*^9, 3.522442069414421*^9}, 3.5237568920485764`*^9, 
   3.523757219519035*^9, 3.523757259739091*^9, {3.5237580436701884`*^9, 
   3.523758059720211*^9}, {3.523758936761439*^9, 3.523758939721443*^9}, 
   3.523810558420226*^9, 3.523818931362772*^9, {3.523835156403449*^9, 
   3.5238351582934523`*^9}, 3.5247721246012163`*^9, {3.5247739098537154`*^9, 
   3.5247740062738504`*^9}, {3.524774046163906*^9, 3.524774061003927*^9}, {
   3.5269452650085325`*^9, 3.526945270312542*^9}, {3.527188364001113*^9, 
   3.5271883677139196`*^9}, {3.5271888173223095`*^9, 3.527188823843121*^9}, {
   3.5271899878391657`*^9, 3.5271900376656528`*^9}, {3.527190166287879*^9, 
   3.5271901716698885`*^9}, {3.527190278608076*^9, 3.5271902902768965`*^9}, {
   3.527982424123417*^9, 3.5279824278986235`*^9}, {3.5279825248995934`*^9, 
   3.5279825340568094`*^9}, {3.5304120848332186`*^9, 3.530412106123248*^9}, {
   3.5304130055745077`*^9, 3.530413008634512*^9}, {3.530413043314561*^9, 
   3.530413055224577*^9}, {3.530413087314622*^9, 3.5304130884346237`*^9}, {
   3.5304131472647057`*^9, 3.5304131483447075`*^9}, 3.53046311973864*^9, {
   3.5304888886920757`*^9, 3.530488894767084*^9}, {3.531941152706251*^9, 
   3.531941162830669*^9}, {3.531941299455709*^9, 3.531941306974922*^9}, {
   3.5319414191859193`*^9, 3.5319414225243254`*^9}, {3.531941554079356*^9, 
   3.531941559040165*^9}, {3.531941786394964*^9, 3.531941805174197*^9}, {
   3.5319419942717295`*^9, 3.531941998764538*^9}, {3.5319420576234407`*^9, 
   3.531942059916645*^9}, {3.531943420348234*^9, 3.5319434261514444`*^9}, {
   3.5319437080127397`*^9, 3.53194372535997*^9}, {3.531943778727664*^9, 
   3.531943779960066*^9}, {3.5319453490892224`*^9, 3.5319453522092276`*^9}, {
   3.5339415241170616`*^9, 3.533941538197081*^9}, {3.5339415789871387`*^9, 
   3.533941604107174*^9}, {3.5339512902895765`*^9, 3.5339512946731844`*^9}, 
   3.533951351067283*^9, {3.5340027757635803`*^9, 3.534002812286766*^9}, {
   3.5341190049334655`*^9, 3.5341190294735003`*^9}, {3.5341191883437223`*^9, 
   3.534119195643733*^9}, {3.5341193695439763`*^9, 3.53411941511404*^9}, 
   3.5341196611243844`*^9, {3.5341196955644326`*^9, 3.5341197132044573`*^9}, {
   3.53411976495453*^9, 3.5341197859645596`*^9}, {3.5341198161046014`*^9, 
   3.5341198333046255`*^9}, 3.5341199475947857`*^9, 3.5341203626853666`*^9, {
   3.5345320463388095`*^9, 3.5345320520621367`*^9}, {3.5400017308272676`*^9, 
   3.540001736107275*^9}, {3.542249989006481*^9, 3.5422499957078643`*^9}, {
   3.542250036073081*^9, 3.542250039670287*^9}, 3.5498209379134893`*^9, 
   3.5498210856636963`*^9, 3.549821116193739*^9, 3.5498220886751003`*^9, {
   3.5498222071852665`*^9, 3.54982220976527*^9}, 3.5498232774067645`*^9, {
   3.6113482525721474`*^9, 3.611348275997181*^9}, {3.611348965777318*^9, 
   3.611348970487325*^9}, 3.6113556452168617`*^9, 3.611383619514218*^9, {
   3.637936083407548*^9, 3.637936110206587*^9}, 3.637936274310949*^9, {
   3.6379363084159966`*^9, 3.637936320439014*^9}, {3.6379363628310733`*^9, 
   3.637936404716133*^9}, 3.6379364350531764`*^9, {3.6379364697612257`*^9, 
   3.637936471099228*^9}, {3.637937776010236*^9, 3.6379378355253215`*^9}, {
   3.637937910986431*^9, 3.637937922436447*^9}, {3.637938068086815*^9, 
   3.6379380952038536`*^9}, {3.6379562370187464`*^9, 
   3.6379563212376947`*^9}, {3.637956406909446*^9, 3.6379564217093897`*^9}, {
   3.6379564588002586`*^9, 3.6379564777542915`*^9}, {3.6379565591084347`*^9, 
   3.6379565603408365`*^9}, {3.63795659060489*^9, 3.6379566159705343`*^9}, {
   3.637959867855445*^9, 3.6379598870902786`*^9}, 3.637960321334961*^9, {
   3.637969757689172*^9, 3.6379697729990473`*^9}, {3.637970949200322*^9, 
   3.6379709596429195`*^9}, {3.63797663550356*^9, 3.6379766407558603`*^9}, {
   3.637977531391802*^9, 3.6379775411083574`*^9}, {3.6379819999593897`*^9, 
   3.637982013478163*^9}, 3.6444331655730658`*^9, {3.706112960431878*^9, 
   3.706112978280899*^9}, {3.7077030714033604`*^9, 3.707703087410989*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["2:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], " ", Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"-", "2"}], "\[LessEqual]", "m", "<", 
       RowBox[{"-", "1"}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.5192504337891226`*^9, 3.5192504707812386`*^9}, 3.5192506717957726`*^9, {
   3.519250720795459*^9, 3.5192507409818945`*^9}, 3.519258420209427*^9, 
   3.519258489779525*^9, {3.519320786305674*^9, 3.519320803294104*^9}, {
   3.519329422708468*^9, 3.5193294257984724`*^9}, 3.5193294706485353`*^9, {
   3.5193302883925123`*^9, 3.519330307237345*^9}, {3.5193303440378103`*^9, 
   3.5193303650666466`*^9}, 3.5193341918281684`*^9, {3.5193346196121197`*^9, 
   3.519334632840943*^9}, {3.519341922663512*^9, 3.5193419232095127`*^9}, 
   3.5193423494490614`*^9, {3.5193456600396833`*^9, 3.519345660273684*^9}, 
   3.519410696547495*^9, {3.519793559756592*^9, 3.5197935600217924`*^9}, {
   3.5210541942272606`*^9, 3.5210542323693275`*^9}, {3.521054705798959*^9, 
   3.5210547345342093`*^9}, {3.521055431683834*^9, 3.5210554455522585`*^9}, {
   3.5210554827427235`*^9, 3.5210555031319594`*^9}, {3.521056059772137*^9, 
   3.521056075652965*^9}, {3.521057417664521*^9, 3.521057417867322*^9}, {
   3.5210574854778404`*^9, 3.5210574857586412`*^9}, {3.5210575212175035`*^9, 
   3.521057540483537*^9}, {3.5210598942936716`*^9, 3.5210599092384977`*^9}, {
   3.521063276214819*^9, 3.521063298928458*^9}, {3.5210639991824884`*^9, 
   3.5210640343449497`*^9}, {3.5210641665551825`*^9, 
   3.5210641665551825`*^9}, {3.521072868148899*^9, 3.521072868148899*^9}, {
   3.5210824253375397`*^9, 3.5210824255559406`*^9}, {3.5211479965711794`*^9, 
   3.521148020673222*^9}, {3.5211480693453074`*^9, 3.5211480699537086`*^9}, {
   3.521148148187846*^9, 3.5211481489366474`*^9}, {3.5211482363436007`*^9, 
   3.5211482363436007`*^9}, {3.521148269556059*^9, 3.521148269556059*^9}, {
   3.521346368187188*^9, 3.521346368421189*^9}, {3.5214702809911447`*^9, 
   3.5214702811783447`*^9}, {3.5216579052539043`*^9, 3.521657905453904*^9}, {
   3.5223485259619713`*^9, 3.522348534381983*^9}, {3.5233208394702005`*^9, 
   3.5233208394702005`*^9}, {3.523320922845537*^9, 3.523320922845537*^9}, 
   3.523747250675035*^9, {3.5237670269856477`*^9, 3.5237670269856477`*^9}, {
   3.523831184179017*^9, 3.523831184179017*^9}, 3.5247720382710953`*^9, {
   3.524772397491598*^9, 3.524772397491598*^9}, {3.524774194324114*^9, 
   3.524774228794162*^9}, {3.526945238644486*^9, 3.526945238644486*^9}, {
   3.5279098167721815`*^9, 3.5279098172421827`*^9}, {3.5296282016140704`*^9, 
   3.5296282019130874`*^9}, 3.530384384323295*^9, {3.5303845765632906`*^9, 
   3.530384576766302*^9}, {3.530412765574172*^9, 3.530412765724172*^9}, {
   3.5304133134449387`*^9, 3.530413327614959*^9}, {3.5304133632650084`*^9, 
   3.5304133653750114`*^9}, {3.5304685359612284`*^9, 
   3.5304685362112293`*^9}, {3.5306637757276535`*^9, 3.530663775992854*^9}, 
   3.531940972073534*^9, {3.531941135920622*^9, 3.531941136887823*^9}, {
   3.531941292685297*^9, 3.5319412934028983`*^9}, {3.531941412696308*^9, 
   3.53194141378831*^9}, {3.531941540834933*^9, 3.531941542176535*^9}, {
   3.531941747348096*^9, 3.5319417604365187`*^9}, {3.5319419776265*^9, 
   3.531941978453302*^9}, {3.5319420524598317`*^9, 3.5319420537078342`*^9}, {
   3.5319437460612063`*^9, 3.5319437460612063`*^9}, {3.531945368214856*^9, 
   3.531945368214856*^9}, {3.5339235218280125`*^9, 3.533923522848014*^9}, {
   3.5340030836026883`*^9, 3.534003084035713*^9}, 3.534118752423112*^9, {
   3.5341190488235273`*^9, 3.534119049053528*^9}, {3.534119148303666*^9, 
   3.534119148303666*^9}, {3.534119453664094*^9, 3.5341194538540945`*^9}, {
   3.534119930854762*^9, 3.534119930854762*^9}, {3.53412041503544*^9, 
   3.53412041503544*^9}, {3.5498208478733635`*^9, 3.5498208478733635`*^9}, {
   3.549821170423815*^9, 3.549821170423815*^9}, {3.5498212022838593`*^9, 
   3.5498212022838593`*^9}, {3.5498220687050724`*^9, 
   3.5498220687050724`*^9}, {3.5498232312167*^9, 3.5498232312167*^9}, {
   3.5498234766870437`*^9, 3.5498234777570453`*^9}, {3.54985254227013*^9, 
   3.5498525425001297`*^9}, 3.5717051188897867`*^9, 3.5758229263769093`*^9, {
   3.6113489510122957`*^9, 3.6113489537697997`*^9}, {3.6113491101575394`*^9, 
   3.6113491196025534`*^9}, {3.6113491544876075`*^9, 
   3.6113491546901073`*^9}, {3.6113492430927434`*^9, 
   3.6113492640427756`*^9}, {3.6113556049368057`*^9, 
   3.6113556049368057`*^9}, {3.6379354926806993`*^9, 3.637935501570712*^9}, {
   3.637935984384406*^9, 3.637936011086444*^9}, {3.637936713196576*^9, 
   3.6379367381516113`*^9}, {3.6379380597968035`*^9, 
   3.6379380597968035`*^9}, {3.637955093083811*^9, 3.6379550934914117`*^9}, {
   3.63795638639141*^9, 3.6379563872962112`*^9}, {3.637956670791031*^9, 
   3.63795667595464*^9}, {3.637956707564296*^9, 3.6379567102943006`*^9}, {
   3.6379567450999618`*^9, 3.6379567527771754`*^9}, {3.637957721680006*^9, 
   3.63795772409801*^9}, {3.6379580063083076`*^9, 3.637958008071111*^9}, {
   3.6379582096592693`*^9, 3.637958217833683*^9}, {3.6379708823304977`*^9, 
   3.637970882540509*^9}, {3.6379710278478203`*^9, 3.6379710278478203`*^9}, {
   3.637976726489764*^9, 3.6379767266327724`*^9}, {3.63798141042267*^9, 
   3.63798141060468*^9}, {3.6444331829660606`*^9, 3.6444331829660606`*^9}, 
   3.648953058619501*^9, 3.6489561109690857`*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: ???", "Subsubsection",
 CellChangeTimes->{
  3.496441803031353*^9, 3.4965396318089237`*^9, {3.4966002562016735`*^9, 
   3.4966002624716825`*^9}, 3.496600707442305*^9, 3.4966008475725017`*^9, {
   3.4966070255131593`*^9, 3.496607032413169*^9}, 3.518279406700592*^9, {
   3.51840552316576*^9, 3.5184055392257824`*^9}, 3.5184690414436746`*^9, 
   3.518469651844529*^9, 3.5184700043450227`*^9, 3.518474659316563*^9, 
   3.5237473322319784`*^9, 3.5247722814214354`*^9, {3.5260660236439*^9, 
   3.526066024233901*^9}, {3.530413463335149*^9, 3.5304134989751987`*^9}, {
   3.5339258909313297`*^9, 3.533925894241334*^9}, {3.5341187688231354`*^9, 
   3.534118769443136*^9}, {3.534119456044097*^9, 3.5341194563640976`*^9}, 
   3.6113471326280394`*^9, {3.6379360318244734`*^9, 3.6379360322144737`*^9}}],

Cell[TextData[{
 "Rule 1.1.1.4",
 ".1.1.3.2.2: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"-", "2"}], "\[LessEqual]", "m", "<", 
   RowBox[{"-", "1"}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.4964417379912624`*^9, 3.4964417471112747`*^9}, {
   3.496441910111503*^9, 3.4964419275315275`*^9}, 3.496451213764926*^9, {
   3.496539487018721*^9, 3.4965395223187704`*^9}, {3.4966001213614845`*^9, 
   3.4966001362815056`*^9}, {3.4966047635399923`*^9, 
   3.4966048329500895`*^9}, {3.496604896730179*^9, 3.496605019710351*^9}, {
   3.496605050490394*^9, 3.4966050527103972`*^9}, {3.4966066606926484`*^9, 
   3.496606694832696*^9}, 3.496606873362946*^9, {3.4966081836347804`*^9, 
   3.496608250534874*^9}, {3.496608418375109*^9, 3.496608441025141*^9}, {
   3.4966322809467688`*^9, 3.4966322818867702`*^9}, {3.4968592460220995`*^9, 
   3.4968592640557313`*^9}, {3.4968593076422076`*^9, 
   3.4968593113862143`*^9}, {3.496859384233942*^9, 3.496859384233942*^9}, {
   3.518223900967896*^9, 3.518223909467908*^9}, 3.5182817155426493`*^9, {
   3.518285874431555*^9, 3.518285899625599*^9}, {3.5182860969191456`*^9, 
   3.518286138321618*^9}, {3.518286898517355*^9, 3.518286898517355*^9}, {
   3.5182870794776726`*^9, 3.5182870794776726`*^9}, {3.518469568024412*^9, 
   3.518469584774435*^9}, {3.518469921924907*^9, 3.5184699227449083`*^9}, {
   3.51847035958552*^9, 3.518470374475541*^9}, {3.518474847889694*^9, 
   3.518474854394906*^9}, {3.518475351645779*^9, 3.51847535181738*^9}, {
   3.518476861483632*^9, 3.5184768701416473`*^9}, {3.5184769318709555`*^9, 
   3.518476937876966*^9}, {3.5185837532117095`*^9, 3.51858375372651*^9}, {
   3.5211482838768845`*^9, 3.5211482838768845`*^9}, {3.5223485487820034`*^9, 
   3.5223485487820034`*^9}, {3.5237580782402368`*^9, 
   3.5237580830402436`*^9}, {3.524772390921589*^9, 3.524772390921589*^9}, {
   3.524774159434065*^9, 3.5247741821040964`*^9}, {3.526945226804065*^9, 
   3.5269452323576756`*^9}, {3.530413508385212*^9, 3.530413508385212*^9}, {
   3.5319411411622305`*^9, 3.5319411411622305`*^9}, {3.5319412943077*^9, 
   3.5319412943077*^9}, {3.531941415098712*^9, 3.531941415098712*^9}, {
   3.531941547106144*^9, 3.531941547776945*^9}, {3.5319417707481365`*^9, 
   3.531941771746538*^9}, {3.5319419851613135`*^9, 3.5319419851613135`*^9}, {
   3.5319420546594353`*^9, 3.5319420546594353`*^9}, {3.531943749524412*^9, 
   3.531943749820813*^9}, {3.531945371147661*^9, 3.531945371147661*^9}, {
   3.5341190906435857`*^9, 3.5341191318936434`*^9}, {3.5341199134547377`*^9, 
   3.5341199250547543`*^9}, {3.5341202922652683`*^9, 
   3.5341202922652683`*^9}, {3.5498208700933943`*^9, 
   3.5498208700933943`*^9}, {3.549821171293816*^9, 3.549821171293816*^9}, {
   3.54982120282386*^9, 3.54982120282386*^9}, {3.549822071815077*^9, 
   3.549822071815077*^9}, {3.549823244226718*^9, 3.549823244226718*^9}, {
   3.6113556232768316`*^9, 3.6113556232768316`*^9}, {3.6379360252744646`*^9, 
   3.6379360252744646`*^9}, {3.6379367466056232`*^9, 
   3.6379367466056232`*^9}, {3.637938047252784*^9, 3.637938053482793*^9}, {
   3.6379577579696703`*^9, 3.6379577579696703`*^9}, {3.637959828010975*^9, 
   3.637959828010975*^9}, {3.637971030866993*^9, 3.6379710308679934`*^9}, {
   3.64443318802335*^9, 3.644433188530379*^9}, 3.650160598553582*^9, {
   3.6501606951051044`*^9, 3.650160697947267*^9}, 3.6986840238734546`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    RowBox[{"(", 
     RowBox[{"e", "+", 
      RowBox[{"f", " ", "x"}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{
     "x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{
        RowBox[{
         SuperscriptBox["a", "2"], " ", "d", " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{"n", "+", "2"}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["b", "2"], " ", "d", " ", "e", " ", "g", " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "3"}], ")"}]}], "+", 
        RowBox[{"a", " ", "b", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"c", " ", "f", " ", "h", " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "-", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", " ", "g"}], "+", 
              RowBox[{"e", " ", "h"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{"b", " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "c"}], "-", 
           RowBox[{"a", " ", "d"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}], " ", "x"}]}], 
       RowBox[{
        SuperscriptBox["b", "2"], " ", "d", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "c"}], "-", 
          RowBox[{"a", " ", "d"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]]}]}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], 
     RowBox[{"m", "+", "1"}]], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], 
     RowBox[{"n", "+", "1"}]]}]}], "-", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{
      SuperscriptBox["a", "2"], " ", 
      SuperscriptBox["d", "2"], " ", "f", " ", "h", " ", 
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"n", "+", "2"}], ")"}]}], "+", 
     RowBox[{"a", " ", "b", " ", "d", " ", 
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "c", " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "-", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", " ", "g"}], "+", 
           RowBox[{"e", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]}], ")"}]}], "+", 
     "\[IndentingNewLine]", "    ", 
     RowBox[{
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["c", "2"], " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "2"}], ")"}]}], "-", 
        RowBox[{"c", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", " ", "g"}], "+", 
           RowBox[{"e", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "3"}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["d", "2"], " ", "e", " ", "g", " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "2"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]}], ")"}]}]}], 
    RowBox[{
     SuperscriptBox["b", "2"], " ", "d", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", " ", "c"}], "-", 
       RowBox[{"a", " ", "d"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"m", "+", "1"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]], 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"m", "+", "1"}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, 3.4958399855843487`*^9, 3.495840155344586*^9, 
   3.495840624735243*^9, {3.4958474296047697`*^9, 3.495847433754776*^9}, {
   3.4958476539050837`*^9, 3.495847660315093*^9}, {3.4958482220958796`*^9, 
   3.4958482231858807`*^9}, {3.495848257515929*^9, 3.4958482607459335`*^9}, 
   3.4959261390123196`*^9, 3.4959262745925093`*^9, 3.4959264909328117`*^9, 
   3.4959265843129425`*^9, 3.495926967463479*^9, {3.496184978535224*^9, 
   3.496185020185282*^9}, {3.4961873840085917`*^9, 3.496187409278627*^9}, {
   3.4961890232008867`*^9, 3.4961890250708895`*^9}, 3.4961956176127515`*^9, {
   3.4961956815728407`*^9, 3.496195696542862*^9}, {3.4961957791729774`*^9, 
   3.4961957920929956`*^9}, 3.496195845773071*^9, 3.518405474905692*^9, {
   3.51840566597596*^9, 3.5184056974360037`*^9}, {3.518405737026059*^9, 
   3.5184057718861084`*^9}, {3.5184058668262415`*^9, 3.518405869606245*^9}, {
   3.5184688792534475`*^9, 3.518468891673465*^9}, 3.5184689356235266`*^9, {
   3.5184691371938086`*^9, 3.5184691450938196`*^9}, {3.51846968832458*^9, 
   3.5184697035846014`*^9}, {3.518470060915102*^9, 3.518470082885133*^9}, {
   3.5184747044318423`*^9, 3.5184747207338715`*^9}, 3.518475002735566*^9, {
   3.5188842113796167`*^9, 3.518884228949641*^9}, {3.518890960739066*^9, 
   3.5188909798390923`*^9}, {3.520101172685255*^9, 3.520101193979293*^9}, 
   3.520101537866297*^9, {3.520101583012776*^9, 3.520101592138792*^9}, 
   3.5237473966912913`*^9, {3.523747635309311*^9, 3.523747662094558*^9}, 
   3.523747693201012*^9, {3.5237589154214087`*^9, 3.523758920041415*^9}, {
   3.523835091963359*^9, 3.523835095403364*^9}, 3.5247720424111013`*^9, {
   3.5247722402213783`*^9, 3.524772242541381*^9}, {3.5247723065014706`*^9, 
   3.524772310491476*^9}, {3.5247724101316156`*^9, 3.5247725806518545`*^9}, {
   3.5247726200519094`*^9, 3.5247727072220316`*^9}, {3.5247728848022804`*^9, 
   3.5247728894922867`*^9}, {3.5247737712335215`*^9, 
   3.5247738023335648`*^9}, {3.5279824084921894`*^9, 
   3.5279824453238535`*^9}, {3.5304116139925594`*^9, 
   3.5304117038726854`*^9}, {3.530411918742986*^9, 3.53041197123306*^9}, 
   3.531941036782448*^9, {3.5319411448594375`*^9, 3.5319411488686447`*^9}, {
   3.531941294947301*^9, 3.531941298394907*^9}, {3.5319414162219143`*^9, 
   3.5319414182655177`*^9}, {3.531941548510146*^9, 3.5319415504133496`*^9}, {
   3.5319417755685453`*^9, 3.5319417799833527`*^9}, {3.5319419862689157`*^9, 
   3.531941989685322*^9}, {3.531942055798238*^9, 3.5319420566406393`*^9}, {
   3.5319437006495266`*^9, 3.5319437038787327`*^9}, {3.5340026346818047`*^9, 
   3.534002637453963*^9}, {3.5340030209706793`*^9, 3.5340030293451586`*^9}, {
   3.534118784243157*^9, 3.5341188511132507`*^9}, {3.534119170853698*^9, 
   3.534119179923711*^9}, {3.534119497584155*^9, 3.5341195421742177`*^9}, {
   3.5498221970752525`*^9, 3.5498221995452557`*^9}, {3.611348176827039*^9, 
   3.61134819860707*^9}, {3.6113489579198065`*^9, 3.61134896037731*^9}, {
   3.63793554203277*^9, 3.6379355918848414`*^9}, {3.6379356258428917`*^9, 
   3.6379358643252325`*^9}, {3.637937535652889*^9, 3.6379375648399315`*^9}, 
   3.637937610196997*^9, {3.6379376404560404`*^9, 3.637937642837044*^9}, {
   3.6379378484063406`*^9, 3.637937885606394*^9}, 3.637955117172253*^9, {
   3.637955266638517*^9, 3.6379552741909304`*^9}, {3.637955498900527*^9, 
   3.637955547316331*^9}, 3.637955868108096*^9, {3.6379559067749643`*^9, 
   3.6379560664124455`*^9}, {3.6379565217775693`*^9, 3.637956524039573*^9}, {
   3.63795719781996*^9, 3.63795722615361*^9}, 3.637957355605961*^9, {
   3.637957410582458*^9, 3.637957472612167*^9}, {3.637957800813346*^9, 
   3.63795783704161*^9}, {3.6379578842814927`*^9, 3.637957921912759*^9}, {
   3.637970083271794*^9, 3.6379702941858573`*^9}, {3.6379704504387946`*^9, 
   3.6379704526239195`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.520101787997136*^9, 3.5201017908831415`*^9}, 
   3.534119660884384*^9, 3.5341197024044423`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_."}], "*", 
     RowBox[{"(", 
      RowBox[{"e_", "+", 
       RowBox[{"f_.", "*", "x_"}]}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"a", "^", "2"}], "*", "d", "*", "f", "*", "h", "*", 
         RowBox[{"(", 
          RowBox[{"n", "+", "2"}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"b", "^", "2"}], "*", "d", "*", "e", "*", "g", "*", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "3"}], ")"}]}], "+", 
        RowBox[{"a", "*", "b", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"c", "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "-", 
           RowBox[{"d", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "+", 
              RowBox[{"e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{"b", "*", "f", "*", "h", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", "*", "c"}], "-", 
           RowBox[{"a", "*", "d"}]}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}], "*", "x"}]}], ")"}], "/", 
      "\[IndentingNewLine]", "    ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "^", "2"}], "*", "d", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "c"}], "-", 
          RowBox[{"a", "*", "d"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "n", "+", "3"}], ")"}]}], ")"}]}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}]}]}], " ", "-", " ", "\n", "  ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"a", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "f", "*", "h", "*", 
         RowBox[{"(", 
          RowBox[{"n", "+", "1"}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{"n", "+", "2"}], ")"}]}], "+", 
        RowBox[{"a", "*", "b", "*", "d", "*", 
         RowBox[{"(", 
          RowBox[{"n", "+", "1"}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "*", "c", "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "-", 
           RowBox[{"d", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "+", 
              RowBox[{"e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]}], ")"}]}], "+", "\n",
         "      ", 
        RowBox[{
         RowBox[{"b", "^", "2"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"c", "^", "2"}], "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "2"}], ")"}]}], "-", 
           RowBox[{"c", "*", "d", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "+", 
              RowBox[{"e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "3"}], ")"}]}], "+", 
           RowBox[{
            RowBox[{"d", "^", "2"}], "*", "e", "*", "g", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "2"}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]}], ")"}]}]}], ")"}], 
      "/", "\n", "    ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "^", "2"}], "*", "d", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "c"}], "-", 
          RowBox[{"a", "*", "d"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "n", "+", "3"}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m", ",", "n"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"GeQ", "[", 
        RowBox[{"m", ",", 
         RowBox[{"-", "2"}]}], "]"}], " ", "&&", " ", 
       RowBox[{"LtQ", "[", 
        RowBox[{"m", ",", 
         RowBox[{"-", "1"}]}], "]"}]}], " ", "||", " ", 
      RowBox[{"SumSimplerQ", "[", 
       RowBox[{"m", ",", "1"}], "]"}]}], ")"}], " ", "&&", " ", 
    RowBox[{"NeQ", "[", 
     RowBox[{"m", ",", 
      RowBox[{"-", "1"}]}], "]"}], " ", "&&", " ", 
    RowBox[{"NeQ", "[", 
     RowBox[{
      RowBox[{"m", "+", "n", "+", "3"}], ",", "0"}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495839738475589*^9, 3.4958405008250694`*^9, {3.495847490784856*^9, 
   3.4958474999948683`*^9}, {3.4958477172451725`*^9, 3.495847721615179*^9}, {
   3.495848224085882*^9, 3.4958482277058873`*^9}, {3.4958482626259365`*^9, 
   3.4958482686359444`*^9}, 3.4959261054722724`*^9, {3.4959262905725317`*^9, 
   3.4959262958725395`*^9}, 3.495926443222745*^9, 3.4961849395451694`*^9, 
   3.496185884976493*^9, 3.4961888731806765`*^9, {3.4961890260508904`*^9, 
   3.4961890290708947`*^9}, {3.496191957967628*^9, 3.4961919600576305`*^9}, 
   3.49619205250776*^9, 3.4961952203321953`*^9, {3.496195426482484*^9, 
   3.496195433172493*^9}, {3.496195586822708*^9, 3.496195595732721*^9}, 
   3.496195754542943*^9, 3.4966189754082823`*^9, {3.4966198797795486`*^9, 
   3.496619907439587*^9}, {3.4968579645422487`*^9, 3.4968579680210547`*^9}, 
   3.5171911044266214`*^9, 3.518211198418105*^9, 3.5182420941409807`*^9, {
   3.518281849687285*^9, 3.518281849874485*^9}, {3.5182861978669233`*^9, 
   3.518286207226939*^9}, 3.518286893072945*^9, 3.518287077449669*^9, {
   3.518405919376315*^9, 3.5184059327163334`*^9}, 3.518406000866429*^9, {
   3.5184061023365707`*^9, 3.518406115016588*^9}, {3.5184065135071464`*^9, 
   3.518406515547149*^9}, {3.518406800569559*^9, 3.5184068071395683`*^9}, {
   3.518455696848171*^9, 3.518455715349804*^9}, {3.518469305994045*^9, 
   3.518469310354051*^9}, {3.5184693414340944`*^9, 3.5184693641841264`*^9}, {
   3.518469461554263*^9, 3.518469497814314*^9}, {3.5184698199647646`*^9, 
   3.5184698496348057`*^9}, {3.5184698834448533`*^9, 3.5184698844848547`*^9}, 
   3.5184701704452553`*^9, {3.518470248195364*^9, 3.518470287395419*^9}, {
   3.51847032361547*^9, 3.518470324325471*^9}, {3.518474812134432*^9, 
   3.5184748359088736`*^9}, {3.5184748784969482`*^9, 3.51847487927695*^9}, 
   3.518475395747057*^9, {3.5184754745583954`*^9, 3.518475478770403*^9}, {
   3.5184759352008047`*^9, 3.518475938726411*^9}, {3.5184760887674747`*^9, 
   3.5184761024174986`*^9}, {3.518476247310553*^9, 3.5184762483245544`*^9}, {
   3.518476459611326*^9, 3.518476460235327*^9}, {3.5185837600757217`*^9, 
   3.518583760356522*^9}, {3.5188842541996765`*^9, 3.5188842747997055`*^9}, {
   3.518890955169058*^9, 3.5188909696490784`*^9}, {3.5188914772697887`*^9, 
   3.518891482339796*^9}, {3.520102006257119*^9, 3.5201020069591208`*^9}, 
   3.5201020756928415`*^9, {3.5202847653043165`*^9, 3.520284765308317*^9}, {
   3.5202851424268866`*^9, 3.520285144721018*^9}, {3.520899838877209*^9, 
   3.5208998429572153`*^9}, {3.521131441309245*^9, 3.521131443849249*^9}, 
   3.521148390206671*^9, {3.5223485088319473`*^9, 3.5223485168319583`*^9}, {
   3.5224420691492205`*^9, 3.522442069414421*^9}, 3.5237568920485764`*^9, 
   3.523757219519035*^9, 3.523757259739091*^9, {3.5237580436701884`*^9, 
   3.523758059720211*^9}, {3.523758936761439*^9, 3.523758939721443*^9}, 
   3.523810558420226*^9, 3.523818931362772*^9, {3.523835156403449*^9, 
   3.5238351582934523`*^9}, 3.5247721246012163`*^9, {3.5247739098537154`*^9, 
   3.5247740062738504`*^9}, {3.524774046163906*^9, 3.524774061003927*^9}, {
   3.5269452650085325`*^9, 3.526945270312542*^9}, {3.527188364001113*^9, 
   3.5271883677139196`*^9}, {3.5271888173223095`*^9, 3.527188823843121*^9}, {
   3.5271899878391657`*^9, 3.5271900376656528`*^9}, {3.527190166287879*^9, 
   3.5271901716698885`*^9}, {3.527190278608076*^9, 3.5271902902768965`*^9}, {
   3.527982424123417*^9, 3.5279824278986235`*^9}, {3.5279825248995934`*^9, 
   3.5279825340568094`*^9}, {3.5304120848332186`*^9, 3.530412106123248*^9}, {
   3.5304130055745077`*^9, 3.530413008634512*^9}, {3.530413043314561*^9, 
   3.530413055224577*^9}, {3.530413087314622*^9, 3.5304130884346237`*^9}, {
   3.5304131472647057`*^9, 3.5304131483447075`*^9}, 3.53046311973864*^9, {
   3.5304888886920757`*^9, 3.530488894767084*^9}, {3.531941152706251*^9, 
   3.531941162830669*^9}, {3.531941299455709*^9, 3.531941306974922*^9}, {
   3.5319414191859193`*^9, 3.5319414225243254`*^9}, {3.531941554079356*^9, 
   3.531941559040165*^9}, {3.531941786394964*^9, 3.531941805174197*^9}, {
   3.5319419942717295`*^9, 3.531941998764538*^9}, {3.5319420576234407`*^9, 
   3.531942059916645*^9}, {3.531943420348234*^9, 3.5319434261514444`*^9}, {
   3.5319437080127397`*^9, 3.53194372535997*^9}, {3.531943778727664*^9, 
   3.531943779960066*^9}, {3.5319453490892224`*^9, 3.5319453522092276`*^9}, {
   3.5339415241170616`*^9, 3.533941538197081*^9}, {3.5339415789871387`*^9, 
   3.533941604107174*^9}, {3.5339512902895765`*^9, 3.5339512946731844`*^9}, 
   3.533951351067283*^9, {3.5340027757635803`*^9, 3.534002812286766*^9}, {
   3.5341190049334655`*^9, 3.5341190294735003`*^9}, {3.5341191883437223`*^9, 
   3.534119195643733*^9}, {3.5341193695439763`*^9, 3.53411941511404*^9}, 
   3.5341196611243844`*^9, {3.5341196955644326`*^9, 3.5341197132044573`*^9}, {
   3.53411976495453*^9, 3.5341197859645596`*^9}, {3.5341198161046014`*^9, 
   3.5341198333046255`*^9}, 3.5341199475947857`*^9, 3.5341203626853666`*^9, {
   3.5345320463388095`*^9, 3.5345320520621367`*^9}, {3.5400017308272676`*^9, 
   3.540001736107275*^9}, {3.542249989006481*^9, 3.5422499957078643`*^9}, {
   3.542250036073081*^9, 3.542250039670287*^9}, 3.5498209379134893`*^9, 
   3.5498210856636963`*^9, 3.549821116193739*^9, 3.5498220886751003`*^9, {
   3.5498222071852665`*^9, 3.54982220976527*^9}, 3.5498232774067645`*^9, {
   3.6113482525721474`*^9, 3.611348275997181*^9}, {3.611348965777318*^9, 
   3.611348970487325*^9}, 3.6113556452168617`*^9, 3.611383619514218*^9, {
   3.637936083407548*^9, 3.637936110206587*^9}, 3.637936274310949*^9, {
   3.6379363084159966`*^9, 3.637936320439014*^9}, {3.6379363628310733`*^9, 
   3.637936404716133*^9}, 3.6379364350531764`*^9, {3.6379364697612257`*^9, 
   3.637936471099228*^9}, {3.637937776010236*^9, 3.6379378355253215`*^9}, {
   3.637937910986431*^9, 3.637937922436447*^9}, {3.637938068086815*^9, 
   3.6379380952038536`*^9}, {3.6379562370187464`*^9, 
   3.6379563212376947`*^9}, {3.637956406909446*^9, 3.6379564217093897`*^9}, {
   3.6379564588002586`*^9, 3.6379564777542915`*^9}, {3.6379565591084347`*^9, 
   3.6379565603408365`*^9}, {3.63795659060489*^9, 3.6379566159705343`*^9}, {
   3.637959792390112*^9, 3.637959800567527*^9}, {3.6379598362789893`*^9, 
   3.6379598364817896`*^9}, {3.637960245216427*^9, 3.6379602578544493`*^9}, 
   3.6379603117877445`*^9, 3.6379703973217564`*^9, {3.6379707078965206`*^9, 
   3.63797074968591*^9}, {3.637970815706687*^9, 3.637970843180258*^9}, {
   3.6379712525816746`*^9, 3.6379712879997005`*^9}, 3.644433197301881*^9, {
   3.706112995375877*^9, 3.7061130216773815`*^9}, {3.707703107342224*^9, 
   3.707703124774455*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{Cell[TextData[StyleBox["4:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], " ", Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"m", "\[NotLess]", 
        RowBox[{"-", "1"}]}], " ", "\[And]", " ", 
       RowBox[{
        RowBox[{"m", "+", "n", "+", "2"}], "\[NotEqual]", "0"}], " ", 
       "\[And]", " ", 
       RowBox[{
        RowBox[{"m", "+", "n", "+", "3"}], "\[NotEqual]", "0"}]}]]]], 
      "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.5192504337891226`*^9, 3.5192504707812386`*^9}, 3.5192506717957726`*^9, {
   3.519250720795459*^9, 3.5192507409818945`*^9}, 3.519258420209427*^9, 
   3.519258489779525*^9, {3.519320786305674*^9, 3.519320803294104*^9}, {
   3.519329422708468*^9, 3.5193294257984724`*^9}, 3.5193294706485353`*^9, {
   3.5193302883925123`*^9, 3.519330307237345*^9}, {3.5193303440378103`*^9, 
   3.5193303650666466`*^9}, 3.5193341918281684`*^9, {3.5193346196121197`*^9, 
   3.519334632840943*^9}, {3.519341922663512*^9, 3.5193419232095127`*^9}, 
   3.5193423494490614`*^9, {3.5193456600396833`*^9, 3.519345660273684*^9}, 
   3.519410696547495*^9, {3.519793559756592*^9, 3.5197935600217924`*^9}, {
   3.5210541942272606`*^9, 3.5210542323693275`*^9}, {3.521054705798959*^9, 
   3.5210547345342093`*^9}, {3.521055431683834*^9, 3.5210554455522585`*^9}, {
   3.5210554827427235`*^9, 3.5210555031319594`*^9}, {3.521056059772137*^9, 
   3.521056075652965*^9}, {3.521057417664521*^9, 3.521057417867322*^9}, {
   3.5210574854778404`*^9, 3.5210574857586412`*^9}, {3.5210575212175035`*^9, 
   3.521057540483537*^9}, {3.5210598942936716`*^9, 3.5210599092384977`*^9}, {
   3.521063276214819*^9, 3.521063298928458*^9}, {3.5210639991824884`*^9, 
   3.5210640343449497`*^9}, {3.5210641665551825`*^9, 
   3.5210641665551825`*^9}, {3.521072868148899*^9, 3.521072868148899*^9}, {
   3.5210824253375397`*^9, 3.5210824255559406`*^9}, {3.5211479965711794`*^9, 
   3.521148020673222*^9}, {3.5211480693453074`*^9, 3.5211480699537086`*^9}, {
   3.521148148187846*^9, 3.5211481489366474`*^9}, {3.5211482363436007`*^9, 
   3.5211482363436007`*^9}, {3.521148269556059*^9, 3.521148269556059*^9}, {
   3.521346368187188*^9, 3.521346368421189*^9}, {3.5214702809911447`*^9, 
   3.5214702811783447`*^9}, {3.5216579052539043`*^9, 3.521657905453904*^9}, {
   3.5223485259619713`*^9, 3.522348534381983*^9}, {3.5233208394702005`*^9, 
   3.5233208394702005`*^9}, {3.523320922845537*^9, 3.523320922845537*^9}, 
   3.523747250675035*^9, {3.5237670269856477`*^9, 3.5237670269856477`*^9}, {
   3.523831184179017*^9, 3.523831184179017*^9}, 3.5247720382710953`*^9, {
   3.524772397491598*^9, 3.524772397491598*^9}, {3.524774194324114*^9, 
   3.524774228794162*^9}, {3.526945238644486*^9, 3.526945238644486*^9}, {
   3.5279098167721815`*^9, 3.5279098172421827`*^9}, {3.5296282016140704`*^9, 
   3.5296282019130874`*^9}, 3.530384384323295*^9, {3.5303845765632906`*^9, 
   3.530384576766302*^9}, {3.530412765574172*^9, 3.530412765724172*^9}, {
   3.5304133134449387`*^9, 3.530413327614959*^9}, {3.5304133632650084`*^9, 
   3.5304133653750114`*^9}, {3.5304685359612284`*^9, 
   3.5304685362112293`*^9}, {3.5306637757276535`*^9, 3.530663775992854*^9}, 
   3.531940972073534*^9, {3.531941135920622*^9, 3.531941136887823*^9}, {
   3.531941292685297*^9, 3.5319412934028983`*^9}, {3.531941412696308*^9, 
   3.53194141378831*^9}, {3.531941540834933*^9, 3.531941542176535*^9}, {
   3.531941747348096*^9, 3.5319417604365187`*^9}, {3.5319419776265*^9, 
   3.531941978453302*^9}, {3.5319420524598317`*^9, 3.5319420537078342`*^9}, {
   3.5319437460612063`*^9, 3.5319437460612063`*^9}, {3.531945368214856*^9, 
   3.531945368214856*^9}, {3.5339235218280125`*^9, 3.533923522848014*^9}, {
   3.5340030836026883`*^9, 3.534003084035713*^9}, 3.534118752423112*^9, {
   3.5341190488235273`*^9, 3.534119049053528*^9}, {3.534119148303666*^9, 
   3.534119148303666*^9}, {3.534119453664094*^9, 3.5341194538540945`*^9}, {
   3.534119930854762*^9, 3.534119930854762*^9}, {3.53412041503544*^9, 
   3.53412041503544*^9}, {3.5498208478733635`*^9, 3.5498208478733635`*^9}, {
   3.549821170423815*^9, 3.549821170423815*^9}, {3.5498212022838593`*^9, 
   3.5498212022838593`*^9}, {3.5498220687050724`*^9, 
   3.5498220687050724`*^9}, {3.5498232312167*^9, 3.5498232312167*^9}, {
   3.5498234766870437`*^9, 3.5498234777570453`*^9}, {3.54985254227013*^9, 
   3.5498525425001297`*^9}, 3.5717051188897867`*^9, 3.5758229263769093`*^9, {
   3.6113489510122957`*^9, 3.6113489537697997`*^9}, {3.6113491101575394`*^9, 
   3.6113491196025534`*^9}, {3.6113491544876075`*^9, 
   3.6113491546901073`*^9}, {3.6113492430927434`*^9, 
   3.6113492640427756`*^9}, {3.6113556049368057`*^9, 
   3.6113556049368057`*^9}, {3.6379354926806993`*^9, 3.637935501570712*^9}, {
   3.637935984384406*^9, 3.637936011086444*^9}, 3.637968068452553*^9, {
   3.637976559762228*^9, 3.6379765616783376`*^9}, {3.644433207793481*^9, 
   3.644433207793481*^9}, 3.6489530592365365`*^9, 3.64895588725229*^9, {
   3.6489560789532547`*^9, 3.6489560807543573`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: ???", "Subsubsection",
 CellChangeTimes->{
  3.496441803031353*^9, 3.4965396318089237`*^9, {3.4966002562016735`*^9, 
   3.4966002624716825`*^9}, 3.496600707442305*^9, 3.4966008475725017`*^9, {
   3.4966070255131593`*^9, 3.496607032413169*^9}, 3.518279406700592*^9, {
   3.51840552316576*^9, 3.5184055392257824`*^9}, 3.5184690414436746`*^9, 
   3.518469651844529*^9, 3.5184700043450227`*^9, 3.518474659316563*^9, 
   3.5237473322319784`*^9, 3.5247722814214354`*^9, {3.5260660236439*^9, 
   3.526066024233901*^9}, {3.530413463335149*^9, 3.5304134989751987`*^9}, {
   3.5339258909313297`*^9, 3.533925894241334*^9}, {3.5341187688231354`*^9, 
   3.534118769443136*^9}, {3.534119456044097*^9, 3.5341194563640976`*^9}, 
   3.6113471326280394`*^9, {3.6379360318244734`*^9, 3.6379360322144737`*^9}}],

Cell[TextData[{
 "Rule 1.1.1.4",
 ".1.1.4: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"m", "\[NotLess]", 
    RowBox[{"-", "1"}]}], " ", "\[And]", " ", 
   RowBox[{
    RowBox[{"m", "+", "n", "+", "2"}], "\[NotEqual]", "0"}], " ", "\[And]", 
   " ", 
   RowBox[{
    RowBox[{"m", "+", "n", "+", "3"}], "\[NotEqual]", "0"}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.4964417379912624`*^9, 3.4964417471112747`*^9}, {
   3.496441910111503*^9, 3.4964419275315275`*^9}, 3.496451213764926*^9, {
   3.496539487018721*^9, 3.4965395223187704`*^9}, {3.4966001213614845`*^9, 
   3.4966001362815056`*^9}, {3.4966047635399923`*^9, 
   3.4966048329500895`*^9}, {3.496604896730179*^9, 3.496605019710351*^9}, {
   3.496605050490394*^9, 3.4966050527103972`*^9}, {3.4966066606926484`*^9, 
   3.496606694832696*^9}, 3.496606873362946*^9, {3.4966081836347804`*^9, 
   3.496608250534874*^9}, {3.496608418375109*^9, 3.496608441025141*^9}, {
   3.4966322809467688`*^9, 3.4966322818867702`*^9}, {3.4968592460220995`*^9, 
   3.4968592640557313`*^9}, {3.4968593076422076`*^9, 
   3.4968593113862143`*^9}, {3.496859384233942*^9, 3.496859384233942*^9}, {
   3.518223900967896*^9, 3.518223909467908*^9}, 3.5182817155426493`*^9, {
   3.518285874431555*^9, 3.518285899625599*^9}, {3.5182860969191456`*^9, 
   3.518286138321618*^9}, {3.518286898517355*^9, 3.518286898517355*^9}, {
   3.5182870794776726`*^9, 3.5182870794776726`*^9}, {3.518469568024412*^9, 
   3.518469584774435*^9}, {3.518469921924907*^9, 3.5184699227449083`*^9}, {
   3.51847035958552*^9, 3.518470374475541*^9}, {3.518474847889694*^9, 
   3.518474854394906*^9}, {3.518475351645779*^9, 3.51847535181738*^9}, {
   3.518476861483632*^9, 3.5184768701416473`*^9}, {3.5184769318709555`*^9, 
   3.518476937876966*^9}, {3.5185837532117095`*^9, 3.51858375372651*^9}, {
   3.5211482838768845`*^9, 3.5211482838768845`*^9}, {3.5223485487820034`*^9, 
   3.5223485487820034`*^9}, {3.5237580782402368`*^9, 
   3.5237580830402436`*^9}, {3.524772390921589*^9, 3.524772390921589*^9}, {
   3.524774159434065*^9, 3.5247741821040964`*^9}, {3.526945226804065*^9, 
   3.5269452323576756`*^9}, {3.530413508385212*^9, 3.530413508385212*^9}, {
   3.5319411411622305`*^9, 3.5319411411622305`*^9}, {3.5319412943077*^9, 
   3.5319412943077*^9}, {3.531941415098712*^9, 3.531941415098712*^9}, {
   3.531941547106144*^9, 3.531941547776945*^9}, {3.5319417707481365`*^9, 
   3.531941771746538*^9}, {3.5319419851613135`*^9, 3.5319419851613135`*^9}, {
   3.5319420546594353`*^9, 3.5319420546594353`*^9}, {3.531943749524412*^9, 
   3.531943749820813*^9}, {3.531945371147661*^9, 3.531945371147661*^9}, {
   3.5341190906435857`*^9, 3.5341191318936434`*^9}, {3.5341199134547377`*^9, 
   3.5341199250547543`*^9}, {3.5341202922652683`*^9, 
   3.5341202922652683`*^9}, {3.5498208700933943`*^9, 
   3.5498208700933943`*^9}, {3.549821171293816*^9, 3.549821171293816*^9}, {
   3.54982120282386*^9, 3.54982120282386*^9}, {3.549822071815077*^9, 
   3.549822071815077*^9}, {3.549823244226718*^9, 3.549823244226718*^9}, {
   3.6113556232768316`*^9, 3.6113556232768316`*^9}, {3.6379360252744646`*^9, 
   3.6379360252744646`*^9}, {3.644433215150902*^9, 3.6444332151519012`*^9}, 
   3.6501605991586165`*^9, {3.6501607164373245`*^9, 3.650160717599391*^9}, 
   3.6986840239434547`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    RowBox[{"(", 
     RowBox[{"e", "+", 
      RowBox[{"f", " ", "x"}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"a", " ", "d", " ", "f", " ", "h", " ", 
            RowBox[{"(", 
             RowBox[{"n", "+", "2"}], ")"}]}], "+", 
           RowBox[{"b", " ", "c", " ", "f", " ", "h", " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "2"}], ")"}]}], "-", 
           RowBox[{"b", " ", "d", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", " ", "g"}], "+", 
              RowBox[{"e", " ", "h"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "3"}], ")"}]}], "-", 
           RowBox[{"b", " ", "d", " ", "f", " ", "h", " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "2"}], ")"}], " ", "x"}]}], ")"}], 
         " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}], 
          RowBox[{"m", "+", "1"}]], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"c", "+", 
            RowBox[{"d", " ", "x"}]}], ")"}], 
          RowBox[{"n", "+", "1"}]]}], 
        RowBox[{
         SuperscriptBox["b", "2"], " ", 
         SuperscriptBox["d", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "2"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]]}]}]}]}]}], "+", 
  "\[IndentingNewLine]", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{
      SuperscriptBox["a", "2"], " ", 
      SuperscriptBox["d", "2"], " ", "f", " ", "h", " ", 
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"n", "+", "2"}], ")"}]}], "+", 
     RowBox[{"a", " ", "b", " ", "d", " ", 
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "c", " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "-", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", " ", "g"}], "+", 
           RowBox[{"e", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["c", "2"], " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "2"}], ")"}]}], "-", 
        RowBox[{"c", " ", "d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", " ", "g"}], "+", 
           RowBox[{"e", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "3"}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["d", "2"], " ", "e", " ", "g", " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "2"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]}], ")"}]}]}], 
    RowBox[{
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["d", "2"], " ", 
     RowBox[{"(", 
      RowBox[{"m", "+", "n", "+", "2"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]], "\[CenterDot]", 
   "\[IndentingNewLine]", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, 3.4958399855843487`*^9, 3.495840155344586*^9, 
   3.495840624735243*^9, {3.4958474296047697`*^9, 3.495847433754776*^9}, {
   3.4958476539050837`*^9, 3.495847660315093*^9}, {3.4958482220958796`*^9, 
   3.4958482231858807`*^9}, {3.495848257515929*^9, 3.4958482607459335`*^9}, 
   3.4959261390123196`*^9, 3.4959262745925093`*^9, 3.4959264909328117`*^9, 
   3.4959265843129425`*^9, 3.495926967463479*^9, {3.496184978535224*^9, 
   3.496185020185282*^9}, {3.4961873840085917`*^9, 3.496187409278627*^9}, {
   3.4961890232008867`*^9, 3.4961890250708895`*^9}, 3.4961956176127515`*^9, {
   3.4961956815728407`*^9, 3.496195696542862*^9}, {3.4961957791729774`*^9, 
   3.4961957920929956`*^9}, 3.496195845773071*^9, 3.518405474905692*^9, {
   3.51840566597596*^9, 3.5184056974360037`*^9}, {3.518405737026059*^9, 
   3.5184057718861084`*^9}, {3.5184058668262415`*^9, 3.518405869606245*^9}, {
   3.5184688792534475`*^9, 3.518468891673465*^9}, 3.5184689356235266`*^9, {
   3.5184691371938086`*^9, 3.5184691450938196`*^9}, {3.51846968832458*^9, 
   3.5184697035846014`*^9}, {3.518470060915102*^9, 3.518470082885133*^9}, {
   3.5184747044318423`*^9, 3.5184747207338715`*^9}, 3.518475002735566*^9, {
   3.5188842113796167`*^9, 3.518884228949641*^9}, {3.518890960739066*^9, 
   3.5188909798390923`*^9}, {3.520101172685255*^9, 3.520101193979293*^9}, 
   3.520101537866297*^9, {3.520101583012776*^9, 3.520101592138792*^9}, 
   3.5237473966912913`*^9, {3.523747635309311*^9, 3.523747662094558*^9}, 
   3.523747693201012*^9, {3.5237589154214087`*^9, 3.523758920041415*^9}, {
   3.523835091963359*^9, 3.523835095403364*^9}, 3.5247720424111013`*^9, {
   3.5247722402213783`*^9, 3.524772242541381*^9}, {3.5247723065014706`*^9, 
   3.524772310491476*^9}, {3.5247724101316156`*^9, 3.5247725806518545`*^9}, {
   3.5247726200519094`*^9, 3.5247727072220316`*^9}, {3.5247728848022804`*^9, 
   3.5247728894922867`*^9}, {3.5247737712335215`*^9, 
   3.5247738023335648`*^9}, {3.5279824084921894`*^9, 
   3.5279824453238535`*^9}, {3.5304116139925594`*^9, 
   3.5304117038726854`*^9}, {3.530411918742986*^9, 3.53041197123306*^9}, 
   3.531941036782448*^9, {3.5319411448594375`*^9, 3.5319411488686447`*^9}, {
   3.531941294947301*^9, 3.531941298394907*^9}, {3.5319414162219143`*^9, 
   3.5319414182655177`*^9}, {3.531941548510146*^9, 3.5319415504133496`*^9}, {
   3.5319417755685453`*^9, 3.5319417799833527`*^9}, {3.5319419862689157`*^9, 
   3.531941989685322*^9}, {3.531942055798238*^9, 3.5319420566406393`*^9}, {
   3.5319437006495266`*^9, 3.5319437038787327`*^9}, {3.5340026346818047`*^9, 
   3.534002637453963*^9}, {3.5340030209706793`*^9, 3.5340030293451586`*^9}, {
   3.534118784243157*^9, 3.5341188511132507`*^9}, {3.534119170853698*^9, 
   3.534119179923711*^9}, {3.534119497584155*^9, 3.5341195421742177`*^9}, {
   3.5498221970752525`*^9, 3.5498221995452557`*^9}, {3.611348176827039*^9, 
   3.61134819860707*^9}, {3.6113489579198065`*^9, 3.61134896037731*^9}, {
   3.63793554203277*^9, 3.6379355918848414`*^9}, {3.6379356258428917`*^9, 
   3.6379358643252325`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.520101787997136*^9, 3.5201017908831415`*^9}, 
   3.534119660884384*^9, 3.5341197024044423`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_."}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_."}], "*", 
     RowBox[{"(", 
      RowBox[{"e_", "+", 
       RowBox[{"f_.", "*", "x_"}]}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"a", "*", "d", "*", "f", "*", "h", "*", 
         RowBox[{"(", 
          RowBox[{"n", "+", "2"}], ")"}]}], "+", 
        RowBox[{"b", "*", "c", "*", "f", "*", "h", "*", 
         RowBox[{"(", 
          RowBox[{"m", "+", "2"}], ")"}]}], "-", 
        RowBox[{"b", "*", "d", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", "*", "g"}], "+", 
           RowBox[{"e", "*", "h"}]}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "3"}], ")"}]}], "-", 
        RowBox[{"b", "*", "d", "*", "f", "*", "h", "*", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "2"}], ")"}], "*", "x"}]}], ")"}]}], 
     "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", "*", "x"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"n", "+", "1"}], ")"}]}], "/", "\n", "    ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "^", "2"}], "*", 
        RowBox[{"d", "^", "2"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "n", "+", "2"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "n", "+", "3"}], ")"}]}], ")"}]}]}], " ", "+", " ",
     "\n", "  ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"a", "^", "2"}], "*", 
         RowBox[{"d", "^", "2"}], "*", "f", "*", "h", "*", 
         RowBox[{"(", 
          RowBox[{"n", "+", "1"}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{"n", "+", "2"}], ")"}]}], "+", 
        RowBox[{"a", "*", "b", "*", "d", "*", 
         RowBox[{"(", 
          RowBox[{"n", "+", "1"}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "*", "c", "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "-", 
           RowBox[{"d", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "+", 
              RowBox[{"e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]}], ")"}]}], "+", "\n",
         "      ", 
        RowBox[{
         RowBox[{"b", "^", "2"}], "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"c", "^", "2"}], "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "2"}], ")"}]}], "-", 
           RowBox[{"c", "*", "d", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "+", 
              RowBox[{"e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "3"}], ")"}]}], "+", 
           RowBox[{
            RowBox[{"d", "^", "2"}], "*", "e", "*", "g", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "2"}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "3"}], ")"}]}]}], ")"}]}]}], ")"}], 
      "/", "\n", "    ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "^", "2"}], "*", 
        RowBox[{"d", "^", "2"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "n", "+", "2"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "n", "+", "3"}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", "m"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m", ",", "n"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"NeQ", "[", 
     RowBox[{
      RowBox[{"m", "+", "n", "+", "2"}], ",", "0"}], "]"}], " ", "&&", " ", 
    RowBox[{"NeQ", "[", 
     RowBox[{
      RowBox[{"m", "+", "n", "+", "3"}], ",", "0"}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495839738475589*^9, 3.4958405008250694`*^9, {3.495847490784856*^9, 
   3.4958474999948683`*^9}, {3.4958477172451725`*^9, 3.495847721615179*^9}, {
   3.495848224085882*^9, 3.4958482277058873`*^9}, {3.4958482626259365`*^9, 
   3.4958482686359444`*^9}, 3.4959261054722724`*^9, {3.4959262905725317`*^9, 
   3.4959262958725395`*^9}, 3.495926443222745*^9, 3.4961849395451694`*^9, 
   3.496185884976493*^9, 3.4961888731806765`*^9, {3.4961890260508904`*^9, 
   3.4961890290708947`*^9}, {3.496191957967628*^9, 3.4961919600576305`*^9}, 
   3.49619205250776*^9, 3.4961952203321953`*^9, {3.496195426482484*^9, 
   3.496195433172493*^9}, {3.496195586822708*^9, 3.496195595732721*^9}, 
   3.496195754542943*^9, 3.4966189754082823`*^9, {3.4966198797795486`*^9, 
   3.496619907439587*^9}, {3.4968579645422487`*^9, 3.4968579680210547`*^9}, 
   3.5171911044266214`*^9, 3.518211198418105*^9, 3.5182420941409807`*^9, {
   3.518281849687285*^9, 3.518281849874485*^9}, {3.5182861978669233`*^9, 
   3.518286207226939*^9}, 3.518286893072945*^9, 3.518287077449669*^9, {
   3.518405919376315*^9, 3.5184059327163334`*^9}, 3.518406000866429*^9, {
   3.5184061023365707`*^9, 3.518406115016588*^9}, {3.5184065135071464`*^9, 
   3.518406515547149*^9}, {3.518406800569559*^9, 3.5184068071395683`*^9}, {
   3.518455696848171*^9, 3.518455715349804*^9}, {3.518469305994045*^9, 
   3.518469310354051*^9}, {3.5184693414340944`*^9, 3.5184693641841264`*^9}, {
   3.518469461554263*^9, 3.518469497814314*^9}, {3.5184698199647646`*^9, 
   3.5184698496348057`*^9}, {3.5184698834448533`*^9, 3.5184698844848547`*^9}, 
   3.5184701704452553`*^9, {3.518470248195364*^9, 3.518470287395419*^9}, {
   3.51847032361547*^9, 3.518470324325471*^9}, {3.518474812134432*^9, 
   3.5184748359088736`*^9}, {3.5184748784969482`*^9, 3.51847487927695*^9}, 
   3.518475395747057*^9, {3.5184754745583954`*^9, 3.518475478770403*^9}, {
   3.5184759352008047`*^9, 3.518475938726411*^9}, {3.5184760887674747`*^9, 
   3.5184761024174986`*^9}, {3.518476247310553*^9, 3.5184762483245544`*^9}, {
   3.518476459611326*^9, 3.518476460235327*^9}, {3.5185837600757217`*^9, 
   3.518583760356522*^9}, {3.5188842541996765`*^9, 3.5188842747997055`*^9}, {
   3.518890955169058*^9, 3.5188909696490784`*^9}, {3.5188914772697887`*^9, 
   3.518891482339796*^9}, {3.520102006257119*^9, 3.5201020069591208`*^9}, 
   3.5201020756928415`*^9, {3.5202847653043165`*^9, 3.520284765308317*^9}, {
   3.5202851424268866`*^9, 3.520285144721018*^9}, {3.520899838877209*^9, 
   3.5208998429572153`*^9}, {3.521131441309245*^9, 3.521131443849249*^9}, 
   3.521148390206671*^9, {3.5223485088319473`*^9, 3.5223485168319583`*^9}, {
   3.5224420691492205`*^9, 3.522442069414421*^9}, 3.5237568920485764`*^9, 
   3.523757219519035*^9, 3.523757259739091*^9, {3.5237580436701884`*^9, 
   3.523758059720211*^9}, {3.523758936761439*^9, 3.523758939721443*^9}, 
   3.523810558420226*^9, 3.523818931362772*^9, {3.523835156403449*^9, 
   3.5238351582934523`*^9}, 3.5247721246012163`*^9, {3.5247739098537154`*^9, 
   3.5247740062738504`*^9}, {3.524774046163906*^9, 3.524774061003927*^9}, {
   3.5269452650085325`*^9, 3.526945270312542*^9}, {3.527188364001113*^9, 
   3.5271883677139196`*^9}, {3.5271888173223095`*^9, 3.527188823843121*^9}, {
   3.5271899878391657`*^9, 3.5271900376656528`*^9}, {3.527190166287879*^9, 
   3.5271901716698885`*^9}, {3.527190278608076*^9, 3.5271902902768965`*^9}, {
   3.527982424123417*^9, 3.5279824278986235`*^9}, {3.5279825248995934`*^9, 
   3.5279825340568094`*^9}, {3.5304120848332186`*^9, 3.530412106123248*^9}, {
   3.5304130055745077`*^9, 3.530413008634512*^9}, {3.530413043314561*^9, 
   3.530413055224577*^9}, {3.530413087314622*^9, 3.5304130884346237`*^9}, {
   3.5304131472647057`*^9, 3.5304131483447075`*^9}, 3.53046311973864*^9, {
   3.5304888886920757`*^9, 3.530488894767084*^9}, {3.531941152706251*^9, 
   3.531941162830669*^9}, {3.531941299455709*^9, 3.531941306974922*^9}, {
   3.5319414191859193`*^9, 3.5319414225243254`*^9}, {3.531941554079356*^9, 
   3.531941559040165*^9}, {3.531941786394964*^9, 3.531941805174197*^9}, {
   3.5319419942717295`*^9, 3.531941998764538*^9}, {3.5319420576234407`*^9, 
   3.531942059916645*^9}, {3.531943420348234*^9, 3.5319434261514444`*^9}, {
   3.5319437080127397`*^9, 3.53194372535997*^9}, {3.531943778727664*^9, 
   3.531943779960066*^9}, {3.5319453490892224`*^9, 3.5319453522092276`*^9}, {
   3.5339415241170616`*^9, 3.533941538197081*^9}, {3.5339415789871387`*^9, 
   3.533941604107174*^9}, {3.5339512902895765`*^9, 3.5339512946731844`*^9}, 
   3.533951351067283*^9, {3.5340027757635803`*^9, 3.534002812286766*^9}, {
   3.5341190049334655`*^9, 3.5341190294735003`*^9}, {3.5341191883437223`*^9, 
   3.534119195643733*^9}, {3.5341193695439763`*^9, 3.53411941511404*^9}, 
   3.5341196611243844`*^9, {3.5341196955644326`*^9, 3.5341197132044573`*^9}, {
   3.53411976495453*^9, 3.5341197859645596`*^9}, {3.5341198161046014`*^9, 
   3.5341198333046255`*^9}, 3.5341199475947857`*^9, 3.5341203626853666`*^9, {
   3.5345320463388095`*^9, 3.5345320520621367`*^9}, {3.5400017308272676`*^9, 
   3.540001736107275*^9}, {3.542249989006481*^9, 3.5422499957078643`*^9}, {
   3.542250036073081*^9, 3.542250039670287*^9}, 3.5498209379134893`*^9, 
   3.5498210856636963`*^9, 3.549821116193739*^9, 3.5498220886751003`*^9, {
   3.5498222071852665`*^9, 3.54982220976527*^9}, 3.5498232774067645`*^9, {
   3.6113482525721474`*^9, 3.611348275997181*^9}, {3.611348965777318*^9, 
   3.611348970487325*^9}, 3.6113556452168617`*^9, 3.611383619514218*^9, {
   3.637936083407548*^9, 3.637936110206587*^9}, 3.637936274310949*^9, {
   3.6379363084159966`*^9, 3.637936320439014*^9}, {3.6379363628310733`*^9, 
   3.637936404716133*^9}, 3.6379364350531764`*^9, {3.6379364697612257`*^9, 
   3.637936471099228*^9}, 3.6379381197688894`*^9, 3.6444332290496964`*^9, {
   3.706112995414879*^9, 3.7061129954238796`*^9}, {3.706113025564604*^9, 
   3.706113027693725*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{Cell[TextData[StyleBox["2:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "|", "n", "|", "p"}], ")"}], "\[Element]", 
        "\[DoubleStruckCapitalZ]"}], " ", "\[Or]", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"n", "|", "p"}], ")"}], "\[Element]", 
        SuperscriptBox["\[DoubleStruckCapitalZ]", "+"]}]}]]]], 
      "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, 
   3.5239334940268483`*^9, {3.524105742828332*^9, 3.524105745433536*^9}, {
   3.524105783326003*^9, 3.5241058043704395`*^9}, {3.524167197804468*^9, 
   3.524167275274576*^9}, {3.5241673584446926`*^9, 3.5241673584446926`*^9}, {
   3.5241684217861814`*^9, 3.5241684663262434`*^9}, {3.5241684966162863`*^9, 
   3.5241685133463097`*^9}, {3.524168558706373*^9, 3.524168575716397*^9}, {
   3.5242542194504414`*^9, 3.5242543397578526`*^9}, {3.5242543718471093`*^9, 
   3.5242544424216332`*^9}, {3.524254478910097*^9, 3.5242545759266677`*^9}, {
   3.5242546436307864`*^9, 3.5242546436307864`*^9}, {3.5242547267009325`*^9, 
   3.5242547400857563`*^9}, {3.5242771462350645`*^9, 
   3.5242771465938654`*^9}, {3.5304877376854625`*^9, 3.530487831775594*^9}, {
   3.5305002113339696`*^9, 3.53050021156397*^9}, {3.531256229526664*^9, 
   3.5312562621635933`*^9}, 3.5312563043041887`*^9, 3.5312565353964834`*^9, 
   3.5312718541780033`*^9, {3.531272022680298*^9, 3.531272043970912*^9}, 
   3.5312721159644337`*^9, {3.531286527477171*^9, 3.53128654727564*^9}, {
   3.53133653657067*^9, 3.5313365374719667`*^9}, {3.5332481026588316`*^9, 
   3.5332481046588345`*^9}, {3.533940608115779*^9, 3.5339406083757796`*^9}, {
   3.533940643135828*^9, 3.533940671755868*^9}, {3.53394080166605*^9, 
   3.53394080166605*^9}, {3.5339408897661734`*^9, 3.5339408897661734`*^9}, {
   3.5340308298369713`*^9, 3.534030830046972*^9}, {3.5346431179954567`*^9, 
   3.534643118292474*^9}, {3.5347066963108644`*^9, 3.5347066964980645`*^9}, {
   3.534708277732442*^9, 3.5347082781536427`*^9}, {3.535151707447782*^9, 
   3.5351517076977825`*^9}, 3.535151798067909*^9, {3.5351519292380924`*^9, 
   3.535151929478093*^9}, {3.5351519735681543`*^9, 3.5351519759881577`*^9}, {
   3.5356775270969605`*^9, 3.5356775274089613`*^9}, {3.539393933879423*^9, 
   3.539393934044432*^9}, 3.5498225109556913`*^9, {3.549822628955857*^9, 
   3.549822647825883*^9}, {3.549822827116134*^9, 3.549822827116134*^9}, {
   3.549823176416623*^9, 3.549823176416623*^9}, 3.5717051161597824`*^9, 
   3.5758229236569057`*^9, {3.6113490147698927`*^9, 3.6113490183148985`*^9}, {
   3.6113493223303647`*^9, 3.6113493225328655`*^9}, {3.6113566796183105`*^9, 
   3.6113566796183105`*^9}, {3.637938371372247*^9, 3.6379383732122498`*^9}, 
   3.6379583928531237`*^9, 3.637958492262499*^9, {3.6444419611211424`*^9, 
   3.6444419611211424`*^9}, {3.6489542720529056`*^9, 
   3.6489542722619176`*^9}, {3.6489558258177757`*^9, 3.648955826005787*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic expansion", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9}],

Cell[TextData[{
 "Rule 1.1.1.4",
 ".1.2: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"m", "|", "n", "|", "p"}], ")"}], "\[Element]", 
    "\[DoubleStruckCapitalZ]"}], " ", "\[Or]", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"n", "|", "p"}], ")"}], "\[Element]", 
    SuperscriptBox["\[DoubleStruckCapitalZ]", "+"]}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4957339078770905`*^9, 
   3.495733966267172*^9}, {3.495734148157427*^9, 3.4957341584974413`*^9}, {
   3.4957346698781567`*^9, 3.495734670108157*^9}, {3.4957347778783083`*^9, 
   3.4957348688784356`*^9}, {3.5182850739057484`*^9, 
   3.5182850817837625`*^9}, {3.5193219410789022`*^9, 
   3.5193219437309074`*^9}, {3.5193301726195183`*^9, 
   3.5193301738595195`*^9}, {3.5199710233740273`*^9, 3.519971026084031*^9}, {
   3.519971058314076*^9, 3.519971083934112*^9}, {3.523219270157716*^9, 
   3.523219270157716*^9}, {3.523924231484662*^9, 3.523924232592264*^9}, {
   3.523930223132303*^9, 3.5239302243647056`*^9}, {3.523933687825989*^9, 
   3.523933687825989*^9}, {3.5241691044427414`*^9, 3.5241691044427414`*^9}, {
   3.530487866440643*^9, 3.530487866440643*^9}, 3.5312563413574686`*^9, 
   3.531272069487603*^9, 3.531272113390733*^9, {3.5339408766961555`*^9, 
   3.5339408833261642`*^9}, {3.535151983378168*^9, 3.535151983378168*^9}, {
   3.549822632795862*^9, 3.5498226330958624`*^9}, {3.549822682015931*^9, 
   3.54982272404599*^9}, {3.5498232150566773`*^9, 3.5498232150566773`*^9}, {
   3.6113567210183687`*^9, 3.6113567210183687`*^9}, {3.6444419648463554`*^9, 
   3.6444419648463554`*^9}, 3.6501605997496505`*^9, {3.6501607311661673`*^9, 
   3.6501607317982035`*^9}, 3.698684024043455*^9}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"a", "+", 
      RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"e", "+", 
      RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
   RowBox[{"(", 
    RowBox[{"g", "+", 
     RowBox[{"h", " ", "x"}]}], ")"}], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
     RowBox[{"\[Integral]", 
      RowBox[{
       RowBox[{"ExpandIntegrand", "[", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"c", "+", 
             RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"e", "+", 
             RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
          RowBox[{"(", 
           RowBox[{"g", "+", 
            RowBox[{"h", " ", "x"}]}], ")"}]}], ",", "x"}], "]"}], 
       RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, {3.4954224033621993`*^9, 3.495422429782236*^9}, {
   3.4962830099393682`*^9, 3.496283015729377*^9}, {3.5241060284804335`*^9, 
   3.5241060764193172`*^9}, {3.524167368204706*^9, 3.5241674428548107`*^9}, {
   3.524168833516758*^9, 3.5241688560167894`*^9}, {3.53038360604578*^9, 
   3.530383613747221*^9}, 3.530383659086814*^9, {3.5312563478167567`*^9, 
   3.5312563530442734`*^9}, {3.531271888617525*^9, 3.5312718914516*^9}, {
   3.533940690055894*^9, 3.533940693145898*^9}, 3.535151793377902*^9, 
   3.5351518250179462`*^9, 3.536688185927653*^9, {3.549822542075735*^9, 
   3.54982254557574*^9}, {3.611349020822402*^9, 3.611349049822447*^9}, {
   3.6379584020883403`*^9, 3.6379584029151416`*^9}, {3.6379584929957004`*^9, 
   3.637958493588501*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{"Int", "[", 
    RowBox[{
     RowBox[{"ExpandIntegrand", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", "m"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "*", 
        RowBox[{"(", 
         RowBox[{"g", "+", 
          RowBox[{"h", "*", "x"}]}], ")"}]}], ",", "x"}], "]"}], ",", "x"}], 
    "]"}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"IntegersQ", "[", 
       RowBox[{"m", ",", "n", ",", "p"}], "]"}], " ", "||", " ", 
      RowBox[{
       RowBox[{"IGtQ", "[", 
        RowBox[{"n", ",", "0"}], "]"}], " ", "&&", " ", 
       RowBox[{"IGtQ", "[", 
        RowBox[{"p", ",", "0"}], "]"}]}]}], ")"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495422238811969*^9, 3.5239327382679205`*^9, {3.5241061049829674`*^9, 
   3.5241061158093867`*^9}, {3.5241061634986706`*^9, 3.524106178100296*^9}, {
   3.5241522039971824`*^9, 3.5241522138657465`*^9}, {3.524167459434834*^9, 
   3.524167501524893*^9}, 3.5241675598849745`*^9, {3.5241689646025457`*^9, 
   3.524169057582676*^9}, {3.5241694886052837`*^9, 3.5241694922252893`*^9}, {
   3.5241697349256287`*^9, 3.524169770915679*^9}, {3.524169890175846*^9, 
   3.52416989278585*^9}, {3.5241699517859325`*^9, 3.524169977745969*^9}, {
   3.5241702075262904`*^9, 3.5241702284463196`*^9}, {3.5241703474164867`*^9, 
   3.5241703535564947`*^9}, {3.5241704168565836`*^9, 
   3.5241704281665993`*^9}, {3.5241707090069923`*^9, 3.5241707118469963`*^9}, 
   3.5241707660170727`*^9, {3.5241735897163877`*^9, 3.524173666646496*^9}, {
   3.524173777586651*^9, 3.5241738523767557`*^9}, {3.5241739428768826`*^9, 
   3.524173979156933*^9}, 3.524174297647379*^9, {3.524185483815135*^9, 
   3.524185485365137*^9}, {3.524185602895302*^9, 3.5241856035153027`*^9}, {
   3.5241856771854057`*^9, 3.5241856830554132`*^9}, {3.524185838105631*^9, 
   3.5241858734356804`*^9}, {3.5241859285057573`*^9, 3.524185944045779*^9}, {
   3.524186003185862*^9, 3.524186038265911*^9}, {3.52418611602602*^9, 
   3.5241861192260246`*^9}, 3.524186217346162*^9, 3.5241863019362803`*^9, {
   3.5241863667163706`*^9, 3.5241863784563875`*^9}, {3.52418651596658*^9, 
   3.5241865406766143`*^9}, {3.5241867699369354`*^9, 
   3.5241868085469894`*^9}, {3.5241868836270943`*^9, 3.5241869237971506`*^9}, 
   3.5241869873472395`*^9, {3.5241870885173817`*^9, 3.524187101037399*^9}, {
   3.5241871740575013`*^9, 3.5241871912575254`*^9}, {3.524187306817687*^9, 
   3.5241873162877*^9}, {3.5241873622777643`*^9, 3.524187409757831*^9}, 
   3.524187460357902*^9, {3.5241874977879543`*^9, 3.524187498347955*^9}, {
   3.524187557468038*^9, 3.5241875586680393`*^9}, {3.524187589468083*^9, 
   3.5241875901780834`*^9}, {3.5241876610181828`*^9, 
   3.5241876929782276`*^9}, {3.524187781768352*^9, 3.524187783788355*^9}, {
   3.5241896786382575`*^9, 3.524189683318266*^9}, {3.524234559451813*^9, 
   3.5242346007294855`*^9}, {3.524238368588504*^9, 3.5242383752965155`*^9}, {
   3.5242384122217803`*^9, 3.524238419928194*^9}, {3.5242393344018*^9, 
   3.524239346819422*^9}, {3.5242394127451377`*^9, 3.5242394565500145`*^9}, {
   3.52423959033585*^9, 3.524239629803919*^9}, {3.524239671487192*^9, 
   3.5242397220468807`*^9}, {3.524239788190997*^9, 3.5242398647715316`*^9}, {
   3.5242437175850987`*^9, 3.5242437668343854`*^9}, {3.524244465247612*^9, 
   3.5242444873372507`*^9}, {3.524244751882516*^9, 3.524244753208518*^9}, {
   3.524245115768755*^9, 3.524245137000392*^9}, {3.5242452528149953`*^9, 
   3.5242452554826*^9}, {3.5242456723777323`*^9, 3.5242456731889334`*^9}, {
   3.524245869936479*^9, 3.5242459980595045`*^9}, {3.5242461068384953`*^9, 
   3.5242461450273623`*^9}, {3.524246187958638*^9, 3.52424618922224*^9}, {
   3.5242462316543145`*^9, 3.524246267690378*^9}, {3.5242463181564665`*^9, 
   3.5242463224620743`*^9}, {3.5242485499936485`*^9, 3.524248561823665*^9}, {
   3.524248621593749*^9, 3.5242486251937537`*^9}, {3.5242487642059507`*^9, 
   3.5242487732359633`*^9}, {3.5242532845563993`*^9, 
   3.5242532909524107`*^9}, {3.52425347849594*^9, 3.5242535106475964`*^9}, {
   3.524253596868948*^9, 3.5242536191613874`*^9}, {3.5242537436028056`*^9, 
   3.5242537593588333`*^9}, 3.5242539276207285`*^9, {3.524254113276655*^9, 
   3.5242541142126565`*^9}, {3.5242547334245443`*^9, 3.5242547363105493`*^9}, 
   3.5249480328482866`*^9, 3.5249480870383625`*^9, 3.530383624409831*^9, 
   3.5303836572717104`*^9, {3.5304855821174417`*^9, 3.5304855869274483`*^9}, {
   3.530486056548106*^9, 3.530486059638111*^9}, {3.5304860949231606`*^9, 
   3.5304860971731634`*^9}, {3.530486238303361*^9, 3.530486240243364*^9}, {
   3.530486952589362*^9, 3.5304870139844484`*^9}, {3.5304870692495255`*^9, 
   3.5304871419796276`*^9}, 3.530487215744731*^9, {3.530487355799927*^9, 
   3.5304873566799283`*^9}, {3.5304874052599964`*^9, 3.530487445625053*^9}, {
   3.530487479950101*^9, 3.5304874842801075`*^9}, {3.5304875702952275`*^9, 
   3.5304875724102306`*^9}, {3.5304876163102922`*^9, 
   3.5304876315153136`*^9}, {3.5312563706495886`*^9, 3.531256451626027*^9}, 
   3.531256559250784*^9, {3.5312719121413507`*^9, 3.5312719878001423`*^9}, {
   3.5312755920427885`*^9, 3.5312755952874546`*^9}, {3.5312856302770605`*^9, 
   3.531285654712197*^9}, {3.53128571933512*^9, 3.531285787002421*^9}, {
   3.5312858245464067`*^9, 3.53128595057763*^9}, {3.5312865586519985`*^9, 
   3.5312865654417615`*^9}, 3.5312884106750765`*^9, 3.5312884470173345`*^9, {
   3.5312884901092978`*^9, 3.5312885050908403`*^9}, {3.5312897715218782`*^9, 
   3.531289778872448*^9}, {3.531289921757907*^9, 3.531289929969715*^9}, {
   3.5312899831061215`*^9, 3.531289984918728*^9}, {3.5312906523184013`*^9, 
   3.5312906554428945`*^9}, {3.5313272051827936`*^9, 
   3.5313272099296193`*^9}, {3.531327286489707*^9, 3.5313272948817744`*^9}, {
   3.531328437394627*^9, 3.5313284476694016`*^9}, {3.531328488668355*^9, 
   3.5313284899702272`*^9}, {3.5313285673514957`*^9, 
   3.5313285721283646`*^9}, {3.531328972333832*^9, 3.5313290468309536`*^9}, 
   3.5313291984689984`*^9, 3.5313298886113744`*^9, {3.5313316869672832`*^9, 
   3.5313316871876*^9}, {3.531333470732211*^9, 3.531333473936819*^9}, {
   3.531334503567355*^9, 3.5313345333702097`*^9}, {3.531334712117235*^9, 
   3.531334724334803*^9}, {3.5313353872780685`*^9, 3.531335388289523*^9}, 
   3.531335434696253*^9, {3.5313387527874336`*^9, 3.5313387613597603`*^9}, {
   3.531339025249214*^9, 3.5313390434353647`*^9}, 3.531341876639312*^9, {
   3.5313421989627905`*^9, 3.531342251227944*^9}, {3.531346616364702*^9, 
   3.531346616715206*^9}, {3.5313466656655936`*^9, 3.5313466801764593`*^9}, {
   3.5315136290734544`*^9, 3.531513629934693*^9}, {3.531605034435397*^9, 
   3.5316050365784783`*^9}, {3.5316052098275986`*^9, 
   3.5316052120307665`*^9}, {3.531605458364978*^9, 3.531605459536662*^9}, {
   3.531699937927347*^9, 3.531699949764368*^9}, {3.531700346314579*^9, 
   3.531700368586605*^9}, {3.533937757524288*^9, 3.5339377669843016`*^9}, {
   3.5339377979043446`*^9, 3.533937819634375*^9}, {3.533938179374879*^9, 
   3.5339381969849033`*^9}, {3.5339382401149635`*^9, 3.533938297835045*^9}, {
   3.533938343125108*^9, 3.53393834467511*^9}, {3.533940711115923*^9, 
   3.533940734385956*^9}, {3.533940828086087*^9, 3.533940838736102*^9}, {
   3.5339509493977776`*^9, 3.533950953016984*^9}, {3.5339537404454803`*^9, 
   3.533953741022681*^9}, {3.535149061766073*^9, 3.5351490873961086`*^9}, 
   3.53515177762788*^9, {3.535151835707961*^9, 3.535151875438017*^9}, 
   3.536688185946654*^9, {3.5498225630257645`*^9, 3.549822615605838*^9}, {
   3.5498226665359097`*^9, 3.549822670285915*^9}, {3.5498227309059997`*^9, 
   3.549822731346*^9}, 3.549823269906754*^9, 3.5498566016258125`*^9, {
   3.6113490321349196`*^9, 3.6113490577574587`*^9}, 3.611356704238345*^9, {
   3.6379382656630964`*^9, 3.637938316392169*^9}, {3.637958403695143*^9, 
   3.637958405239546*^9}, {3.6379584942281027`*^9, 3.6379584957569056`*^9}, {
   3.644441973453848*^9, 3.644441976360014*^9}, {3.7075934741513433`*^9, 
   3.7075934911063137`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{Cell[TextData[StyleBox["3.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{"m", "<", 
       RowBox[{"-", "1"}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.534118429444058*^9, 3.534118443920883*^9}, {3.5341185894379387`*^9, 
   3.5341185897187395`*^9}, {3.534126368193774*^9, 3.534126368483775*^9}, {
   3.5347073427604*^9, 3.5347073430411997`*^9}, {3.535151711347787*^9, 
   3.5351517116277876`*^9}, {3.535151925298087*^9, 3.5351519255180874`*^9}, {
   3.5356775304977665`*^9, 3.535677530762967*^9}, {3.539393935916008*^9, 
   3.5393939361497617`*^9}, {3.5498214781142454`*^9, 3.54982148130425*^9}, {
   3.5498223076054068`*^9, 3.549822311385412*^9}, {3.549823219676684*^9, 
   3.549823219676684*^9}, {3.5498234629870243`*^9, 3.5498234851170554`*^9}, {
   3.549852537380123*^9, 3.549852537590123*^9}, 3.5717051167397833`*^9, 
   3.5758229243469067`*^9, {3.6113489203222485`*^9, 3.611348923219753*^9}, {
   3.6113491920426655`*^9, 3.611349194465169*^9}, {3.611349323642867*^9, 
   3.611349323855367*^9}, {3.6113556961469336`*^9, 3.6113556961469336`*^9}, {
   3.6379383749222527`*^9, 3.637938375112253*^9}, 3.6379584062379475`*^9, 
   3.6379584964433064`*^9, {3.644441998056255*^9, 3.644441998056255*^9}, {
   3.644472420961872*^9, 3.644472420961872*^9}, {3.6489542736719985`*^9, 
   3.6489542738660097`*^9}, {3.648955827244858*^9, 3.6489558274428687`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{Cell[TextData[StyleBox["1:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], " ", Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"m", "<", 
        RowBox[{"-", "1"}]}], " ", "\[And]", " ", 
       RowBox[{"n", ">", "0"}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.5192504337891226`*^9, 3.5192504707812386`*^9}, 3.5192506717957726`*^9, {
   3.519250720795459*^9, 3.5192507409818945`*^9}, 3.519258420209427*^9, 
   3.519258489779525*^9, {3.519320786305674*^9, 3.519320803294104*^9}, {
   3.519329422708468*^9, 3.5193294257984724`*^9}, 3.5193294706485353`*^9, {
   3.5193302883925123`*^9, 3.519330307237345*^9}, {3.5193303440378103`*^9, 
   3.5193303650666466`*^9}, 3.5193341918281684`*^9, {3.5193346196121197`*^9, 
   3.519334632840943*^9}, {3.519341922663512*^9, 3.5193419232095127`*^9}, 
   3.5193423494490614`*^9, {3.5193456600396833`*^9, 3.519345660273684*^9}, 
   3.519410696547495*^9, {3.519793559756592*^9, 3.5197935600217924`*^9}, {
   3.5210541942272606`*^9, 3.5210542323693275`*^9}, {3.521054705798959*^9, 
   3.5210547345342093`*^9}, {3.521055431683834*^9, 3.5210554455522585`*^9}, {
   3.5210554827427235`*^9, 3.5210555031319594`*^9}, {3.521056059772137*^9, 
   3.521056075652965*^9}, {3.521057417664521*^9, 3.521057417867322*^9}, {
   3.5210574854778404`*^9, 3.5210574857586412`*^9}, {3.5210575212175035`*^9, 
   3.521057540483537*^9}, {3.5210598942936716`*^9, 3.5210599092384977`*^9}, {
   3.521063276214819*^9, 3.521063298928458*^9}, {3.5210639991824884`*^9, 
   3.5210640343449497`*^9}, {3.5210641665551825`*^9, 
   3.5210641665551825`*^9}, {3.521072868148899*^9, 3.521072868148899*^9}, {
   3.5210824253375397`*^9, 3.5210824255559406`*^9}, {3.5211479965711794`*^9, 
   3.521148020673222*^9}, {3.5211480693453074`*^9, 3.5211480699537086`*^9}, {
   3.521148148187846*^9, 3.5211481489366474`*^9}, {3.5211482363436007`*^9, 
   3.5211482363436007`*^9}, {3.521148269556059*^9, 3.521148269556059*^9}, {
   3.521346368187188*^9, 3.521346368421189*^9}, {3.5214702809911447`*^9, 
   3.5214702811783447`*^9}, {3.5216579052539043`*^9, 3.521657905453904*^9}, {
   3.5223485259619713`*^9, 3.522348534381983*^9}, {3.5233208394702005`*^9, 
   3.5233208394702005`*^9}, {3.523320922845537*^9, 3.523320922845537*^9}, 
   3.523747250675035*^9, {3.5237670269856477`*^9, 3.5237670269856477`*^9}, {
   3.523831184179017*^9, 3.523831184179017*^9}, 3.5247720382710953`*^9, {
   3.524772397491598*^9, 3.524772397491598*^9}, {3.524774194324114*^9, 
   3.524774228794162*^9}, {3.526945238644486*^9, 3.526945238644486*^9}, {
   3.5279098167721815`*^9, 3.5279098172421827`*^9}, {3.5296282016140704`*^9, 
   3.5296282019130874`*^9}, 3.530384384323295*^9, {3.5303845765632906`*^9, 
   3.530384576766302*^9}, {3.530412765574172*^9, 3.530412765724172*^9}, {
   3.5304133134449387`*^9, 3.530413327614959*^9}, {3.5304133632650084`*^9, 
   3.5304133653750114`*^9}, {3.5304685359612284`*^9, 
   3.5304685362112293`*^9}, {3.5306637757276535`*^9, 3.530663775992854*^9}, 
   3.531940972073534*^9, {3.531941135920622*^9, 3.531941136887823*^9}, {
   3.531941292685297*^9, 3.5319412934028983`*^9}, {3.531941412696308*^9, 
   3.53194141378831*^9}, {3.531941540834933*^9, 3.531941542176535*^9}, {
   3.531941747348096*^9, 3.5319417604365187`*^9}, {3.5319419776265*^9, 
   3.531941978453302*^9}, {3.5319420524598317`*^9, 3.5319420537078342`*^9}, {
   3.5319437460612063`*^9, 3.5319437460612063`*^9}, {3.531945368214856*^9, 
   3.531945368214856*^9}, {3.5339235218280125`*^9, 3.533923522848014*^9}, {
   3.5340030836026883`*^9, 3.534003084035713*^9}, 3.534118752423112*^9, {
   3.5341190488235273`*^9, 3.534119049053528*^9}, {3.534119148303666*^9, 
   3.534119148303666*^9}, {3.534120420875448*^9, 3.534120420875448*^9}, {
   3.5498208462833614`*^9, 3.5498208462833614`*^9}, {3.5498211663538094`*^9, 
   3.5498211663538094`*^9}, {3.549821200773857*^9, 3.549821200773857*^9}, {
   3.5498216451444798`*^9, 3.5498216451444798`*^9}, {3.5498232226966877`*^9, 
   3.5498232226966877`*^9}, 3.571705117349784*^9, 3.5758229250769076`*^9, 
   3.611347276925747*^9, {3.611349129752569*^9, 3.6113491528051047`*^9}, {
   3.611349210162693*^9, 3.611349212315196*^9}, {3.6113552773263474`*^9, 
   3.6113552773263474`*^9}, {3.6113554899766445`*^9, 3.61135550774667*^9}, 
   3.6379584069867487`*^9, 3.637958496973707*^9, {3.6444420047256365`*^9, 
   3.6444420047256365`*^9}, {3.6444722735044384`*^9, 3.644472285350116*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Nondegenerate trilinear recurrence 1", "Subsubsection",
 CellChangeTimes->{
  3.496441803031353*^9, 3.4965396318089237`*^9, {3.4966002562016735`*^9, 
   3.4966002624716825`*^9}, 3.496600707442305*^9, 3.4966008475725017`*^9, {
   3.4966070255131593`*^9, 3.496607032413169*^9}, 3.518279406700592*^9, {
   3.51840552316576*^9, 3.5184055392257824`*^9}, 3.5184690414436746`*^9, 
   3.518469651844529*^9, 3.5184700043450227`*^9, 3.518474659316563*^9, 
   3.5237473322319784`*^9, 3.5247722814214354`*^9, {3.5260660236439*^9, 
   3.526066024233901*^9}, {3.530413463335149*^9, 3.5304134989751987`*^9}, {
   3.5339258909313297`*^9, 3.533925894241334*^9}, {3.5341187688231354`*^9, 
   3.534118769443136*^9}, 3.6113471282355328`*^9}],

Cell[TextData[{
 "Rule 1.1.1.4",
 ".1.3.1: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"m", "<", 
    RowBox[{"-", "1"}]}], " ", "\[And]", " ", 
   RowBox[{"n", ">", "0"}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.4964417379912624`*^9, 3.4964417471112747`*^9}, {
   3.496441910111503*^9, 3.4964419275315275`*^9}, 3.496451213764926*^9, {
   3.496539487018721*^9, 3.4965395223187704`*^9}, {3.4966001213614845`*^9, 
   3.4966001362815056`*^9}, {3.4966047635399923`*^9, 
   3.4966048329500895`*^9}, {3.496604896730179*^9, 3.496605019710351*^9}, {
   3.496605050490394*^9, 3.4966050527103972`*^9}, {3.4966066606926484`*^9, 
   3.496606694832696*^9}, 3.496606873362946*^9, {3.4966081836347804`*^9, 
   3.496608250534874*^9}, {3.496608418375109*^9, 3.496608441025141*^9}, {
   3.4966322809467688`*^9, 3.4966322818867702`*^9}, {3.4968592460220995`*^9, 
   3.4968592640557313`*^9}, {3.4968593076422076`*^9, 
   3.4968593113862143`*^9}, {3.496859384233942*^9, 3.496859384233942*^9}, {
   3.518223900967896*^9, 3.518223909467908*^9}, 3.5182817155426493`*^9, {
   3.518285874431555*^9, 3.518285899625599*^9}, {3.5182860969191456`*^9, 
   3.518286138321618*^9}, {3.518286898517355*^9, 3.518286898517355*^9}, {
   3.5182870794776726`*^9, 3.5182870794776726`*^9}, {3.518469568024412*^9, 
   3.518469584774435*^9}, {3.518469921924907*^9, 3.5184699227449083`*^9}, {
   3.51847035958552*^9, 3.518470374475541*^9}, {3.518474847889694*^9, 
   3.518474854394906*^9}, {3.518475351645779*^9, 3.51847535181738*^9}, {
   3.518476861483632*^9, 3.5184768701416473`*^9}, {3.5184769318709555`*^9, 
   3.518476937876966*^9}, {3.5185837532117095`*^9, 3.51858375372651*^9}, {
   3.5211482838768845`*^9, 3.5211482838768845`*^9}, {3.5223485487820034`*^9, 
   3.5223485487820034`*^9}, {3.5237580782402368`*^9, 
   3.5237580830402436`*^9}, {3.524772390921589*^9, 3.524772390921589*^9}, {
   3.524774159434065*^9, 3.5247741821040964`*^9}, {3.526945226804065*^9, 
   3.5269452323576756`*^9}, {3.530413508385212*^9, 3.530413508385212*^9}, {
   3.5319411411622305`*^9, 3.5319411411622305`*^9}, {3.5319412943077*^9, 
   3.5319412943077*^9}, {3.531941415098712*^9, 3.531941415098712*^9}, {
   3.531941547106144*^9, 3.531941547776945*^9}, {3.5319417707481365`*^9, 
   3.531941771746538*^9}, {3.5319419851613135`*^9, 3.5319419851613135`*^9}, {
   3.5319420546594353`*^9, 3.5319420546594353`*^9}, {3.531943749524412*^9, 
   3.531943749820813*^9}, {3.531945371147661*^9, 3.531945371147661*^9}, {
   3.5341190906435857`*^9, 3.5341191318936434`*^9}, {3.534120297225275*^9, 
   3.534120297225275*^9}, {3.5498208623633833`*^9, 3.5498208623633833`*^9}, {
   3.5498211672938104`*^9, 3.5498211672938104`*^9}, {3.549821201683859*^9, 
   3.549821201683859*^9}, {3.549821649714486*^9, 3.549821649714486*^9}, {
   3.5498232266166935`*^9, 3.5498232266166935`*^9}, {3.611355253586314*^9, 
   3.611355262896327*^9}, {3.6113556127468166`*^9, 3.6113556127468166`*^9}, {
   3.6444420095999155`*^9, 3.6444420095999155`*^9}, {3.6444728947669725`*^9, 
   3.6444728947669725`*^9}, 3.6501606003466845`*^9, {3.650160737093506*^9, 
   3.650160740007673*^9}, 3.698684024113455*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "g"}], "-", 
          RowBox[{"a", " ", "h"}]}], ")"}], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}], 
         RowBox[{"m", "+", "1"}]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", " ", "x"}]}], ")"}], 
         RowBox[{"p", "+", "1"}]]}], 
       RowBox[{"b", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "e"}], "-", 
          RowBox[{"a", " ", "f"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}]}]]}]}]}]}], "-", 
  "\[IndentingNewLine]", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"b", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", " ", "e"}], "-", 
       RowBox[{"a", " ", "f"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"m", "+", "1"}], ")"}]}]], 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"m", "+", "1"}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], 
      RowBox[{"n", "-", "1"}]], " ", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], "p"], "\[CenterDot]", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "c", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", " ", "g"}], "-", 
           RowBox[{"e", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "g"}], "-", 
           RowBox[{"a", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "e", " ", "n"}], "+", 
           RowBox[{"c", " ", "f", " ", 
            RowBox[{"(", 
             RowBox[{"p", "+", "1"}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{"d", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", " ", "g"}], "-", 
              RowBox[{"e", " ", "h"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "+", 
           RowBox[{"f", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", " ", "g"}], "-", 
              RowBox[{"a", " ", "h"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"n", "+", "p", "+", "1"}], ")"}]}]}], ")"}], " ", 
         "x"}]}], ")"}]}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, 3.4958399855843487`*^9, 3.495840155344586*^9, 
   3.495840624735243*^9, {3.4958474296047697`*^9, 3.495847433754776*^9}, {
   3.4958476539050837`*^9, 3.495847660315093*^9}, {3.4958482220958796`*^9, 
   3.4958482231858807`*^9}, {3.495848257515929*^9, 3.4958482607459335`*^9}, 
   3.4959261390123196`*^9, 3.4959262745925093`*^9, 3.4959264909328117`*^9, 
   3.4959265843129425`*^9, 3.495926967463479*^9, {3.496184978535224*^9, 
   3.496185020185282*^9}, {3.4961873840085917`*^9, 3.496187409278627*^9}, {
   3.4961890232008867`*^9, 3.4961890250708895`*^9}, 3.4961956176127515`*^9, {
   3.4961956815728407`*^9, 3.496195696542862*^9}, {3.4961957791729774`*^9, 
   3.4961957920929956`*^9}, 3.496195845773071*^9, 3.518405474905692*^9, {
   3.51840566597596*^9, 3.5184056974360037`*^9}, {3.518405737026059*^9, 
   3.5184057718861084`*^9}, {3.5184058668262415`*^9, 3.518405869606245*^9}, {
   3.5184688792534475`*^9, 3.518468891673465*^9}, 3.5184689356235266`*^9, {
   3.5184691371938086`*^9, 3.5184691450938196`*^9}, {3.51846968832458*^9, 
   3.5184697035846014`*^9}, {3.518470060915102*^9, 3.518470082885133*^9}, {
   3.5184747044318423`*^9, 3.5184747207338715`*^9}, 3.518475002735566*^9, {
   3.5188842113796167`*^9, 3.518884228949641*^9}, {3.518890960739066*^9, 
   3.5188909798390923`*^9}, {3.520101172685255*^9, 3.520101193979293*^9}, 
   3.520101537866297*^9, {3.520101583012776*^9, 3.520101592138792*^9}, 
   3.5237473966912913`*^9, {3.523747635309311*^9, 3.523747662094558*^9}, 
   3.523747693201012*^9, {3.5237589154214087`*^9, 3.523758920041415*^9}, {
   3.523835091963359*^9, 3.523835095403364*^9}, 3.5247720424111013`*^9, {
   3.5247722402213783`*^9, 3.524772242541381*^9}, {3.5247723065014706`*^9, 
   3.524772310491476*^9}, {3.5247724101316156`*^9, 3.5247725806518545`*^9}, {
   3.5247726200519094`*^9, 3.5247727072220316`*^9}, {3.5247728848022804`*^9, 
   3.5247728894922867`*^9}, {3.5247737712335215`*^9, 
   3.5247738023335648`*^9}, {3.5279824084921894`*^9, 
   3.5279824453238535`*^9}, {3.5304116139925594`*^9, 
   3.5304117038726854`*^9}, {3.530411918742986*^9, 3.53041197123306*^9}, 
   3.531941036782448*^9, {3.5319411448594375`*^9, 3.5319411488686447`*^9}, {
   3.531941294947301*^9, 3.531941298394907*^9}, {3.5319414162219143`*^9, 
   3.5319414182655177`*^9}, {3.531941548510146*^9, 3.5319415504133496`*^9}, {
   3.5319417755685453`*^9, 3.5319417799833527`*^9}, {3.5319419862689157`*^9, 
   3.531941989685322*^9}, {3.531942055798238*^9, 3.5319420566406393`*^9}, {
   3.5319437006495266`*^9, 3.5319437038787327`*^9}, {3.5340026346818047`*^9, 
   3.534002637453963*^9}, {3.5340030209706793`*^9, 3.5340030293451586`*^9}, {
   3.534118784243157*^9, 3.5341188511132507`*^9}, {3.534119170853698*^9, 
   3.534119179923711*^9}, {3.549821168493812*^9, 3.549821169183813*^9}, {
   3.5498212149238772`*^9, 3.5498212296038976`*^9}, {3.5498217386846104`*^9, 
   3.549821773394659*^9}, {3.5498218408947535`*^9, 3.549821918944863*^9}, {
   3.549917485847399*^9, 3.549917508554234*^9}, {3.549917548167096*^9, 
   3.5499175797767453`*^9}, {3.611347222158168*^9, 3.6113472629657264`*^9}, 
   3.611355123216131*^9, {3.6379584080007505`*^9, 3.6379584131351595`*^9}, {
   3.637958497628908*^9, 3.6379585005013137`*^9}, {3.63795864635797*^9, 
   3.6379586946272554`*^9}, {3.6379587749617977`*^9, 3.6379587764282*^9}, {
   3.6379588563841405`*^9, 3.637958922082856*^9}, {3.6379589875963717`*^9, 
   3.637958992681981*^9}, {3.6444725469970813`*^9, 3.6444726690630627`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.520101787997136*^9, 3.5201017908831415`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", "*", "g"}], "-", 
       RowBox[{"a", "*", "h"}]}], ")"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", "*", "x"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"p", "+", "1"}], ")"}]}], "/", 
      RowBox[{"(", 
       RowBox[{"b", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}]}], ")"}]}]}], " ", "-", " ", "\n", 
    "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"b", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"n", "-", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "*", "\n", "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"b", "*", "c", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "-", 
              RowBox[{"e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", "g"}], "-", 
              RowBox[{"a", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", "*", "e", "*", "n"}], "+", 
              RowBox[{"c", "*", "f", "*", 
               RowBox[{"(", 
                RowBox[{"p", "+", "1"}], ")"}]}]}], ")"}]}], "+", 
           RowBox[{"d", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", "*", "g"}], "-", 
                 RowBox[{"e", "*", "h"}]}], ")"}], "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "1"}], ")"}]}], "+", 
              RowBox[{"f", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"b", "*", "g"}], "-", 
                 RowBox[{"a", "*", "h"}]}], ")"}], "*", 
               RowBox[{"(", 
                RowBox[{"n", "+", "p", "+", "1"}], ")"}]}]}], ")"}], "*", 
            "x"}]}], ",", "x"}], "]"}]}], ",", "x"}], "]"}]}]}], " ", "/;", 
   "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "p"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"LtQ", "[", 
     RowBox[{"m", ",", 
      RowBox[{"-", "1"}]}], "]"}], " ", "&&", " ", 
    RowBox[{"GtQ", "[", 
     RowBox[{"n", ",", "0"}], "]"}], " ", "&&", " ", 
    RowBox[{"IntegerQ", "[", "m", "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495839738475589*^9, 3.4958405008250694`*^9, {3.495847490784856*^9, 
   3.4958474999948683`*^9}, {3.4958477172451725`*^9, 3.495847721615179*^9}, {
   3.495848224085882*^9, 3.4958482277058873`*^9}, {3.4958482626259365`*^9, 
   3.4958482686359444`*^9}, 3.4959261054722724`*^9, {3.4959262905725317`*^9, 
   3.4959262958725395`*^9}, 3.495926443222745*^9, 3.4961849395451694`*^9, 
   3.496185884976493*^9, 3.4961888731806765`*^9, {3.4961890260508904`*^9, 
   3.4961890290708947`*^9}, {3.496191957967628*^9, 3.4961919600576305`*^9}, 
   3.49619205250776*^9, 3.4961952203321953`*^9, {3.496195426482484*^9, 
   3.496195433172493*^9}, {3.496195586822708*^9, 3.496195595732721*^9}, 
   3.496195754542943*^9, 3.4966189754082823`*^9, {3.4966198797795486`*^9, 
   3.496619907439587*^9}, {3.4968579645422487`*^9, 3.4968579680210547`*^9}, 
   3.5171911044266214`*^9, 3.518211198418105*^9, 3.5182420941409807`*^9, {
   3.518281849687285*^9, 3.518281849874485*^9}, {3.5182861978669233`*^9, 
   3.518286207226939*^9}, 3.518286893072945*^9, 3.518287077449669*^9, {
   3.518405919376315*^9, 3.5184059327163334`*^9}, 3.518406000866429*^9, {
   3.5184061023365707`*^9, 3.518406115016588*^9}, {3.5184065135071464`*^9, 
   3.518406515547149*^9}, {3.518406800569559*^9, 3.5184068071395683`*^9}, {
   3.518455696848171*^9, 3.518455715349804*^9}, {3.518469305994045*^9, 
   3.518469310354051*^9}, {3.5184693414340944`*^9, 3.5184693641841264`*^9}, {
   3.518469461554263*^9, 3.518469497814314*^9}, {3.5184698199647646`*^9, 
   3.5184698496348057`*^9}, {3.5184698834448533`*^9, 3.5184698844848547`*^9}, 
   3.5184701704452553`*^9, {3.518470248195364*^9, 3.518470287395419*^9}, {
   3.51847032361547*^9, 3.518470324325471*^9}, {3.518474812134432*^9, 
   3.5184748359088736`*^9}, {3.5184748784969482`*^9, 3.51847487927695*^9}, 
   3.518475395747057*^9, {3.5184754745583954`*^9, 3.518475478770403*^9}, {
   3.5184759352008047`*^9, 3.518475938726411*^9}, {3.5184760887674747`*^9, 
   3.5184761024174986`*^9}, {3.518476247310553*^9, 3.5184762483245544`*^9}, {
   3.518476459611326*^9, 3.518476460235327*^9}, {3.5185837600757217`*^9, 
   3.518583760356522*^9}, {3.5188842541996765`*^9, 3.5188842747997055`*^9}, {
   3.518890955169058*^9, 3.5188909696490784`*^9}, {3.5188914772697887`*^9, 
   3.518891482339796*^9}, {3.520102006257119*^9, 3.5201020069591208`*^9}, 
   3.5201020756928415`*^9, {3.5202847653043165`*^9, 3.520284765308317*^9}, {
   3.5202851424268866`*^9, 3.520285144721018*^9}, {3.520899838877209*^9, 
   3.5208998429572153`*^9}, {3.521131441309245*^9, 3.521131443849249*^9}, 
   3.521148390206671*^9, {3.5223485088319473`*^9, 3.5223485168319583`*^9}, {
   3.5224420691492205`*^9, 3.522442069414421*^9}, 3.5237568920485764`*^9, 
   3.523757219519035*^9, 3.523757259739091*^9, {3.5237580436701884`*^9, 
   3.523758059720211*^9}, {3.523758936761439*^9, 3.523758939721443*^9}, 
   3.523810558420226*^9, 3.523818931362772*^9, {3.523835156403449*^9, 
   3.5238351582934523`*^9}, 3.5247721246012163`*^9, {3.5247739098537154`*^9, 
   3.5247740062738504`*^9}, {3.524774046163906*^9, 3.524774061003927*^9}, {
   3.5269452650085325`*^9, 3.526945270312542*^9}, {3.527188364001113*^9, 
   3.5271883677139196`*^9}, {3.5271888173223095`*^9, 3.527188823843121*^9}, {
   3.5271899878391657`*^9, 3.5271900376656528`*^9}, {3.527190166287879*^9, 
   3.5271901716698885`*^9}, {3.527190278608076*^9, 3.5271902902768965`*^9}, {
   3.527982424123417*^9, 3.5279824278986235`*^9}, {3.5279825248995934`*^9, 
   3.5279825340568094`*^9}, {3.5304120848332186`*^9, 3.530412106123248*^9}, {
   3.5304130055745077`*^9, 3.530413008634512*^9}, {3.530413043314561*^9, 
   3.530413055224577*^9}, {3.530413087314622*^9, 3.5304130884346237`*^9}, {
   3.5304131472647057`*^9, 3.5304131483447075`*^9}, 3.53046311973864*^9, {
   3.5304888886920757`*^9, 3.530488894767084*^9}, {3.531941152706251*^9, 
   3.531941162830669*^9}, {3.531941299455709*^9, 3.531941306974922*^9}, {
   3.5319414191859193`*^9, 3.5319414225243254`*^9}, {3.531941554079356*^9, 
   3.531941559040165*^9}, {3.531941786394964*^9, 3.531941805174197*^9}, {
   3.5319419942717295`*^9, 3.531941998764538*^9}, {3.5319420576234407`*^9, 
   3.531942059916645*^9}, {3.531943420348234*^9, 3.5319434261514444`*^9}, {
   3.5319437080127397`*^9, 3.53194372535997*^9}, {3.531943778727664*^9, 
   3.531943779960066*^9}, {3.5319453490892224`*^9, 3.5319453522092276`*^9}, {
   3.5339415241170616`*^9, 3.533941538197081*^9}, {3.5339415789871387`*^9, 
   3.533941604107174*^9}, {3.5339512902895765`*^9, 3.5339512946731844`*^9}, 
   3.533951351067283*^9, {3.5340027757635803`*^9, 3.534002812286766*^9}, {
   3.5341190049334655`*^9, 3.5341190294735003`*^9}, {3.5341191883437223`*^9, 
   3.534119195643733*^9}, {3.5341193695439763`*^9, 3.53411941511404*^9}, {
   3.53411972218447*^9, 3.534119730414481*^9}, {3.534119793074569*^9, 
   3.5341197976045756`*^9}, {3.53411983666463*^9, 3.5341198371946306`*^9}, 
   3.534120368175374*^9, {3.53453202606665*^9, 3.534532032343009*^9}, {
   3.542249979559941*^9, 3.5422499863813305`*^9}, {3.542250027233576*^9, 
   3.5422500301127405`*^9}, 3.549820936973488*^9, {3.549821077543685*^9, 
   3.5498210849636955`*^9}, 3.549821115273738*^9, {3.5498212350039053`*^9, 
   3.5498212517139287`*^9}, 3.549821676434523*^9, 3.5498219662049294`*^9, 
   3.549822009354989*^9, 3.5498232746767607`*^9, {3.5499175558931084`*^9, 
   3.5499175584215117`*^9}, 3.5499176695472803`*^9, 3.5499177068009357`*^9, {
   3.6113472899957657`*^9, 3.6113473345658293`*^9}, {3.611355221746269*^9, 
   3.6113552425762987`*^9}, {3.611355526936696*^9, 3.6113555439167204`*^9}, {
   3.6113745662410493`*^9, 3.6113745688910527`*^9}, {3.611383366373863*^9, 
   3.6113833926639004`*^9}, {3.6113834350339594`*^9, 3.611383450953982*^9}, {
   3.611383543174111*^9, 3.6113835497941203`*^9}, {3.6113836141442103`*^9, 
   3.6113836145942106`*^9}, {3.637938185234982*^9, 3.637938201515005*^9}, 
   3.6379383191521726`*^9, {3.6379584141335616`*^9, 3.637958417799568*^9}, {
   3.637958501343715*^9, 3.637958504650921*^9}, {3.637958722787305*^9, 
   3.6379587418213387`*^9}, {3.637958936765482*^9, 3.6379589664251347`*^9}, 
   3.637959072828322*^9, 3.6391773685805335`*^9, {3.644442018554427*^9, 
   3.6444420209265633`*^9}, 3.6444728782420273`*^9, {3.644472929758974*^9, 
   3.644472937606423*^9}, {3.6538459150857544`*^9, 3.653845937660994*^9}, 
   3.6538461798320217`*^9, {3.653848647164784*^9, 3.653848653890396*^9}, {
   3.707703400883561*^9, 3.70770341751519*^9}},
 Background->GrayLevel[0.85]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", "*", "g"}], "-", 
       RowBox[{"a", "*", "h"}]}], ")"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", "*", "x"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"p", "+", "1"}], ")"}]}], "/", 
      RowBox[{"(", 
       RowBox[{"b", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}]}], ")"}]}]}], " ", "-", " ", "\n", 
    "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"b", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"n", "-", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "*", "\n", "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"b", "*", "c", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "-", 
              RowBox[{"e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", "g"}], "-", 
              RowBox[{"a", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", "*", "e", "*", "n"}], "+", 
              RowBox[{"c", "*", "f", "*", 
               RowBox[{"(", 
                RowBox[{"p", "+", "1"}], ")"}]}]}], ")"}]}], "+", 
           RowBox[{"d", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", "*", "g"}], "-", 
                 RowBox[{"e", "*", "h"}]}], ")"}], "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "1"}], ")"}]}], "+", 
              RowBox[{"f", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"b", "*", "g"}], "-", 
                 RowBox[{"a", "*", "h"}]}], ")"}], "*", 
               RowBox[{"(", 
                RowBox[{"n", "+", "p", "+", "1"}], ")"}]}]}], ")"}], "*", 
            "x"}]}], ",", "x"}], "]"}]}], ",", "x"}], "]"}]}]}], " ", "/;", 
   "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "p"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"LtQ", "[", 
     RowBox[{"m", ",", 
      RowBox[{"-", "1"}]}], "]"}], " ", "&&", " ", 
    RowBox[{"GtQ", "[", 
     RowBox[{"n", ",", "0"}], "]"}], " ", "&&", " ", 
    RowBox[{"IntegersQ", "[", 
     RowBox[{
      RowBox[{"2", "*", "m"}], ",", 
      RowBox[{"2", "*", "n"}], ",", 
      RowBox[{"2", "*", "p"}]}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495839738475589*^9, 3.4958405008250694`*^9, {3.495847490784856*^9, 
   3.4958474999948683`*^9}, {3.4958477172451725`*^9, 3.495847721615179*^9}, {
   3.495848224085882*^9, 3.4958482277058873`*^9}, {3.4958482626259365`*^9, 
   3.4958482686359444`*^9}, 3.4959261054722724`*^9, {3.4959262905725317`*^9, 
   3.4959262958725395`*^9}, 3.495926443222745*^9, 3.4961849395451694`*^9, 
   3.496185884976493*^9, 3.4961888731806765`*^9, {3.4961890260508904`*^9, 
   3.4961890290708947`*^9}, {3.496191957967628*^9, 3.4961919600576305`*^9}, 
   3.49619205250776*^9, 3.4961952203321953`*^9, {3.496195426482484*^9, 
   3.496195433172493*^9}, {3.496195586822708*^9, 3.496195595732721*^9}, 
   3.496195754542943*^9, 3.4966189754082823`*^9, {3.4966198797795486`*^9, 
   3.496619907439587*^9}, {3.4968579645422487`*^9, 3.4968579680210547`*^9}, 
   3.5171911044266214`*^9, 3.518211198418105*^9, 3.5182420941409807`*^9, {
   3.518281849687285*^9, 3.518281849874485*^9}, {3.5182861978669233`*^9, 
   3.518286207226939*^9}, 3.518286893072945*^9, 3.518287077449669*^9, {
   3.518405919376315*^9, 3.5184059327163334`*^9}, 3.518406000866429*^9, {
   3.5184061023365707`*^9, 3.518406115016588*^9}, {3.5184065135071464`*^9, 
   3.518406515547149*^9}, {3.518406800569559*^9, 3.5184068071395683`*^9}, {
   3.518455696848171*^9, 3.518455715349804*^9}, {3.518469305994045*^9, 
   3.518469310354051*^9}, {3.5184693414340944`*^9, 3.5184693641841264`*^9}, {
   3.518469461554263*^9, 3.518469497814314*^9}, {3.5184698199647646`*^9, 
   3.5184698496348057`*^9}, {3.5184698834448533`*^9, 3.5184698844848547`*^9}, 
   3.5184701704452553`*^9, {3.518470248195364*^9, 3.518470287395419*^9}, {
   3.51847032361547*^9, 3.518470324325471*^9}, {3.518474812134432*^9, 
   3.5184748359088736`*^9}, {3.5184748784969482`*^9, 3.51847487927695*^9}, 
   3.518475395747057*^9, {3.5184754745583954`*^9, 3.518475478770403*^9}, {
   3.5184759352008047`*^9, 3.518475938726411*^9}, {3.5184760887674747`*^9, 
   3.5184761024174986`*^9}, {3.518476247310553*^9, 3.5184762483245544`*^9}, {
   3.518476459611326*^9, 3.518476460235327*^9}, {3.5185837600757217`*^9, 
   3.518583760356522*^9}, {3.5188842541996765`*^9, 3.5188842747997055`*^9}, {
   3.518890955169058*^9, 3.5188909696490784`*^9}, {3.5188914772697887`*^9, 
   3.518891482339796*^9}, {3.520102006257119*^9, 3.5201020069591208`*^9}, 
   3.5201020756928415`*^9, {3.5202847653043165`*^9, 3.520284765308317*^9}, {
   3.5202851424268866`*^9, 3.520285144721018*^9}, {3.520899838877209*^9, 
   3.5208998429572153`*^9}, {3.521131441309245*^9, 3.521131443849249*^9}, 
   3.521148390206671*^9, {3.5223485088319473`*^9, 3.5223485168319583`*^9}, {
   3.5224420691492205`*^9, 3.522442069414421*^9}, 3.5237568920485764`*^9, 
   3.523757219519035*^9, 3.523757259739091*^9, {3.5237580436701884`*^9, 
   3.523758059720211*^9}, {3.523758936761439*^9, 3.523758939721443*^9}, 
   3.523810558420226*^9, 3.523818931362772*^9, {3.523835156403449*^9, 
   3.5238351582934523`*^9}, 3.5247721246012163`*^9, {3.5247739098537154`*^9, 
   3.5247740062738504`*^9}, {3.524774046163906*^9, 3.524774061003927*^9}, {
   3.5269452650085325`*^9, 3.526945270312542*^9}, {3.527188364001113*^9, 
   3.5271883677139196`*^9}, {3.5271888173223095`*^9, 3.527188823843121*^9}, {
   3.5271899878391657`*^9, 3.5271900376656528`*^9}, {3.527190166287879*^9, 
   3.5271901716698885`*^9}, {3.527190278608076*^9, 3.5271902902768965`*^9}, {
   3.527982424123417*^9, 3.5279824278986235`*^9}, {3.5279825248995934`*^9, 
   3.5279825340568094`*^9}, {3.5304120848332186`*^9, 3.530412106123248*^9}, {
   3.5304130055745077`*^9, 3.530413008634512*^9}, {3.530413043314561*^9, 
   3.530413055224577*^9}, {3.530413087314622*^9, 3.5304130884346237`*^9}, {
   3.5304131472647057`*^9, 3.5304131483447075`*^9}, 3.53046311973864*^9, {
   3.5304888886920757`*^9, 3.530488894767084*^9}, {3.531941152706251*^9, 
   3.531941162830669*^9}, {3.531941299455709*^9, 3.531941306974922*^9}, {
   3.5319414191859193`*^9, 3.5319414225243254`*^9}, {3.531941554079356*^9, 
   3.531941559040165*^9}, {3.531941786394964*^9, 3.531941805174197*^9}, {
   3.5319419942717295`*^9, 3.531941998764538*^9}, {3.5319420576234407`*^9, 
   3.531942059916645*^9}, {3.531943420348234*^9, 3.5319434261514444`*^9}, {
   3.5319437080127397`*^9, 3.53194372535997*^9}, {3.531943778727664*^9, 
   3.531943779960066*^9}, {3.5319453490892224`*^9, 3.5319453522092276`*^9}, {
   3.5339415241170616`*^9, 3.533941538197081*^9}, {3.5339415789871387`*^9, 
   3.533941604107174*^9}, {3.5339512902895765`*^9, 3.5339512946731844`*^9}, 
   3.533951351067283*^9, {3.5340027757635803`*^9, 3.534002812286766*^9}, {
   3.5341190049334655`*^9, 3.5341190294735003`*^9}, {3.5341191883437223`*^9, 
   3.534119195643733*^9}, {3.5341193695439763`*^9, 3.53411941511404*^9}, {
   3.53411972218447*^9, 3.534119730414481*^9}, {3.534119793074569*^9, 
   3.5341197976045756`*^9}, {3.53411983666463*^9, 3.5341198371946306`*^9}, 
   3.534120368175374*^9, {3.53453202606665*^9, 3.534532032343009*^9}, {
   3.542249979559941*^9, 3.5422499863813305`*^9}, {3.542250027233576*^9, 
   3.5422500301127405`*^9}, 3.549820936973488*^9, {3.549821077543685*^9, 
   3.5498210849636955`*^9}, 3.549821115273738*^9, {3.5498212350039053`*^9, 
   3.5498212517139287`*^9}, 3.549821676434523*^9, 3.5498219662049294`*^9, 
   3.549822009354989*^9, 3.5498232746767607`*^9, {3.5499175558931084`*^9, 
   3.5499175584215117`*^9}, 3.5499176695472803`*^9, 3.5499177068009357`*^9, {
   3.6113472899957657`*^9, 3.6113473345658293`*^9}, {3.611355221746269*^9, 
   3.6113552425762987`*^9}, {3.611355526936696*^9, 3.6113555439167204`*^9}, {
   3.6113745662410493`*^9, 3.6113745688910527`*^9}, {3.611383366373863*^9, 
   3.6113833926639004`*^9}, {3.6113834350339594`*^9, 3.611383450953982*^9}, {
   3.611383543174111*^9, 3.6113835497941203`*^9}, {3.6113836141442103`*^9, 
   3.6113836145942106`*^9}, {3.637938185234982*^9, 3.637938201515005*^9}, 
   3.6379383191521726`*^9, {3.6379584141335616`*^9, 3.637958417799568*^9}, {
   3.637958501343715*^9, 3.637958504650921*^9}, {3.637958722787305*^9, 
   3.6379587418213387`*^9}, {3.637958936765482*^9, 3.6379589664251347`*^9}, 
   3.637959072828322*^9, 3.6391773685805335`*^9, {3.644442018554427*^9, 
   3.6444420209265633`*^9}, 3.6444728782420273`*^9, {3.644472929758974*^9, 
   3.644472937606423*^9}, 3.6538458884359074`*^9, {3.6538459655110435`*^9, 
   3.653846003987711*^9}, {3.653847647881613*^9, 3.6538476487708144`*^9}, {
   3.653848641406374*^9, 3.6538486615344095`*^9}, 3.7077034282324095`*^9},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{Cell[TextData[StyleBox["2:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], " ", Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"m", "<", 
        RowBox[{"-", "1"}]}], " ", "\[And]", " ", 
       RowBox[{"n", "\[NotGreater]", "0"}]}]]]], 
      "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.5192504337891226`*^9, 3.5192504707812386`*^9}, 3.5192506717957726`*^9, {
   3.519250720795459*^9, 3.5192507409818945`*^9}, 3.519258420209427*^9, 
   3.519258489779525*^9, {3.519320786305674*^9, 3.519320803294104*^9}, {
   3.519329422708468*^9, 3.5193294257984724`*^9}, 3.5193294706485353`*^9, {
   3.5193302883925123`*^9, 3.519330307237345*^9}, {3.5193303440378103`*^9, 
   3.5193303650666466`*^9}, 3.5193341918281684`*^9, {3.5193346196121197`*^9, 
   3.519334632840943*^9}, {3.519341922663512*^9, 3.5193419232095127`*^9}, 
   3.5193423494490614`*^9, {3.5193456600396833`*^9, 3.519345660273684*^9}, 
   3.519410696547495*^9, {3.519793559756592*^9, 3.5197935600217924`*^9}, {
   3.5210541942272606`*^9, 3.5210542323693275`*^9}, {3.521054705798959*^9, 
   3.5210547345342093`*^9}, {3.521055431683834*^9, 3.5210554455522585`*^9}, {
   3.5210554827427235`*^9, 3.5210555031319594`*^9}, {3.521056059772137*^9, 
   3.521056075652965*^9}, {3.521057417664521*^9, 3.521057417867322*^9}, {
   3.5210574854778404`*^9, 3.5210574857586412`*^9}, {3.5210575212175035`*^9, 
   3.521057540483537*^9}, {3.5210598942936716`*^9, 3.5210599092384977`*^9}, {
   3.521063276214819*^9, 3.521063298928458*^9}, {3.5210639991824884`*^9, 
   3.5210640343449497`*^9}, {3.5210641665551825`*^9, 
   3.5210641665551825`*^9}, {3.521072868148899*^9, 3.521072868148899*^9}, {
   3.5210824253375397`*^9, 3.5210824255559406`*^9}, {3.5211479965711794`*^9, 
   3.521148020673222*^9}, {3.5211480693453074`*^9, 3.5211480699537086`*^9}, {
   3.521148148187846*^9, 3.5211481489366474`*^9}, {3.5211482363436007`*^9, 
   3.5211482363436007`*^9}, {3.521148269556059*^9, 3.521148269556059*^9}, {
   3.521346368187188*^9, 3.521346368421189*^9}, {3.5214702809911447`*^9, 
   3.5214702811783447`*^9}, {3.5216579052539043`*^9, 3.521657905453904*^9}, {
   3.5223485259619713`*^9, 3.522348534381983*^9}, {3.5233208394702005`*^9, 
   3.5233208394702005`*^9}, {3.523320922845537*^9, 3.523320922845537*^9}, 
   3.523747250675035*^9, {3.5237670269856477`*^9, 3.5237670269856477`*^9}, {
   3.523831184179017*^9, 3.523831184179017*^9}, 3.5247720382710953`*^9, {
   3.524772397491598*^9, 3.524772397491598*^9}, {3.524774194324114*^9, 
   3.524774228794162*^9}, {3.526945238644486*^9, 3.526945238644486*^9}, {
   3.5279098167721815`*^9, 3.5279098172421827`*^9}, {3.5296282016140704`*^9, 
   3.5296282019130874`*^9}, 3.530384384323295*^9, {3.5303845765632906`*^9, 
   3.530384576766302*^9}, {3.530412765574172*^9, 3.530412765724172*^9}, {
   3.5304133134449387`*^9, 3.530413327614959*^9}, {3.5304133632650084`*^9, 
   3.5304133653750114`*^9}, {3.5304685359612284`*^9, 
   3.5304685362112293`*^9}, {3.5306637757276535`*^9, 3.530663775992854*^9}, 
   3.531940972073534*^9, {3.531941135920622*^9, 3.531941136887823*^9}, {
   3.531941292685297*^9, 3.5319412934028983`*^9}, {3.531941412696308*^9, 
   3.53194141378831*^9}, {3.531941540834933*^9, 3.531941542176535*^9}, {
   3.531941747348096*^9, 3.5319417604365187`*^9}, {3.5319419776265*^9, 
   3.531941978453302*^9}, {3.5319420524598317`*^9, 3.5319420537078342`*^9}, {
   3.5319437460612063`*^9, 3.5319437460612063`*^9}, {3.531945368214856*^9, 
   3.531945368214856*^9}, {3.5339235218280125`*^9, 3.533923522848014*^9}, {
   3.5340030836026883`*^9, 3.534003084035713*^9}, 3.534118752423112*^9, {
   3.5341190488235273`*^9, 3.534119049053528*^9}, {3.534119148303666*^9, 
   3.534119148303666*^9}, {3.534119453664094*^9, 3.5341194538540945`*^9}, {
   3.534119902144722*^9, 3.534119902374722*^9}, {3.534120406425428*^9, 
   3.534120406425428*^9}, {3.549820849863366*^9, 3.5498208498733664`*^9}, {
   3.549821172193817*^9, 3.549821172193817*^9}, {3.549821203363861*^9, 
   3.549821203363861*^9}, {3.549822107375127*^9, 3.549822107375127*^9}, {
   3.549823247326722*^9, 3.549823247326722*^9}, {3.549823490687063*^9, 
   3.549823492017065*^9}, {3.549823618477242*^9, 3.5498236350772657`*^9}, 
   3.5717051179597855`*^9, 3.575822925736909*^9, {3.611348144806993*^9, 
   3.611348144806993*^9}, {3.611348896789712*^9, 3.611348900119717*^9}, 
   3.611349282915304*^9, {3.611349324885369*^9, 3.6113493250653687`*^9}, {
   3.611349703468462*^9, 3.611349703468462*^9}, {3.6113557010469403`*^9, 
   3.6113557010469403`*^9}, {3.637938376592255*^9, 3.637938376772256*^9}, 
   3.637958426816384*^9, 3.637958512123334*^9, {3.644442063200981*^9, 
   3.644442063200981*^9}, {3.6444722513391705`*^9, 3.6444722533592863`*^9}, {
   3.644472364258629*^9, 3.6444723744222107`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Nondegenerate trilinear recurrence 3", "Subsubsection",
 CellChangeTimes->{
  3.496441803031353*^9, 3.4965396318089237`*^9, {3.4966002562016735`*^9, 
   3.4966002624716825`*^9}, 3.496600707442305*^9, 3.4966008475725017`*^9, {
   3.4966070255131593`*^9, 3.496607032413169*^9}, 3.518279406700592*^9, {
   3.51840552316576*^9, 3.5184055392257824`*^9}, 3.5184690414436746`*^9, 
   3.518469651844529*^9, 3.5184700043450227`*^9, 3.518474659316563*^9, 
   3.5237473322319784`*^9, 3.5247722814214354`*^9, {3.5260660236439*^9, 
   3.526066024233901*^9}, {3.530413463335149*^9, 3.5304134989751987`*^9}, {
   3.5339258909313297`*^9, 3.533925894241334*^9}, {3.5341187688231354`*^9, 
   3.534118769443136*^9}, {3.534119456044097*^9, 3.5341194563640976`*^9}, {
   3.534119904484725*^9, 3.5341199048347254`*^9}, 3.6113471307105365`*^9}],

Cell[TextData[{
 "Rule 1.1.1.4",
 ".1.3.2: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"m", "<", 
    RowBox[{"-", "1"}]}], " ", "\[And]", " ", 
   RowBox[{"n", "\[NotGreater]", "0"}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.4964417379912624`*^9, 3.4964417471112747`*^9}, {
   3.496441910111503*^9, 3.4964419275315275`*^9}, 3.496451213764926*^9, {
   3.496539487018721*^9, 3.4965395223187704`*^9}, {3.4966001213614845`*^9, 
   3.4966001362815056`*^9}, {3.4966047635399923`*^9, 
   3.4966048329500895`*^9}, {3.496604896730179*^9, 3.496605019710351*^9}, {
   3.496605050490394*^9, 3.4966050527103972`*^9}, {3.4966066606926484`*^9, 
   3.496606694832696*^9}, 3.496606873362946*^9, {3.4966081836347804`*^9, 
   3.496608250534874*^9}, {3.496608418375109*^9, 3.496608441025141*^9}, {
   3.4966322809467688`*^9, 3.4966322818867702`*^9}, {3.4968592460220995`*^9, 
   3.4968592640557313`*^9}, {3.4968593076422076`*^9, 
   3.4968593113862143`*^9}, {3.496859384233942*^9, 3.496859384233942*^9}, {
   3.518223900967896*^9, 3.518223909467908*^9}, 3.5182817155426493`*^9, {
   3.518285874431555*^9, 3.518285899625599*^9}, {3.5182860969191456`*^9, 
   3.518286138321618*^9}, {3.518286898517355*^9, 3.518286898517355*^9}, {
   3.5182870794776726`*^9, 3.5182870794776726`*^9}, {3.518469568024412*^9, 
   3.518469584774435*^9}, {3.518469921924907*^9, 3.5184699227449083`*^9}, {
   3.51847035958552*^9, 3.518470374475541*^9}, {3.518474847889694*^9, 
   3.518474854394906*^9}, {3.518475351645779*^9, 3.51847535181738*^9}, {
   3.518476861483632*^9, 3.5184768701416473`*^9}, {3.5184769318709555`*^9, 
   3.518476937876966*^9}, {3.5185837532117095`*^9, 3.51858375372651*^9}, {
   3.5211482838768845`*^9, 3.5211482838768845`*^9}, {3.5223485487820034`*^9, 
   3.5223485487820034`*^9}, {3.5237580782402368`*^9, 
   3.5237580830402436`*^9}, {3.524772390921589*^9, 3.524772390921589*^9}, {
   3.524774159434065*^9, 3.5247741821040964`*^9}, {3.526945226804065*^9, 
   3.5269452323576756`*^9}, {3.530413508385212*^9, 3.530413508385212*^9}, {
   3.5319411411622305`*^9, 3.5319411411622305`*^9}, {3.5319412943077*^9, 
   3.5319412943077*^9}, {3.531941415098712*^9, 3.531941415098712*^9}, {
   3.531941547106144*^9, 3.531941547776945*^9}, {3.5319417707481365`*^9, 
   3.531941771746538*^9}, {3.5319419851613135`*^9, 3.5319419851613135`*^9}, {
   3.5319420546594353`*^9, 3.5319420546594353`*^9}, {3.531943749524412*^9, 
   3.531943749820813*^9}, {3.531945371147661*^9, 3.531945371147661*^9}, {
   3.5341190906435857`*^9, 3.5341191318936434`*^9}, {3.534120260765224*^9, 
   3.5341202685852346`*^9}, {3.53412040067542*^9, 3.5341204008654203`*^9}, {
   3.549820877533405*^9, 3.549820877533405*^9}, {3.549821172943818*^9, 
   3.549821172943818*^9}, {3.549821204003862*^9, 3.549821204003862*^9}, {
   3.54982210991513*^9, 3.54982210991513*^9}, {3.549823249286725*^9, 
   3.549823249286725*^9}, {3.5498236779473257`*^9, 3.5498236779473257`*^9}, {
   3.611348133836977*^9, 3.6113481426269903`*^9}, {3.6113557053269463`*^9, 
   3.6113557053269463`*^9}, {3.6444420718154736`*^9, 3.6444420718154736`*^9}, 
   3.6501606009287176`*^9, {3.650160751695341*^9, 3.650160752682398*^9}, 
   3.698684024193455*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "g"}], "-", 
          RowBox[{"a", " ", "h"}]}], ")"}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}], 
         RowBox[{"m", "+", "1"}]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}], ")"}], 
         RowBox[{"n", "+", "1"}]], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", " ", "x"}]}], ")"}], 
         RowBox[{"p", "+", "1"}]]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "c"}], "-", 
          RowBox[{"a", " ", "d"}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "e"}], "-", 
          RowBox[{"a", " ", "f"}]}], ")"}]}]]}]}]}]}], "+", 
  "\[IndentingNewLine]", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"m", "+", "1"}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", " ", "c"}], "-", 
       RowBox[{"a", " ", "d"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", " ", "e"}], "-", 
       RowBox[{"a", " ", "f"}]}], ")"}]}]], 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"m", "+", "1"}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], "p"], "\[CenterDot]", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"a", " ", "d", " ", "f", " ", "g"}], "-", 
           RowBox[{"b", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "e"}], "+", 
              RowBox[{"c", " ", "f"}]}], ")"}], " ", "g"}], "+", 
           RowBox[{"b", " ", "c", " ", "e", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "g"}], "-", 
           RowBox[{"a", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "e", " ", 
            RowBox[{"(", 
             RowBox[{"n", "+", "1"}], ")"}]}], "+", 
           RowBox[{"c", " ", "f", " ", 
            RowBox[{"(", 
             RowBox[{"p", "+", "1"}], ")"}]}]}], ")"}]}], "-", 
        RowBox[{"d", " ", "f", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "g"}], "-", 
           RowBox[{"a", " ", "h"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "p", "+", "3"}], ")"}], " ", "x"}]}], 
       ")"}]}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, 3.4958399855843487`*^9, 3.495840155344586*^9, 
   3.495840624735243*^9, {3.4958474296047697`*^9, 3.495847433754776*^9}, {
   3.4958476539050837`*^9, 3.495847660315093*^9}, {3.4958482220958796`*^9, 
   3.4958482231858807`*^9}, {3.495848257515929*^9, 3.4958482607459335`*^9}, 
   3.4959261390123196`*^9, 3.4959262745925093`*^9, 3.4959264909328117`*^9, 
   3.4959265843129425`*^9, 3.495926967463479*^9, {3.496184978535224*^9, 
   3.496185020185282*^9}, {3.4961873840085917`*^9, 3.496187409278627*^9}, {
   3.4961890232008867`*^9, 3.4961890250708895`*^9}, 3.4961956176127515`*^9, {
   3.4961956815728407`*^9, 3.496195696542862*^9}, {3.4961957791729774`*^9, 
   3.4961957920929956`*^9}, 3.496195845773071*^9, 3.518405474905692*^9, {
   3.51840566597596*^9, 3.5184056974360037`*^9}, {3.518405737026059*^9, 
   3.5184057718861084`*^9}, {3.5184058668262415`*^9, 3.518405869606245*^9}, {
   3.5184688792534475`*^9, 3.518468891673465*^9}, 3.5184689356235266`*^9, {
   3.5184691371938086`*^9, 3.5184691450938196`*^9}, {3.51846968832458*^9, 
   3.5184697035846014`*^9}, {3.518470060915102*^9, 3.518470082885133*^9}, {
   3.5184747044318423`*^9, 3.5184747207338715`*^9}, 3.518475002735566*^9, {
   3.5188842113796167`*^9, 3.518884228949641*^9}, {3.518890960739066*^9, 
   3.5188909798390923`*^9}, {3.520101172685255*^9, 3.520101193979293*^9}, 
   3.520101537866297*^9, {3.520101583012776*^9, 3.520101592138792*^9}, 
   3.5237473966912913`*^9, {3.523747635309311*^9, 3.523747662094558*^9}, 
   3.523747693201012*^9, {3.5237589154214087`*^9, 3.523758920041415*^9}, {
   3.523835091963359*^9, 3.523835095403364*^9}, 3.5247720424111013`*^9, {
   3.5247722402213783`*^9, 3.524772242541381*^9}, {3.5247723065014706`*^9, 
   3.524772310491476*^9}, {3.5247724101316156`*^9, 3.5247725806518545`*^9}, {
   3.5247726200519094`*^9, 3.5247727072220316`*^9}, {3.5247728848022804`*^9, 
   3.5247728894922867`*^9}, {3.5247737712335215`*^9, 
   3.5247738023335648`*^9}, {3.5279824084921894`*^9, 
   3.5279824453238535`*^9}, {3.5304116139925594`*^9, 
   3.5304117038726854`*^9}, {3.530411918742986*^9, 3.53041197123306*^9}, 
   3.531941036782448*^9, {3.5319411448594375`*^9, 3.5319411488686447`*^9}, {
   3.531941294947301*^9, 3.531941298394907*^9}, {3.5319414162219143`*^9, 
   3.5319414182655177`*^9}, {3.531941548510146*^9, 3.5319415504133496`*^9}, {
   3.5319417755685453`*^9, 3.5319417799833527`*^9}, {3.5319419862689157`*^9, 
   3.531941989685322*^9}, {3.531942055798238*^9, 3.5319420566406393`*^9}, {
   3.5319437006495266`*^9, 3.5319437038787327`*^9}, {3.5340026346818047`*^9, 
   3.534002637453963*^9}, {3.5340030209706793`*^9, 3.5340030293451586`*^9}, {
   3.534118784243157*^9, 3.5341188511132507`*^9}, {3.534119170853698*^9, 
   3.534119179923711*^9}, {3.534119497584155*^9, 3.5341195421742177`*^9}, {
   3.5341199788848295`*^9, 3.534120010914874*^9}, {3.5498209881835594`*^9, 
   3.549820997693573*^9}, {3.5498211737338195`*^9, 3.549821174583821*^9}, {
   3.5498212805939693`*^9, 3.5498212951739893`*^9}, {3.6113478994666405`*^9, 
   3.611347952146716*^9}, {3.6113489074647284`*^9, 3.6113489132097373`*^9}, {
   3.6379584276899853`*^9, 3.6379584308567905`*^9}, {3.6379585128097353`*^9, 
   3.637958515102939*^9}, {3.637959232582328*^9, 3.6379592347351313`*^9}, 
   3.6538536937305636`*^9},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.520101787997136*^9, 3.5201017908831415`*^9}, 
   3.534119660884384*^9, 3.5341197024044423`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", "*", "g"}], "-", 
       RowBox[{"a", "*", "h"}]}], ")"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", "*", "x"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"p", "+", "1"}], ")"}]}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "c"}], "-", 
          RowBox[{"a", "*", "d"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}]}], ")"}]}]}], " ", "+", " ", 
    "\[IndentingNewLine]", "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "c"}], "-", 
          RowBox[{"a", "*", "d"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "*", "\n", "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"a", "*", "d", "*", "f", "*", "g"}], "-", 
              RowBox[{"b", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "e"}], "+", 
                 RowBox[{"c", "*", "f"}]}], ")"}], "*", "g"}], "+", 
              RowBox[{"b", "*", "c", "*", "e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", "g"}], "-", 
              RowBox[{"a", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", "*", "e", "*", 
               RowBox[{"(", 
                RowBox[{"n", "+", "1"}], ")"}]}], "+", 
              RowBox[{"c", "*", "f", "*", 
               RowBox[{"(", 
                RowBox[{"p", "+", "1"}], ")"}]}]}], ")"}]}], "-", 
           RowBox[{"d", "*", "f", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", "g"}], "-", 
              RowBox[{"a", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "p", "+", "3"}], ")"}], "*", "x"}]}],
           ",", "x"}], "]"}]}], ",", "x"}], "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "n", ",", "p"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"LtQ", "[", 
     RowBox[{"m", ",", 
      RowBox[{"-", "1"}]}], "]"}], " ", "&&", " ", 
    RowBox[{"IntegerQ", "[", "m", "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495839738475589*^9, 3.4958405008250694`*^9, {3.495847490784856*^9, 
   3.4958474999948683`*^9}, {3.4958477172451725`*^9, 3.495847721615179*^9}, {
   3.495848224085882*^9, 3.4958482277058873`*^9}, {3.4958482626259365`*^9, 
   3.4958482686359444`*^9}, 3.4959261054722724`*^9, {3.4959262905725317`*^9, 
   3.4959262958725395`*^9}, 3.495926443222745*^9, 3.4961849395451694`*^9, 
   3.496185884976493*^9, 3.4961888731806765`*^9, {3.4961890260508904`*^9, 
   3.4961890290708947`*^9}, {3.496191957967628*^9, 3.4961919600576305`*^9}, 
   3.49619205250776*^9, 3.4961952203321953`*^9, {3.496195426482484*^9, 
   3.496195433172493*^9}, {3.496195586822708*^9, 3.496195595732721*^9}, 
   3.496195754542943*^9, 3.4966189754082823`*^9, {3.4966198797795486`*^9, 
   3.496619907439587*^9}, {3.4968579645422487`*^9, 3.4968579680210547`*^9}, 
   3.5171911044266214`*^9, 3.518211198418105*^9, 3.5182420941409807`*^9, {
   3.518281849687285*^9, 3.518281849874485*^9}, {3.5182861978669233`*^9, 
   3.518286207226939*^9}, 3.518286893072945*^9, 3.518287077449669*^9, {
   3.518405919376315*^9, 3.5184059327163334`*^9}, 3.518406000866429*^9, {
   3.5184061023365707`*^9, 3.518406115016588*^9}, {3.5184065135071464`*^9, 
   3.518406515547149*^9}, {3.518406800569559*^9, 3.5184068071395683`*^9}, {
   3.518455696848171*^9, 3.518455715349804*^9}, {3.518469305994045*^9, 
   3.518469310354051*^9}, {3.5184693414340944`*^9, 3.5184693641841264`*^9}, {
   3.518469461554263*^9, 3.518469497814314*^9}, {3.5184698199647646`*^9, 
   3.5184698496348057`*^9}, {3.5184698834448533`*^9, 3.5184698844848547`*^9}, 
   3.5184701704452553`*^9, {3.518470248195364*^9, 3.518470287395419*^9}, {
   3.51847032361547*^9, 3.518470324325471*^9}, {3.518474812134432*^9, 
   3.5184748359088736`*^9}, {3.5184748784969482`*^9, 3.51847487927695*^9}, 
   3.518475395747057*^9, {3.5184754745583954`*^9, 3.518475478770403*^9}, {
   3.5184759352008047`*^9, 3.518475938726411*^9}, {3.5184760887674747`*^9, 
   3.5184761024174986`*^9}, {3.518476247310553*^9, 3.5184762483245544`*^9}, {
   3.518476459611326*^9, 3.518476460235327*^9}, {3.5185837600757217`*^9, 
   3.518583760356522*^9}, {3.5188842541996765`*^9, 3.5188842747997055`*^9}, {
   3.518890955169058*^9, 3.5188909696490784`*^9}, {3.5188914772697887`*^9, 
   3.518891482339796*^9}, {3.520102006257119*^9, 3.5201020069591208`*^9}, 
   3.5201020756928415`*^9, {3.5202847653043165`*^9, 3.520284765308317*^9}, {
   3.5202851424268866`*^9, 3.520285144721018*^9}, {3.520899838877209*^9, 
   3.5208998429572153`*^9}, {3.521131441309245*^9, 3.521131443849249*^9}, 
   3.521148390206671*^9, {3.5223485088319473`*^9, 3.5223485168319583`*^9}, {
   3.5224420691492205`*^9, 3.522442069414421*^9}, 3.5237568920485764`*^9, 
   3.523757219519035*^9, 3.523757259739091*^9, {3.5237580436701884`*^9, 
   3.523758059720211*^9}, {3.523758936761439*^9, 3.523758939721443*^9}, 
   3.523810558420226*^9, 3.523818931362772*^9, {3.523835156403449*^9, 
   3.5238351582934523`*^9}, 3.5247721246012163`*^9, {3.5247739098537154`*^9, 
   3.5247740062738504`*^9}, {3.524774046163906*^9, 3.524774061003927*^9}, {
   3.5269452650085325`*^9, 3.526945270312542*^9}, {3.527188364001113*^9, 
   3.5271883677139196`*^9}, {3.5271888173223095`*^9, 3.527188823843121*^9}, {
   3.5271899878391657`*^9, 3.5271900376656528`*^9}, {3.527190166287879*^9, 
   3.5271901716698885`*^9}, {3.527190278608076*^9, 3.5271902902768965`*^9}, {
   3.527982424123417*^9, 3.5279824278986235`*^9}, {3.5279825248995934`*^9, 
   3.5279825340568094`*^9}, {3.5304120848332186`*^9, 3.530412106123248*^9}, {
   3.5304130055745077`*^9, 3.530413008634512*^9}, {3.530413043314561*^9, 
   3.530413055224577*^9}, {3.530413087314622*^9, 3.5304130884346237`*^9}, {
   3.5304131472647057`*^9, 3.5304131483447075`*^9}, 3.53046311973864*^9, {
   3.5304888886920757`*^9, 3.530488894767084*^9}, {3.531941152706251*^9, 
   3.531941162830669*^9}, {3.531941299455709*^9, 3.531941306974922*^9}, {
   3.5319414191859193`*^9, 3.5319414225243254`*^9}, {3.531941554079356*^9, 
   3.531941559040165*^9}, {3.531941786394964*^9, 3.531941805174197*^9}, {
   3.5319419942717295`*^9, 3.531941998764538*^9}, {3.5319420576234407`*^9, 
   3.531942059916645*^9}, {3.531943420348234*^9, 3.5319434261514444`*^9}, {
   3.5319437080127397`*^9, 3.53194372535997*^9}, {3.531943778727664*^9, 
   3.531943779960066*^9}, {3.5319453490892224`*^9, 3.5319453522092276`*^9}, {
   3.5339415241170616`*^9, 3.533941538197081*^9}, {3.5339415789871387`*^9, 
   3.533941604107174*^9}, {3.5339512902895765`*^9, 3.5339512946731844`*^9}, 
   3.533951351067283*^9, {3.5340027757635803`*^9, 3.534002812286766*^9}, {
   3.5341190049334655`*^9, 3.5341190294735003`*^9}, {3.5341191883437223`*^9, 
   3.534119195643733*^9}, {3.5341193695439763`*^9, 3.53411941511404*^9}, 
   3.5341196611243844`*^9, {3.5341196955644326`*^9, 3.5341197132044573`*^9}, {
   3.53411976495453*^9, 3.5341197859645596`*^9}, {3.5341198161046014`*^9, 
   3.5341198333046255`*^9}, {3.5341202066851482`*^9, 
   3.5341202338551865`*^9}, {3.5341203290053196`*^9, 
   3.5341203384853325`*^9}, {3.5345320585805097`*^9, 3.534532063088767*^9}, {
   3.542250001432192*^9, 3.542250008476595*^9}, {3.5422500440135355`*^9, 
   3.5422500469807053`*^9}, {3.5498208880934196`*^9, 
   3.5498208937334275`*^9}, {3.549820948423504*^9, 3.5498209681835318`*^9}, {
   3.549821086453697*^9, 3.54982111701374*^9}, {3.5498213009139977`*^9, 
   3.549821315764018*^9}, 3.549822116275139*^9, 3.549823280296769*^9, {
   3.549823640347273*^9, 3.54982366705731*^9}, {3.6113479820117593`*^9, 
   3.611348006211794*^9}, 3.611348098771927*^9, {3.6113489350197706`*^9, 
   3.6113489387847767`*^9}, 3.6113497097884707`*^9, 3.6113557224169703`*^9, 
   3.637938291209133*^9, 3.6379383214221754`*^9, {3.6379584320111933`*^9, 
   3.637958435365199*^9}, {3.6379585158829403`*^9, 3.6379585188157454`*^9}, {
   3.637959272834798*^9, 3.6379592755336027`*^9}, 3.6391773616711383`*^9, 
   3.6444420781858377`*^9, {3.653846036299368*^9, 3.653846039217573*^9}, {
   3.6538461554119787`*^9, 3.653846164116794*^9}, {3.6538485694782467`*^9, 
   3.6538485975466967`*^9}, 3.6538537066265836`*^9, {3.7077034595008645`*^9, 
   3.7077034627768707`*^9}},
 Background->GrayLevel[0.85]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", "*", "g"}], "-", 
       RowBox[{"a", "*", "h"}]}], ")"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", "*", "x"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"p", "+", "1"}], ")"}]}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "c"}], "-", 
          RowBox[{"a", "*", "d"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}]}], ")"}]}]}], " ", "+", " ", 
    "\[IndentingNewLine]", "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "c"}], "-", 
          RowBox[{"a", "*", "d"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "*", "\n", "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"a", "*", "d", "*", "f", "*", "g"}], "-", 
              RowBox[{"b", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "e"}], "+", 
                 RowBox[{"c", "*", "f"}]}], ")"}], "*", "g"}], "+", 
              RowBox[{"b", "*", "c", "*", "e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", "g"}], "-", 
              RowBox[{"a", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", "*", "e", "*", 
               RowBox[{"(", 
                RowBox[{"n", "+", "1"}], ")"}]}], "+", 
              RowBox[{"c", "*", "f", "*", 
               RowBox[{"(", 
                RowBox[{"p", "+", "1"}], ")"}]}]}], ")"}]}], "-", 
           RowBox[{"d", "*", "f", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", "g"}], "-", 
              RowBox[{"a", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "p", "+", "3"}], ")"}], "*", "x"}]}],
           ",", "x"}], "]"}]}], ",", "x"}], "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "n", ",", "p"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"LtQ", "[", 
     RowBox[{"m", ",", 
      RowBox[{"-", "1"}]}], "]"}], " ", "&&", " ", 
    RowBox[{"IntegersQ", "[", 
     RowBox[{
      RowBox[{"2", "*", "m"}], ",", 
      RowBox[{"2", "*", "n"}], ",", 
      RowBox[{"2", "*", "p"}]}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495839738475589*^9, 3.4958405008250694`*^9, {3.495847490784856*^9, 
   3.4958474999948683`*^9}, {3.4958477172451725`*^9, 3.495847721615179*^9}, {
   3.495848224085882*^9, 3.4958482277058873`*^9}, {3.4958482626259365`*^9, 
   3.4958482686359444`*^9}, 3.4959261054722724`*^9, {3.4959262905725317`*^9, 
   3.4959262958725395`*^9}, 3.495926443222745*^9, 3.4961849395451694`*^9, 
   3.496185884976493*^9, 3.4961888731806765`*^9, {3.4961890260508904`*^9, 
   3.4961890290708947`*^9}, {3.496191957967628*^9, 3.4961919600576305`*^9}, 
   3.49619205250776*^9, 3.4961952203321953`*^9, {3.496195426482484*^9, 
   3.496195433172493*^9}, {3.496195586822708*^9, 3.496195595732721*^9}, 
   3.496195754542943*^9, 3.4966189754082823`*^9, {3.4966198797795486`*^9, 
   3.496619907439587*^9}, {3.4968579645422487`*^9, 3.4968579680210547`*^9}, 
   3.5171911044266214`*^9, 3.518211198418105*^9, 3.5182420941409807`*^9, {
   3.518281849687285*^9, 3.518281849874485*^9}, {3.5182861978669233`*^9, 
   3.518286207226939*^9}, 3.518286893072945*^9, 3.518287077449669*^9, {
   3.518405919376315*^9, 3.5184059327163334`*^9}, 3.518406000866429*^9, {
   3.5184061023365707`*^9, 3.518406115016588*^9}, {3.5184065135071464`*^9, 
   3.518406515547149*^9}, {3.518406800569559*^9, 3.5184068071395683`*^9}, {
   3.518455696848171*^9, 3.518455715349804*^9}, {3.518469305994045*^9, 
   3.518469310354051*^9}, {3.5184693414340944`*^9, 3.5184693641841264`*^9}, {
   3.518469461554263*^9, 3.518469497814314*^9}, {3.5184698199647646`*^9, 
   3.5184698496348057`*^9}, {3.5184698834448533`*^9, 3.5184698844848547`*^9}, 
   3.5184701704452553`*^9, {3.518470248195364*^9, 3.518470287395419*^9}, {
   3.51847032361547*^9, 3.518470324325471*^9}, {3.518474812134432*^9, 
   3.5184748359088736`*^9}, {3.5184748784969482`*^9, 3.51847487927695*^9}, 
   3.518475395747057*^9, {3.5184754745583954`*^9, 3.518475478770403*^9}, {
   3.5184759352008047`*^9, 3.518475938726411*^9}, {3.5184760887674747`*^9, 
   3.5184761024174986`*^9}, {3.518476247310553*^9, 3.5184762483245544`*^9}, {
   3.518476459611326*^9, 3.518476460235327*^9}, {3.5185837600757217`*^9, 
   3.518583760356522*^9}, {3.5188842541996765`*^9, 3.5188842747997055`*^9}, {
   3.518890955169058*^9, 3.5188909696490784`*^9}, {3.5188914772697887`*^9, 
   3.518891482339796*^9}, {3.520102006257119*^9, 3.5201020069591208`*^9}, 
   3.5201020756928415`*^9, {3.5202847653043165`*^9, 3.520284765308317*^9}, {
   3.5202851424268866`*^9, 3.520285144721018*^9}, {3.520899838877209*^9, 
   3.5208998429572153`*^9}, {3.521131441309245*^9, 3.521131443849249*^9}, 
   3.521148390206671*^9, {3.5223485088319473`*^9, 3.5223485168319583`*^9}, {
   3.5224420691492205`*^9, 3.522442069414421*^9}, 3.5237568920485764`*^9, 
   3.523757219519035*^9, 3.523757259739091*^9, {3.5237580436701884`*^9, 
   3.523758059720211*^9}, {3.523758936761439*^9, 3.523758939721443*^9}, 
   3.523810558420226*^9, 3.523818931362772*^9, {3.523835156403449*^9, 
   3.5238351582934523`*^9}, 3.5247721246012163`*^9, {3.5247739098537154`*^9, 
   3.5247740062738504`*^9}, {3.524774046163906*^9, 3.524774061003927*^9}, {
   3.5269452650085325`*^9, 3.526945270312542*^9}, {3.527188364001113*^9, 
   3.5271883677139196`*^9}, {3.5271888173223095`*^9, 3.527188823843121*^9}, {
   3.5271899878391657`*^9, 3.5271900376656528`*^9}, {3.527190166287879*^9, 
   3.5271901716698885`*^9}, {3.527190278608076*^9, 3.5271902902768965`*^9}, {
   3.527982424123417*^9, 3.5279824278986235`*^9}, {3.5279825248995934`*^9, 
   3.5279825340568094`*^9}, {3.5304120848332186`*^9, 3.530412106123248*^9}, {
   3.5304130055745077`*^9, 3.530413008634512*^9}, {3.530413043314561*^9, 
   3.530413055224577*^9}, {3.530413087314622*^9, 3.5304130884346237`*^9}, {
   3.5304131472647057`*^9, 3.5304131483447075`*^9}, 3.53046311973864*^9, {
   3.5304888886920757`*^9, 3.530488894767084*^9}, {3.531941152706251*^9, 
   3.531941162830669*^9}, {3.531941299455709*^9, 3.531941306974922*^9}, {
   3.5319414191859193`*^9, 3.5319414225243254`*^9}, {3.531941554079356*^9, 
   3.531941559040165*^9}, {3.531941786394964*^9, 3.531941805174197*^9}, {
   3.5319419942717295`*^9, 3.531941998764538*^9}, {3.5319420576234407`*^9, 
   3.531942059916645*^9}, {3.531943420348234*^9, 3.5319434261514444`*^9}, {
   3.5319437080127397`*^9, 3.53194372535997*^9}, {3.531943778727664*^9, 
   3.531943779960066*^9}, {3.5319453490892224`*^9, 3.5319453522092276`*^9}, {
   3.5339415241170616`*^9, 3.533941538197081*^9}, {3.5339415789871387`*^9, 
   3.533941604107174*^9}, {3.5339512902895765`*^9, 3.5339512946731844`*^9}, 
   3.533951351067283*^9, {3.5340027757635803`*^9, 3.534002812286766*^9}, {
   3.5341190049334655`*^9, 3.5341190294735003`*^9}, {3.5341191883437223`*^9, 
   3.534119195643733*^9}, {3.5341193695439763`*^9, 3.53411941511404*^9}, 
   3.5341196611243844`*^9, {3.5341196955644326`*^9, 3.5341197132044573`*^9}, {
   3.53411976495453*^9, 3.5341197859645596`*^9}, {3.5341198161046014`*^9, 
   3.5341198333046255`*^9}, {3.5341202066851482`*^9, 
   3.5341202338551865`*^9}, {3.5341203290053196`*^9, 
   3.5341203384853325`*^9}, {3.5345320585805097`*^9, 3.534532063088767*^9}, {
   3.542250001432192*^9, 3.542250008476595*^9}, {3.5422500440135355`*^9, 
   3.5422500469807053`*^9}, {3.5498208880934196`*^9, 
   3.5498208937334275`*^9}, {3.549820948423504*^9, 3.5498209681835318`*^9}, {
   3.549821086453697*^9, 3.54982111701374*^9}, {3.5498213009139977`*^9, 
   3.549821315764018*^9}, 3.549822116275139*^9, 3.549823280296769*^9, {
   3.549823640347273*^9, 3.54982366705731*^9}, {3.6113479820117593`*^9, 
   3.611348006211794*^9}, 3.611348098771927*^9, {3.6113489350197706`*^9, 
   3.6113489387847767`*^9}, 3.6113497097884707`*^9, 3.6113557224169703`*^9, 
   3.637938291209133*^9, 3.6379383214221754`*^9, {3.6379584320111933`*^9, 
   3.637958435365199*^9}, {3.6379585158829403`*^9, 3.6379585188157454`*^9}, {
   3.637959272834798*^9, 3.6379592755336027`*^9}, 3.6391773616711383`*^9, 
   3.6444420781858377`*^9, {3.653846027656953*^9, 3.653846058050807*^9}, {
   3.6538485483060093`*^9, 3.6538485591188283`*^9}, 3.6538537092065873`*^9, {
   3.707703467678279*^9, 3.707703471533486*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{Cell[TextData[StyleBox["4:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], " ", Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"m", ">", "0"}], " ", "\[And]", " ", 
       RowBox[{
        RowBox[{"m", "+", "n", "+", "p", "+", "2"}], "\[NotEqual]", 
        "0"}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.5192504337891226`*^9, 3.5192504707812386`*^9}, 3.5192506717957726`*^9, {
   3.519250720795459*^9, 3.5192507409818945`*^9}, 3.519258420209427*^9, 
   3.519258489779525*^9, {3.519320786305674*^9, 3.519320803294104*^9}, {
   3.519329422708468*^9, 3.5193294257984724`*^9}, 3.5193294706485353`*^9, {
   3.5193302883925123`*^9, 3.519330307237345*^9}, {3.5193303440378103`*^9, 
   3.5193303650666466`*^9}, 3.5193341918281684`*^9, {3.5193346196121197`*^9, 
   3.519334632840943*^9}, {3.519341922663512*^9, 3.5193419232095127`*^9}, 
   3.5193423494490614`*^9, {3.5193456600396833`*^9, 3.519345660273684*^9}, 
   3.519410696547495*^9, {3.519793559756592*^9, 3.5197935600217924`*^9}, {
   3.5210541942272606`*^9, 3.5210542323693275`*^9}, {3.521054705798959*^9, 
   3.5210547345342093`*^9}, {3.521055431683834*^9, 3.5210554455522585`*^9}, {
   3.5210554827427235`*^9, 3.5210555031319594`*^9}, {3.521056059772137*^9, 
   3.521056075652965*^9}, {3.521057417664521*^9, 3.521057417867322*^9}, {
   3.5210574854778404`*^9, 3.5210574857586412`*^9}, {3.5210575212175035`*^9, 
   3.521057540483537*^9}, {3.5210598942936716`*^9, 3.5210599092384977`*^9}, {
   3.521063276214819*^9, 3.521063298928458*^9}, {3.5210639991824884`*^9, 
   3.5210640343449497`*^9}, {3.5210641665551825`*^9, 
   3.5210641665551825`*^9}, {3.521072868148899*^9, 3.521072868148899*^9}, {
   3.5210824253375397`*^9, 3.5210824255559406`*^9}, {3.5211479965711794`*^9, 
   3.521148020673222*^9}, {3.5211480693453074`*^9, 3.5211480699537086`*^9}, {
   3.521148148187846*^9, 3.5211481489366474`*^9}, {3.5211482363436007`*^9, 
   3.5211482363436007`*^9}, {3.521148269556059*^9, 3.521148269556059*^9}, {
   3.521346368187188*^9, 3.521346368421189*^9}, {3.5214702809911447`*^9, 
   3.5214702811783447`*^9}, {3.5216579052539043`*^9, 3.521657905453904*^9}, {
   3.5223485259619713`*^9, 3.522348534381983*^9}, {3.5233208394702005`*^9, 
   3.5233208394702005`*^9}, {3.523320922845537*^9, 3.523320922845537*^9}, 
   3.523747250675035*^9, {3.5237670269856477`*^9, 3.5237670269856477`*^9}, {
   3.523831184179017*^9, 3.523831184179017*^9}, 3.5247720382710953`*^9, {
   3.524772397491598*^9, 3.524772397491598*^9}, {3.524774194324114*^9, 
   3.524774228794162*^9}, {3.526945238644486*^9, 3.526945238644486*^9}, {
   3.5279098167721815`*^9, 3.5279098172421827`*^9}, {3.5296282016140704`*^9, 
   3.5296282019130874`*^9}, 3.530384384323295*^9, {3.5303845765632906`*^9, 
   3.530384576766302*^9}, {3.530412765574172*^9, 3.530412765724172*^9}, {
   3.5304133134449387`*^9, 3.530413327614959*^9}, {3.5304133632650084`*^9, 
   3.5304133653750114`*^9}, {3.5304685359612284`*^9, 
   3.5304685362112293`*^9}, {3.5306637757276535`*^9, 3.530663775992854*^9}, 
   3.531940972073534*^9, {3.531941135920622*^9, 3.531941136887823*^9}, {
   3.531941292685297*^9, 3.5319412934028983`*^9}, {3.531941412696308*^9, 
   3.53194141378831*^9}, {3.531941540834933*^9, 3.531941542176535*^9}, {
   3.531941747348096*^9, 3.5319417604365187`*^9}, {3.5319419776265*^9, 
   3.531941978453302*^9}, {3.5319420524598317`*^9, 3.5319420537078342`*^9}, {
   3.5319437460612063`*^9, 3.5319437460612063`*^9}, {3.531945368214856*^9, 
   3.531945368214856*^9}, {3.5339235218280125`*^9, 3.533923522848014*^9}, {
   3.5340030836026883`*^9, 3.534003084035713*^9}, 3.534118752423112*^9, {
   3.5341190488235273`*^9, 3.534119049053528*^9}, {3.534119148303666*^9, 
   3.534119148303666*^9}, {3.534119453664094*^9, 3.5341194538540945`*^9}, {
   3.534119930854762*^9, 3.534119930854762*^9}, {3.53412041503544*^9, 
   3.53412041503544*^9}, {3.5498208478733635`*^9, 3.5498208478733635`*^9}, {
   3.549821170423815*^9, 3.549821170423815*^9}, {3.5498212022838593`*^9, 
   3.5498212022838593`*^9}, {3.5498220687050724`*^9, 
   3.5498220687050724`*^9}, {3.5498232312167*^9, 3.5498232312167*^9}, {
   3.5498234766870437`*^9, 3.5498234777570453`*^9}, {3.54985254227013*^9, 
   3.5498525425001297`*^9}, 3.5717051188897867`*^9, 3.5758229263769093`*^9, {
   3.6113489510122957`*^9, 3.6113489537697997`*^9}, {3.6113491101575394`*^9, 
   3.6113491196025534`*^9}, {3.6113491544876075`*^9, 
   3.6113491546901073`*^9}, {3.6113492430927434`*^9, 
   3.6113492640427756`*^9}, {3.6113556049368057`*^9, 3.6113556049368057`*^9}, 
   3.6379584187199697`*^9, 3.6379585055089226`*^9, {3.637972693909114*^9, 
   3.637972694776163*^9}, {3.6444420343103285`*^9, 3.6444420343103285`*^9}, {
   3.6444723068093433`*^9, 3.6444723084334364`*^9}, {3.6489542750360765`*^9, 
   3.648954275260089*^9}, {3.648955828719942*^9, 3.648955828890952*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Nondegenerate trilinear recurrence 2", "Subsubsection",
 CellChangeTimes->{
  3.496441803031353*^9, 3.4965396318089237`*^9, {3.4966002562016735`*^9, 
   3.4966002624716825`*^9}, 3.496600707442305*^9, 3.4966008475725017`*^9, {
   3.4966070255131593`*^9, 3.496607032413169*^9}, 3.518279406700592*^9, {
   3.51840552316576*^9, 3.5184055392257824`*^9}, 3.5184690414436746`*^9, 
   3.518469651844529*^9, 3.5184700043450227`*^9, 3.518474659316563*^9, 
   3.5237473322319784`*^9, 3.5247722814214354`*^9, {3.5260660236439*^9, 
   3.526066024233901*^9}, {3.530413463335149*^9, 3.5304134989751987`*^9}, {
   3.5339258909313297`*^9, 3.533925894241334*^9}, {3.5341187688231354`*^9, 
   3.534118769443136*^9}, {3.534119456044097*^9, 3.5341194563640976`*^9}, 
   3.6113471326280394`*^9}],

Cell[TextData[{
 "Rule 1.1.1.4",
 ".1.4: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"m", ">", "0"}], " ", "\[And]", " ", 
   RowBox[{
    RowBox[{"m", "+", "n", "+", "p", "+", "2"}], "\[NotEqual]", "0"}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.4964417379912624`*^9, 3.4964417471112747`*^9}, {
   3.496441910111503*^9, 3.4964419275315275`*^9}, 3.496451213764926*^9, {
   3.496539487018721*^9, 3.4965395223187704`*^9}, {3.4966001213614845`*^9, 
   3.4966001362815056`*^9}, {3.4966047635399923`*^9, 
   3.4966048329500895`*^9}, {3.496604896730179*^9, 3.496605019710351*^9}, {
   3.496605050490394*^9, 3.4966050527103972`*^9}, {3.4966066606926484`*^9, 
   3.496606694832696*^9}, 3.496606873362946*^9, {3.4966081836347804`*^9, 
   3.496608250534874*^9}, {3.496608418375109*^9, 3.496608441025141*^9}, {
   3.4966322809467688`*^9, 3.4966322818867702`*^9}, {3.4968592460220995`*^9, 
   3.4968592640557313`*^9}, {3.4968593076422076`*^9, 
   3.4968593113862143`*^9}, {3.496859384233942*^9, 3.496859384233942*^9}, {
   3.518223900967896*^9, 3.518223909467908*^9}, 3.5182817155426493`*^9, {
   3.518285874431555*^9, 3.518285899625599*^9}, {3.5182860969191456`*^9, 
   3.518286138321618*^9}, {3.518286898517355*^9, 3.518286898517355*^9}, {
   3.5182870794776726`*^9, 3.5182870794776726`*^9}, {3.518469568024412*^9, 
   3.518469584774435*^9}, {3.518469921924907*^9, 3.5184699227449083`*^9}, {
   3.51847035958552*^9, 3.518470374475541*^9}, {3.518474847889694*^9, 
   3.518474854394906*^9}, {3.518475351645779*^9, 3.51847535181738*^9}, {
   3.518476861483632*^9, 3.5184768701416473`*^9}, {3.5184769318709555`*^9, 
   3.518476937876966*^9}, {3.5185837532117095`*^9, 3.51858375372651*^9}, {
   3.5211482838768845`*^9, 3.5211482838768845`*^9}, {3.5223485487820034`*^9, 
   3.5223485487820034`*^9}, {3.5237580782402368`*^9, 
   3.5237580830402436`*^9}, {3.524772390921589*^9, 3.524772390921589*^9}, {
   3.524774159434065*^9, 3.5247741821040964`*^9}, {3.526945226804065*^9, 
   3.5269452323576756`*^9}, {3.530413508385212*^9, 3.530413508385212*^9}, {
   3.5319411411622305`*^9, 3.5319411411622305`*^9}, {3.5319412943077*^9, 
   3.5319412943077*^9}, {3.531941415098712*^9, 3.531941415098712*^9}, {
   3.531941547106144*^9, 3.531941547776945*^9}, {3.5319417707481365`*^9, 
   3.531941771746538*^9}, {3.5319419851613135`*^9, 3.5319419851613135`*^9}, {
   3.5319420546594353`*^9, 3.5319420546594353`*^9}, {3.531943749524412*^9, 
   3.531943749820813*^9}, {3.531945371147661*^9, 3.531945371147661*^9}, {
   3.5341190906435857`*^9, 3.5341191318936434`*^9}, {3.5341199134547377`*^9, 
   3.5341199250547543`*^9}, {3.5341202922652683`*^9, 
   3.5341202922652683`*^9}, {3.5498208700933943`*^9, 
   3.5498208700933943`*^9}, {3.549821171293816*^9, 3.549821171293816*^9}, {
   3.54982120282386*^9, 3.54982120282386*^9}, {3.549822071815077*^9, 
   3.549822071815077*^9}, {3.549823244226718*^9, 3.549823244226718*^9}, {
   3.6113556232768316`*^9, 3.6113556232768316`*^9}, {3.637972702515606*^9, 
   3.6379727034636602`*^9}, {3.644442038919592*^9, 3.644442038919592*^9}, 
   3.650160601523752*^9, {3.6501607670332184`*^9, 3.650160767602251*^9}, 
   3.698684024423455*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{"h", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}], ")"}], 
         RowBox[{"n", "+", "1"}]], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", " ", "x"}]}], ")"}], 
         RowBox[{"p", "+", "1"}]]}], 
       RowBox[{"d", " ", "f", 
        RowBox[{"(", 
         RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ")"}]}]]}]}]}]}], "+", 
  "\[IndentingNewLine]", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"d", " ", "f", 
     RowBox[{"(", 
      RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ")"}]}]], 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"m", "-", "1"}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], "p"], "\[CenterDot]", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"a", " ", "d", " ", "f", " ", "g", " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ")"}]}], "-", 
        RowBox[{"h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "c", " ", "e", " ", "m"}], "+", 
           RowBox[{"a", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "e", 
               RowBox[{"(", 
                RowBox[{"n", "+", "1"}], ")"}]}], "+", 
              RowBox[{"c", " ", "f", 
               RowBox[{"(", 
                RowBox[{"p", "+", "1"}], ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "d", " ", "f", " ", "g", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ")"}]}], "+", 
           RowBox[{"h", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"a", " ", "d", " ", "f", " ", "m"}], "-", 
              RowBox[{"b", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", " ", "e", 
                  RowBox[{"(", 
                   RowBox[{"m", "+", "n", "+", "1"}], ")"}]}], "+", 
                 RowBox[{"c", " ", "f", 
                  RowBox[{"(", 
                   RowBox[{"m", "+", "p", "+", "1"}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}], " ", "x"}]}], ")"}]}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, 3.4958399855843487`*^9, 3.495840155344586*^9, 
   3.495840624735243*^9, {3.4958474296047697`*^9, 3.495847433754776*^9}, {
   3.4958476539050837`*^9, 3.495847660315093*^9}, {3.4958482220958796`*^9, 
   3.4958482231858807`*^9}, {3.495848257515929*^9, 3.4958482607459335`*^9}, 
   3.4959261390123196`*^9, 3.4959262745925093`*^9, 3.4959264909328117`*^9, 
   3.4959265843129425`*^9, 3.495926967463479*^9, {3.496184978535224*^9, 
   3.496185020185282*^9}, {3.4961873840085917`*^9, 3.496187409278627*^9}, {
   3.4961890232008867`*^9, 3.4961890250708895`*^9}, 3.4961956176127515`*^9, {
   3.4961956815728407`*^9, 3.496195696542862*^9}, {3.4961957791729774`*^9, 
   3.4961957920929956`*^9}, 3.496195845773071*^9, 3.518405474905692*^9, {
   3.51840566597596*^9, 3.5184056974360037`*^9}, {3.518405737026059*^9, 
   3.5184057718861084`*^9}, {3.5184058668262415`*^9, 3.518405869606245*^9}, {
   3.5184688792534475`*^9, 3.518468891673465*^9}, 3.5184689356235266`*^9, {
   3.5184691371938086`*^9, 3.5184691450938196`*^9}, {3.51846968832458*^9, 
   3.5184697035846014`*^9}, {3.518470060915102*^9, 3.518470082885133*^9}, {
   3.5184747044318423`*^9, 3.5184747207338715`*^9}, 3.518475002735566*^9, {
   3.5188842113796167`*^9, 3.518884228949641*^9}, {3.518890960739066*^9, 
   3.5188909798390923`*^9}, {3.520101172685255*^9, 3.520101193979293*^9}, 
   3.520101537866297*^9, {3.520101583012776*^9, 3.520101592138792*^9}, 
   3.5237473966912913`*^9, {3.523747635309311*^9, 3.523747662094558*^9}, 
   3.523747693201012*^9, {3.5237589154214087`*^9, 3.523758920041415*^9}, {
   3.523835091963359*^9, 3.523835095403364*^9}, 3.5247720424111013`*^9, {
   3.5247722402213783`*^9, 3.524772242541381*^9}, {3.5247723065014706`*^9, 
   3.524772310491476*^9}, {3.5247724101316156`*^9, 3.5247725806518545`*^9}, {
   3.5247726200519094`*^9, 3.5247727072220316`*^9}, {3.5247728848022804`*^9, 
   3.5247728894922867`*^9}, {3.5247737712335215`*^9, 
   3.5247738023335648`*^9}, {3.5279824084921894`*^9, 
   3.5279824453238535`*^9}, {3.5304116139925594`*^9, 
   3.5304117038726854`*^9}, {3.530411918742986*^9, 3.53041197123306*^9}, 
   3.531941036782448*^9, {3.5319411448594375`*^9, 3.5319411488686447`*^9}, {
   3.531941294947301*^9, 3.531941298394907*^9}, {3.5319414162219143`*^9, 
   3.5319414182655177`*^9}, {3.531941548510146*^9, 3.5319415504133496`*^9}, {
   3.5319417755685453`*^9, 3.5319417799833527`*^9}, {3.5319419862689157`*^9, 
   3.531941989685322*^9}, {3.531942055798238*^9, 3.5319420566406393`*^9}, {
   3.5319437006495266`*^9, 3.5319437038787327`*^9}, {3.5340026346818047`*^9, 
   3.534002637453963*^9}, {3.5340030209706793`*^9, 3.5340030293451586`*^9}, {
   3.534118784243157*^9, 3.5341188511132507`*^9}, {3.534119170853698*^9, 
   3.534119179923711*^9}, {3.534119497584155*^9, 3.5341195421742177`*^9}, {
   3.5498221970752525`*^9, 3.5498221995452557`*^9}, {3.611348176827039*^9, 
   3.61134819860707*^9}, {3.6113489579198065`*^9, 3.61134896037731*^9}, {
   3.637958419967972*^9, 3.637958422323576*^9}, {3.637958506351324*^9, 
   3.637958508160927*^9}, {3.6379591386233625`*^9, 3.637959156953395*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.520101787997136*^9, 3.5201017908831415`*^9}, 
   3.534119660884384*^9, 3.5341197024044423`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{"h", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", "m"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", "*", "x"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"p", "+", "1"}], ")"}]}], "/", 
      RowBox[{"(", 
       RowBox[{"d", "*", "f", "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ")"}]}], ")"}]}]}], " ",
     "+", " ", "\n", "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"d", "*", "f", "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"m", "-", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "*", "\n", "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"a", "*", "d", "*", "f", "*", "g", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ")"}]}], "-", 
           RowBox[{"h", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", "c", "*", "e", "*", "m"}], "+", 
              RowBox[{"a", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "e", "*", 
                  RowBox[{"(", 
                   RowBox[{"n", "+", "1"}], ")"}]}], "+", 
                 RowBox[{"c", "*", "f", "*", 
                  RowBox[{"(", 
                   RowBox[{"p", "+", "1"}], ")"}]}]}], ")"}]}]}], ")"}]}], 
           "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", "d", "*", "f", "*", "g", "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ")"}]}], "+", 
              RowBox[{"h", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"a", "*", "d", "*", "f", "*", "m"}], "-", 
                 RowBox[{"b", "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"d", "*", "e", "*", 
                    RowBox[{"(", 
                    RowBox[{"m", "+", "n", "+", "1"}], ")"}]}], "+", 
                    RowBox[{"c", "*", "f", "*", 
                    RowBox[{"(", 
                    RowBox[{"m", "+", "p", "+", "1"}], ")"}]}]}], ")"}]}]}], 
                ")"}]}]}], ")"}], "*", "x"}]}], ",", "x"}], "]"}]}], ",", 
       "x"}], "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "n", ",", "p"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"GtQ", "[", 
     RowBox[{"m", ",", "0"}], "]"}], " ", "&&", " ", 
    RowBox[{"NeQ", "[", 
     RowBox[{
      RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ",", "0"}], "]"}], " ", "&&",
     " ", 
    RowBox[{"IntegerQ", "[", "m", "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495839738475589*^9, 3.4958405008250694`*^9, {3.495847490784856*^9, 
   3.4958474999948683`*^9}, {3.4958477172451725`*^9, 3.495847721615179*^9}, {
   3.495848224085882*^9, 3.4958482277058873`*^9}, {3.4958482626259365`*^9, 
   3.4958482686359444`*^9}, 3.4959261054722724`*^9, {3.4959262905725317`*^9, 
   3.4959262958725395`*^9}, 3.495926443222745*^9, 3.4961849395451694`*^9, 
   3.496185884976493*^9, 3.4961888731806765`*^9, {3.4961890260508904`*^9, 
   3.4961890290708947`*^9}, {3.496191957967628*^9, 3.4961919600576305`*^9}, 
   3.49619205250776*^9, 3.4961952203321953`*^9, {3.496195426482484*^9, 
   3.496195433172493*^9}, {3.496195586822708*^9, 3.496195595732721*^9}, 
   3.496195754542943*^9, 3.4966189754082823`*^9, {3.4966198797795486`*^9, 
   3.496619907439587*^9}, {3.4968579645422487`*^9, 3.4968579680210547`*^9}, 
   3.5171911044266214`*^9, 3.518211198418105*^9, 3.5182420941409807`*^9, {
   3.518281849687285*^9, 3.518281849874485*^9}, {3.5182861978669233`*^9, 
   3.518286207226939*^9}, 3.518286893072945*^9, 3.518287077449669*^9, {
   3.518405919376315*^9, 3.5184059327163334`*^9}, 3.518406000866429*^9, {
   3.5184061023365707`*^9, 3.518406115016588*^9}, {3.5184065135071464`*^9, 
   3.518406515547149*^9}, {3.518406800569559*^9, 3.5184068071395683`*^9}, {
   3.518455696848171*^9, 3.518455715349804*^9}, {3.518469305994045*^9, 
   3.518469310354051*^9}, {3.5184693414340944`*^9, 3.5184693641841264`*^9}, {
   3.518469461554263*^9, 3.518469497814314*^9}, {3.5184698199647646`*^9, 
   3.5184698496348057`*^9}, {3.5184698834448533`*^9, 3.5184698844848547`*^9}, 
   3.5184701704452553`*^9, {3.518470248195364*^9, 3.518470287395419*^9}, {
   3.51847032361547*^9, 3.518470324325471*^9}, {3.518474812134432*^9, 
   3.5184748359088736`*^9}, {3.5184748784969482`*^9, 3.51847487927695*^9}, 
   3.518475395747057*^9, {3.5184754745583954`*^9, 3.518475478770403*^9}, {
   3.5184759352008047`*^9, 3.518475938726411*^9}, {3.5184760887674747`*^9, 
   3.5184761024174986`*^9}, {3.518476247310553*^9, 3.5184762483245544`*^9}, {
   3.518476459611326*^9, 3.518476460235327*^9}, {3.5185837600757217`*^9, 
   3.518583760356522*^9}, {3.5188842541996765`*^9, 3.5188842747997055`*^9}, {
   3.518890955169058*^9, 3.5188909696490784`*^9}, {3.5188914772697887`*^9, 
   3.518891482339796*^9}, {3.520102006257119*^9, 3.5201020069591208`*^9}, 
   3.5201020756928415`*^9, {3.5202847653043165`*^9, 3.520284765308317*^9}, {
   3.5202851424268866`*^9, 3.520285144721018*^9}, {3.520899838877209*^9, 
   3.5208998429572153`*^9}, {3.521131441309245*^9, 3.521131443849249*^9}, 
   3.521148390206671*^9, {3.5223485088319473`*^9, 3.5223485168319583`*^9}, {
   3.5224420691492205`*^9, 3.522442069414421*^9}, 3.5237568920485764`*^9, 
   3.523757219519035*^9, 3.523757259739091*^9, {3.5237580436701884`*^9, 
   3.523758059720211*^9}, {3.523758936761439*^9, 3.523758939721443*^9}, 
   3.523810558420226*^9, 3.523818931362772*^9, {3.523835156403449*^9, 
   3.5238351582934523`*^9}, 3.5247721246012163`*^9, {3.5247739098537154`*^9, 
   3.5247740062738504`*^9}, {3.524774046163906*^9, 3.524774061003927*^9}, {
   3.5269452650085325`*^9, 3.526945270312542*^9}, {3.527188364001113*^9, 
   3.5271883677139196`*^9}, {3.5271888173223095`*^9, 3.527188823843121*^9}, {
   3.5271899878391657`*^9, 3.5271900376656528`*^9}, {3.527190166287879*^9, 
   3.5271901716698885`*^9}, {3.527190278608076*^9, 3.5271902902768965`*^9}, {
   3.527982424123417*^9, 3.5279824278986235`*^9}, {3.5279825248995934`*^9, 
   3.5279825340568094`*^9}, {3.5304120848332186`*^9, 3.530412106123248*^9}, {
   3.5304130055745077`*^9, 3.530413008634512*^9}, {3.530413043314561*^9, 
   3.530413055224577*^9}, {3.530413087314622*^9, 3.5304130884346237`*^9}, {
   3.5304131472647057`*^9, 3.5304131483447075`*^9}, 3.53046311973864*^9, {
   3.5304888886920757`*^9, 3.530488894767084*^9}, {3.531941152706251*^9, 
   3.531941162830669*^9}, {3.531941299455709*^9, 3.531941306974922*^9}, {
   3.5319414191859193`*^9, 3.5319414225243254`*^9}, {3.531941554079356*^9, 
   3.531941559040165*^9}, {3.531941786394964*^9, 3.531941805174197*^9}, {
   3.5319419942717295`*^9, 3.531941998764538*^9}, {3.5319420576234407`*^9, 
   3.531942059916645*^9}, {3.531943420348234*^9, 3.5319434261514444`*^9}, {
   3.5319437080127397`*^9, 3.53194372535997*^9}, {3.531943778727664*^9, 
   3.531943779960066*^9}, {3.5319453490892224`*^9, 3.5319453522092276`*^9}, {
   3.5339415241170616`*^9, 3.533941538197081*^9}, {3.5339415789871387`*^9, 
   3.533941604107174*^9}, {3.5339512902895765`*^9, 3.5339512946731844`*^9}, 
   3.533951351067283*^9, {3.5340027757635803`*^9, 3.534002812286766*^9}, {
   3.5341190049334655`*^9, 3.5341190294735003`*^9}, {3.5341191883437223`*^9, 
   3.534119195643733*^9}, {3.5341193695439763`*^9, 3.53411941511404*^9}, 
   3.5341196611243844`*^9, {3.5341196955644326`*^9, 3.5341197132044573`*^9}, {
   3.53411976495453*^9, 3.5341197859645596`*^9}, {3.5341198161046014`*^9, 
   3.5341198333046255`*^9}, 3.5341199475947857`*^9, 3.5341203626853666`*^9, {
   3.5345320463388095`*^9, 3.5345320520621367`*^9}, {3.5400017308272676`*^9, 
   3.540001736107275*^9}, {3.542249989006481*^9, 3.5422499957078643`*^9}, {
   3.542250036073081*^9, 3.542250039670287*^9}, 3.5498209379134893`*^9, 
   3.5498210856636963`*^9, 3.549821116193739*^9, 3.5498220886751003`*^9, {
   3.5498222071852665`*^9, 3.54982220976527*^9}, 3.5498232774067645`*^9, {
   3.6113482525721474`*^9, 3.611348275997181*^9}, {3.611348965777318*^9, 
   3.611348970487325*^9}, 3.6113556452168617`*^9, 3.611383619514218*^9, {
   3.6379381927749925`*^9, 3.637938198985001*^9}, {3.6379584232907777`*^9, 
   3.6379584260987825`*^9}, {3.6379585089721284`*^9, 
   3.6379585114369326`*^9}, {3.637959170182218*^9, 3.637959182022639*^9}, {
   3.6391772204710617`*^9, 3.6391772302726226`*^9}, {3.639177321047815*^9, 
   3.639177347493327*^9}, 3.6444420490071692`*^9, {3.65073924204595*^9, 
   3.6507392577968507`*^9}, {3.6507393101678467`*^9, 
   3.6507393368873744`*^9}, {3.6507395041869435`*^9, 3.6507395227380047`*^9}, 
   3.65073956881964*^9, {3.6507396041886635`*^9, 3.650739606717808*^9}, 
   3.650739652547429*^9, {3.6538484729448767`*^9, 3.653848482354693*^9}, 
   3.706112995450881*^9, 3.706113031362935*^9, {3.7077034796455*^9, 
   3.7077034849027095`*^9}},
 Background->GrayLevel[0.85]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{"h", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", "m"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", "*", "x"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"p", "+", "1"}], ")"}]}], "/", 
      RowBox[{"(", 
       RowBox[{"d", "*", "f", "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ")"}]}], ")"}]}]}], " ",
     "+", " ", "\n", "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"d", "*", "f", "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"m", "-", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "*", "\n", "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"a", "*", "d", "*", "f", "*", "g", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ")"}]}], "-", 
           RowBox[{"h", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", "c", "*", "e", "*", "m"}], "+", 
              RowBox[{"a", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "e", "*", 
                  RowBox[{"(", 
                   RowBox[{"n", "+", "1"}], ")"}]}], "+", 
                 RowBox[{"c", "*", "f", "*", 
                  RowBox[{"(", 
                   RowBox[{"p", "+", "1"}], ")"}]}]}], ")"}]}]}], ")"}]}], 
           "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", "d", "*", "f", "*", "g", "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ")"}]}], "+", 
              RowBox[{"h", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"a", "*", "d", "*", "f", "*", "m"}], "-", 
                 RowBox[{"b", "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"d", "*", "e", "*", 
                    RowBox[{"(", 
                    RowBox[{"m", "+", "n", "+", "1"}], ")"}]}], "+", 
                    RowBox[{"c", "*", "f", "*", 
                    RowBox[{"(", 
                    RowBox[{"m", "+", "p", "+", "1"}], ")"}]}]}], ")"}]}]}], 
                ")"}]}]}], ")"}], "*", "x"}]}], ",", "x"}], "]"}]}], ",", 
       "x"}], "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "n", ",", "p"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"GtQ", "[", 
     RowBox[{"m", ",", "0"}], "]"}], " ", "&&", " ", 
    RowBox[{"NeQ", "[", 
     RowBox[{
      RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ",", "0"}], "]"}], " ", "&&",
     " ", 
    RowBox[{"IntegersQ", "[", 
     RowBox[{
      RowBox[{"2", "*", "m"}], ",", 
      RowBox[{"2", "*", "n"}], ",", 
      RowBox[{"2", "*", "p"}]}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495839738475589*^9, 3.4958405008250694`*^9, {3.495847490784856*^9, 
   3.4958474999948683`*^9}, {3.4958477172451725`*^9, 3.495847721615179*^9}, {
   3.495848224085882*^9, 3.4958482277058873`*^9}, {3.4958482626259365`*^9, 
   3.4958482686359444`*^9}, 3.4959261054722724`*^9, {3.4959262905725317`*^9, 
   3.4959262958725395`*^9}, 3.495926443222745*^9, 3.4961849395451694`*^9, 
   3.496185884976493*^9, 3.4961888731806765`*^9, {3.4961890260508904`*^9, 
   3.4961890290708947`*^9}, {3.496191957967628*^9, 3.4961919600576305`*^9}, 
   3.49619205250776*^9, 3.4961952203321953`*^9, {3.496195426482484*^9, 
   3.496195433172493*^9}, {3.496195586822708*^9, 3.496195595732721*^9}, 
   3.496195754542943*^9, 3.4966189754082823`*^9, {3.4966198797795486`*^9, 
   3.496619907439587*^9}, {3.4968579645422487`*^9, 3.4968579680210547`*^9}, 
   3.5171911044266214`*^9, 3.518211198418105*^9, 3.5182420941409807`*^9, {
   3.518281849687285*^9, 3.518281849874485*^9}, {3.5182861978669233`*^9, 
   3.518286207226939*^9}, 3.518286893072945*^9, 3.518287077449669*^9, {
   3.518405919376315*^9, 3.5184059327163334`*^9}, 3.518406000866429*^9, {
   3.5184061023365707`*^9, 3.518406115016588*^9}, {3.5184065135071464`*^9, 
   3.518406515547149*^9}, {3.518406800569559*^9, 3.5184068071395683`*^9}, {
   3.518455696848171*^9, 3.518455715349804*^9}, {3.518469305994045*^9, 
   3.518469310354051*^9}, {3.5184693414340944`*^9, 3.5184693641841264`*^9}, {
   3.518469461554263*^9, 3.518469497814314*^9}, {3.5184698199647646`*^9, 
   3.5184698496348057`*^9}, {3.5184698834448533`*^9, 3.5184698844848547`*^9}, 
   3.5184701704452553`*^9, {3.518470248195364*^9, 3.518470287395419*^9}, {
   3.51847032361547*^9, 3.518470324325471*^9}, {3.518474812134432*^9, 
   3.5184748359088736`*^9}, {3.5184748784969482`*^9, 3.51847487927695*^9}, 
   3.518475395747057*^9, {3.5184754745583954`*^9, 3.518475478770403*^9}, {
   3.5184759352008047`*^9, 3.518475938726411*^9}, {3.5184760887674747`*^9, 
   3.5184761024174986`*^9}, {3.518476247310553*^9, 3.5184762483245544`*^9}, {
   3.518476459611326*^9, 3.518476460235327*^9}, {3.5185837600757217`*^9, 
   3.518583760356522*^9}, {3.5188842541996765`*^9, 3.5188842747997055`*^9}, {
   3.518890955169058*^9, 3.5188909696490784`*^9}, {3.5188914772697887`*^9, 
   3.518891482339796*^9}, {3.520102006257119*^9, 3.5201020069591208`*^9}, 
   3.5201020756928415`*^9, {3.5202847653043165`*^9, 3.520284765308317*^9}, {
   3.5202851424268866`*^9, 3.520285144721018*^9}, {3.520899838877209*^9, 
   3.5208998429572153`*^9}, {3.521131441309245*^9, 3.521131443849249*^9}, 
   3.521148390206671*^9, {3.5223485088319473`*^9, 3.5223485168319583`*^9}, {
   3.5224420691492205`*^9, 3.522442069414421*^9}, 3.5237568920485764`*^9, 
   3.523757219519035*^9, 3.523757259739091*^9, {3.5237580436701884`*^9, 
   3.523758059720211*^9}, {3.523758936761439*^9, 3.523758939721443*^9}, 
   3.523810558420226*^9, 3.523818931362772*^9, {3.523835156403449*^9, 
   3.5238351582934523`*^9}, 3.5247721246012163`*^9, {3.5247739098537154`*^9, 
   3.5247740062738504`*^9}, {3.524774046163906*^9, 3.524774061003927*^9}, {
   3.5269452650085325`*^9, 3.526945270312542*^9}, {3.527188364001113*^9, 
   3.5271883677139196`*^9}, {3.5271888173223095`*^9, 3.527188823843121*^9}, {
   3.5271899878391657`*^9, 3.5271900376656528`*^9}, {3.527190166287879*^9, 
   3.5271901716698885`*^9}, {3.527190278608076*^9, 3.5271902902768965`*^9}, {
   3.527982424123417*^9, 3.5279824278986235`*^9}, {3.5279825248995934`*^9, 
   3.5279825340568094`*^9}, {3.5304120848332186`*^9, 3.530412106123248*^9}, {
   3.5304130055745077`*^9, 3.530413008634512*^9}, {3.530413043314561*^9, 
   3.530413055224577*^9}, {3.530413087314622*^9, 3.5304130884346237`*^9}, {
   3.5304131472647057`*^9, 3.5304131483447075`*^9}, 3.53046311973864*^9, {
   3.5304888886920757`*^9, 3.530488894767084*^9}, {3.531941152706251*^9, 
   3.531941162830669*^9}, {3.531941299455709*^9, 3.531941306974922*^9}, {
   3.5319414191859193`*^9, 3.5319414225243254`*^9}, {3.531941554079356*^9, 
   3.531941559040165*^9}, {3.531941786394964*^9, 3.531941805174197*^9}, {
   3.5319419942717295`*^9, 3.531941998764538*^9}, {3.5319420576234407`*^9, 
   3.531942059916645*^9}, {3.531943420348234*^9, 3.5319434261514444`*^9}, {
   3.5319437080127397`*^9, 3.53194372535997*^9}, {3.531943778727664*^9, 
   3.531943779960066*^9}, {3.5319453490892224`*^9, 3.5319453522092276`*^9}, {
   3.5339415241170616`*^9, 3.533941538197081*^9}, {3.5339415789871387`*^9, 
   3.533941604107174*^9}, {3.5339512902895765`*^9, 3.5339512946731844`*^9}, 
   3.533951351067283*^9, {3.5340027757635803`*^9, 3.534002812286766*^9}, {
   3.5341190049334655`*^9, 3.5341190294735003`*^9}, {3.5341191883437223`*^9, 
   3.534119195643733*^9}, {3.5341193695439763`*^9, 3.53411941511404*^9}, 
   3.5341196611243844`*^9, {3.5341196955644326`*^9, 3.5341197132044573`*^9}, {
   3.53411976495453*^9, 3.5341197859645596`*^9}, {3.5341198161046014`*^9, 
   3.5341198333046255`*^9}, 3.5341199475947857`*^9, 3.5341203626853666`*^9, {
   3.5345320463388095`*^9, 3.5345320520621367`*^9}, {3.5400017308272676`*^9, 
   3.540001736107275*^9}, {3.542249989006481*^9, 3.5422499957078643`*^9}, {
   3.542250036073081*^9, 3.542250039670287*^9}, 3.5498209379134893`*^9, 
   3.5498210856636963`*^9, 3.549821116193739*^9, 3.5498220886751003`*^9, {
   3.5498222071852665`*^9, 3.54982220976527*^9}, 3.5498232774067645`*^9, {
   3.6113482525721474`*^9, 3.611348275997181*^9}, {3.611348965777318*^9, 
   3.611348970487325*^9}, 3.6113556452168617`*^9, 3.611383619514218*^9, {
   3.6379381927749925`*^9, 3.637938198985001*^9}, {3.6379584232907777`*^9, 
   3.6379584260987825`*^9}, {3.6379585089721284`*^9, 
   3.6379585114369326`*^9}, {3.637959170182218*^9, 3.637959182022639*^9}, {
   3.6391772204710617`*^9, 3.6391772302726226`*^9}, {3.639177321047815*^9, 
   3.639177347493327*^9}, 3.6444420490071692`*^9, {3.65073924204595*^9, 
   3.6507392577968507`*^9}, {3.6507393101678467`*^9, 
   3.6507393368873744`*^9}, {3.650739469179941*^9, 3.650739491252204*^9}, {
   3.6507396686473503`*^9, 3.6507396713525047`*^9}, {3.653846123738923*^9, 
   3.65384612798213*^9}, {3.6538482426746693`*^9, 3.6538482519908857`*^9}, 
   3.653848464037261*^9, 3.706112995476883*^9, 3.7061130344671125`*^9, {
   3.707703489769918*^9, 3.707703492827523*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{Cell[TextData[StyleBox["5:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], " ", Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"m", "+", "n", "+", "p", "+", "2"}], "\[Element]", 
        SuperscriptBox["\[DoubleStruckCapitalZ]", "-"]}], "\[And]", " ", 
       RowBox[{"m", "\[NotEqual]", 
        RowBox[{"-", "1"}]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.5192504337891226`*^9, 3.5192504707812386`*^9}, 3.5192506717957726`*^9, {
   3.519250720795459*^9, 3.5192507409818945`*^9}, 3.519258420209427*^9, 
   3.519258489779525*^9, {3.519320786305674*^9, 3.519320803294104*^9}, {
   3.519329422708468*^9, 3.5193294257984724`*^9}, 3.5193294706485353`*^9, {
   3.5193302883925123`*^9, 3.519330307237345*^9}, {3.5193303440378103`*^9, 
   3.5193303650666466`*^9}, 3.5193341918281684`*^9, {3.5193346196121197`*^9, 
   3.519334632840943*^9}, {3.519341922663512*^9, 3.5193419232095127`*^9}, 
   3.5193423494490614`*^9, {3.5193456600396833`*^9, 3.519345660273684*^9}, 
   3.519410696547495*^9, {3.519793559756592*^9, 3.5197935600217924`*^9}, {
   3.5210541942272606`*^9, 3.5210542323693275`*^9}, {3.521054705798959*^9, 
   3.5210547345342093`*^9}, {3.521055431683834*^9, 3.5210554455522585`*^9}, {
   3.5210554827427235`*^9, 3.5210555031319594`*^9}, {3.521056059772137*^9, 
   3.521056075652965*^9}, {3.521057417664521*^9, 3.521057417867322*^9}, {
   3.5210574854778404`*^9, 3.5210574857586412`*^9}, {3.5210575212175035`*^9, 
   3.521057540483537*^9}, {3.5210598942936716`*^9, 3.5210599092384977`*^9}, {
   3.521063276214819*^9, 3.521063298928458*^9}, {3.5210639991824884`*^9, 
   3.5210640343449497`*^9}, {3.5210641665551825`*^9, 
   3.5210641665551825`*^9}, {3.521072868148899*^9, 3.521072868148899*^9}, {
   3.5210824253375397`*^9, 3.5210824255559406`*^9}, {3.5211479965711794`*^9, 
   3.521148020673222*^9}, {3.5211480693453074`*^9, 3.5211480699537086`*^9}, {
   3.521148148187846*^9, 3.5211481489366474`*^9}, {3.5211482363436007`*^9, 
   3.5211482363436007`*^9}, {3.521148269556059*^9, 3.521148269556059*^9}, {
   3.521346368187188*^9, 3.521346368421189*^9}, {3.5214702809911447`*^9, 
   3.5214702811783447`*^9}, {3.5216579052539043`*^9, 3.521657905453904*^9}, {
   3.5223485259619713`*^9, 3.522348534381983*^9}, {3.5233208394702005`*^9, 
   3.5233208394702005`*^9}, {3.523320922845537*^9, 3.523320922845537*^9}, 
   3.523747250675035*^9, {3.5237670269856477`*^9, 3.5237670269856477`*^9}, {
   3.523831184179017*^9, 3.523831184179017*^9}, 3.5247720382710953`*^9, {
   3.524772397491598*^9, 3.524772397491598*^9}, {3.524774194324114*^9, 
   3.524774228794162*^9}, {3.526945238644486*^9, 3.526945238644486*^9}, {
   3.5279098167721815`*^9, 3.5279098172421827`*^9}, {3.5296282016140704`*^9, 
   3.5296282019130874`*^9}, 3.530384384323295*^9, {3.5303845765632906`*^9, 
   3.530384576766302*^9}, {3.530412765574172*^9, 3.530412765724172*^9}, {
   3.5304133134449387`*^9, 3.530413327614959*^9}, {3.5304133632650084`*^9, 
   3.5304133653750114`*^9}, {3.5304685359612284`*^9, 
   3.5304685362112293`*^9}, {3.5306637757276535`*^9, 3.530663775992854*^9}, 
   3.531940972073534*^9, {3.531941135920622*^9, 3.531941136887823*^9}, {
   3.531941292685297*^9, 3.5319412934028983`*^9}, {3.531941412696308*^9, 
   3.53194141378831*^9}, {3.531941540834933*^9, 3.531941542176535*^9}, {
   3.531941747348096*^9, 3.5319417604365187`*^9}, {3.5319419776265*^9, 
   3.531941978453302*^9}, {3.5319420524598317`*^9, 3.5319420537078342`*^9}, {
   3.5319437460612063`*^9, 3.5319437460612063`*^9}, {3.531945368214856*^9, 
   3.531945368214856*^9}, {3.5339235218280125`*^9, 3.533923522848014*^9}, {
   3.5340030836026883`*^9, 3.534003084035713*^9}, 3.534118752423112*^9, {
   3.5341190488235273`*^9, 3.534119049053528*^9}, {3.534119148303666*^9, 
   3.534119148303666*^9}, {3.534119453664094*^9, 3.5341194538540945`*^9}, {
   3.534119902144722*^9, 3.534119902374722*^9}, {3.534120406425428*^9, 
   3.534120406425428*^9}, {3.549820849863366*^9, 3.5498208498733664`*^9}, {
   3.549821172193817*^9, 3.549821172193817*^9}, {3.549821203363861*^9, 
   3.549821203363861*^9}, {3.549822107375127*^9, 3.549822107375127*^9}, {
   3.549823247326722*^9, 3.549823247326722*^9}, {3.549823490687063*^9, 
   3.549823492017065*^9}, {3.549823618477242*^9, 3.5498236350772657`*^9}, 
   3.5717051179597855`*^9, 3.575822925736909*^9, {3.611348144806993*^9, 
   3.611348144806993*^9}, {3.611348896789712*^9, 3.611348900119717*^9}, 
   3.611349282915304*^9, {3.611349324885369*^9, 3.6113493250653687`*^9}, {
   3.611349703468462*^9, 3.611349703468462*^9}, {3.6113557010469403`*^9, 
   3.6113557010469403`*^9}, {3.637938376592255*^9, 3.637938376772256*^9}, 
   3.637958426816384*^9, 3.637958512123334*^9, {3.644442063200981*^9, 
   3.644442063200981*^9}, {3.6444722513391705`*^9, 3.6444722533592863`*^9}, {
   3.644472364258629*^9, 3.6444723744222107`*^9}, 3.653853292037979*^9, {
   3.6538533502040615`*^9, 3.653853350494062*^9}, {3.65385345113721*^9, 
   3.65385345113721*^9}, {3.653856718621895*^9, 3.6538567188918953`*^9}, {
   3.739309800033972*^9, 3.7393098209068084`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Nondegenerate trilinear recurrence 3", "Subsubsection",
 CellChangeTimes->{
  3.496441803031353*^9, 3.4965396318089237`*^9, {3.4966002562016735`*^9, 
   3.4966002624716825`*^9}, 3.496600707442305*^9, 3.4966008475725017`*^9, {
   3.4966070255131593`*^9, 3.496607032413169*^9}, 3.518279406700592*^9, {
   3.51840552316576*^9, 3.5184055392257824`*^9}, 3.5184690414436746`*^9, 
   3.518469651844529*^9, 3.5184700043450227`*^9, 3.518474659316563*^9, 
   3.5237473322319784`*^9, 3.5247722814214354`*^9, {3.5260660236439*^9, 
   3.526066024233901*^9}, {3.530413463335149*^9, 3.5304134989751987`*^9}, {
   3.5339258909313297`*^9, 3.533925894241334*^9}, {3.5341187688231354`*^9, 
   3.534118769443136*^9}, {3.534119456044097*^9, 3.5341194563640976`*^9}, {
   3.534119904484725*^9, 3.5341199048347254`*^9}, 3.6113471307105365`*^9}],

Cell[TextData[{
 "Note: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"m", "+", "n", "+", "p", "+", "2"}], "\[Element]", 
   SuperscriptBox["\[DoubleStruckCapitalZ]", "-"]}]]],
 ", then ",
 Cell[BoxData[
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], 
    RowBox[{"\[DifferentialD]", "x"}]}]}]],
  CellDingbat->None,
  CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
    3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
    3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
    3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
    3.495391696001576*^9, {3.4954224033621993`*^9, 3.495422429782236*^9}, {
    3.4962830099393682`*^9, 3.496283015729377*^9}, {3.5241060284804335`*^9, 
    3.5241060764193172`*^9}, {3.524167368204706*^9, 3.5241674428548107`*^9}, {
    3.524168833516758*^9, 3.5241688560167894`*^9}, {3.53038360604578*^9, 
    3.530383613747221*^9}, 3.530383659086814*^9, {3.5312563478167567`*^9, 
    3.5312563530442734`*^9}, {3.531271888617525*^9, 3.5312718914516*^9}, {
    3.533940690055894*^9, 3.533940693145898*^9}, {3.5341120443575926`*^9, 
    3.5341120761876373`*^9}, 3.534113111409086*^9, {3.6114230672993755`*^9, 
    3.6114230708393803`*^9}, {3.611431925169129*^9, 3.6114319432791543`*^9}, {
    3.6114320618693204`*^9, 3.6114320622593207`*^9}, 3.611432265149605*^9, {
    3.611432351819726*^9, 3.6114323543097296`*^9}},
  TextAlignment->Center,
  FontSize->12,
  FontWeight->"Bold"],
 " can be expressed in terms of the hypergeometric function 2F1."
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4957339078770905`*^9, 
   3.495733966267172*^9}, {3.495734148157427*^9, 3.4957341584974413`*^9}, {
   3.4957346698781567`*^9, 3.495734670108157*^9}, {3.4957347778783083`*^9, 
   3.4957348688784356`*^9}, {3.5182850739057484`*^9, 
   3.5182850817837625`*^9}, {3.5193219410789022`*^9, 
   3.5193219437309074`*^9}, {3.5193301726195183`*^9, 
   3.5193301738595195`*^9}, {3.5199710233740273`*^9, 3.519971026084031*^9}, {
   3.519971058314076*^9, 3.519971083934112*^9}, {3.523219270157716*^9, 
   3.523219270157716*^9}, {3.523924231484662*^9, 3.523924232592264*^9}, {
   3.523930223132303*^9, 3.5239302243647056`*^9}, {3.523933687825989*^9, 
   3.523933687825989*^9}, {3.5241691044427414`*^9, 3.5241691044427414`*^9}, {
   3.530487866440643*^9, 3.530487866440643*^9}, 3.5312563413574686`*^9, 
   3.531272069487603*^9, 3.531272113390733*^9, {3.5339408766961555`*^9, 
   3.5339408833261642`*^9}, {3.534112449108159*^9, 3.5341124666181836`*^9}, {
   3.534113376879458*^9, 3.534113409039503*^9}, {3.5398880554756165`*^9, 
   3.5398880554756165`*^9}, {3.549824368378292*^9, 3.549824368378292*^9}, {
   3.6114321567394533`*^9, 3.6114321567394533`*^9}, {3.6114351527236476`*^9, 
   3.6114351527236476`*^9}, {3.61151699737206*^9, 3.61151699737206*^9}, {
   3.6115298674555836`*^9, 3.6115298674555836`*^9}, {3.6313094271547956`*^9, 
   3.6313094723823824`*^9}, {3.6538535012702837`*^9, 3.6538535012702837`*^9}}],

Cell[TextData[{
 "Rule 1.1.1.4",
 ".1.5: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"m", "+", "n", "+", "p", "+", "2"}], "\[Element]", 
    SuperscriptBox["\[DoubleStruckCapitalZ]", "-"]}], "\[And]", " ", 
   RowBox[{"m", "\[NotEqual]", 
    RowBox[{"-", "1"}]}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.4964417379912624`*^9, 3.4964417471112747`*^9}, {
   3.496441910111503*^9, 3.4964419275315275`*^9}, 3.496451213764926*^9, {
   3.496539487018721*^9, 3.4965395223187704`*^9}, {3.4966001213614845`*^9, 
   3.4966001362815056`*^9}, {3.4966047635399923`*^9, 
   3.4966048329500895`*^9}, {3.496604896730179*^9, 3.496605019710351*^9}, {
   3.496605050490394*^9, 3.4966050527103972`*^9}, {3.4966066606926484`*^9, 
   3.496606694832696*^9}, 3.496606873362946*^9, {3.4966081836347804`*^9, 
   3.496608250534874*^9}, {3.496608418375109*^9, 3.496608441025141*^9}, {
   3.4966322809467688`*^9, 3.4966322818867702`*^9}, {3.4968592460220995`*^9, 
   3.4968592640557313`*^9}, {3.4968593076422076`*^9, 
   3.4968593113862143`*^9}, {3.496859384233942*^9, 3.496859384233942*^9}, {
   3.518223900967896*^9, 3.518223909467908*^9}, 3.5182817155426493`*^9, {
   3.518285874431555*^9, 3.518285899625599*^9}, {3.5182860969191456`*^9, 
   3.518286138321618*^9}, {3.518286898517355*^9, 3.518286898517355*^9}, {
   3.5182870794776726`*^9, 3.5182870794776726`*^9}, {3.518469568024412*^9, 
   3.518469584774435*^9}, {3.518469921924907*^9, 3.5184699227449083`*^9}, {
   3.51847035958552*^9, 3.518470374475541*^9}, {3.518474847889694*^9, 
   3.518474854394906*^9}, {3.518475351645779*^9, 3.51847535181738*^9}, {
   3.518476861483632*^9, 3.5184768701416473`*^9}, {3.5184769318709555`*^9, 
   3.518476937876966*^9}, {3.5185837532117095`*^9, 3.51858375372651*^9}, {
   3.5211482838768845`*^9, 3.5211482838768845`*^9}, {3.5223485487820034`*^9, 
   3.5223485487820034`*^9}, {3.5237580782402368`*^9, 
   3.5237580830402436`*^9}, {3.524772390921589*^9, 3.524772390921589*^9}, {
   3.524774159434065*^9, 3.5247741821040964`*^9}, {3.526945226804065*^9, 
   3.5269452323576756`*^9}, {3.530413508385212*^9, 3.530413508385212*^9}, {
   3.5319411411622305`*^9, 3.5319411411622305`*^9}, {3.5319412943077*^9, 
   3.5319412943077*^9}, {3.531941415098712*^9, 3.531941415098712*^9}, {
   3.531941547106144*^9, 3.531941547776945*^9}, {3.5319417707481365`*^9, 
   3.531941771746538*^9}, {3.5319419851613135`*^9, 3.5319419851613135`*^9}, {
   3.5319420546594353`*^9, 3.5319420546594353`*^9}, {3.531943749524412*^9, 
   3.531943749820813*^9}, {3.531945371147661*^9, 3.531945371147661*^9}, {
   3.5341190906435857`*^9, 3.5341191318936434`*^9}, {3.534120260765224*^9, 
   3.5341202685852346`*^9}, {3.53412040067542*^9, 3.5341204008654203`*^9}, {
   3.549820877533405*^9, 3.549820877533405*^9}, {3.549821172943818*^9, 
   3.549821172943818*^9}, {3.549821204003862*^9, 3.549821204003862*^9}, {
   3.54982210991513*^9, 3.54982210991513*^9}, {3.549823249286725*^9, 
   3.549823249286725*^9}, {3.5498236779473257`*^9, 3.5498236779473257`*^9}, {
   3.611348133836977*^9, 3.6113481426269903`*^9}, {3.6113557053269463`*^9, 
   3.6113557053269463`*^9}, {3.6444420718154736`*^9, 3.6444420718154736`*^9}, 
   3.6501606009287176`*^9, {3.650160751695341*^9, 3.650160752682398*^9}, {
   3.653853366100085*^9, 3.653853367030086*^9}, {3.6538534538872137`*^9, 
   3.6538534538872137`*^9}, {3.6538568341020584`*^9, 3.653856834372059*^9}, 
   3.698684024493456*^9, {3.7393098330904303`*^9, 3.7393098330904303`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "g"}], "-", 
          RowBox[{"a", " ", "h"}]}], ")"}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}], 
         RowBox[{"m", "+", "1"}]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}], ")"}], 
         RowBox[{"n", "+", "1"}]], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", " ", "x"}]}], ")"}], 
         RowBox[{"p", "+", "1"}]]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "c"}], "-", 
          RowBox[{"a", " ", "d"}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "e"}], "-", 
          RowBox[{"a", " ", "f"}]}], ")"}]}]]}]}]}]}], "+", 
  "\[IndentingNewLine]", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"m", "+", "1"}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", " ", "c"}], "-", 
       RowBox[{"a", " ", "d"}]}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", " ", "e"}], "-", 
       RowBox[{"a", " ", "f"}]}], ")"}]}]], 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"m", "+", "1"}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], "p"], "\[CenterDot]", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"a", " ", "d", " ", "f", " ", "g"}], "-", 
           RowBox[{"b", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "e"}], "+", 
              RowBox[{"c", " ", "f"}]}], ")"}], " ", "g"}], "+", 
           RowBox[{"b", " ", "c", " ", "e", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "g"}], "-", 
           RowBox[{"a", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "e", " ", 
            RowBox[{"(", 
             RowBox[{"n", "+", "1"}], ")"}]}], "+", 
           RowBox[{"c", " ", "f", " ", 
            RowBox[{"(", 
             RowBox[{"p", "+", "1"}], ")"}]}]}], ")"}]}], "-", 
        RowBox[{"d", " ", "f", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "g"}], "-", 
           RowBox[{"a", " ", "h"}]}], ")"}], 
         RowBox[{"(", 
          RowBox[{"m", "+", "n", "+", "p", "+", "3"}], ")"}], " ", "x"}]}], 
       ")"}]}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, 3.4958399855843487`*^9, 3.495840155344586*^9, 
   3.495840624735243*^9, {3.4958474296047697`*^9, 3.495847433754776*^9}, {
   3.4958476539050837`*^9, 3.495847660315093*^9}, {3.4958482220958796`*^9, 
   3.4958482231858807`*^9}, {3.495848257515929*^9, 3.4958482607459335`*^9}, 
   3.4959261390123196`*^9, 3.4959262745925093`*^9, 3.4959264909328117`*^9, 
   3.4959265843129425`*^9, 3.495926967463479*^9, {3.496184978535224*^9, 
   3.496185020185282*^9}, {3.4961873840085917`*^9, 3.496187409278627*^9}, {
   3.4961890232008867`*^9, 3.4961890250708895`*^9}, 3.4961956176127515`*^9, {
   3.4961956815728407`*^9, 3.496195696542862*^9}, {3.4961957791729774`*^9, 
   3.4961957920929956`*^9}, 3.496195845773071*^9, 3.518405474905692*^9, {
   3.51840566597596*^9, 3.5184056974360037`*^9}, {3.518405737026059*^9, 
   3.5184057718861084`*^9}, {3.5184058668262415`*^9, 3.518405869606245*^9}, {
   3.5184688792534475`*^9, 3.518468891673465*^9}, 3.5184689356235266`*^9, {
   3.5184691371938086`*^9, 3.5184691450938196`*^9}, {3.51846968832458*^9, 
   3.5184697035846014`*^9}, {3.518470060915102*^9, 3.518470082885133*^9}, {
   3.5184747044318423`*^9, 3.5184747207338715`*^9}, 3.518475002735566*^9, {
   3.5188842113796167`*^9, 3.518884228949641*^9}, {3.518890960739066*^9, 
   3.5188909798390923`*^9}, {3.520101172685255*^9, 3.520101193979293*^9}, 
   3.520101537866297*^9, {3.520101583012776*^9, 3.520101592138792*^9}, 
   3.5237473966912913`*^9, {3.523747635309311*^9, 3.523747662094558*^9}, 
   3.523747693201012*^9, {3.5237589154214087`*^9, 3.523758920041415*^9}, {
   3.523835091963359*^9, 3.523835095403364*^9}, 3.5247720424111013`*^9, {
   3.5247722402213783`*^9, 3.524772242541381*^9}, {3.5247723065014706`*^9, 
   3.524772310491476*^9}, {3.5247724101316156`*^9, 3.5247725806518545`*^9}, {
   3.5247726200519094`*^9, 3.5247727072220316`*^9}, {3.5247728848022804`*^9, 
   3.5247728894922867`*^9}, {3.5247737712335215`*^9, 
   3.5247738023335648`*^9}, {3.5279824084921894`*^9, 
   3.5279824453238535`*^9}, {3.5304116139925594`*^9, 
   3.5304117038726854`*^9}, {3.530411918742986*^9, 3.53041197123306*^9}, 
   3.531941036782448*^9, {3.5319411448594375`*^9, 3.5319411488686447`*^9}, {
   3.531941294947301*^9, 3.531941298394907*^9}, {3.5319414162219143`*^9, 
   3.5319414182655177`*^9}, {3.531941548510146*^9, 3.5319415504133496`*^9}, {
   3.5319417755685453`*^9, 3.5319417799833527`*^9}, {3.5319419862689157`*^9, 
   3.531941989685322*^9}, {3.531942055798238*^9, 3.5319420566406393`*^9}, {
   3.5319437006495266`*^9, 3.5319437038787327`*^9}, {3.5340026346818047`*^9, 
   3.534002637453963*^9}, {3.5340030209706793`*^9, 3.5340030293451586`*^9}, {
   3.534118784243157*^9, 3.5341188511132507`*^9}, {3.534119170853698*^9, 
   3.534119179923711*^9}, {3.534119497584155*^9, 3.5341195421742177`*^9}, {
   3.5341199788848295`*^9, 3.534120010914874*^9}, {3.5498209881835594`*^9, 
   3.549820997693573*^9}, {3.5498211737338195`*^9, 3.549821174583821*^9}, {
   3.5498212805939693`*^9, 3.5498212951739893`*^9}, {3.6113478994666405`*^9, 
   3.611347952146716*^9}, {3.6113489074647284`*^9, 3.6113489132097373`*^9}, {
   3.6379584276899853`*^9, 3.6379584308567905`*^9}, {3.6379585128097353`*^9, 
   3.637958515102939*^9}, {3.637959232582328*^9, 3.6379592347351313`*^9}, 
   3.6538535523003583`*^9, 3.6538536242214627`*^9},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.520101787997136*^9, 3.5201017908831415`*^9}, 
   3.534119660884384*^9, 3.5341197024044423`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", "*", "g"}], "-", 
       RowBox[{"a", "*", "h"}]}], ")"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"n", "+", "1"}], ")"}]}], "*", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", "*", "x"}]}], ")"}], "^", 
       RowBox[{"(", 
        RowBox[{"p", "+", "1"}], ")"}]}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "c"}], "-", 
          RowBox[{"a", "*", "d"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}]}], ")"}]}]}], " ", "+", " ", 
    "\[IndentingNewLine]", "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "c"}], "-", 
          RowBox[{"a", "*", "d"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "*", "\n", "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"a", "*", "d", "*", "f", "*", "g"}], "-", 
              RowBox[{"b", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "e"}], "+", 
                 RowBox[{"c", "*", "f"}]}], ")"}], "*", "g"}], "+", 
              RowBox[{"b", "*", "c", "*", "e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", "g"}], "-", 
              RowBox[{"a", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", "*", "e", "*", 
               RowBox[{"(", 
                RowBox[{"n", "+", "1"}], ")"}]}], "+", 
              RowBox[{"c", "*", "f", "*", 
               RowBox[{"(", 
                RowBox[{"p", "+", "1"}], ")"}]}]}], ")"}]}], "-", 
           RowBox[{"d", "*", "f", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", "g"}], "-", 
              RowBox[{"a", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "n", "+", "p", "+", "3"}], ")"}], "*", "x"}]}],
           ",", "x"}], "]"}]}], ",", "x"}], "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "n", ",", "p"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"ILtQ", "[", 
     RowBox[{
      RowBox[{"m", "+", "n", "+", "p", "+", "2"}], ",", "0"}], "]"}], " ", "&&",
     " ", 
    RowBox[{"NeQ", "[", 
     RowBox[{"m", ",", 
      RowBox[{"-", "1"}]}], "]"}], " ", "&&", " ", "\n", "  ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SumSimplerQ", "[", 
       RowBox[{"m", ",", "1"}], "]"}], " ", "||", " ", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{
         RowBox[{"NeQ", "[", 
          RowBox[{"n", ",", 
           RowBox[{"-", "1"}]}], "]"}], " ", "&&", " ", 
         RowBox[{"SumSimplerQ", "[", 
          RowBox[{"n", ",", "1"}], "]"}]}], "]"}], " ", "&&", " ", 
       RowBox[{"Not", "[", 
        RowBox[{
         RowBox[{"NeQ", "[", 
          RowBox[{"p", ",", 
           RowBox[{"-", "1"}]}], "]"}], " ", "&&", " ", 
         RowBox[{"SumSimplerQ", "[", 
          RowBox[{"p", ",", "1"}], "]"}]}], "]"}]}]}], ")"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495839738475589*^9, 3.4958405008250694`*^9, {3.495847490784856*^9, 
   3.4958474999948683`*^9}, {3.4958477172451725`*^9, 3.495847721615179*^9}, {
   3.495848224085882*^9, 3.4958482277058873`*^9}, {3.4958482626259365`*^9, 
   3.4958482686359444`*^9}, 3.4959261054722724`*^9, {3.4959262905725317`*^9, 
   3.4959262958725395`*^9}, 3.495926443222745*^9, 3.4961849395451694`*^9, 
   3.496185884976493*^9, 3.4961888731806765`*^9, {3.4961890260508904`*^9, 
   3.4961890290708947`*^9}, {3.496191957967628*^9, 3.4961919600576305`*^9}, 
   3.49619205250776*^9, 3.4961952203321953`*^9, {3.496195426482484*^9, 
   3.496195433172493*^9}, {3.496195586822708*^9, 3.496195595732721*^9}, 
   3.496195754542943*^9, 3.4966189754082823`*^9, {3.4966198797795486`*^9, 
   3.496619907439587*^9}, {3.4968579645422487`*^9, 3.4968579680210547`*^9}, 
   3.5171911044266214`*^9, 3.518211198418105*^9, 3.5182420941409807`*^9, {
   3.518281849687285*^9, 3.518281849874485*^9}, {3.5182861978669233`*^9, 
   3.518286207226939*^9}, 3.518286893072945*^9, 3.518287077449669*^9, {
   3.518405919376315*^9, 3.5184059327163334`*^9}, 3.518406000866429*^9, {
   3.5184061023365707`*^9, 3.518406115016588*^9}, {3.5184065135071464`*^9, 
   3.518406515547149*^9}, {3.518406800569559*^9, 3.5184068071395683`*^9}, {
   3.518455696848171*^9, 3.518455715349804*^9}, {3.518469305994045*^9, 
   3.518469310354051*^9}, {3.5184693414340944`*^9, 3.5184693641841264`*^9}, {
   3.518469461554263*^9, 3.518469497814314*^9}, {3.5184698199647646`*^9, 
   3.5184698496348057`*^9}, {3.5184698834448533`*^9, 3.5184698844848547`*^9}, 
   3.5184701704452553`*^9, {3.518470248195364*^9, 3.518470287395419*^9}, {
   3.51847032361547*^9, 3.518470324325471*^9}, {3.518474812134432*^9, 
   3.5184748359088736`*^9}, {3.5184748784969482`*^9, 3.51847487927695*^9}, 
   3.518475395747057*^9, {3.5184754745583954`*^9, 3.518475478770403*^9}, {
   3.5184759352008047`*^9, 3.518475938726411*^9}, {3.5184760887674747`*^9, 
   3.5184761024174986`*^9}, {3.518476247310553*^9, 3.5184762483245544`*^9}, {
   3.518476459611326*^9, 3.518476460235327*^9}, {3.5185837600757217`*^9, 
   3.518583760356522*^9}, {3.5188842541996765`*^9, 3.5188842747997055`*^9}, {
   3.518890955169058*^9, 3.5188909696490784`*^9}, {3.5188914772697887`*^9, 
   3.518891482339796*^9}, {3.520102006257119*^9, 3.5201020069591208`*^9}, 
   3.5201020756928415`*^9, {3.5202847653043165`*^9, 3.520284765308317*^9}, {
   3.5202851424268866`*^9, 3.520285144721018*^9}, {3.520899838877209*^9, 
   3.5208998429572153`*^9}, {3.521131441309245*^9, 3.521131443849249*^9}, 
   3.521148390206671*^9, {3.5223485088319473`*^9, 3.5223485168319583`*^9}, {
   3.5224420691492205`*^9, 3.522442069414421*^9}, 3.5237568920485764`*^9, 
   3.523757219519035*^9, 3.523757259739091*^9, {3.5237580436701884`*^9, 
   3.523758059720211*^9}, {3.523758936761439*^9, 3.523758939721443*^9}, 
   3.523810558420226*^9, 3.523818931362772*^9, {3.523835156403449*^9, 
   3.5238351582934523`*^9}, 3.5247721246012163`*^9, {3.5247739098537154`*^9, 
   3.5247740062738504`*^9}, {3.524774046163906*^9, 3.524774061003927*^9}, {
   3.5269452650085325`*^9, 3.526945270312542*^9}, {3.527188364001113*^9, 
   3.5271883677139196`*^9}, {3.5271888173223095`*^9, 3.527188823843121*^9}, {
   3.5271899878391657`*^9, 3.5271900376656528`*^9}, {3.527190166287879*^9, 
   3.5271901716698885`*^9}, {3.527190278608076*^9, 3.5271902902768965`*^9}, {
   3.527982424123417*^9, 3.5279824278986235`*^9}, {3.5279825248995934`*^9, 
   3.5279825340568094`*^9}, {3.5304120848332186`*^9, 3.530412106123248*^9}, {
   3.5304130055745077`*^9, 3.530413008634512*^9}, {3.530413043314561*^9, 
   3.530413055224577*^9}, {3.530413087314622*^9, 3.5304130884346237`*^9}, {
   3.5304131472647057`*^9, 3.5304131483447075`*^9}, 3.53046311973864*^9, {
   3.5304888886920757`*^9, 3.530488894767084*^9}, {3.531941152706251*^9, 
   3.531941162830669*^9}, {3.531941299455709*^9, 3.531941306974922*^9}, {
   3.5319414191859193`*^9, 3.5319414225243254`*^9}, {3.531941554079356*^9, 
   3.531941559040165*^9}, {3.531941786394964*^9, 3.531941805174197*^9}, {
   3.5319419942717295`*^9, 3.531941998764538*^9}, {3.5319420576234407`*^9, 
   3.531942059916645*^9}, {3.531943420348234*^9, 3.5319434261514444`*^9}, {
   3.5319437080127397`*^9, 3.53194372535997*^9}, {3.531943778727664*^9, 
   3.531943779960066*^9}, {3.5319453490892224`*^9, 3.5319453522092276`*^9}, {
   3.5339415241170616`*^9, 3.533941538197081*^9}, {3.5339415789871387`*^9, 
   3.533941604107174*^9}, {3.5339512902895765`*^9, 3.5339512946731844`*^9}, 
   3.533951351067283*^9, {3.5340027757635803`*^9, 3.534002812286766*^9}, {
   3.5341190049334655`*^9, 3.5341190294735003`*^9}, {3.5341191883437223`*^9, 
   3.534119195643733*^9}, {3.5341193695439763`*^9, 3.53411941511404*^9}, 
   3.5341196611243844`*^9, {3.5341196955644326`*^9, 3.5341197132044573`*^9}, {
   3.53411976495453*^9, 3.5341197859645596`*^9}, {3.5341198161046014`*^9, 
   3.5341198333046255`*^9}, {3.5341202066851482`*^9, 
   3.5341202338551865`*^9}, {3.5341203290053196`*^9, 
   3.5341203384853325`*^9}, {3.5345320585805097`*^9, 3.534532063088767*^9}, {
   3.542250001432192*^9, 3.542250008476595*^9}, {3.5422500440135355`*^9, 
   3.5422500469807053`*^9}, {3.5498208880934196`*^9, 
   3.5498208937334275`*^9}, {3.549820948423504*^9, 3.5498209681835318`*^9}, {
   3.549821086453697*^9, 3.54982111701374*^9}, {3.5498213009139977`*^9, 
   3.549821315764018*^9}, 3.549822116275139*^9, 3.549823280296769*^9, {
   3.549823640347273*^9, 3.54982366705731*^9}, {3.6113479820117593`*^9, 
   3.611348006211794*^9}, 3.611348098771927*^9, {3.6113489350197706`*^9, 
   3.6113489387847767`*^9}, 3.6113497097884707`*^9, 3.6113557224169703`*^9, 
   3.637938291209133*^9, 3.6379383214221754`*^9, {3.6379584320111933`*^9, 
   3.637958435365199*^9}, {3.6379585158829403`*^9, 3.6379585188157454`*^9}, {
   3.637959272834798*^9, 3.6379592755336027`*^9}, 3.6391773616711383`*^9, 
   3.6444420781858377`*^9, {3.653846027656953*^9, 3.653846058050807*^9}, {
   3.6538485483060093`*^9, 3.6538485591188283`*^9}, {3.653853556492364*^9, 
   3.6538535595223684`*^9}, 3.6538536614385185`*^9, {3.653853838787775*^9, 
   3.653853864089811*^9}, {3.7061129955048842`*^9, 3.7061129955238853`*^9}, {
   3.7061130390393744`*^9, 3.7061130544602566`*^9}, {3.707593540143118*^9, 
   3.707593544868388*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{Cell[TextData[StyleBox["6.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}], "p"], " ", 
       RowBox[{"(", 
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}], ")"}]}], 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.534118429444058*^9, 3.534118443920883*^9}, {3.5341185894379387`*^9, 
   3.5341185897187395`*^9}, {3.534126368193774*^9, 3.534126368483775*^9}, {
   3.5347073427604*^9, 3.5347073430411997`*^9}, {3.535151711347787*^9, 
   3.5351517116277876`*^9}, {3.535151925298087*^9, 3.5351519255180874`*^9}, {
   3.5356775304977665`*^9, 3.535677530762967*^9}, {3.539393935916008*^9, 
   3.5393939361497617`*^9}, {3.5498214781142454`*^9, 3.54982148130425*^9}, {
   3.5498223076054068`*^9, 3.549822311385412*^9}, {3.549823219676684*^9, 
   3.549823219676684*^9}, {3.5498234629870243`*^9, 3.5498234851170554`*^9}, {
   3.549852537380123*^9, 3.549852537590123*^9}, 3.5717051167397833`*^9, 
   3.5758229243469067`*^9, {3.6113489203222485`*^9, 3.611348923219753*^9}, {
   3.6113491920426655`*^9, 3.611349194465169*^9}, {3.611349323642867*^9, 
   3.611349323855367*^9}, {3.6113556961469336`*^9, 3.6113556961469336`*^9}, {
   3.6379383749222527`*^9, 3.637938375112253*^9}, 3.6379584062379475`*^9, 
   3.6379584964433064`*^9, {3.644441998056255*^9, 3.644441998056255*^9}, {
   3.6444441261729765`*^9, 3.6444441416958637`*^9}, {3.6489542608672657`*^9, 
   3.6489542611852837`*^9}, {3.6489558301520243`*^9, 
   3.6489558303540354`*^9}, {3.6538568002150106`*^9, 3.6538568005550113`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{Cell[TextData[StyleBox["1:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
       RowBox[{"(", 
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}], ")"}]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.637938382042263*^9, 3.637938382212263*^9}, 
   3.6379584361296005`*^9, 3.637958525088957*^9, {3.644442095375821*^9, 
   3.6444421167450438`*^9}, {3.6444441446990356`*^9, 3.6444441654322214`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic expansion", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.52692391485268*^9, 
   3.5269239214514923`*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    RowBox[{"g", "+", 
     RowBox[{"h", " ", "x"}]}], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}]}]], "\[Equal]", 
   RowBox[{
    FractionBox[
     RowBox[{
      RowBox[{"b", " ", "g"}], "-", 
      RowBox[{"a", " ", "h"}]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "c"}], "-", 
        RowBox[{"a", " ", "d"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}]}]], "-", 
    FractionBox[
     RowBox[{
      RowBox[{"d", " ", "g"}], "-", 
      RowBox[{"c", " ", "h"}]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "c"}], "-", 
        RowBox[{"a", " ", "d"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}]}]]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5305579596307745`*^9, 3.5305579676023884`*^9}, {
   3.5346427869652395`*^9, 3.534642792293544*^9}, {3.534706470110467*^9, 
   3.534706470110467*^9}, {3.53470814564701*^9, 3.53470814564701*^9}, {
   3.5497628893122673`*^9, 3.5497628893122673`*^9}, {3.549861763110261*^9, 
   3.549861763110261*^9}, {3.6379584408740087`*^9, 3.6379584431828127`*^9}, {
   3.637958529333164*^9, 3.6379585304407663`*^9}, {3.6379592371375356`*^9, 
   3.6379592371375356`*^9}, {3.637959370861769*^9, 3.637959380407786*^9}}],

Cell["Rule 1.1.1.4.1.6.1:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5346428654127264`*^9, 3.5346428654127264`*^9}, {
   3.5346430222260027`*^9, 3.5346430222260027`*^9}, {3.534706547783003*^9, 
   3.534706547783003*^9}, {3.549762992727182*^9, 3.549762992727182*^9}, {
   3.5498518507891617`*^9, 3.5498518507891617`*^9}, {3.5498619240544662`*^9, 
   3.5498619240544662`*^9}, {3.5499243006306405`*^9, 
   3.5499243006306405`*^9}, {3.611357201729041*^9, 3.611357201729041*^9}, 
   3.64444212961878*^9, 3.6501606021127853`*^9, {3.6501607799709587`*^9, 
   3.6501607813880396`*^9}, {3.6538568492730803`*^9, 3.6538568494730806`*^9}, 
   3.698684024573456*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
      RowBox[{"(", 
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}], ")"}]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}]}]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
      FractionBox[
       RowBox[{
        RowBox[{"b", " ", "g"}], "-", 
        RowBox[{"a", " ", "h"}]}], 
       RowBox[{
        RowBox[{"b", " ", "c"}], "-", 
        RowBox[{"a", " ", "d"}]}]]}]}], 
    RowBox[{"\[Integral]", 
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]], 
      RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "-", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"d", " ", "g"}], "-", 
     RowBox[{"c", " ", "h"}]}], 
    RowBox[{
     RowBox[{"b", " ", "c"}], "-", 
     RowBox[{"a", " ", "d"}]}]], 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, 3.620233215990496*^9, {3.6379584438848143`*^9, 
   3.637958445195216*^9}, {3.6379585312363677`*^9, 3.6379585431235886`*^9}, 
   3.6379592382295375`*^9, {3.637959341348918*^9, 3.637959352578537*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"g_.", "+", 
        RowBox[{"h_.", "*", "x_"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a_.", "+", 
          RowBox[{"b_.", "*", "x_"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"c_.", "+", 
          RowBox[{"d_.", "*", "x_"}]}], ")"}]}], ")"}]}]}], ",", "x_Symbol"}],
    "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "g"}], "-", 
        RowBox[{"a", "*", "h"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "c"}], "-", 
        RowBox[{"a", "*", "d"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "/", 
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", "*", "x"}]}], ")"}]}], ",", "x"}], "]"}]}], " ", "-", 
    " ", "\n", "  ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", "*", "g"}], "-", 
        RowBox[{"c", "*", "h"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "c"}], "-", 
        RowBox[{"a", "*", "d"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "/", 
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", "*", "x"}]}], ")"}]}], ",", "x"}], "]"}]}]}], " ", "/;",
    "\n", 
   RowBox[{"FreeQ", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
       "h"}], "}"}], ",", "x"}], "]"}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.6379584465524187`*^9, 3.6379584487208223`*^9}, {
   3.6379585441687903`*^9, 3.637958545869193*^9}, 3.637959276750405*^9, {
   3.6379593897678022`*^9, 3.637959398784618*^9}, 3.644442132711957*^9},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{Cell[TextData[StyleBox["2:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}], "p"], " ", 
       RowBox[{"(", 
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}], ")"}]}], 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767252620544`*^9}, {
   3.526876907329974*^9, 3.5268769569848614`*^9}, {3.5269242339668407`*^9, 
   3.5269242339668407`*^9}, 3.5269267394468417`*^9, {3.526927027594948*^9, 
   3.526927035675762*^9}, {3.530558366526289*^9, 3.5305583787255106`*^9}, {
   3.5305584367264123`*^9, 3.5305584385984154`*^9}, {3.531942849761632*^9, 
   3.531942849917632*^9}, {3.5339406784958773`*^9, 3.5339406791758785`*^9}, {
   3.5341185863023334`*^9, 3.5341185863023334`*^9}, {3.534126360463763*^9, 
   3.534126361033764*^9}, {3.5347073402331953`*^9, 3.5347073404671955`*^9}, {
   3.534707390340483*^9, 3.534707390340483*^9}, {3.5393939323303337`*^9, 
   3.5393939325113444`*^9}, {3.5498230222764077`*^9, 3.5498230222764077`*^9}, 
   3.5717051155797815`*^9, 3.5758229229669046`*^9, {3.611349524660698*^9, 
   3.611349524893198*^9}, {3.6113560726974607`*^9, 3.611356089987485*^9}, {
   3.611510728968608*^9, 3.611510728968608*^9}, {3.6115112953519373`*^9, 
   3.611511295611938*^9}, {3.6314138645722046`*^9, 3.631413864872222*^9}, {
   3.6379383894122734`*^9, 3.6379383896322737`*^9}, 3.6379584590480404`*^9, 
   3.6379585599736185`*^9, 3.6444421663828826`*^9, {3.644443998196656*^9, 
   3.644444015607652*^9}, {3.6444441587898417`*^9, 3.6444441676463485`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic expansion", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    RowBox[{"g", "+", 
     RowBox[{"h", " ", "x"}]}], 
    RowBox[{"a", "+", 
     RowBox[{"b", " ", "x"}]}]], "\[Equal]", 
   RowBox[{
    FractionBox["h", "b"], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"b", " ", "g"}], "-", 
      RowBox[{"a", " ", "h"}]}], 
     RowBox[{"b", " ", 
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}]}]]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6444442984488297`*^9, 3.6444442984488297`*^9}}],

Cell["Rule 1.1.1.4.1.6.2:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5269270224625387`*^9, 3.5269270224625387`*^9}, {
   3.5305583575562735`*^9, 3.530558360660679*^9}, {3.5347074228665404`*^9, 
   3.5347074228665404`*^9}, {3.549823103506521*^9, 3.549823103506521*^9}, {
   3.611356258837721*^9, 3.611356258837721*^9}, 3.644442171303164*^9, 
   3.6501606027158203`*^9, {3.6501607859403*^9, 3.650160787728402*^9}, {
   3.6538568529330854`*^9, 3.653856853213086*^9}, 3.6986840246434555`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], "p"], " ", 
      RowBox[{"(", 
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}], ")"}]}], 
     RowBox[{"a", "+", 
      RowBox[{"b", " ", "x"}]}]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
      FractionBox["h", "b"]}]}], 
    RowBox[{"\[Integral]", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
      RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "+", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"b", " ", "g"}], "-", 
     RowBox[{"a", " ", "h"}]}], "b"], 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}], "p"]}], 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, {3.526876998184534*^9, 3.526877026217783*^9}, {
   3.5269267437524495`*^9, 3.5269267730181007`*^9}, {3.526927247898535*^9, 
   3.5269273030134315`*^9}, {3.5305581442882986`*^9, 
   3.5305581869543734`*^9}, {3.611356104997506*^9, 3.6113561134475174`*^9}, {
   3.611356245767703*^9, 3.6113562484177065`*^9}, 3.6115107423236275`*^9, {
   3.611510804573718*^9, 3.611510839793771*^9}, {3.6115109977190027`*^9, 
   3.611511008154019*^9}, {3.6314127071020007`*^9, 3.631412710136174*^9}, {
   3.63795846466405*^9, 3.6379584653972516`*^9}, {3.637958565355628*^9, 
   3.63795856660363*^9}, 3.6379592397895403`*^9, {3.6444441961279774`*^9, 
   3.644444222601492*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"g_.", "+", 
        RowBox[{"h_.", "*", "x_"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}]}]}], ",", "x_Symbol"}], "]"}], 
  " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"h", "/", "b"}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}]}], ",", "x"}], 
      "]"}]}], " ", "+", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "g"}], "-", 
        RowBox[{"a", "*", "h"}]}], ")"}], "/", "b"}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"e", "+", 
            RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "/", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}]}]}], ",", "x"}], "]"}]}]}], " ", "/;",
    "\n", 
   RowBox[{"FreeQ", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
       "h", ",", "n", ",", "p"}], "}"}], ",", "x"}], "]"}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.5268770685406575`*^9, 
   3.526877093875102*^9}, 3.5268771340139728`*^9, {3.5268772574725895`*^9, 
   3.5268772665362053`*^9}, 3.526918736047184*^9, {3.5269248094046516`*^9, 
   3.5269248214790726`*^9}, {3.5269273228098664`*^9, 3.526927337832693*^9}, 
   3.5269274194832363`*^9, 3.5269274496068892`*^9, {3.530558205830407*^9, 
   3.5305582319292526`*^9}, {3.5305584134979715`*^9, 3.530558416742777*^9}, {
   3.530558496131316*^9, 3.530558497223318*^9}, {3.5341265814440727`*^9, 
   3.534126648154166*^9}, 3.5341266899942245`*^9, 3.53412693663457*^9, 
   3.5347074111041193`*^9, {3.542249947080083*^9, 3.5422499596938047`*^9}, 
   3.5498231142565365`*^9, {3.611357718939765*^9, 3.6113577465898037`*^9}, 
   3.611357798449877*^9, 3.6113582696105366`*^9, {3.611358301400581*^9, 
   3.611358368820675*^9}, {3.6115947754819465`*^9, 3.611594810058608*^9}, {
   3.6379584663800535`*^9, 3.637958467518855*^9}, {3.6379585674304314`*^9, 
   3.6379585690840344`*^9}, 3.6379592776396065`*^9, 3.6444421768374805`*^9},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{Cell[TextData[StyleBox["7:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767252620544`*^9}, {
   3.526876907329974*^9, 3.5268769569848614`*^9}, {3.5269242339668407`*^9, 
   3.5269242339668407`*^9}, 3.5269267394468417`*^9, {3.526927027594948*^9, 
   3.526927035675762*^9}, {3.530558366526289*^9, 3.5305583787255106`*^9}, {
   3.5305584367264123`*^9, 3.5305584385984154`*^9}, {3.531942849761632*^9, 
   3.531942849917632*^9}, {3.5339406784958773`*^9, 3.5339406791758785`*^9}, {
   3.5341185863023334`*^9, 3.5341185863023334`*^9}, {3.534126360463763*^9, 
   3.534126361033764*^9}, {3.5347073402331953`*^9, 3.5347073404671955`*^9}, {
   3.534707390340483*^9, 3.534707390340483*^9}, {3.5393939323303337`*^9, 
   3.5393939325113444`*^9}, {3.5498230222764077`*^9, 3.5498230222764077`*^9}, 
   3.5717051155797815`*^9, 3.5758229229669046`*^9, {3.611349524660698*^9, 
   3.611349524893198*^9}, {3.6113560726974607`*^9, 3.611356089987485*^9}, {
   3.611510728968608*^9, 3.611510728968608*^9}, {3.6115112953519373`*^9, 
   3.611511295611938*^9}, {3.6314138645722046`*^9, 3.631413864872222*^9}, {
   3.6379383894122734`*^9, 3.6379383896322737`*^9}, 3.6379584590480404`*^9, 
   3.6379585599736185`*^9, 3.6444421663828826`*^9, {3.6538539737999697`*^9, 
   3.65385397412997*^9}, {3.732861395003543*^9, 3.7328613953585634`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic expansion", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"g", "+", 
    RowBox[{"h", " ", "x"}]}], "\[Equal]", 
   RowBox[{
    FractionBox[
     RowBox[{"h", " ", 
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}]}], "b"], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"b", " ", "g"}], "-", 
      RowBox[{"a", " ", "h"}]}], "b"]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}}],

Cell[TextData[{
 "Note: For ",
 Cell[BoxData[
  FractionBox[
   RowBox[{"g", "+", 
    RowBox[{"h", " ", "x"}]}], 
   RowBox[{
    SqrtBox[
     RowBox[{"a", "+", 
      RowBox[{"b", " ", "x"}]}]], " ", 
    SqrtBox[
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "x"}]}]], " ", 
    SqrtBox[
     RowBox[{"e", "+", 
      RowBox[{"f", " ", "x"}]}]]}]]],
  CellDingbat->None,
  CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
    3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
    3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
    3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
    3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
    3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
    3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
    3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
    3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
    3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
    3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
    3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
    3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
    3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
    3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
    3.5268694010835896`*^9}, {3.526876998184534*^9, 3.526877026217783*^9}, {
    3.5269267437524495`*^9, 3.5269267730181007`*^9}, {3.526927247898535*^9, 
    3.5269273030134315`*^9}, {3.5305581442882986`*^9, 
    3.5305581869543734`*^9}, {3.611356104997506*^9, 3.6113561134475174`*^9}, {
    3.611356245767703*^9, 3.6113562484177065`*^9}, 3.6115107423236275`*^9, {
    3.611510804573718*^9, 3.611510839793771*^9}, {3.6115109977190027`*^9, 
    3.611511008154019*^9}, {3.6314127659653673`*^9, 3.631412844227844*^9}, {
    3.6314128921435843`*^9, 3.6314129099506035`*^9}, {3.6314130107203665`*^9, 
    3.6314130156126466`*^9}, 3.6314130699587555`*^9, {3.6314135151302176`*^9, 
    3.631413517413348*^9}, {3.637958454695633*^9, 3.6379584553820343`*^9}, {
    3.637958553716007*^9, 3.6379585548392096`*^9}, {3.637958790515025*^9, 
    3.637958812278863*^9}},
  TextAlignment->Center,
  FontSize->12,
  FontWeight->"Bold"],
 ", ensuring the simpler square-root factors remain in the denominator of the \
resulting integrands causes the two elliptic integrals in the antiderivative \
to have the same and simplest arguments."
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6314129530730696`*^9, 
   3.6314129530730696`*^9}, {3.631413062203312*^9, 3.631413062203312*^9}, {
   3.631413107387896*^9, 3.631413107387896*^9}, {3.6314131538225517`*^9, 
   3.6314131584568167`*^9}, {3.6314131960739684`*^9, 3.631413256039398*^9}, {
   3.631413292053458*^9, 3.631413316139836*^9}, {3.631413369579892*^9, 
   3.63141337897143*^9}, {3.631413415434515*^9, 3.631413490764824*^9}, {
   3.6314214327200775`*^9, 3.6314214565004377`*^9}, {3.631421524578332*^9, 
   3.631421526802459*^9}, {3.6314215823296347`*^9, 3.6314215966904564`*^9}, {
   3.6314763190748787`*^9, 3.63147632749236*^9}, {3.733336809697542*^9, 
   3.733336814400811*^9}}],

Cell["Rule 1.1.1.4.1.7:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5269270224625387`*^9, 3.5269270224625387`*^9}, {
   3.5305583575562735`*^9, 3.530558360660679*^9}, {3.5347074228665404`*^9, 
   3.5347074228665404`*^9}, {3.549823103506521*^9, 3.549823103506521*^9}, {
   3.611356258837721*^9, 3.611356258837721*^9}, 3.644442171303164*^9, 
   3.650160603918889*^9, {3.6501608093586397`*^9, 3.650160813530878*^9}, {
   3.653853940911923*^9, 3.6538539412119236`*^9}, 3.698684024783456*^9, {
   3.73286141978196*^9, 3.7328614200859776`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      FractionBox["h", "b"]}]}], 
    RowBox[{"\[Integral]", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], 
       RowBox[{"m", "+", "1"}]], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
      RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "+", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"b", " ", "g"}], "-", 
     RowBox[{"a", " ", "h"}]}], "b"], 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, {3.526876998184534*^9, 3.526877026217783*^9}, {
   3.5269267437524495`*^9, 3.5269267730181007`*^9}, {3.526927247898535*^9, 
   3.5269273030134315`*^9}, {3.5305581442882986`*^9, 
   3.5305581869543734`*^9}, {3.611356104997506*^9, 3.6113561134475174`*^9}, {
   3.611356245767703*^9, 3.6113562484177065`*^9}, 3.6115107423236275`*^9, {
   3.611510804573718*^9, 3.611510839793771*^9}, {3.6115109977190027`*^9, 
   3.611511008154019*^9}, {3.6314127071020007`*^9, 3.631412710136174*^9}, {
   3.63795846466405*^9, 3.6379584653972516`*^9}, {3.637958565355628*^9, 
   3.63795856660363*^9}, 3.6379592397895403`*^9},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Sqrt", "[", 
        RowBox[{"a_.", "+", 
         RowBox[{"b_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"c_", "+", 
         RowBox[{"d_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"e_", "+", 
         RowBox[{"f_.", "*", "x_"}]}], "]"}]}], ")"}]}], ",", "x_Symbol"}], 
   "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"h", "/", "f"}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"e", "+", 
          RowBox[{"f", "*", "x"}]}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{"a", "+", 
            RowBox[{"b", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"c", "+", 
            RowBox[{"d", "*", "x"}]}], "]"}]}], ")"}]}], ",", "x"}], "]"}]}], 
    " ", "+", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"f", "*", "g"}], "-", 
        RowBox[{"e", "*", "h"}]}], ")"}], "/", "f"}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{"a", "+", 
            RowBox[{"b", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"c", "+", 
            RowBox[{"d", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"e", "+", 
            RowBox[{"f", "*", "x"}]}], "]"}]}], ")"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"SimplerQ", "[", 
     RowBox[{
      RowBox[{"a", "+", 
       RowBox[{"b", "*", "x"}]}], ",", 
      RowBox[{"e", "+", 
       RowBox[{"f", "*", "x"}]}]}], "]"}], " ", "&&", " ", 
    RowBox[{"SimplerQ", "[", 
     RowBox[{
      RowBox[{"c", "+", 
       RowBox[{"d", "*", "x"}]}], ",", 
      RowBox[{"e", "+", 
       RowBox[{"f", "*", "x"}]}]}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.5268770685406575`*^9, 
   3.526877093875102*^9}, 3.5268771340139728`*^9, {3.5268772574725895`*^9, 
   3.5268772665362053`*^9}, 3.526918736047184*^9, {3.5269248094046516`*^9, 
   3.5269248214790726`*^9}, {3.5269273228098664`*^9, 3.526927337832693*^9}, 
   3.5269274194832363`*^9, 3.5269274496068892`*^9, {3.530558205830407*^9, 
   3.5305582319292526`*^9}, {3.5305584134979715`*^9, 3.530558416742777*^9}, {
   3.530558496131316*^9, 3.530558497223318*^9}, {3.5341265814440727`*^9, 
   3.534126648154166*^9}, 3.5341266899942245`*^9, 3.53412693663457*^9, 
   3.5347074111041193`*^9, {3.542249947080083*^9, 3.5422499596938047`*^9}, 
   3.5498231142565365`*^9, {3.611357718939765*^9, 3.6113577465898037`*^9}, 
   3.611357798449877*^9, 3.6113582696105366`*^9, {3.611358301400581*^9, 
   3.611358368820675*^9}, {3.6115947754819465`*^9, 3.611594810058608*^9}, {
   3.6313962125613604`*^9, 3.631396225369093*^9}, {3.6313962995803375`*^9, 
   3.631396305839696*^9}, 3.631396335975419*^9, {3.6314129762393947`*^9, 
   3.631413000213766*^9}, {3.6314135993970375`*^9, 3.631413603277259*^9}, 
   3.6314136696210537`*^9, 3.6314137057051177`*^9, {3.6314213413978543`*^9, 
   3.631421383419258*^9}, {3.6314762039282923`*^9, 3.631476232069902*^9}, {
   3.631477207105671*^9, 3.6314772406255884`*^9}, {3.6379584565520363`*^9, 
   3.637958458283639*^9}, {3.637958555884411*^9, 3.637958558616416*^9}, {
   3.6379588223096805`*^9, 3.6379588384285088`*^9}, 3.644442144202614*^9},
 Background->GrayLevel[0.85]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
     RowBox[{"(", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], ")"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"h", "/", "b"}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}]}], ",", "x"}], 
      "]"}]}], " ", "+", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "g"}], "-", 
        RowBox[{"a", "*", "h"}]}], ")"}], "/", "b"}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", "m"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m", ",", "n", ",", "p"}], "}"}], ",", "x"}], "]"}], " ", "&&",
     " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SumSimplerQ", "[", 
       RowBox[{"m", ",", "1"}], "]"}], " ", "||", " ", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{"SumSimplerQ", "[", 
         RowBox[{"n", ",", "1"}], "]"}], "]"}], " ", "&&", " ", 
       RowBox[{"Not", "[", 
        RowBox[{"SumSimplerQ", "[", 
         RowBox[{"p", ",", "1"}], "]"}], "]"}]}]}], ")"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.5268770685406575`*^9, 
   3.526877093875102*^9}, 3.5268771340139728`*^9, {3.5268772574725895`*^9, 
   3.5268772665362053`*^9}, 3.526918736047184*^9, {3.5269248094046516`*^9, 
   3.5269248214790726`*^9}, {3.5269273228098664`*^9, 3.526927337832693*^9}, 
   3.5269274194832363`*^9, 3.5269274496068892`*^9, {3.530558205830407*^9, 
   3.5305582319292526`*^9}, {3.5305584134979715`*^9, 3.530558416742777*^9}, {
   3.530558496131316*^9, 3.530558497223318*^9}, 3.53470741696973*^9, {
   3.542249963774038*^9, 3.542249976738779*^9}, 3.54982311701654*^9, {
   3.6104719528423166`*^9, 3.6104720245024166`*^9}, {3.611356300147779*^9, 
   3.6113563823778944`*^9}, {3.611356434467967*^9, 3.6113564361279697`*^9}, 
   3.611511110881668*^9, 3.61152794381289*^9, {3.611542003192854*^9, 
   3.611542057370434*^9}, 3.6115422634207416`*^9, {3.6115425950312333`*^9, 
   3.611542608601253*^9}, {3.63141271425541*^9, 3.6314127182346373`*^9}, 
   3.637938298965144*^9, {3.637958468236457*^9, 3.637958469500059*^9}, {
   3.637958569817236*^9, 3.6379585715332384`*^9}, 3.637959278622408*^9, 
   3.644442185556979*^9},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{Cell[TextData[StyleBox["2.",
   FontFamily->"Arial"]], "None"], "  ", 
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], "q"], 
    RowBox[{"\[DifferentialD]", "x"}], "  ", 
    StyleBox["when",
     FontFamily->"Arial",
     FontWeight->"Plain"], 
    StyleBox["  ",
     FontFamily->"Arial",
     FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
     RowBox[{
      RowBox[{
       RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
      " ", "\[And]", " ", 
      RowBox[{
       SuperscriptBox["n", "2"], "\[Equal]", 
       FractionBox["1", "4"]}], " ", "\[And]", " ", 
      RowBox[{
       SuperscriptBox["p", "2"], "\[Equal]", 
       FractionBox["1", "4"]}], " ", "\[And]", " ", 
      RowBox[{
       SuperscriptBox["q", "2"], "\[Equal]", 
       FractionBox["1", "4"]}]}]]]], "None"]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.539393717282713*^9, 3.5393937175197268`*^9}, {3.5393939972431717`*^9, 
   3.5393939972431717`*^9}, {3.54976183300485*^9, 3.549761843369443*^9}, 
   3.5497618783514433`*^9, {3.5498272575323367`*^9, 3.5498272577023373`*^9}, {
   3.5498590820409126`*^9, 3.549859083098973*^9}, {3.549861971973207*^9, 
   3.549861974052326*^9}, {3.5499239781513543`*^9, 3.5499239781513543`*^9}, {
   3.5716376069321833`*^9, 3.5716376095821867`*^9}, 3.571704053418295*^9, {
   3.571705098009757*^9, 3.5717051012397614`*^9}, 3.5717051920898886`*^9, 
   3.5758229151368937`*^9, 3.61151142537963*^9, {3.6375210294106445`*^9, 
   3.6375211225176077`*^9}, {3.644442260768281*^9, 3.644442260768281*^9}, {
   3.644442312905263*^9, 3.64444231686749*^9}, 3.647390660600108*^9, {
   3.6473907736905766`*^9, 3.647390819717209*^9}, {3.6473912085964518`*^9, 
   3.647391208843466*^9}, {3.6473912679138446`*^9, 3.6473912679138446`*^9}, {
   3.647396300569696*^9, 3.6473963246130714`*^9}, {3.6906631681351275`*^9, 
   3.6906631683951283`*^9}, {3.6906632461472373`*^9, 
   3.6906632887133045`*^9}, {3.732499894755187*^9, 3.732499895072205*^9}, {
   3.732737922040406*^9, 3.7327379264706593`*^9}, {3.732738472429887*^9, 
   3.7327385052267623`*^9}, {3.732740510611464*^9, 3.7327405512117863`*^9}, {
   3.7327409448252993`*^9, 3.7327409448252993`*^9}, {3.7327521678282185`*^9, 
   3.732752176626722*^9}, {3.7327527044179096`*^9, 3.7327527144164815`*^9}, 
   3.7329884096643987`*^9, {3.73299167596122*^9, 3.7329917088290997`*^9}, {
   3.732991799676296*^9, 3.7329918026394653`*^9}, {3.7333333782312737`*^9, 
   3.7333333939431725`*^9}, {3.733333531683051*^9, 3.733333531683051*^9}, {
   3.733333908581608*^9, 3.7333339394133716`*^9}, {3.733336864775693*^9, 
   3.733336865013706*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{Cell[TextData[StyleBox["1.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{
        SuperscriptBox["n", "2"], "\[Equal]", 
        FractionBox["1", "4"]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.539393717282713*^9, 3.5393937175197268`*^9}, {3.5393939972431717`*^9, 
   3.5393939972431717`*^9}, {3.54976183300485*^9, 3.549761843369443*^9}, 
   3.5497618783514433`*^9, {3.5498272575323367`*^9, 3.5498272577023373`*^9}, {
   3.5498590820409126`*^9, 3.549859083098973*^9}, {3.549861971973207*^9, 
   3.549861974052326*^9}, {3.5499239781513543`*^9, 3.5499239781513543`*^9}, {
   3.5716376069321833`*^9, 3.5716376095821867`*^9}, 3.571704053418295*^9, {
   3.571705098009757*^9, 3.5717051012397614`*^9}, 3.5717051920898886`*^9, 
   3.5758229151368937`*^9, 3.61151142537963*^9, {3.6375210294106445`*^9, 
   3.6375211225176077`*^9}, {3.644442260768281*^9, 3.644442260768281*^9}, {
   3.644442312905263*^9, 3.64444231686749*^9}, 3.647390660600108*^9, {
   3.6473907736905766`*^9, 3.647390819717209*^9}, {3.6473912085964518`*^9, 
   3.647391208843466*^9}, {3.6473912679138446`*^9, 3.6473912679138446`*^9}, {
   3.647396300569696*^9, 3.6473963246130714`*^9}, {3.6906631681351275`*^9, 
   3.6906631683951283`*^9}, {3.6906632461472373`*^9, 
   3.6906632887133045`*^9}, {3.732499894755187*^9, 3.732499895072205*^9}, {
   3.732737922040406*^9, 3.7327379264706593`*^9}, {3.732738472429887*^9, 
   3.7327385052267623`*^9}, {3.732740510611464*^9, 3.7327405512117863`*^9}, {
   3.7327409448252993`*^9, 3.7327409448252993`*^9}, {3.7327521678282185`*^9, 
   3.732752176626722*^9}, {3.7327527044179096`*^9, 3.7327527144164815`*^9}, 
   3.7329884096643987`*^9, {3.73299167596122*^9, 3.7329917088290997`*^9}, {
   3.732991799676296*^9, 3.7329918026394653`*^9}, {3.7333333782312737`*^9, 
   3.7333333939431725`*^9}, {3.733333531683051*^9, 3.733333531683051*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{Cell[TextData[StyleBox["1.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}]]]], 
      "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.539393717282713*^9, 3.5393937175197268`*^9}, {3.5393939972431717`*^9, 
   3.5393939972431717`*^9}, {3.54976183300485*^9, 3.549761843369443*^9}, 
   3.5497618783514433`*^9, {3.5498272575323367`*^9, 3.5498272577023373`*^9}, {
   3.5498590820409126`*^9, 3.549859083098973*^9}, {3.549861971973207*^9, 
   3.549861974052326*^9}, {3.5499239781513543`*^9, 3.5499239781513543`*^9}, {
   3.5716376069321833`*^9, 3.5716376095821867`*^9}, 3.571704053418295*^9, {
   3.571705098009757*^9, 3.5717051012397614`*^9}, 3.5717051920898886`*^9, 
   3.5758229151368937`*^9, 3.61151142537963*^9, {3.6375210294106445`*^9, 
   3.6375211225176077`*^9}, {3.644442260768281*^9, 3.644442260768281*^9}, {
   3.644442312905263*^9, 3.64444231686749*^9}, 3.647390660600108*^9, {
   3.6473907736905766`*^9, 3.647390819717209*^9}, {3.6473912085964518`*^9, 
   3.647391208843466*^9}, {3.6473912679138446`*^9, 3.6473912679138446`*^9}, {
   3.647396300569696*^9, 3.6473963246130714`*^9}, {3.6906631681351275`*^9, 
   3.6906631683951283`*^9}, {3.6906632461472373`*^9, 
   3.6906632887133045`*^9}, {3.732499894755187*^9, 3.732499895072205*^9}, {
   3.732737922040406*^9, 3.7327379264706593`*^9}, {3.732738472429887*^9, 
   3.7327385052267623`*^9}, {3.732740510611464*^9, 3.7327405512117863`*^9}, {
   3.7327409448252993`*^9, 3.7327409448252993`*^9}, {3.7327521678282185`*^9, 
   3.732752176626722*^9}, {3.7327527044179096`*^9, 3.7327527144164815`*^9}, {
   3.7327542987701015`*^9, 3.7327543151260366`*^9}, 3.7329885165585127`*^9, {
   3.7329918612078156`*^9, 3.7329918768927126`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["1:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{"m", "<", 
        RowBox[{"-", "1"}]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, 3.6202339138681226`*^9, {
   3.624745639354846*^9, 3.6247456402468967`*^9}, {3.637522303714407*^9, 
   3.6375223060594115`*^9}, 3.6390669973751264`*^9, {3.6444425214011884`*^9, 
   3.6444425218222127`*^9}, 3.6444425997666707`*^9, 3.6906631382090836`*^9, 
   3.6906631976551685`*^9, {3.6906632334152193`*^9, 3.69066323360522*^9}, {
   3.7327330816756277`*^9, 3.7327330924772453`*^9}, {3.732734032900035*^9, 
   3.7327340368592615`*^9}, {3.732734582462468*^9, 3.7327345828194885`*^9}, 
   3.7327379415195203`*^9, 3.7327405597332735`*^9, {3.732740645977206*^9, 
   3.7327406461742177`*^9}, 3.7327521719874563`*^9, 3.732752727257216*^9, {
   3.732754369145127*^9, 3.732754380642784*^9}, {3.7327546327892065`*^9, 
   3.7327546327892065`*^9}, {3.7327547402903547`*^9, 
   3.7327547405103674`*^9}, {3.732760584048599*^9, 3.7327606057378397`*^9}, {
   3.732810948251402*^9, 3.732810948251402*^9}, 3.7329885185686274`*^9, 
   3.732991862553892*^9, {3.734376154221362*^9, 3.7343761545683823`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Integration by parts", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5269270224625387`*^9, 3.5269270224625387`*^9}, {
   3.5305583575562735`*^9, 3.530558360660679*^9}, {3.5347074228665404`*^9, 
   3.5347074228665404`*^9}, {3.549823103506521*^9, 3.549823103506521*^9}, {
   3.611356258837721*^9, 3.611356258837721*^9}, {3.63917293207978*^9, 
   3.63917293208078*^9}, 3.6501606099462337`*^9, 3.650160886705063*^9, {
   3.6906636169318275`*^9, 3.6906636171718283`*^9}, 3.698684025703457*^9, {
   3.7324999650142055`*^9, 3.73249996526722*^9}, {3.7327340558413467`*^9, 
   3.7327340651808815`*^9}, {3.7327546348363237`*^9, 
   3.7327546348363237`*^9}, {3.732760417960099*^9, 3.732760428242687*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["\[PartialD]", "x"], 
    RowBox[{"(", 
     RowBox[{
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}], ")"}]}], "\[Equal]", 
   FractionBox[
    RowBox[{
     RowBox[{"d", " ", "e", " ", "g"}], "+", 
     RowBox[{"c", " ", "f", " ", "g"}], "+", 
     RowBox[{"c", " ", "e", " ", "h"}], "+", 
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", " ", "f", " ", "g"}], "+", 
        RowBox[{"d", " ", "e", " ", "h"}], "+", 
        RowBox[{"c", " ", "f", " ", "h"}]}], ")"}], " ", "x"}], "+", 
     RowBox[{"3", " ", "d", " ", "f", " ", "h", " ", 
      SuperscriptBox["x", "2"]}]}], 
    RowBox[{"2", " ", 
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]]}]]}]],
  CellChangeTimes->{{3.732760371222426*^9, 3.732760372401493*^9}, {
   3.7327604402703753`*^9, 3.7327604641247396`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5269270224625387`*^9, 3.5269270224625387`*^9}, {
   3.5305583575562735`*^9, 3.530558360660679*^9}, {3.5347074228665404`*^9, 
   3.5347074228665404`*^9}, {3.549823103506521*^9, 3.549823103506521*^9}, {
   3.611356258837721*^9, 3.611356258837721*^9}, {3.63917293207978*^9, 
   3.63917293208078*^9}, 3.6501606099462337`*^9, 3.650160886705063*^9, {
   3.6906636169318275`*^9, 3.6906636171718283`*^9}, 3.698684025703457*^9, {
   3.7324999650142055`*^9, 3.73249996526722*^9}, {3.7327340558413467`*^9, 
   3.7327340651808815`*^9}, {3.7327546348363237`*^9, 
   3.7327546348363237`*^9}, {3.732760417960099*^9, 3.7327604362691464`*^9}, 
   3.7327604706421127`*^9}],

Cell[TextData[{
 "Rule 1.1.1.4.2.1.1.1: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], " ", 
   "\[And]", " ", 
   RowBox[{"m", "<", 
    RowBox[{"-", "1"}]}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5269270224625387`*^9, 3.5269270224625387`*^9}, {
   3.5305583575562735`*^9, 3.530558360660679*^9}, {3.5347074228665404`*^9, 
   3.5347074228665404`*^9}, {3.549823103506521*^9, 3.549823103506521*^9}, {
   3.611356258837721*^9, 3.611356258837721*^9}, {3.63917293207978*^9, 
   3.63917293208078*^9}, 3.6501606099462337`*^9, 3.650160886705063*^9, {
   3.6906636169318275`*^9, 3.6906636171718283`*^9}, 3.698684025703457*^9, {
   3.7324999650142055`*^9, 3.73249996526722*^9}, {3.7327340558413467`*^9, 
   3.7327340651808815`*^9}, {3.7327546348363237`*^9, 
   3.7327546348363237`*^9}, {3.732760611532171*^9, 3.732760611532171*^9}, {
   3.732810956235858*^9, 3.7328109562368584`*^9}, 3.7333370880614643`*^9, {
   3.7333373751178827`*^9, 3.7333373766369696`*^9}, {3.734376233696908*^9, 
   3.7343762339809237`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
    SqrtBox[
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "x"}]}]], " ", 
    SqrtBox[
     RowBox[{"e", "+", 
      RowBox[{"f", " ", "x"}]}]], " ", 
    SqrtBox[
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{
     "x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}], 
         RowBox[{"m", "+", "1"}]], " ", 
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}], 
       RowBox[{"b", " ", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}]}]]}]}]}]}], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", " ", "b", " ", 
     RowBox[{"(", 
      RowBox[{"m", "+", "1"}], ")"}]}]], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"m", "+", "1"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "e", " ", "g"}], "+", 
         RowBox[{"c", " ", "f", " ", "g"}], "+", 
         RowBox[{"c", " ", "e", " ", "h"}], "+", 
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "f", " ", "g"}], "+", 
            RowBox[{"d", " ", "e", " ", "h"}], "+", 
            RowBox[{"c", " ", "f", " ", "h"}]}], ")"}], " ", "x"}], "+", 
         RowBox[{"3", " ", "d", " ", "f", " ", "h", " ", 
          SuperscriptBox["x", "2"]}]}], ")"}]}], 
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906862370138397`*^9, 
   3.690686270846775*^9, 3.6906865143317013`*^9, {3.690686592792189*^9, 
   3.690686597382452*^9}, {3.7327331215549088`*^9, 3.7327331395009356`*^9}, {
   3.7327331887557526`*^9, 3.732733214749239*^9}, {3.732733257841704*^9, 
   3.7327333953595695`*^9}, {3.7327345913469763`*^9, 3.732734696479989*^9}, {
   3.7327347282478065`*^9, 3.732734752345185*^9}, {3.732734822447194*^9, 
   3.732734831705724*^9}, 3.7327359959442396`*^9, {3.7327360341624255`*^9, 
   3.732736042400897*^9}, {3.7327543871821585`*^9, 3.7327544277524786`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"c_.", "+", 
       RowBox[{"d_.", "*", "x_"}]}], "]"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"e_.", "+", 
       RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"c", "+", 
       RowBox[{"d", "*", "x"}]}], "]"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"e", "+", 
       RowBox[{"f", "*", "x"}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"g", "+", 
        RowBox[{"h", "*", "x"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{"b", "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}]}], ")"}]}]}], " ", "-", " ", "\n", 
    "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"2", "*", "b", "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", "*", "x"}]}], ")"}], "^", 
          RowBox[{"(", 
           RowBox[{"m", "+", "1"}], ")"}]}], "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Sqrt", "[", 
            RowBox[{"c", "+", 
             RowBox[{"d", "*", "x"}]}], "]"}], "*", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"e", "+", 
             RowBox[{"f", "*", "x"}]}], "]"}], "*", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"g", "+", 
             RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], "*", 
        "\[IndentingNewLine]", "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"d", "*", "e", "*", "g"}], "+", 
           RowBox[{"c", "*", "f", "*", "g"}], "+", 
           RowBox[{"c", "*", "e", "*", "h"}], "+", 
           RowBox[{"2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", "*", "f", "*", "g"}], "+", 
              RowBox[{"d", "*", "e", "*", "h"}], "+", 
              RowBox[{"c", "*", "f", "*", "h"}]}], ")"}], "*", "x"}], "+", 
           RowBox[{"3", "*", "d", "*", "f", "*", "h", "*", 
            RowBox[{"x", "^", "2"}]}]}], ",", "x"}], "]"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"IntegerQ", "[", 
     RowBox[{"2", "*", "m"}], "]"}], " ", "&&", " ", 
    RowBox[{"LtQ", "[", 
     RowBox[{"m", ",", 
      RowBox[{"-", "1"}]}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375238754486885`*^9, 
   3.63752389858753*^9}, 3.6444425309977374`*^9, {3.6906621348624887`*^9, 
   3.6906621495825095`*^9}, {3.6906867607807975`*^9, 3.6906867777757697`*^9}, 
   3.690686824907466*^9, {3.732733463768482*^9, 3.732733550071419*^9}, {
   3.73273385500686*^9, 3.732733916393371*^9}, {3.7327339528134537`*^9, 
   3.7327339633430567`*^9}, 3.732734128646511*^9, {3.7327342384447913`*^9, 
   3.732734296346103*^9}, {3.732734393919684*^9, 3.7327344161499557`*^9}, {
   3.7327348742871594`*^9, 3.732734945992261*^9}, {3.732734980528236*^9, 
   3.7327349822293334`*^9}, 3.7327360101010494`*^9, {3.732754445583499*^9, 
   3.7327544533769445`*^9}, 3.7327545612811165`*^9, {3.732754637506476*^9, 
   3.7327546403286376`*^9}, {3.73276059525424*^9, 3.73276059612729*^9}, {
   3.7327606375036564`*^9, 3.732760637797673*^9}, {3.7328109587250004`*^9, 
   3.7328109597700605`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["2:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{"m", "\[NotLess]", 
        RowBox[{"-", "1"}]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, 3.6202339138681226`*^9, {
   3.624745639354846*^9, 3.6247456402468967`*^9}, {3.637522303714407*^9, 
   3.6375223060594115`*^9}, 3.6390669973751264`*^9, {3.6444425214011884`*^9, 
   3.6444425218222127`*^9}, 3.6444425997666707`*^9, 3.6906631382090836`*^9, 
   3.6906631976551685`*^9, {3.6906632334152193`*^9, 3.69066323360522*^9}, {
   3.7327330816756277`*^9, 3.7327330924772453`*^9}, {3.732734032900035*^9, 
   3.7327340368592615`*^9}, {3.732734582462468*^9, 3.7327345828194885`*^9}, 
   3.7327379415195203`*^9, 3.7327405597332735`*^9, {3.732740645977206*^9, 
   3.7327406461742177`*^9}, 3.7327521719874563`*^9, 3.732752727257216*^9, {
   3.732754369145127*^9, 3.732754380642784*^9}, {3.7327546327892065`*^9, 
   3.7327546327892065`*^9}, {3.7327547402903547`*^9, 
   3.7327547405103674`*^9}, {3.732760584048599*^9, 3.7327606057378397`*^9}, {
   3.732810948251402*^9, 3.732810948251402*^9}, {3.732811988691911*^9, 
   3.7328119994625273`*^9}, 3.7329885179025893`*^9, 3.732991862001861*^9, {
   3.7343761584386034`*^9, 3.734376179101785*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[TextData[{
 "Rule 1.1.1.4.2.1.1.2: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], " ", 
   "\[And]", " ", 
   RowBox[{"m", "\[NotLess]", 
    RowBox[{"-", "1"}]}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5269270224625387`*^9, 3.5269270224625387`*^9}, {
   3.5305583575562735`*^9, 3.530558360660679*^9}, {3.5347074228665404`*^9, 
   3.5347074228665404`*^9}, {3.549823103506521*^9, 3.549823103506521*^9}, {
   3.611356258837721*^9, 3.611356258837721*^9}, {3.63917293207978*^9, 
   3.63917293208078*^9}, 3.6501606099462337`*^9, 3.650160886705063*^9, {
   3.6906636169318275`*^9, 3.6906636171718283`*^9}, 3.698684025703457*^9, {
   3.7324999650142055`*^9, 3.73249996526722*^9}, {3.7327340558413467`*^9, 
   3.7327340651808815`*^9}, {3.7327546348363237`*^9, 
   3.7327546348363237`*^9}, {3.732760611532171*^9, 3.732760611532171*^9}, {
   3.732810956235858*^9, 3.7328109562368584`*^9}, {3.7328120054908724`*^9, 
   3.7328120054908724`*^9}, {3.7333370642060995`*^9, 
   3.7333370743366785`*^9}, {3.7333373324274406`*^9, 3.733337333882524*^9}, {
   3.7333373917828355`*^9, 3.7333373923208666`*^9}, {3.734376184244079*^9, 
   3.734376184244079*^9}, {3.7343762386271896`*^9, 3.7343762388122005`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
    SqrtBox[
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "x"}]}]], " ", 
    SqrtBox[
     RowBox[{"e", "+", 
      RowBox[{"f", " ", "x"}]}]], " ", 
    SqrtBox[
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{
     "x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}], 
         RowBox[{"m", "+", "1"}]], " ", 
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}], 
       RowBox[{"b", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "m"}], "+", "5"}], ")"}]}]]}]}]}]}], "+", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"b", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "m"}], "+", "5"}], ")"}]}]], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
       RowBox[{
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}]], " ", "\[CenterDot]", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", "b", " ", "c", " ", "e", " ", "g"}], "-", 
        RowBox[{"a", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "e", " ", "g"}], "+", 
           RowBox[{"c", " ", "f", " ", "g"}], "+", 
           RowBox[{"c", " ", "e", " ", "h"}]}], ")"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "e", " ", "g"}], "+", 
              RowBox[{"c", " ", "f", " ", "g"}], "+", 
              RowBox[{"c", " ", "e", " ", "h"}]}], ")"}]}], "-", 
           RowBox[{"a", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "f", " ", "g"}], "+", 
              RowBox[{"d", " ", "e", " ", "h"}], "+", 
              RowBox[{"c", " ", "f", " ", "h"}]}], ")"}]}]}], ")"}], " ", 
         "x"}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"3", " ", "a", " ", "d", " ", "f", " ", "h"}], "-", 
           RowBox[{"b", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "f", " ", "g"}], "+", 
              RowBox[{"d", " ", "e", " ", "h"}], "+", 
              RowBox[{"c", " ", "f", " ", "h"}]}], ")"}]}]}], ")"}], " ", 
         SuperscriptBox["x", "2"]}]}], ")"}]}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906862370138397`*^9, 
   3.690686270846775*^9, 3.6906865143317013`*^9, {3.690686592792189*^9, 
   3.690686597382452*^9}, {3.7327331215549088`*^9, 3.7327331395009356`*^9}, {
   3.7327331887557526`*^9, 3.732733214749239*^9}, {3.732733257841704*^9, 
   3.7327333953595695`*^9}, {3.7327345913469763`*^9, 3.732734696479989*^9}, {
   3.7327347282478065`*^9, 3.732734752345185*^9}, {3.732734822447194*^9, 
   3.732734831705724*^9}, 3.7327359959442396`*^9, {3.7327360341624255`*^9, 
   3.732736042400897*^9}, {3.7327543871821585`*^9, 3.7327544277524786`*^9}, {
   3.7328112627353888`*^9, 3.7328113110021496`*^9}, 3.7328114875612483`*^9, {
   3.732811531436758*^9, 3.7328116083971596`*^9}, {3.73281166364732*^9, 
   3.7328117050446873`*^9}, {3.732857692404766*^9, 3.732857693304818*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"c_.", "+", 
       RowBox[{"d_.", "*", "x_"}]}], "]"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"e_.", "+", 
       RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"g_.", "+", 
       RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ",", "x_Symbol"}], "]"}], " ", ":=",
   "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{"2", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"c", "+", 
       RowBox[{"d", "*", "x"}]}], "]"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"e", "+", 
       RowBox[{"f", "*", "x"}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"g", "+", 
        RowBox[{"h", "*", "x"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{"b", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "*", "m"}], "+", "5"}], ")"}]}], ")"}]}]}], " ", "+", 
    " ", "\n", "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"b", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "*", "m"}], "+", "5"}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", "*", "x"}]}], ")"}], "^", "m"}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Sqrt", "[", 
            RowBox[{"c", "+", 
             RowBox[{"d", "*", "x"}]}], "]"}], "*", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"e", "+", 
             RowBox[{"f", "*", "x"}]}], "]"}], "*", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"g", "+", 
             RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], "*", 
        "\[IndentingNewLine]", "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"3", "*", "b", "*", "c", "*", "e", "*", "g"}], "-", 
           RowBox[{"a", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", "*", "e", "*", "g"}], "+", 
              RowBox[{"c", "*", "f", "*", "g"}], "+", 
              RowBox[{"c", "*", "e", "*", "h"}]}], ")"}]}], "+", 
           RowBox[{"2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "e", "*", "g"}], "+", 
                 RowBox[{"c", "*", "f", "*", "g"}], "+", 
                 RowBox[{"c", "*", "e", "*", "h"}]}], ")"}]}], "-", 
              RowBox[{"a", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "f", "*", "g"}], "+", 
                 RowBox[{"d", "*", "e", "*", "h"}], "+", 
                 RowBox[{"c", "*", "f", "*", "h"}]}], ")"}]}]}], ")"}], "*", 
            "x"}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"3", "*", "a", "*", "d", "*", "f", "*", "h"}], "-", 
              RowBox[{"b", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "f", "*", "g"}], "+", 
                 RowBox[{"d", "*", "e", "*", "h"}], "+", 
                 RowBox[{"c", "*", "f", "*", "h"}]}], ")"}]}]}], ")"}], "*", 
            RowBox[{"x", "^", "2"}]}]}], ",", "x"}], "]"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"IntegerQ", "[", 
     RowBox[{"2", "*", "m"}], "]"}], " ", "&&", " ", 
    RowBox[{"Not", "[", 
     RowBox[{"LtQ", "[", 
      RowBox[{"m", ",", 
       RowBox[{"-", "1"}]}], "]"}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375238754486885`*^9, 
   3.63752389858753*^9}, 3.6444425309977374`*^9, {3.6906621348624887`*^9, 
   3.6906621495825095`*^9}, {3.6906867607807975`*^9, 3.6906867777757697`*^9}, 
   3.690686824907466*^9, {3.732733463768482*^9, 3.732733550071419*^9}, {
   3.73273385500686*^9, 3.732733916393371*^9}, {3.7327339528134537`*^9, 
   3.7327339633430567`*^9}, 3.732734128646511*^9, {3.7327342384447913`*^9, 
   3.732734296346103*^9}, {3.732734393919684*^9, 3.7327344161499557`*^9}, {
   3.7327348742871594`*^9, 3.732734945992261*^9}, {3.732734980528236*^9, 
   3.7327349822293334`*^9}, 3.7327360101010494`*^9, {3.732754445583499*^9, 
   3.7327544533769445`*^9}, 3.7327545612811165`*^9, {3.732754637506476*^9, 
   3.7327546403286376`*^9}, {3.73276059525424*^9, 3.73276059612729*^9}, {
   3.7327606375036564`*^9, 3.732760637797673*^9}, {3.7328109587250004`*^9, 
   3.7328109597700605`*^9}, 3.732811810419715*^9, {3.7328120370706787`*^9, 
   3.732812038172742*^9}, 3.7328120737297754`*^9, 3.732857699758187*^9, 
   3.733335108763254*^9, {3.7333373479283276`*^9, 3.7333373543236933`*^9}, {
   3.734376197827856*^9, 3.7343762052452803`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{Cell[TextData[StyleBox["2.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}], 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}]]]], 
      "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.539393717282713*^9, 3.5393937175197268`*^9}, {3.5393939972431717`*^9, 
   3.5393939972431717`*^9}, {3.54976183300485*^9, 3.549761843369443*^9}, 
   3.5497618783514433`*^9, {3.5498272575323367`*^9, 3.5498272577023373`*^9}, {
   3.5498590820409126`*^9, 3.549859083098973*^9}, {3.549861971973207*^9, 
   3.549861974052326*^9}, {3.5499239781513543`*^9, 3.5499239781513543`*^9}, {
   3.5716376069321833`*^9, 3.5716376095821867`*^9}, 3.571704053418295*^9, {
   3.571705098009757*^9, 3.5717051012397614`*^9}, 3.5717051920898886`*^9, 
   3.5758229151368937`*^9, 3.61151142537963*^9, {3.6375210294106445`*^9, 
   3.6375211225176077`*^9}, {3.644442260768281*^9, 3.644442260768281*^9}, {
   3.644442312905263*^9, 3.64444231686749*^9}, 3.647390660600108*^9, {
   3.6473907736905766`*^9, 3.647390819717209*^9}, {3.6473912085964518`*^9, 
   3.647391208843466*^9}, {3.6473912679138446`*^9, 3.6473912679138446`*^9}, {
   3.647396300569696*^9, 3.6473963246130714`*^9}, {3.6906631681351275`*^9, 
   3.6906631683951283`*^9}, {3.6906632461472373`*^9, 
   3.6906632887133045`*^9}, {3.732499894755187*^9, 3.732499895072205*^9}, {
   3.7327608903751197`*^9, 3.732760890625134*^9}, {3.7327722265444784`*^9, 
   3.732772237144493*^9}, {3.7327729017054234`*^9, 3.732772901935424*^9}, {
   3.732827529277381*^9, 3.7328275371568317`*^9}, 3.732988555979767*^9, {
   3.73299186320393*^9, 3.7329918821160116`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["1:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}], 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{"m", ">", "0"}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, 3.6202339138681226`*^9, {
   3.624745639354846*^9, 3.6247456402468967`*^9}, {3.637522303714407*^9, 
   3.6375223060594115`*^9}, 3.6390669973751264`*^9, {3.6444425214011884`*^9, 
   3.6444425218222127`*^9}, 3.6444425997666707`*^9, 3.6906631382090836`*^9, 
   3.6906631976551685`*^9, {3.6906632334152193`*^9, 3.69066323360522*^9}, {
   3.6908496403632865`*^9, 3.690849646876659*^9}, {3.6909187075544405`*^9, 
   3.690918707788441*^9}, {3.73275247923503*^9, 3.73275247941304*^9}, 
   3.7327713308632245`*^9, {3.7327723095445943`*^9, 3.7327723375746336`*^9}, {
   3.7327723773846893`*^9, 3.732772386344702*^9}, {3.7327729837355385`*^9, 
   3.732772983915539*^9}, {3.732807276136369*^9, 3.732807279286549*^9}, {
   3.7328073359837923`*^9, 3.732807338435932*^9}, 3.7328272156774445`*^9, {
   3.7328274625075617`*^9, 3.7328274625075617`*^9}, {3.7328275598281283`*^9, 
   3.7328275600381403`*^9}, {3.7328602908333883`*^9, 3.732860293653549*^9}, {
   3.732860483739422*^9, 3.7328604839494333`*^9}, 3.7329885567698126`*^9, 
   3.7329918638079643`*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell[TextData[{
 "Rule",
 " 1.1.1.4.2.1.2.1",
 ": If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], " ", 
   "\[And]", " ", 
   RowBox[{"m", ">", "0"}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5269270224625387`*^9, 3.5269270224625387`*^9}, {
   3.5305583575562735`*^9, 3.530558360660679*^9}, {3.5347074228665404`*^9, 
   3.5347074228665404`*^9}, {3.549823103506521*^9, 3.549823103506521*^9}, {
   3.611356258837721*^9, 3.611356258837721*^9}, {3.63917293207978*^9, 
   3.63917293208078*^9}, 3.6501606099462337`*^9, 3.650160886705063*^9, {
   3.6906636169318275`*^9, 3.6906636171718283`*^9}, 3.698684025703457*^9, {
   3.7324999650142055`*^9, 3.73249996526722*^9}, {3.7327340558413467`*^9, 
   3.7327340651808815`*^9}, {3.7327546348363237`*^9, 
   3.7327546348363237`*^9}, {3.732760611532171*^9, 3.732760611532171*^9}, {
   3.732772395564715*^9, 3.732772395564715*^9}, {3.7328072883500676`*^9, 
   3.7328072883500676`*^9}, {3.732807344437276*^9, 3.732807344437276*^9}, {
   3.7328274648786974`*^9, 3.7328274648786974`*^9}, {3.7328603014709964`*^9, 
   3.7328603014709964`*^9}, 3.7333370920196905`*^9, {3.7333374155761967`*^9, 
   3.7333374165922546`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}], 
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{
     "x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}], 
       RowBox[{"d", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "m"}], "+", "3"}], ")"}]}]]}]}]}]}], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"d", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "m"}], "+", "3"}], ")"}]}]], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"m", "-", "1"}]], 
       RowBox[{
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}]], "\[CenterDot]", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "b", " ", "c", " ", "e", " ", "g", " ", "m"}], "+", 
        RowBox[{"a", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"c", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", " ", "g"}], "+", 
              RowBox[{"e", " ", "h"}]}], ")"}]}], "-", 
           RowBox[{"2", " ", "d", " ", "e", " ", "g", " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}]}], ")"}]}], "-", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "d", " ", "e", " ", "g"}], "-", 
              RowBox[{"c", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", " ", "g"}], "+", 
                 RowBox[{"e", " ", "h"}]}], ")"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", " ", "m"}], "+", "1"}], ")"}]}]}], ")"}]}], "-", 
           RowBox[{"a", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "c", " ", "f", " ", "h"}], "-", 
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", " ", "m"}], "+", "1"}], ")"}], 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", " ", "g"}], "+", 
                 RowBox[{"e", " ", "h"}]}], ")"}]}]}], ")"}]}]}], ")"}], " ", 
         "x"}], "-", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "a", " ", "d", " ", "f", " ", "h", " ", "m"}], 
           "+", 
           RowBox[{"b", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", " ", "g"}], "+", 
                 RowBox[{"e", " ", "h"}]}], ")"}]}], "-", 
              RowBox[{"2", " ", "c", " ", "f", " ", "h", " ", 
               RowBox[{"(", 
                RowBox[{"m", "+", "1"}], ")"}]}]}], ")"}]}]}], ")"}], " ", 
         SuperscriptBox["x", "2"]}]}], ")"}]}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906862370138397`*^9, 
   3.690686270846775*^9, 3.6906865143317013`*^9, {3.690686592792189*^9, 
   3.690686597382452*^9}, {3.690849723898064*^9, 3.6908497599941287`*^9}, {
   3.690849801173484*^9, 3.6908499318219566`*^9}, {3.7327713601732655`*^9, 
   3.7327713689032774`*^9}, {3.7327714316433654`*^9, 3.732771581493575*^9}, {
   3.7327716324936466`*^9, 3.7327716430536613`*^9}, {3.732827229456232*^9, 
   3.7328272364986353`*^9}, {3.7328272941319313`*^9, 
   3.7328272980991583`*^9}, {3.7328578349709206`*^9, 
   3.7328578408392563`*^9}, {3.7328602414885654`*^9, 3.732860258282526*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"e_.", "+", 
       RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"g_.", "+", 
        RowBox[{"h_.", "*", "x_"}]}], "]"}], "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], "]"}]}]}], ",", "x_Symbol"}], "]"}], 
  " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{"2", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", "m"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"c", "+", 
       RowBox[{"d", "*", "x"}]}], "]"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"e", "+", 
       RowBox[{"f", "*", "x"}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"g", "+", 
        RowBox[{"h", "*", "x"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{"d", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "*", "m"}], "+", "3"}], ")"}]}], ")"}]}]}], " ", "-", 
    " ", "\n", "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"d", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "*", "m"}], "+", "3"}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", "*", "x"}]}], ")"}], "^", 
           RowBox[{"(", 
            RowBox[{"m", "-", "1"}], ")"}]}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Sqrt", "[", 
             RowBox[{"c", "+", 
              RowBox[{"d", "*", "x"}]}], "]"}], "*", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"e", "+", 
              RowBox[{"f", "*", "x"}]}], "]"}], "*", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"g", "+", 
              RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ")"}], "*", "\n", 
        "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"2", "*", "b", "*", "c", "*", "e", "*", "g", "*", "m"}], 
           "+", 
           RowBox[{"a", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"c", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", "*", "g"}], "+", 
                 RowBox[{"e", "*", "h"}]}], ")"}]}], "-", 
              RowBox[{"2", "*", "d", "*", "e", "*", "g", "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "1"}], ")"}]}]}], ")"}]}], " ", "-", " ", 
           "\n", "      ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", "*", "d", "*", "e", "*", "g"}], "-", 
                 RowBox[{"c", "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"f", "*", "g"}], "+", 
                    RowBox[{"e", "*", "h"}]}], ")"}], "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"2", "*", "m"}], "+", "1"}], ")"}]}]}], ")"}]}], 
              "-", 
              RowBox[{"a", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", "*", "c", "*", "f", "*", "h"}], "-", 
                 RowBox[{"d", "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"2", "*", "m"}], "+", "1"}], ")"}], "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"f", "*", "g"}], "+", 
                    RowBox[{"e", "*", "h"}]}], ")"}]}]}], ")"}]}]}], ")"}], 
            "*", "x"}], " ", "-", " ", "\n", "      ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "*", "a", "*", "d", "*", "f", "*", "h", "*", "m"}],
               "+", 
              RowBox[{"b", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"f", "*", "g"}], "+", 
                    RowBox[{"e", "*", "h"}]}], ")"}]}], "-", 
                 RowBox[{"2", "*", "c", "*", "f", "*", "h", "*", 
                  RowBox[{"(", 
                   RowBox[{"m", "+", "1"}], ")"}]}]}], ")"}]}]}], ")"}], "*", 
            RowBox[{"x", "^", "2"}]}]}], ",", "x"}], "]"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"IntegerQ", "[", 
     RowBox[{"2", "*", "m"}], "]"}], " ", "&&", " ", 
    RowBox[{"GtQ", "[", 
     RowBox[{"m", ",", "0"}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375238754486885`*^9, 
   3.63752389858753*^9}, 3.6444425309977374`*^9, {3.6906621348624887`*^9, 
   3.6906621495825095`*^9}, {3.6906867607807975`*^9, 3.6906867777757697`*^9}, 
   3.690686824907466*^9, {3.690849985562031*^9, 3.690849989333246*^9}, {
   3.6908500749581437`*^9, 3.6908501341015263`*^9}, {3.7327713881833043`*^9, 
   3.732771418233347*^9}, 3.7327717566238203`*^9, {3.7327725108548765`*^9, 
   3.7327725188748875`*^9}, {3.732806856126346*^9, 3.73280686668495*^9}, {
   3.732807294788436*^9, 3.7328072994647036`*^9}, {3.7328073486815186`*^9, 
   3.732807351821698*^9}, {3.7328272566347866`*^9, 3.7328272678694296`*^9}, 
   3.7328273672531137`*^9, {3.732827467819866*^9, 3.732827472715146*^9}, {
   3.7328603039571385`*^9, 3.7328603082453837`*^9}, {3.732860410713245*^9, 
   3.7328604529306593`*^9}, 3.733335146818431*^9},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["2.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}], 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{"m", "<", "0"}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.539393717282713*^9, 3.5393937175197268`*^9}, {3.5393939972431717`*^9, 
   3.5393939972431717`*^9}, {3.54976183300485*^9, 3.549761843369443*^9}, 
   3.5497618783514433`*^9, {3.5498272575323367`*^9, 3.5498272577023373`*^9}, {
   3.5498590820409126`*^9, 3.549859083098973*^9}, {3.549861971973207*^9, 
   3.549861974052326*^9}, {3.5499239781513543`*^9, 3.5499239781513543`*^9}, {
   3.5716376069321833`*^9, 3.5716376095821867`*^9}, 3.571704053418295*^9, {
   3.571705098009757*^9, 3.5717051012397614`*^9}, 3.5717051920898886`*^9, 
   3.5758229151368937`*^9, 3.61151142537963*^9, {3.6375210294106445`*^9, 
   3.6375211225176077`*^9}, {3.644442260768281*^9, 3.644442260768281*^9}, {
   3.644442312905263*^9, 3.64444231686749*^9}, 3.647390660600108*^9, {
   3.6473907736905766`*^9, 3.647390819717209*^9}, {3.6473912085964518`*^9, 
   3.647391208843466*^9}, {3.6473912679138446`*^9, 3.6473912679138446`*^9}, {
   3.647396300569696*^9, 3.6473963246130714`*^9}, {3.6906631681351275`*^9, 
   3.6906631683951283`*^9}, {3.6906632461472373`*^9, 
   3.6906632887133045`*^9}, {3.732499894755187*^9, 3.732499895072205*^9}, {
   3.7327608903751197`*^9, 3.732760890625134*^9}, {3.7327722265444784`*^9, 
   3.732772237144493*^9}, {3.7327729017054234`*^9, 3.732772901935424*^9}, {
   3.732827529277381*^9, 3.7328275371568317`*^9}, 3.732988555979767*^9, {
   3.73299186320393*^9, 3.7329918821160116`*^9}, {3.7333353335521116`*^9, 
   3.733335344945763*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["1:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, 3.6202339138681226`*^9, {
   3.624745639354846*^9, 3.6247456402468967`*^9}, 3.6375206261804075`*^9, {
   3.637521131035223*^9, 3.637521134280029*^9}, {3.6375212227245846`*^9, 
   3.637521222989785*^9}, {3.6444423446760807`*^9, 3.6444423463511763`*^9}, 
   3.6444424235945945`*^9, 3.6473906762140017`*^9, {3.647391210994589*^9, 
   3.6473912128036923`*^9}, 3.647396315832569*^9, 3.64972048424479*^9, 
   3.649720531185272*^9, {3.649720974428851*^9, 3.649720974772052*^9}, 
   3.7324994105064898`*^9, {3.7324995842964296`*^9, 3.732499585208482*^9}, 
   3.7329885573128433`*^9, 3.732991864312993*^9, {3.7333353479419346`*^9, 
   3.733335349838043*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic expansion", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    RowBox[{
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]]}], 
    RowBox[{"a", "+", 
     RowBox[{"b", " ", "x"}]}]], "\[Equal]", 
   RowBox[{
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "e"}], "-", 
        RowBox[{"a", " ", "f"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "g"}], "-", 
        RowBox[{"a", " ", "h"}]}], ")"}]}], 
     RowBox[{
      SuperscriptBox["b", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"b", " ", "f", " ", "g"}], "+", 
      RowBox[{"b", " ", "e", " ", "h"}], "-", 
      RowBox[{"a", " ", "f", " ", "h"}], "+", 
      RowBox[{"b", " ", "f", " ", "h", " ", "x"}]}], 
     RowBox[{
      SuperscriptBox["b", "2"], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]]}]}]], "Input",
  CellChangeTimes->{{3.649720348711752*^9, 3.6497203523777585`*^9}, {
   3.6497205709029417`*^9, 3.6497205712617426`*^9}}]
}], "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9, {3.649720584693366*^9, 3.649720593710182*^9}, {
   3.649721173734801*^9, 3.649721173734801*^9}}],

Cell["Rule 1.1.1.4.2.1.2.2.1:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5346428654127264`*^9, 3.5346428654127264`*^9}, {
   3.5346430222260027`*^9, 3.5346430222260027`*^9}, {3.534706547783003*^9, 
   3.534706547783003*^9}, {3.549762992727182*^9, 3.549762992727182*^9}, {
   3.5498518507891617`*^9, 3.5498518507891617`*^9}, {3.5498619240544662`*^9, 
   3.5498619240544662`*^9}, {3.5499243006306405`*^9, 
   3.5499243006306405`*^9}, {3.611357201729041*^9, 3.611357201729041*^9}, {
   3.620233486271372*^9, 3.620233486271372*^9}, 3.6444424277228303`*^9, 
   3.6501606063200264`*^9, 3.6501608462147474`*^9, 3.6986840250634565`*^9, {
   3.732499860399222*^9, 3.732499861504285*^9}, {3.7333370992101016`*^9, 
   3.733337106365511*^9}, {3.73333742962*^9, 3.7333374311160855`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     RowBox[{
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]]}]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "e"}], "-", 
          RowBox[{"a", " ", "f"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "g"}], "-", 
          RowBox[{"a", " ", "h"}]}], ")"}]}], 
       SuperscriptBox["b", "2"]]}]}], " ", 
    RowBox[{"\[Integral]", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], " ", 
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}]], 
      RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "+", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox["b", "2"]], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"b", " ", "f", " ", "g"}], "+", 
       RowBox[{"b", " ", "e", " ", "h"}], "-", 
       RowBox[{"a", " ", "f", " ", "h"}], "+", 
       RowBox[{"b", " ", "f", " ", "h", " ", "x"}]}], 
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, {3.6202339278301473`*^9, 
   3.6202340167971034`*^9}, 3.637520635152423*^9, 3.637520669274683*^9, 
   3.6375207738068676`*^9, {3.6497205344456778`*^9, 3.6497205558957157`*^9}, {
   3.649720607329006*^9, 3.6497206416802664`*^9}, {3.649720675267125*^9, 
   3.649720704033576*^9}, {3.6497228120324783`*^9, 3.64972281257848*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Sqrt", "[", 
      RowBox[{"e_.", "+", 
       RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"g_.", "+", 
        RowBox[{"h_.", "*", "x_"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a_.", "+", 
          RowBox[{"b_.", "*", "x_"}]}], ")"}], "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"c_.", "+", 
          RowBox[{"d_.", "*", "x_"}]}], "]"}]}], ")"}]}]}], ",", "x_Symbol"}],
    "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", "*", "e"}], "-", 
       RowBox[{"a", "*", "f"}]}], ")"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "g"}], "-", 
        RowBox[{"a", "*", "h"}]}], ")"}], "/", 
      RowBox[{"b", "^", "2"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", "*", "x"}]}], ")"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"c", "+", 
            RowBox[{"d", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"e", "+", 
            RowBox[{"f", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ",", "x"}], "]"}]}], 
    " ", "+", " ", "\n", "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"b", "^", "2"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"b", "*", "f", "*", "g"}], "+", 
           RowBox[{"b", "*", "e", "*", "h"}], "-", 
           RowBox[{"a", "*", "f", "*", "h"}], "+", 
           RowBox[{"b", "*", "f", "*", "h", "*", "x"}]}], ",", "x"}], "]"}], 
        "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{"c", "+", 
            RowBox[{"d", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"e", "+", 
            RowBox[{"f", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{"FreeQ", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
       "h"}], "}"}], ",", "x"}], "]"}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375206859199123`*^9, 
   3.6375207021947412`*^9}, 3.6375208942208796`*^9, 3.6444424311490264`*^9, {
   3.6497207739216986`*^9, 3.649720787634123*^9}, 3.6497208461030254`*^9, 
   3.6497228220944963`*^9, {3.73248772960538*^9, 3.732487738489888*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["2:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}], 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{"m", "<", 
        RowBox[{"-", "1"}]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, 3.6202339138681226`*^9, {
   3.624745639354846*^9, 3.6247456402468967`*^9}, {3.637522303714407*^9, 
   3.6375223060594115`*^9}, 3.6390669973751264`*^9, {3.6444425214011884`*^9, 
   3.6444425218222127`*^9}, 3.6444425997666707`*^9, 3.6906631382090836`*^9, 
   3.6906631976551685`*^9, {3.6906632334152193`*^9, 3.69066323360522*^9}, {
   3.6908496403632865`*^9, 3.690849646876659*^9}, {3.6909187075544405`*^9, 
   3.690918707788441*^9}, {3.73275247923503*^9, 3.73275247941304*^9}, 
   3.7327713308632245`*^9, {3.7327723095445943`*^9, 3.7327723375746336`*^9}, {
   3.7327723773846893`*^9, 3.732772386344702*^9}, {3.7327729837355385`*^9, 
   3.732772983915539*^9}, {3.732807276136369*^9, 3.732807279286549*^9}, {
   3.7328073359837923`*^9, 3.732807338435932*^9}, 3.7328272156774445`*^9, {
   3.7328274625075617`*^9, 3.7328274625075617`*^9}, {3.7328275598281283`*^9, 
   3.7328275600381403`*^9}, 3.732988557829873*^9, 3.732991864859024*^9, {
   3.733335351125117*^9, 3.733335352180177*^9}, {3.7343774060919647`*^9, 
   3.7343774060919647`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[TextData[{
 "Rule",
 " 1.1.1.4.2.1.2.2.2",
 ": If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], " ", 
   "\[And]", " ", 
   RowBox[{"m", "<", 
    RowBox[{"-", "1"}]}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5269270224625387`*^9, 3.5269270224625387`*^9}, {
   3.5305583575562735`*^9, 3.530558360660679*^9}, {3.5347074228665404`*^9, 
   3.5347074228665404`*^9}, {3.549823103506521*^9, 3.549823103506521*^9}, {
   3.611356258837721*^9, 3.611356258837721*^9}, {3.63917293207978*^9, 
   3.63917293208078*^9}, 3.6501606099462337`*^9, 3.650160886705063*^9, {
   3.6906636169318275`*^9, 3.6906636171718283`*^9}, 3.698684025703457*^9, {
   3.7324999650142055`*^9, 3.73249996526722*^9}, {3.7327340558413467`*^9, 
   3.7327340651808815`*^9}, {3.7327546348363237`*^9, 
   3.7327546348363237`*^9}, {3.732760611532171*^9, 3.732760611532171*^9}, {
   3.732772395564715*^9, 3.732772395564715*^9}, {3.7328072883500676`*^9, 
   3.7328072883500676`*^9}, {3.732807344437276*^9, 3.732807344437276*^9}, {
   3.7328274648786974`*^9, 3.7328274648786974`*^9}, 3.7333371122538476`*^9, {
   3.733337444054826*^9, 3.733337445517909*^9}, {3.7343774106042233`*^9, 
   3.7343774106042233`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}], 
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{
     "x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}], 
         RowBox[{"m", "+", "1"}]], " ", 
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "c"}], "-", 
          RowBox[{"a", " ", "d"}]}], ")"}]}]]}]}]}]}], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{"m", "+", "1"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", " ", "c"}], "-", 
       RowBox[{"a", " ", "d"}]}], ")"}]}]], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"m", "+", "1"}]], 
       RowBox[{
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}]], "\[CenterDot]", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"c", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", " ", "g"}], "+", 
           RowBox[{"e", " ", "h"}]}], ")"}]}], "+", 
        RowBox[{"d", " ", "e", " ", "g", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "m"}], "+", "3"}], ")"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"c", " ", "f", " ", "h"}], "+", 
           RowBox[{"d", " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "2"}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", " ", "g"}], "+", 
              RowBox[{"e", " ", "h"}]}], ")"}]}]}], ")"}], " ", "x"}], "+", 
        RowBox[{"d", " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "m"}], "+", "5"}], ")"}], " ", 
         SuperscriptBox["x", "2"]}]}], ")"}]}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906862370138397`*^9, 
   3.690686270846775*^9, 3.6906865143317013`*^9, {3.690686592792189*^9, 
   3.690686597382452*^9}, {3.690849723898064*^9, 3.6908497599941287`*^9}, {
   3.690849801173484*^9, 3.6908499318219566`*^9}, {3.7327713601732655`*^9, 
   3.7327713689032774`*^9}, {3.7327714316433654`*^9, 3.732771581493575*^9}, {
   3.7327716324936466`*^9, 3.7327716430536613`*^9}, {3.732827229456232*^9, 
   3.7328272364986353`*^9}, {3.7328272941319313`*^9, 
   3.7328272980991583`*^9}, {3.7328578349709206`*^9, 3.7328578408392563`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"e_.", "+", 
       RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"g_.", "+", 
        RowBox[{"h_.", "*", "x_"}]}], "]"}], "/", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], "]"}]}]}], ",", "x_Symbol"}], "]"}], 
  " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"c", "+", 
       RowBox[{"d", "*", "x"}]}], "]"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"e", "+", 
       RowBox[{"f", "*", "x"}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"g", "+", 
        RowBox[{"h", "*", "x"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "c"}], "-", 
          RowBox[{"a", "*", "d"}]}], ")"}]}], ")"}]}]}], " ", "-", " ", "\n", 
    "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"2", "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "c"}], "-", 
          RowBox[{"a", "*", "d"}]}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", "*", "x"}]}], ")"}], "^", 
           RowBox[{"(", 
            RowBox[{"m", "+", "1"}], ")"}]}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Sqrt", "[", 
             RowBox[{"c", "+", 
              RowBox[{"d", "*", "x"}]}], "]"}], "*", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"e", "+", 
              RowBox[{"f", "*", "x"}]}], "]"}], "*", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"g", "+", 
              RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ")"}], "*", "\n", 
        "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"c", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "+", 
              RowBox[{"e", "*", "h"}]}], ")"}]}], "+", 
           RowBox[{"d", "*", "e", "*", "g", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "*", "m"}], "+", "3"}], ")"}]}], "+", 
           RowBox[{"2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"c", "*", "f", "*", "h"}], "+", 
              RowBox[{"d", "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "2"}], ")"}], "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", "*", "g"}], "+", 
                 RowBox[{"e", "*", "h"}]}], ")"}]}]}], ")"}], "*", "x"}], "+", 
           RowBox[{"d", "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "*", "m"}], "+", "5"}], ")"}], "*", 
            RowBox[{"x", "^", "2"}]}]}], ",", "x"}], "]"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"IntegerQ", "[", 
     RowBox[{"2", "*", "m"}], "]"}], " ", "&&", " ", 
    RowBox[{"LtQ", "[", 
     RowBox[{"m", ",", 
      RowBox[{"-", "1"}]}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375238754486885`*^9, 
   3.63752389858753*^9}, 3.6444425309977374`*^9, {3.6906621348624887`*^9, 
   3.6906621495825095`*^9}, {3.6906867607807975`*^9, 3.6906867777757697`*^9}, 
   3.690686824907466*^9, {3.690849985562031*^9, 3.690849989333246*^9}, {
   3.6908500749581437`*^9, 3.6908501341015263`*^9}, {3.7327713881833043`*^9, 
   3.732771418233347*^9}, 3.7327717566238203`*^9, {3.7327725108548765`*^9, 
   3.7327725188748875`*^9}, {3.732806856126346*^9, 3.73280686668495*^9}, {
   3.732807294788436*^9, 3.7328072994647036`*^9}, {3.7328073486815186`*^9, 
   3.732807351821698*^9}, {3.7328272566347866`*^9, 3.7328272678694296`*^9}, 
   3.7328273672531137`*^9, {3.732827467819866*^9, 3.732827472715146*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{Cell[TextData[StyleBox["2.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}], ")"}], "n"]}], 
      RowBox[{
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{
        SuperscriptBox["n", "2"], "\[Equal]", 
        FractionBox["1", "4"]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.539393717282713*^9, 3.5393937175197268`*^9}, {3.5393939972431717`*^9, 
   3.5393939972431717`*^9}, {3.54976183300485*^9, 3.549761843369443*^9}, 
   3.5497618783514433`*^9, {3.5498272575323367`*^9, 3.5498272577023373`*^9}, {
   3.5498590820409126`*^9, 3.549859083098973*^9}, {3.549861971973207*^9, 
   3.549861974052326*^9}, {3.5499239781513543`*^9, 3.5499239781513543`*^9}, {
   3.5716376069321833`*^9, 3.5716376095821867`*^9}, 3.571704053418295*^9, {
   3.571705098009757*^9, 3.5717051012397614`*^9}, 3.5717051920898886`*^9, 
   3.5758229151368937`*^9, 3.61151142537963*^9, {3.6375210294106445`*^9, 
   3.6375211225176077`*^9}, {3.644442260768281*^9, 3.644442260768281*^9}, {
   3.644442312905263*^9, 3.64444231686749*^9}, 3.647390660600108*^9, {
   3.6473907736905766`*^9, 3.647390819717209*^9}, {3.6473912085964518`*^9, 
   3.647391208843466*^9}, {3.6473912679138446`*^9, 3.6473912679138446`*^9}, {
   3.647396300569696*^9, 3.6473963246130714`*^9}, {3.6906631681351275`*^9, 
   3.6906631683951283`*^9}, {3.6906632461472373`*^9, 
   3.6906632887133045`*^9}, {3.732499894755187*^9, 3.732499895072205*^9}, {
   3.732737922040406*^9, 3.7327379264706593`*^9}, {3.732738472429887*^9, 
   3.7327385052267623`*^9}, {3.732740510611464*^9, 3.7327405512117863`*^9}, {
   3.7327409448252993`*^9, 3.7327409448252993`*^9}, {3.7327521678282185`*^9, 
   3.732752176626722*^9}, {3.7327527044179096`*^9, 3.7327527144164815`*^9}, 
   3.7329884096643987`*^9, {3.73299167596122*^9, 3.7329917088290997`*^9}, {
   3.732991898891971*^9, 3.7329918991289845`*^9}, {3.73333342222079*^9, 
   3.73333342222079*^9}, {3.7333335239516087`*^9, 3.7333335252766843`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{Cell[TextData[StyleBox["1.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}]]]], 
      "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.539393717282713*^9, 3.5393937175197268`*^9}, {3.5393939972431717`*^9, 
   3.5393939972431717`*^9}, {3.54976183300485*^9, 3.549761843369443*^9}, 
   3.5497618783514433`*^9, {3.5498272575323367`*^9, 3.5498272577023373`*^9}, {
   3.5498590820409126`*^9, 3.549859083098973*^9}, {3.549861971973207*^9, 
   3.549861974052326*^9}, {3.5499239781513543`*^9, 3.5499239781513543`*^9}, {
   3.5716376069321833`*^9, 3.5716376095821867`*^9}, 3.571704053418295*^9, {
   3.571705098009757*^9, 3.5717051012397614`*^9}, 3.5717051920898886`*^9, 
   3.5758229151368937`*^9, 3.61151142537963*^9, {3.6375210294106445`*^9, 
   3.6375211225176077`*^9}, {3.644442260768281*^9, 3.644442260768281*^9}, {
   3.644442312905263*^9, 3.64444231686749*^9}, 3.647390660600108*^9, {
   3.6473907736905766`*^9, 3.647390819717209*^9}, {3.6473912085964518`*^9, 
   3.647391208843466*^9}, {3.6473912679138446`*^9, 3.6473912679138446`*^9}, {
   3.647396300569696*^9, 3.6473963246130714`*^9}, {3.6906631681351275`*^9, 
   3.6906631683951283`*^9}, {3.6906632461472373`*^9, 
   3.6906632887133045`*^9}, {3.732499894755187*^9, 3.732499895072205*^9}, {
   3.732737922040406*^9, 3.7327379264706593`*^9}, {3.732738472429887*^9, 
   3.7327385052267623`*^9}, {3.732740510611464*^9, 3.7327405512117863`*^9}, {
   3.7327409448252993`*^9, 3.7327409448252993`*^9}, {3.7327521678282185`*^9, 
   3.732752176626722*^9}, {3.7327527044179096`*^9, 3.7327527144164815`*^9}, 
   3.7329884096643987`*^9, 3.7329918209785147`*^9, {3.7329919918622885`*^9, 
   3.732991992132304*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["1.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{"m", ">", "0"}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.539393717282713*^9, 3.5393937175197268`*^9}, {3.5393939972431717`*^9, 
   3.5393939972431717`*^9}, {3.54976183300485*^9, 3.549761843369443*^9}, 
   3.5497618783514433`*^9, {3.5498272575323367`*^9, 3.5498272577023373`*^9}, {
   3.5498590820409126`*^9, 3.549859083098973*^9}, {3.549861971973207*^9, 
   3.549861974052326*^9}, {3.5499239781513543`*^9, 3.5499239781513543`*^9}, {
   3.5716376069321833`*^9, 3.5716376095821867`*^9}, 3.571704053418295*^9, {
   3.571705098009757*^9, 3.5717051012397614`*^9}, 3.5717051920898886`*^9, 
   3.5758229151368937`*^9, 3.61151142537963*^9, {3.6375210294106445`*^9, 
   3.6375211225176077`*^9}, {3.644442260768281*^9, 3.644442260768281*^9}, {
   3.644442312905263*^9, 3.64444231686749*^9}, 3.647390660600108*^9, {
   3.6473907736905766`*^9, 3.647390819717209*^9}, {3.6473912085964518`*^9, 
   3.647391208843466*^9}, {3.6473912679138446`*^9, 3.6473912679138446`*^9}, {
   3.647396300569696*^9, 3.6473963246130714`*^9}, {3.6906631681351275`*^9, 
   3.6906631683951283`*^9}, {3.6906632461472373`*^9, 
   3.6906632887133045`*^9}, {3.732499894755187*^9, 3.732499895072205*^9}, {
   3.732737922040406*^9, 3.7327379264706593`*^9}, {3.732738472429887*^9, 
   3.7327385052267623`*^9}, {3.732740510611464*^9, 3.7327405512117863`*^9}, {
   3.7327409448252993`*^9, 3.7327409448252993`*^9}, {3.7327521678282185`*^9, 
   3.732752176626722*^9}, {3.7327527175236597`*^9, 3.7327527441591825`*^9}, 
   3.7329884124055552`*^9, 3.732991821736558*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["1:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]], 
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, 3.6202339138681226`*^9, {
   3.624745639354846*^9, 3.6247456402468967`*^9}, {3.637522303714407*^9, 
   3.6375223060594115`*^9}, 3.6390669973751264`*^9, {3.6444425214011884`*^9, 
   3.6444425218222127`*^9}, 3.6444425997666707`*^9, 3.6906631382090836`*^9, 
   3.6906631976551685`*^9, {3.6906632334152193`*^9, 3.69066323360522*^9}, {
   3.7327524776569395`*^9, 3.732752477856951*^9}, {3.7327527697176447`*^9, 
   3.7327527754179707`*^9}, {3.732861224416786*^9, 3.7328612246377983`*^9}, 
   3.7329884137896347`*^9, 3.732991822844621*^9, {3.7333371250195775`*^9, 
   3.733337125266592*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["\<\
Derivation: Piecewise constant extraction and integration by substitution\
\>", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9, {3.620234434581437*^9, 3.6202344396046457`*^9}, {
   3.690664333768237*^9, 3.690664341188247*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["\[PartialD]", "x"], 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], " ", 
      SqrtBox[
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "g"}], "-", 
           RowBox[{"a", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "g"}], "-", 
           RowBox[{"c", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}]}]]], " ", 
      SqrtBox[
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "g"}], "-", 
           RowBox[{"a", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", " ", "x"}]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", " ", "g"}], "-", 
           RowBox[{"e", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}]}]]]}], 
     RowBox[{
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]]}]]}], "\[Equal]", "0"}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox["1", 
    RowBox[{
     SqrtBox[
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}]], " ", 
     SqrtBox[
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "g"}], "-", 
          RowBox[{"a", " ", "h"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}], ")"}]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"d", " ", "g"}], "-", 
          RowBox[{"c", " ", "h"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}]}]]], " ", 
     SqrtBox[
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "g"}], "-", 
          RowBox[{"a", " ", "h"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"f", " ", "g"}], "-", 
          RowBox[{"e", " ", "h"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}]}]]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]]}]], "\[Equal]", 
   RowBox[{"2", " ", 
    RowBox[{"Subst", "[", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"h", "-", 
          RowBox[{"b", " ", 
           SuperscriptBox["x", "2"]}]}], ")"}], " ", 
        SqrtBox[
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", " ", "c"}], "-", 
              RowBox[{"a", " ", "d"}]}], ")"}], " ", 
            SuperscriptBox["x", "2"]}], 
           RowBox[{
            RowBox[{"d", " ", "g"}], "-", 
            RowBox[{"c", " ", "h"}]}]]}]], " ", 
        SqrtBox[
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", " ", "e"}], "-", 
              RowBox[{"a", " ", "f"}]}], ")"}], " ", 
            SuperscriptBox["x", "2"]}], 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}]]}]]}]], ",", "x", ",", 
      FractionBox[
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]], 
       SqrtBox[
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]]]}], "]"}], " ", 
    RowBox[{
     SubscriptBox["\[PartialD]", "x"], 
     FractionBox[
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]], 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]]]}]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}, {3.690664586481409*^9, 
   3.690664586481409*^9}, {3.6906647291955585`*^9, 3.6906647291955585`*^9}, {
   3.690686698262222*^9, 3.690686698262222*^9}}],

Cell["Rule 1.1.1.4.2.2.1.1.1:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5346428654127264`*^9, 3.5346428654127264`*^9}, {
   3.5346430222260027`*^9, 3.5346430222260027`*^9}, {3.534706547783003*^9, 
   3.534706547783003*^9}, {3.549762992727182*^9, 3.549762992727182*^9}, {
   3.5498518507891617`*^9, 3.5498518507891617`*^9}, {3.5498619240544662`*^9, 
   3.5498619240544662`*^9}, {3.5499243006306405`*^9, 
   3.5499243006306405`*^9}, {3.611357201729041*^9, 3.611357201729041*^9}, {
   3.620233486271372*^9, 3.620233486271372*^9}, 3.644442526707492*^9, 
   3.6501606069260607`*^9, {3.6501608506620016`*^9, 3.650160851202033*^9}, {
   3.6906635832577796`*^9, 3.69066358350778*^9}, 3.698684025283457*^9, 
   3.732499926488002*^9, {3.7333371550782967`*^9, 3.733337156860399*^9}, {
   3.733337465575056*^9, 3.7333374674491634`*^9}}],

Cell[BoxData[{
 RowBox[{"\[Integral]", 
  RowBox[{
   FractionBox[
    SqrtBox[
     RowBox[{"a", "+", 
      RowBox[{"b", " ", "x"}]}]], 
    RowBox[{
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]]}]], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"c", "+", 
            RowBox[{"d", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "g"}], "-", 
            RowBox[{"c", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"e", "+", 
            RowBox[{"f", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]]}], 
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]]}]]}]}], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       SqrtBox[
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"c", "+", 
            RowBox[{"d", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "g"}], "-", 
            RowBox[{"c", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"e", "+", 
            RowBox[{"f", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"  ", 
  RowBox[{
   RowBox[{"\[LongRightArrow]", "  ", 
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], " ", 
      SqrtBox[
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "g"}], "-", 
           RowBox[{"a", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "g"}], "-", 
           RowBox[{"c", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}]}]]], " ", 
      SqrtBox[
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "g"}], "-", 
           RowBox[{"a", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", " ", "x"}]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", " ", "g"}], "-", 
           RowBox[{"e", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}]}]]]}], 
     RowBox[{
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]]}]]}], " ", 
   RowBox[{"Subst", "[", 
    RowBox[{
     RowBox[{"\[Integral]", 
      RowBox[{
       FractionBox["1", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"h", "-", 
           RowBox[{"b", " ", 
            SuperscriptBox["x", "2"]}]}], ")"}], " ", 
         SqrtBox[
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"b", " ", "c"}], "-", 
               RowBox[{"a", " ", "d"}]}], ")"}], " ", 
             SuperscriptBox["x", "2"]}], 
            RowBox[{
             RowBox[{"d", " ", "g"}], "-", 
             RowBox[{"c", " ", "h"}]}]]}]], " ", 
         SqrtBox[
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"b", " ", "e"}], "-", 
               RowBox[{"a", " ", "f"}]}], ")"}], " ", 
             SuperscriptBox["x", "2"]}], 
            RowBox[{
             RowBox[{"f", " ", "g"}], "-", 
             RowBox[{"e", " ", "h"}]}]]}]]}]], 
       RowBox[{"\[DifferentialD]", "x"}]}]}], ",", "x", ",", 
     FractionBox[
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]], 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]]]}], "]"}]}]}]}], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906862370138397`*^9, 
   3.690686270846775*^9, 3.6906865143317013`*^9, {3.690686592792189*^9, 
   3.690686597382452*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Sqrt", "[", 
      RowBox[{"a_.", "+", 
       RowBox[{"b_.", "*", "x_"}]}], "]"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Sqrt", "[", 
        RowBox[{"c_.", "+", 
         RowBox[{"d_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"e_.", "+", 
         RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"g_.", "+", 
         RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}], ",", "x_Symbol"}], 
   "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{"2", "*", 
    RowBox[{"(", 
     RowBox[{"a", "+", 
      RowBox[{"b", "*", "x"}]}], ")"}], "*", 
    RowBox[{"Sqrt", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "g"}], "-", 
        RowBox[{"a", "*", "h"}]}], ")"}], "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", "*", "x"}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", "*", "g"}], "-", 
           RowBox[{"c", "*", "h"}]}], ")"}], "*", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}]}], ")"}]}]}], "]"}], "*", 
    RowBox[{
     RowBox[{"Sqrt", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", "*", "g"}], "-", 
         RowBox[{"a", "*", "h"}]}], ")"}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", "*", "x"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", "*", "g"}], "-", 
            RowBox[{"e", "*", "h"}]}], ")"}], "*", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", "*", "x"}]}], ")"}]}], ")"}]}]}], "]"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Sqrt", "[", 
        RowBox[{"c", "+", 
         RowBox[{"d", "*", "x"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"e", "+", 
         RowBox[{"f", "*", "x"}]}], "]"}]}], ")"}]}], "*", 
    "\[IndentingNewLine]", "    ", 
    RowBox[{"Subst", "[", 
     RowBox[{
      RowBox[{"Int", "[", 
       RowBox[{
        RowBox[{"1", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"h", "-", 
             RowBox[{"b", "*", 
              RowBox[{"x", "^", "2"}]}]}], ")"}], "*", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"b", "*", "c"}], "-", 
                RowBox[{"a", "*", "d"}]}], ")"}], "*", 
              RowBox[{
               RowBox[{"x", "^", "2"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "g"}], "-", 
                 RowBox[{"c", "*", "h"}]}], ")"}]}]}]}], "]"}], "*", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"b", "*", "e"}], "-", 
                RowBox[{"a", "*", "f"}]}], ")"}], "*", 
              RowBox[{
               RowBox[{"x", "^", "2"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", "*", "g"}], "-", 
                 RowBox[{"e", "*", "h"}]}], ")"}]}]}]}], "]"}]}], ")"}]}], 
        ",", "x"}], "]"}], ",", "x", ",", 
      RowBox[{
       RowBox[{"Sqrt", "[", 
        RowBox[{"g", "+", 
         RowBox[{"h", "*", "x"}]}], "]"}], "/", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"a", "+", 
         RowBox[{"b", "*", "x"}]}], "]"}]}]}], "]"}]}], " ", "/;", "\n", 
   RowBox[{"FreeQ", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
       "h"}], "}"}], ",", "x"}], "]"}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375238754486885`*^9, 
   3.63752389858753*^9}, 3.6444425309977374`*^9, {3.6906621348624887`*^9, 
   3.6906621495825095`*^9}, {3.6906867607807975`*^9, 3.6906867777757697`*^9}, 
   3.690686824907466*^9},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["2:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], 
       RowBox[{"3", "/", "2"}]], 
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, 3.6202339138681226`*^9, {
   3.624745639354846*^9, 3.6247456402468967`*^9}, {3.637522303714407*^9, 
   3.6375223060594115`*^9}, 3.6390669973751264`*^9, {3.6444425214011884`*^9, 
   3.6444425218222127`*^9}, 3.6444425997666707`*^9, 3.6906631382090836`*^9, 
   3.6906631976551685`*^9, {3.6906632334152193`*^9, 3.69066323360522*^9}, {
   3.6908496403632865`*^9, 3.690849646876659*^9}, {3.6909187075544405`*^9, 
   3.690918707788441*^9}, {3.6909235135198183`*^9, 3.6909235290198402`*^9}, {
   3.7327524806551113`*^9, 3.7327524808141203`*^9}, {3.732752771527748*^9, 
   3.7327527734258566`*^9}, {3.732861226045879*^9, 3.7328612262108884`*^9}, 
   3.732988414391669*^9, 3.7329918233886523`*^9, {3.7333371308309097`*^9, 
   3.733337131105926*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic expansion", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9, {3.620234434581437*^9, 3.6202344396046457`*^9}, {
   3.690664333768237*^9, 3.690664341188247*^9}, {3.6908496587223363`*^9, 
   3.6908496620505266`*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], 
     RowBox[{"3", "/", "2"}]], 
    SqrtBox[
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "x"}]}]]], "\[Equal]", 
   RowBox[{
    FractionBox[
     RowBox[{"b", " ", 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]]}], "d"], "-", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "c"}], "-", 
        RowBox[{"a", " ", "d"}]}], ")"}], " ", 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]]}], 
     RowBox[{"d", " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]]}]]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}, {3.6908497024188356`*^9, 
   3.6908497024188356`*^9}, {3.6908497702987185`*^9, 
   3.6908497777081423`*^9}, {3.690923739793342*^9, 3.690923739793342*^9}, {
   3.6909242094496307`*^9, 3.6909242094496307`*^9}, {3.6909243535930386`*^9, 
   3.6909243535930386`*^9}}],

Cell["Rule 1.1.1.4.2.2.1.1.2:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5346428654127264`*^9, 3.5346428654127264`*^9}, {
   3.5346430222260027`*^9, 3.5346430222260027`*^9}, {3.534706547783003*^9, 
   3.534706547783003*^9}, {3.549762992727182*^9, 3.549762992727182*^9}, {
   3.5498518507891617`*^9, 3.5498518507891617`*^9}, {3.5498619240544662`*^9, 
   3.5498619240544662`*^9}, {3.5499243006306405`*^9, 
   3.5499243006306405`*^9}, {3.611357201729041*^9, 3.611357201729041*^9}, {
   3.620233486271372*^9, 3.620233486271372*^9}, 3.644442526707492*^9, 
   3.6501606069260607`*^9, {3.6501608506620016`*^9, 3.650160851202033*^9}, {
   3.6906635832577796`*^9, 3.69066358350778*^9}, {3.6908497163326316`*^9, 
   3.6908497165996466`*^9}, {3.690918716696057*^9, 3.6909187169144573`*^9}, {
   3.690923519099826*^9, 3.690923519439827*^9}, 3.698684025503457*^9, 
   3.732499930544234*^9, {3.7333371625697255`*^9, 3.7333371653848867`*^9}, {
   3.733337477890761*^9, 3.733337480431906*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"3", "/", "2"}]], 
     RowBox[{
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
      FractionBox["b", "d"]}]}], " ", 
    RowBox[{"\[Integral]", 
     RowBox[{
      FractionBox[
       RowBox[{
        SqrtBox[
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]]}], 
       RowBox[{
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}]], 
      RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "-", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", " ", "c"}], "-", 
       RowBox[{"a", " ", "d"}]}], ")"}], " "}], "d"], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]], 
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906862370138397`*^9, 
   3.690686270846775*^9, 3.6906865143317013`*^9, {3.690686592792189*^9, 
   3.690686597382452*^9}, {3.690849723898064*^9, 3.6908497599941287`*^9}, {
   3.690849801173484*^9, 3.6908499318219566`*^9}, 3.6909237652359786`*^9, {
   3.690924220694647*^9, 3.6909242700767174`*^9}, 3.6909243039319673`*^9},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"3", "/", "2"}], ")"}]}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Sqrt", "[", 
        RowBox[{"c_.", "+", 
         RowBox[{"d_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"e_.", "+", 
         RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"g_.", "+", 
         RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}], ",", "x_Symbol"}], 
   "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"b", "/", "d"}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"a", "+", 
          RowBox[{"b", "*", "x"}]}], "]"}], "*", 
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], "]"}], "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Sqrt", "[", 
            RowBox[{"e", "+", 
             RowBox[{"f", "*", "x"}]}], "]"}], "*", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"g", "+", 
             RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}]}], ",", "x"}], 
      "]"}]}], " ", "-", " ", "\n", "  ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "c"}], "-", 
        RowBox[{"a", "*", "d"}]}], ")"}], "/", "d"}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"a", "+", 
          RowBox[{"b", "*", "x"}]}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{"c", "+", 
            RowBox[{"d", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"e", "+", 
            RowBox[{"f", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{"FreeQ", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
       "h"}], "}"}], ",", "x"}], "]"}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375238754486885`*^9, 
   3.63752389858753*^9}, 3.6444425309977374`*^9, {3.6906621348624887`*^9, 
   3.6906621495825095`*^9}, {3.6906867607807975`*^9, 3.6906867777757697`*^9}, 
   3.690686824907466*^9, {3.690849985562031*^9, 3.690849989333246*^9}, {
   3.6908500749581437`*^9, 3.6908501341015263`*^9}, {3.6909244074222097`*^9, 
   3.690924417604313*^9}, 3.6909244715303917`*^9},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["3:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{"m", "\[GreaterEqual]", "2"}]}]]]], 
      "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, 3.6202339138681226`*^9, {
   3.624745639354846*^9, 3.6247456402468967`*^9}, {3.637522303714407*^9, 
   3.6375223060594115`*^9}, 3.6390669973751264`*^9, {3.6444425214011884`*^9, 
   3.6444425218222127`*^9}, 3.6444425997666707`*^9, 3.6906631382090836`*^9, 
   3.6906631976551685`*^9, {3.6906632334152193`*^9, 3.69066323360522*^9}, {
   3.7327330816756277`*^9, 3.7327330924772453`*^9}, {3.732734032900035*^9, 
   3.7327340368592615`*^9}, {3.732734582462468*^9, 3.7327345828194885`*^9}, 
   3.7327379415195203`*^9, 3.7327405597332735`*^9, {3.732740645977206*^9, 
   3.7327406461742177`*^9}, 3.7327521719874563`*^9, 3.732752727257216*^9, {
   3.7327545912548304`*^9, 3.7327545967611456`*^9}, {3.732820194591262*^9, 
   3.732820202362706*^9}, {3.732861227703974*^9, 3.732861228390013*^9}, 
   3.732988415024705*^9, 3.732991823934684*^9, {3.7333371361052117`*^9, 
   3.733337136453232*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[TextData[{
 "Rule",
 " 1.1.1.4.2.2.1.1.3",
 ": If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], " ", 
   "\[And]", " ", 
   RowBox[{"m", "\[GreaterEqual]", "2"}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5269270224625387`*^9, 3.5269270224625387`*^9}, {
   3.5305583575562735`*^9, 3.530558360660679*^9}, {3.5347074228665404`*^9, 
   3.5347074228665404`*^9}, {3.549823103506521*^9, 3.549823103506521*^9}, {
   3.611356258837721*^9, 3.611356258837721*^9}, {3.63917293207978*^9, 
   3.63917293208078*^9}, 3.6501606099462337`*^9, 3.650160886705063*^9, {
   3.6906636169318275`*^9, 3.6906636171718283`*^9}, 3.698684025703457*^9, {
   3.7324999650142055`*^9, 3.73249996526722*^9}, {3.7327340558413467`*^9, 
   3.7327340651808815`*^9}, {3.732754601702428*^9, 3.732754601702428*^9}, {
   3.732820216676525*^9, 3.732820216676525*^9}, 3.733337171437233*^9, {
   3.7333374914385357`*^9, 3.733337492877618*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
     RowBox[{
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{
     "x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{"2", " ", 
        SuperscriptBox["b", "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}], 
         RowBox[{"m", "-", "2"}]], " ", 
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}], 
       RowBox[{"d", " ", "f", " ", "h", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "m"}], "-", "1"}], ")"}]}]]}]}]}]}], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"d", " ", "f", " ", "h", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "m"}], "-", "1"}], ")"}]}]], 
   RowBox[{"\[Integral]", 
    RowBox[{
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"m", "-", "3"}]], 
       RowBox[{
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}]], "\[CenterDot]", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"a", " ", 
         SuperscriptBox["b", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "e", " ", "g"}], "+", 
           RowBox[{"c", " ", "f", " ", "g"}], "+", 
           RowBox[{"c", " ", "e", " ", "h"}]}], ")"}]}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["b", "3"], " ", "c", " ", "e", " ", "g", " ", 
         RowBox[{"(", 
          RowBox[{"m", "-", "2"}], ")"}]}], "-", 
        RowBox[{
         SuperscriptBox["a", "3"], " ", "d", " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "m"}], "-", "1"}], ")"}]}], "+", 
        "\[IndentingNewLine]", 
        RowBox[{"b", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "a", " ", "b", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "f", " ", "g"}], "+", 
              RowBox[{"d", " ", "e", " ", "h"}], "+", 
              RowBox[{"c", " ", "f", " ", "h"}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "m"}], "-", "3"}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "e", " ", "g"}], "+", 
              RowBox[{"c", " ", "f", " ", "g"}], "+", 
              RowBox[{"c", " ", "e", " ", "h"}]}], ")"}]}], "-", 
           RowBox[{"3", " ", 
            SuperscriptBox["a", "2"], " ", "d", " ", "f", " ", "h", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "m"}], "-", "1"}], ")"}]}]}], ")"}], " ", 
         "x"}], "-", "\[IndentingNewLine]", 
        RowBox[{"2", " ", 
         SuperscriptBox["b", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"m", "-", "1"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"3", " ", "a", " ", "d", " ", "f", " ", "h"}], "-", 
           RowBox[{"b", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "f", " ", "g"}], "+", 
              RowBox[{"d", " ", "e", " ", "h"}], "+", 
              RowBox[{"c", " ", "f", " ", "h"}]}], ")"}]}]}], ")"}], " ", 
         SuperscriptBox["x", "2"]}]}], ")"}]}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906862370138397`*^9, 
   3.690686270846775*^9, 3.6906865143317013`*^9, {3.690686592792189*^9, 
   3.690686597382452*^9}, {3.7327331215549088`*^9, 3.7327331395009356`*^9}, {
   3.7327331887557526`*^9, 3.732733214749239*^9}, {3.732733257841704*^9, 
   3.7327333953595695`*^9}, {3.7327345913469763`*^9, 3.732734696479989*^9}, {
   3.7327347282478065`*^9, 3.732734752345185*^9}, {3.732734822447194*^9, 
   3.732734831705724*^9}, 3.7327359959442396`*^9, {3.7327360341624255`*^9, 
   3.732736042400897*^9}, {3.7328202411969275`*^9, 3.7328202946959877`*^9}, 
   3.732857750920113*^9},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Sqrt", "[", 
        RowBox[{"c_.", "+", 
         RowBox[{"d_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"e_.", "+", 
         RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"g_.", "+", 
         RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}], ",", "x_Symbol"}], 
   "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{"2", "*", 
     RowBox[{"b", "^", "2"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "-", "2"}], ")"}]}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"c", "+", 
       RowBox[{"d", "*", "x"}]}], "]"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"e", "+", 
       RowBox[{"f", "*", "x"}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"g", "+", 
        RowBox[{"h", "*", "x"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{"d", "*", "f", "*", "h", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "*", "m"}], "-", "1"}], ")"}]}], ")"}]}]}], " ", "-", 
    " ", "\n", "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"d", "*", "f", "*", "h", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "*", "m"}], "-", "1"}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", "*", "x"}]}], ")"}], "^", 
           RowBox[{"(", 
            RowBox[{"m", "-", "3"}], ")"}]}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Sqrt", "[", 
             RowBox[{"c", "+", 
              RowBox[{"d", "*", "x"}]}], "]"}], "*", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"e", "+", 
              RowBox[{"f", "*", "x"}]}], "]"}], "*", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"g", "+", 
              RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ")"}], "*", "\n", 
        "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"a", "*", 
            RowBox[{"b", "^", "2"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", "*", "e", "*", "g"}], "+", 
              RowBox[{"c", "*", "f", "*", "g"}], "+", 
              RowBox[{"c", "*", "e", "*", "h"}]}], ")"}]}], "+", 
           RowBox[{"2", "*", 
            RowBox[{"b", "^", "3"}], "*", "c", "*", "e", "*", "g", "*", 
            RowBox[{"(", 
             RowBox[{"m", "-", "2"}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"a", "^", "3"}], "*", "d", "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "*", "m"}], "-", "1"}], ")"}]}], " ", "+", " ", 
           "\n", "      ", 
           RowBox[{"b", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "*", "a", "*", "b", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "f", "*", "g"}], "+", 
                 RowBox[{"d", "*", "e", "*", "h"}], "+", 
                 RowBox[{"c", "*", "f", "*", "h"}]}], ")"}]}], "+", 
              RowBox[{
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", "*", "m"}], "-", "3"}], ")"}], "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "e", "*", "g"}], "+", 
                 RowBox[{"c", "*", "f", "*", "g"}], "+", 
                 RowBox[{"c", "*", "e", "*", "h"}]}], ")"}]}], "-", 
              RowBox[{"3", "*", 
               RowBox[{"a", "^", "2"}], "*", "d", "*", "f", "*", "h", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", "*", "m"}], "-", "1"}], ")"}]}]}], ")"}], "*", 
            "x"}], " ", "-", " ", "\n", "      ", 
           RowBox[{"2", "*", 
            RowBox[{"b", "^", "2"}], "*", 
            RowBox[{"(", 
             RowBox[{"m", "-", "1"}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"3", "*", "a", "*", "d", "*", "f", "*", "h"}], "-", 
              RowBox[{"b", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "f", "*", "g"}], "+", 
                 RowBox[{"d", "*", "e", "*", "h"}], "+", 
                 RowBox[{"c", "*", "f", "*", "h"}]}], ")"}]}]}], ")"}], "*", 
            RowBox[{"x", "^", "2"}]}]}], ",", "x"}], "]"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"IntegerQ", "[", 
     RowBox[{"2", "*", "m"}], "]"}], " ", "&&", " ", 
    RowBox[{"GeQ", "[", 
     RowBox[{"m", ",", "2"}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375238754486885`*^9, 
   3.63752389858753*^9}, 3.6444425309977374`*^9, {3.6906621348624887`*^9, 
   3.6906621495825095`*^9}, {3.6906867607807975`*^9, 3.6906867777757697`*^9}, 
   3.690686824907466*^9, {3.732733463768482*^9, 3.732733550071419*^9}, {
   3.73273385500686*^9, 3.732733916393371*^9}, {3.7327339528134537`*^9, 
   3.7327339633430567`*^9}, 3.732734128646511*^9, {3.7327342384447913`*^9, 
   3.732734296346103*^9}, {3.732734393919684*^9, 3.7327344161499557`*^9}, {
   3.7327348742871594`*^9, 3.732734945992261*^9}, {3.732734980528236*^9, 
   3.7327349822293334`*^9}, 3.7327360101010494`*^9, {3.732754604639596*^9, 
   3.732754606697714*^9}, {3.7328202198497066`*^9, 3.7328202226958694`*^9}, {
   3.7328204322458553`*^9, 3.7328204514559536`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["2.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{"m", "<", "0"}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.539393717282713*^9, 3.5393937175197268`*^9}, {3.5393939972431717`*^9, 
   3.5393939972431717`*^9}, {3.54976183300485*^9, 3.549761843369443*^9}, 
   3.5497618783514433`*^9, {3.5498272575323367`*^9, 3.5498272577023373`*^9}, {
   3.5498590820409126`*^9, 3.549859083098973*^9}, {3.549861971973207*^9, 
   3.549861974052326*^9}, {3.5499239781513543`*^9, 3.5499239781513543`*^9}, {
   3.5716376069321833`*^9, 3.5716376095821867`*^9}, 3.571704053418295*^9, {
   3.571705098009757*^9, 3.5717051012397614`*^9}, 3.5717051920898886`*^9, 
   3.5758229151368937`*^9, 3.61151142537963*^9, {3.6375210294106445`*^9, 
   3.6375211225176077`*^9}, {3.644442260768281*^9, 3.644442260768281*^9}, {
   3.644442312905263*^9, 3.64444231686749*^9}, 3.647390660600108*^9, {
   3.6473907736905766`*^9, 3.647390819717209*^9}, {3.6473912085964518`*^9, 
   3.647391208843466*^9}, {3.6473912679138446`*^9, 3.6473912679138446`*^9}, {
   3.647396300569696*^9, 3.6473963246130714`*^9}, {3.6906631681351275`*^9, 
   3.6906631683951283`*^9}, {3.6906632461472373`*^9, 
   3.6906632887133045`*^9}, {3.732499894755187*^9, 3.732499895072205*^9}, {
   3.732737922040406*^9, 3.7327379264706593`*^9}, {3.732738472429887*^9, 
   3.7327385052267623`*^9}, {3.732740510611464*^9, 3.7327405512117863`*^9}, {
   3.7327409448252993`*^9, 3.7327409448252993`*^9}, {3.7327521678282185`*^9, 
   3.732752176626722*^9}, {3.7327527175236597`*^9, 3.7327527230499754`*^9}, 
   3.7329884157947493`*^9, 3.732991824480715*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["1:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, 3.6202339138681226`*^9, {
   3.624745639354846*^9, 3.6247456402468967`*^9}, 3.6375206261804075`*^9, {
   3.637521131035223*^9, 3.637521134280029*^9}, {3.6375212227245846`*^9, 
   3.637521222989785*^9}, {3.6444423446760807`*^9, 3.6444423463511763`*^9}, 
   3.6444424235945945`*^9, 3.6473906762140017`*^9, {3.647391210994589*^9, 
   3.6473912128036923`*^9}, 3.647396315832569*^9, 3.731532841709029*^9, {
   3.7315329891654634`*^9, 3.7315329942157516`*^9}, 3.73153717467286*^9, 
   3.731537277004713*^9, 3.732499298426079*^9, 3.7324994089644012`*^9, 
   3.732499514147417*^9, 3.7327384219359984`*^9, 3.7327405523898535`*^9, 
   3.732752170003343*^9, 3.73275272557712*^9, 3.732988416529791*^9, 
   3.7329918250347466`*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Integration by substitution", "Subsubsection",
 CellChangeTimes->{
  3.4953915070313115`*^9, 3.495840214754669*^9, {3.4958483177760134`*^9, 
   3.495848318886015*^9}, {3.495925911922002*^9, 3.495925920122013*^9}, 
   3.4961847242848682`*^9, 3.496184957525194*^9, 3.4961852577556148`*^9, 
   3.496185323645707*^9, {3.5185620328669024`*^9, 3.5185620358269067`*^9}, {
   3.7315212574568486`*^9, 3.7315212865695133`*^9}, 3.731533006552458*^9}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    RowBox[{"F", "[", "x", "]"}], 
    SqrtBox[
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "x"}]}]]], "\[Equal]", 
   RowBox[{
    FractionBox["2", "d"], " ", 
    RowBox[{"Subst", "[", 
     RowBox[{
      RowBox[{"F", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"c", "-", 
          SuperscriptBox["x", "2"]}], "d"]}], "]"}], ",", "x", ",", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]]}], "]"}], " ", 
    RowBox[{
     SubscriptBox["\[PartialD]", "x"], 
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]]}]}]}]],
  CellChangeTimes->{{3.731521444401541*^9, 3.731521452841024*^9}}]
}], "Subsubsection",
 CellChangeTimes->{
  3.4953915070313115`*^9, 3.495840214754669*^9, {3.4958483177760134`*^9, 
   3.495848318886015*^9}, {3.495925911922002*^9, 3.495925920122013*^9}, 
   3.4961847242848682`*^9, 3.496184957525194*^9, 3.4961852577556148`*^9, 
   3.496185323645707*^9, {3.5185620328669024`*^9, 3.5185620358269067`*^9}, {
   3.7315212574568486`*^9, 3.7315212865695133`*^9}, {3.7315214235633492`*^9, 
   3.731521424588408*^9}, 3.731521460147442*^9, {3.7315215899768677`*^9, 
   3.7315215899768677`*^9}, {3.7315330263455896`*^9, 
   3.7315330398773637`*^9}, {3.731534268616644*^9, 3.731534268616644*^9}, {
   3.7315371048438663`*^9, 3.731537110048164*^9}, {3.732382795996565*^9, 
   3.732382795996565*^9}}],

Cell["Rule 1.1.1.4.2.2.1.2.1:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5346428654127264`*^9, 3.5346428654127264`*^9}, {
   3.5346430222260027`*^9, 3.5346430222260027`*^9}, {3.534706547783003*^9, 
   3.534706547783003*^9}, {3.549762992727182*^9, 3.549762992727182*^9}, {
   3.5498518507891617`*^9, 3.5498518507891617`*^9}, {3.5498619240544662`*^9, 
   3.5498619240544662`*^9}, {3.5499243006306405`*^9, 
   3.5499243006306405`*^9}, {3.611357201729041*^9, 3.611357201729041*^9}, {
   3.620233486271372*^9, 3.620233486271372*^9}, 3.6444424277228303`*^9, 
   3.6501606051179576`*^9, {3.650160833112998*^9, 3.6501608347090893`*^9}, 
   3.698684024923456*^9, {3.7315329041966033`*^9, 3.731532922129629*^9}, {
   3.7315329673332143`*^9, 3.731532976604745*^9}, {3.7315330434485683`*^9, 
   3.7315330443386188`*^9}, 3.7315371225418787`*^9, {3.731537272281443*^9, 
   3.7315372724334517`*^9}, {3.7324998323496175`*^9, 3.73249983256763*^9}, {
   3.7333371774295754`*^9, 3.7333371791646748`*^9}, {3.7333375082174954`*^9, 
   3.73333750969958*^9}}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], " ", 
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]]}]], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
     RowBox[{"-", "2"}]}]}], " ", 
   RowBox[{"Subst", "[", 
    RowBox[{
     RowBox[{"\[Integral]", 
      RowBox[{
       FractionBox["1", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "c"}], "-", 
           RowBox[{"a", " ", "d"}], "-", 
           RowBox[{"b", " ", 
            SuperscriptBox["x", "2"]}]}], ")"}], " ", 
         SqrtBox[
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{"d", " ", "e"}], "-", 
             RowBox[{"c", " ", "f"}]}], "d"], "+", 
           FractionBox[
            RowBox[{"f", " ", 
             SuperscriptBox["x", "2"]}], "d"]}]], " ", 
         SqrtBox[
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{"d", " ", "g"}], "-", 
             RowBox[{"c", " ", "h"}]}], "d"], "+", 
           FractionBox[
            RowBox[{"h", " ", 
             SuperscriptBox["x", "2"]}], "d"]}]]}]], 
       RowBox[{"\[DifferentialD]", "x"}]}]}], ",", "x", ",", 
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]]}], "]"}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, {3.6202339278301473`*^9, 
   3.6202340167971034`*^9}, 3.637520635152423*^9, 3.637520669274683*^9, 
   3.6375207738068676`*^9, {3.7315212940699425`*^9, 3.7315213149961395`*^9}, {
   3.731521629739142*^9, 3.731521670633481*^9}, {3.731533094385481*^9, 
   3.731533095200528*^9}, 3.7315334872599525`*^9, {3.7315343332903423`*^9, 
   3.7315343338113728`*^9}, {3.731537143952103*^9, 3.7315371515875397`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{"1", "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a_.", "+", 
         RowBox[{"b_.", "*", "x_"}]}], ")"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"c_.", "+", 
         RowBox[{"d_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"e_.", "+", 
         RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"g_.", "+", 
         RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}], ",", "x_Symbol"}], 
   "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "2"}], "*", 
    RowBox[{"Subst", "[", 
     RowBox[{
      RowBox[{"Int", "[", 
       RowBox[{
        RowBox[{"1", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Simp", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"b", "*", "c"}], "-", 
              RowBox[{"a", "*", "d"}], "-", 
              RowBox[{"b", "*", 
               RowBox[{"x", "^", "2"}]}]}], ",", "x"}], "]"}], "*", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"Simp", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"d", "*", "e"}], "-", 
                  RowBox[{"c", "*", "f"}]}], ")"}], "/", "d"}], "+", 
               RowBox[{"f", "*", 
                RowBox[{
                 RowBox[{"x", "^", "2"}], "/", "d"}]}]}], ",", "x"}], "]"}], 
            "]"}], "*", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"Simp", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"d", "*", "g"}], "-", 
                  RowBox[{"c", "*", "h"}]}], ")"}], "/", "d"}], "+", 
               RowBox[{"h", "*", 
                RowBox[{
                 RowBox[{"x", "^", "2"}], "/", "d"}]}]}], ",", "x"}], "]"}], 
            "]"}]}], ")"}]}], ",", "x"}], "]"}], ",", "x", ",", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"c", "+", 
        RowBox[{"d", "*", "x"}]}], "]"}]}], "]"}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"GtQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", "*", "e"}], "-", 
         RowBox[{"c", "*", "f"}]}], ")"}], "/", "d"}], ",", "0"}], 
     "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375206859199123`*^9, 
   3.6375207021947412`*^9}, 3.6375208942208796`*^9, 3.6444424311490264`*^9, {
   3.7315218008379283`*^9, 3.7315218032750673`*^9}, {3.7315333814469004`*^9, 
   3.731533409557508*^9}, {3.7315334568212113`*^9, 3.7315334643776436`*^9}, 
   3.7315343773778644`*^9, 3.7315372567765565`*^9, 3.731537289545431*^9, {
   3.731538289468623*^9, 3.731538307873676*^9}, {3.731538412096637*^9, 
   3.7315384228032494`*^9}, {3.7324876577412696`*^9, 
   3.7324876822996745`*^9}, {3.7325509913605905`*^9, 3.732551011868763*^9}},
 Background->GrayLevel[0.85]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{"1", "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a_.", "+", 
         RowBox[{"b_.", "*", "x_"}]}], ")"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"c_.", "+", 
         RowBox[{"d_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"e_.", "+", 
         RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"g_.", "+", 
         RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}], ",", "x_Symbol"}], 
   "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "2"}], "*", 
    RowBox[{"Subst", "[", 
     RowBox[{
      RowBox[{"Int", "[", 
       RowBox[{
        RowBox[{"1", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Simp", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"b", "*", "c"}], "-", 
              RowBox[{"a", "*", "d"}], "-", 
              RowBox[{"b", "*", 
               RowBox[{"x", "^", "2"}]}]}], ",", "x"}], "]"}], "*", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"Simp", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"d", "*", "e"}], "-", 
                  RowBox[{"c", "*", "f"}]}], ")"}], "/", "d"}], "+", 
               RowBox[{"f", "*", 
                RowBox[{
                 RowBox[{"x", "^", "2"}], "/", "d"}]}]}], ",", "x"}], "]"}], 
            "]"}], "*", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"Simp", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"d", "*", "g"}], "-", 
                  RowBox[{"c", "*", "h"}]}], ")"}], "/", "d"}], "+", 
               RowBox[{"h", "*", 
                RowBox[{
                 RowBox[{"x", "^", "2"}], "/", "d"}]}]}], ",", "x"}], "]"}], 
            "]"}]}], ")"}]}], ",", "x"}], "]"}], ",", "x", ",", 
      RowBox[{"Sqrt", "[", 
       RowBox[{"c", "+", 
        RowBox[{"d", "*", "x"}]}], "]"}]}], "]"}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"Not", "[", 
     RowBox[{"SimplerQ", "[", 
      RowBox[{
       RowBox[{"e", "+", 
        RowBox[{"f", "*", "x"}]}], ",", 
       RowBox[{"c", "+", 
        RowBox[{"d", "*", "x"}]}]}], "]"}], "]"}], " ", "&&", " ", 
    RowBox[{"Not", "[", 
     RowBox[{"SimplerQ", "[", 
      RowBox[{
       RowBox[{"g", "+", 
        RowBox[{"h", "*", "x"}]}], ",", 
       RowBox[{"c", "+", 
        RowBox[{"d", "*", "x"}]}]}], "]"}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375206859199123`*^9, 
   3.6375207021947412`*^9}, 3.6375208942208796`*^9, 3.6444424311490264`*^9, {
   3.7315218008379283`*^9, 3.7315218032750673`*^9}, {3.7315333814469004`*^9, 
   3.731533409557508*^9}, {3.7315334568212113`*^9, 3.7315334643776436`*^9}, 
   3.7315343773778644`*^9, 3.7315372567765565`*^9, 3.731537289545431*^9, {
   3.731538289468623*^9, 3.731538307873676*^9}, {3.731538412096637*^9, 
   3.7315384228032494`*^9}, {3.7324876577412696`*^9, 3.7324876822996745`*^9}, 
   3.7325509463730173`*^9},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["x:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       SqrtBox[
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, {3.6202339053349075`*^9, 
   3.620233905600108*^9}, {3.6247456440521145`*^9, 3.624745644897163*^9}, {
   3.6375223073456144`*^9, 3.6375223085186167`*^9}, {3.639067057738579*^9, 
   3.6390670593146687`*^9}, {3.644442565589716*^9, 3.6444425657907276`*^9}, 
   3.644442601309759*^9, 3.6906631444390926`*^9, {3.690663199701172*^9, 
   3.6906632123011894`*^9}, {3.7327523608822603`*^9, 3.73275236121728*^9}, 
   3.732752726223157*^9, 3.73298841721083*^9, 3.732991825601779*^9, {
   3.734741392823414*^9, 3.7347413931214314`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["\<\
Derivation: Piecewise constant extraction and integration by substitution\
\>", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9, {3.620234434581437*^9, 3.6202344396046457`*^9}, {
   3.690664333768237*^9, 3.690664341188247*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["\[PartialD]", "x"], 
    FractionBox[
     RowBox[{
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "g"}], "-", 
           RowBox[{"a", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "g"}], "-", 
           RowBox[{"c", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}]}]]]}], 
     RowBox[{
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "g"}], "-", 
           RowBox[{"a", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", " ", "x"}]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", " ", "g"}], "-", 
           RowBox[{"e", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}]}]]]}]]}], "\[Equal]", "0"}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}, {3.722480250428427*^9, 
   3.722480250428427*^9}, {3.72248044208939*^9, 3.722480446707654*^9}, {
   3.7346622510944366`*^9, 3.7346622510944366`*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox["1", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"3", "/", "2"}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]], " ", 
     SqrtBox[
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "g"}], "-", 
          RowBox[{"a", " ", "h"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}], ")"}]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"d", " ", "g"}], "-", 
          RowBox[{"c", " ", "h"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}]}]]], " ", 
     SqrtBox[
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "g"}], "-", 
          RowBox[{"a", " ", "h"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"f", " ", "g"}], "-", 
          RowBox[{"e", " ", "h"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}]}]]]}]], "\[Equal]", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["2", 
      RowBox[{
       RowBox[{"b", " ", "g"}], "-", 
       RowBox[{"a", " ", "h"}]}]]}], 
    RowBox[{"Subst", "[", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        SqrtBox[
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", " ", "c"}], "-", 
              RowBox[{"a", " ", "d"}]}], ")"}], " ", 
            SuperscriptBox["x", "2"]}], 
           RowBox[{
            RowBox[{"d", " ", "g"}], "-", 
            RowBox[{"c", " ", "h"}]}]]}]], " ", 
        SqrtBox[
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", " ", "e"}], "-", 
              RowBox[{"a", " ", "f"}]}], ")"}], " ", 
            SuperscriptBox["x", "2"]}], 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}]]}]]}]], ",", "x", ",", 
      FractionBox[
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]], 
       SqrtBox[
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]]]}], "]"}], " ", 
    RowBox[{
     SubscriptBox["\[PartialD]", "x"], 
     FractionBox[
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]], 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]]]}]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}, {3.690664586481409*^9, 
   3.690664586481409*^9}, {3.6906647291955585`*^9, 3.6906647291955585`*^9}, {
   3.7224803179912915`*^9, 3.72248034803301*^9}, {3.7224805866006556`*^9, 
   3.7224805866006556`*^9}, {3.7224810340752497`*^9, 
   3.7224810340752497`*^9}, {3.7224811873540163`*^9, 
   3.7224811873540163`*^9}, {3.7346622957229896`*^9, 3.7346623562894535`*^9}}],

Cell["Rule 1.1.1.4.2.2.1.2.2:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5346428654127264`*^9, 3.5346428654127264`*^9}, {
   3.5346430222260027`*^9, 3.5346430222260027`*^9}, {3.534706547783003*^9, 
   3.534706547783003*^9}, {3.549762992727182*^9, 3.549762992727182*^9}, {
   3.5498518507891617`*^9, 3.5498518507891617`*^9}, {3.5498619240544662`*^9, 
   3.5498619240544662`*^9}, {3.5499243006306405`*^9, 
   3.5499243006306405`*^9}, {3.611357201729041*^9, 3.611357201729041*^9}, {
   3.620233486271372*^9, 3.620233486271372*^9}, 3.644442569629947*^9, 
   3.65016060813413*^9, {3.6501608631237144`*^9, 3.6501608639767632`*^9}, {
   3.690663566866756*^9, 3.690663567106756*^9}, 3.698684025133456*^9, 
   3.7324999230338044`*^9, {3.7333371863700867`*^9, 3.73333718799718*^9}, {
   3.733337518558087*^9, 3.733337520153178*^9}}],

Cell[BoxData[{
 RowBox[{"\[Integral]", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     SqrtBox[
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]]}]], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"c", "+", 
            RowBox[{"d", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "g"}], "-", 
            RowBox[{"c", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"e", "+", 
            RowBox[{"f", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]]}], 
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]]}]]}]}], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"3", "/", "2"}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"c", "+", 
            RowBox[{"d", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "g"}], "-", 
            RowBox[{"c", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"e", "+", 
            RowBox[{"f", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"  ", 
  RowBox[{
   RowBox[{"\[LongRightArrow]", "  ", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"c", "+", 
            RowBox[{"d", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "g"}], "-", 
            RowBox[{"c", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"e", "+", 
            RowBox[{"f", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", " ", "g"}], "-", 
         RowBox[{"a", " ", "h"}]}], ")"}], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]]}]]}]}], " ", 
   RowBox[{"Subst", "[", 
    RowBox[{
     RowBox[{"\[Integral]", 
      RowBox[{
       FractionBox["1", 
        RowBox[{
         SqrtBox[
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"b", " ", "c"}], "-", 
               RowBox[{"a", " ", "d"}]}], ")"}], " ", 
             SuperscriptBox["x", "2"]}], 
            RowBox[{
             RowBox[{"d", " ", "g"}], "-", 
             RowBox[{"c", " ", "h"}]}]]}]], " ", 
         SqrtBox[
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"b", " ", "e"}], "-", 
               RowBox[{"a", " ", "f"}]}], ")"}], " ", 
             SuperscriptBox["x", "2"]}], 
            RowBox[{
             RowBox[{"f", " ", "g"}], "-", 
             RowBox[{"e", " ", "h"}]}]]}]]}]], 
       RowBox[{"\[DifferentialD]", "x"}]}]}], ",", "x", ",", 
     FractionBox[
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]], 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]]]}], "]"}]}]}]}], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.7224803930805864`*^9, 
   3.7224804651227074`*^9, {3.7224805221639695`*^9, 3.7224805548348384`*^9}, 
   3.7224806131601744`*^9, {3.722480934292542*^9, 3.7224809675474443`*^9}, {
   3.7224812494545684`*^9, 3.7224812551218925`*^9}, {3.722481286776703*^9, 
   3.7224813150973225`*^9}, {3.722481348597239*^9, 3.722481393962834*^9}, {
   3.734662358424576*^9, 3.7346623641619043`*^9}, {3.7346625193197784`*^9, 
   3.7346625489124713`*^9}, {3.7346626239377623`*^9, 3.734662657336673*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Int", "[", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"a_.", "+", 
          RowBox[{"b_.", "*", "x_"}]}], "]"}], "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"c_.", "+", 
          RowBox[{"d_.", "*", "x_"}]}], "]"}], "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"e_.", "+", 
          RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"g_.", "+", 
          RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}], ",", "x_Symbol"}], 
    "]"}], " ", ":=", "\n", "  ", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], "*", 
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", "*", "x"}]}], ")"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", "*", "g"}], "-", 
         RowBox[{"a", "*", "h"}]}], ")"}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", "*", "x"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", "*", "g"}], "-", 
            RowBox[{"c", "*", "h"}]}], ")"}], "*", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", "*", "x"}]}], ")"}]}], ")"}]}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "g"}], "-", 
          RowBox[{"a", "*", "h"}]}], ")"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"f", "*", "g"}], "-", 
             RowBox[{"e", "*", "h"}]}], ")"}], "*", 
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", "*", "x"}]}], ")"}]}], ")"}]}]}], "]"}], "/", 
      "\[IndentingNewLine]", "    ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "g"}], "-", 
          RowBox[{"a", "*", "h"}]}], ")"}], "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"c", "+", 
          RowBox[{"d", "*", "x"}]}], "]"}], "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"e", "+", 
          RowBox[{"f", "*", "x"}]}], "]"}]}], ")"}]}], "*", "\n", "    ", 
     RowBox[{"Subst", "[", 
      RowBox[{
       RowBox[{"Int", "[", 
        RowBox[{
         RowBox[{"1", "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Sqrt", "[", 
             RowBox[{"1", "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"b", "*", "c"}], "-", 
                 RowBox[{"a", "*", "d"}]}], ")"}], "*", 
               RowBox[{
                RowBox[{"x", "^", "2"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"d", "*", "g"}], "-", 
                  RowBox[{"c", "*", "h"}]}], ")"}]}]}]}], "]"}], "*", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"1", "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"b", "*", "e"}], "-", 
                 RowBox[{"a", "*", "f"}]}], ")"}], "*", 
               RowBox[{
                RowBox[{"x", "^", "2"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"f", "*", "g"}], "-", 
                  RowBox[{"e", "*", "h"}]}], ")"}]}]}]}], "]"}]}], ")"}]}], 
         ",", "x"}], "]"}], ",", "x", ",", 
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"g", "+", 
          RowBox[{"h", "*", "x"}]}], "]"}], "/", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"a", "+", 
          RowBox[{"b", "*", "x"}]}], "]"}]}]}], "]"}]}], " ", "/;", "\n", 
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h"}], "}"}], ",", "x"}], "]"}]}]}], " ", "*)"}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, 3.637524238038328*^9, 
   3.6444425736891794`*^9, {3.690664998252344*^9, 3.690664998422344*^9}, 
   3.6906650477132215`*^9, {3.722481549067705*^9, 3.7224815553240633`*^9}, {
   3.7346628458734565`*^9, 3.7346628500696964`*^9}, 3.734663023356608*^9, {
   3.73474138331787*^9, 3.7347413878681307`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["2:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       SqrtBox[
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, {3.6202339053349075`*^9, 
   3.620233905600108*^9}, {3.6247456440521145`*^9, 3.624745644897163*^9}, {
   3.6375223073456144`*^9, 3.6375223085186167`*^9}, {3.639067057738579*^9, 
   3.6390670593146687`*^9}, {3.644442565589716*^9, 3.6444425657907276`*^9}, 
   3.644442601309759*^9, 3.6906631444390926`*^9, {3.690663199701172*^9, 
   3.6906632123011894`*^9}, {3.7327523608822603`*^9, 3.73275236121728*^9}, 
   3.732752726223157*^9, 3.73298841721083*^9, 3.732991825601779*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell["\<\
Derivation: Piecewise constant extraction and integration by substitution\
\>", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9, {3.620234434581437*^9, 3.6202344396046457`*^9}, {
   3.690664333768237*^9, 3.690664341188247*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["\[PartialD]", "x"], 
    FractionBox[
     RowBox[{
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]], " ", 
      SqrtBox[
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "e"}], "-", 
           RowBox[{"a", " ", "f"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "e"}], "-", 
           RowBox[{"c", " ", "f"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}]}]]]}], 
     RowBox[{
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "e"}], "-", 
            RowBox[{"a", " ", "f"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"g", "+", 
            RowBox[{"h", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]}]]}]]}], "\[Equal]", "0"}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}, {3.722480250428427*^9, 
   3.722480250428427*^9}, {3.72248044208939*^9, 3.722480446707654*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox["1", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"3", "/", "2"}]], " ", 
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "e"}], "-", 
          RowBox[{"a", " ", "f"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}], ")"}]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"d", " ", "e"}], "-", 
          RowBox[{"c", " ", "f"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}]}]]], " ", 
     SqrtBox[
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "b"}], " ", "e"}], "+", 
          RowBox[{"a", " ", "f"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}], ")"}]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"f", " ", "g"}], "-", 
          RowBox[{"e", " ", "h"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}]}]]]}]], "\[Equal]", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["2", 
      RowBox[{
       RowBox[{"b", " ", "e"}], "-", 
       RowBox[{"a", " ", "f"}]}]]}], 
    RowBox[{"Subst", "[", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        SqrtBox[
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", " ", "c"}], "-", 
              RowBox[{"a", " ", "d"}]}], ")"}], " ", 
            SuperscriptBox["x", "2"]}], 
           RowBox[{
            RowBox[{"d", " ", "e"}], "-", 
            RowBox[{"c", " ", "f"}]}]]}]], " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", " ", "g"}], "-", 
              RowBox[{"a", " ", "h"}]}], ")"}], " ", 
            SuperscriptBox["x", "2"]}], 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}]]}]]}]], ",", "x", ",", 
      FractionBox[
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], 
       SqrtBox[
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]]]}], "]"}], " ", 
    RowBox[{
     SubscriptBox["\[PartialD]", "x"], 
     FractionBox[
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]]]}]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}, {3.690664586481409*^9, 
   3.690664586481409*^9}, {3.6906647291955585`*^9, 3.6906647291955585`*^9}, {
   3.7224803179912915`*^9, 3.72248034803301*^9}, {3.7224805866006556`*^9, 
   3.7224805866006556`*^9}, {3.7224810340752497`*^9, 
   3.7224810340752497`*^9}, {3.7224811873540163`*^9, 3.7224811873540163`*^9}}],

Cell["Rule 1.1.1.4.2.2.1.2.2:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5346428654127264`*^9, 3.5346428654127264`*^9}, {
   3.5346430222260027`*^9, 3.5346430222260027`*^9}, {3.534706547783003*^9, 
   3.534706547783003*^9}, {3.549762992727182*^9, 3.549762992727182*^9}, {
   3.5498518507891617`*^9, 3.5498518507891617`*^9}, {3.5498619240544662`*^9, 
   3.5498619240544662`*^9}, {3.5499243006306405`*^9, 
   3.5499243006306405`*^9}, {3.611357201729041*^9, 3.611357201729041*^9}, {
   3.620233486271372*^9, 3.620233486271372*^9}, 3.644442569629947*^9, 
   3.65016060813413*^9, {3.6501608631237144`*^9, 3.6501608639767632`*^9}, {
   3.690663566866756*^9, 3.690663567106756*^9}, 3.698684025133456*^9, 
   3.7324999230338044`*^9, {3.7333371863700867`*^9, 3.73333718799718*^9}, {
   3.733337518558087*^9, 3.733337520153178*^9}}],

Cell[BoxData[{
 RowBox[{"\[Integral]", 
  RowBox[{
   FractionBox["1", 
    RowBox[{
     SqrtBox[
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]]}]], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
     RowBox[{"-", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "e"}], "-", 
          RowBox[{"a", " ", "f"}]}], ")"}], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]], " ", 
        SqrtBox[
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"b", " ", "e"}], "-", 
             RowBox[{"a", " ", "f"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"c", "+", 
             RowBox[{"d", " ", "x"}]}], ")"}]}], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "e"}], "-", 
             RowBox[{"c", " ", "f"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", " ", "x"}]}], ")"}]}]]]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"f", " ", "g"}], "-", 
          RowBox[{"e", " ", "h"}]}], ")"}], " ", 
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"-", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", " ", "e"}], "-", 
              RowBox[{"a", " ", "f"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"g", "+", 
              RowBox[{"h", " ", "x"}]}], ")"}]}], 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", " ", "g"}], "-", 
              RowBox[{"e", " ", "h"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"b", " ", "x"}]}], ")"}]}]]}]]}]]}]}]}], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"3", "/", "2"}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "e"}], "-", 
            RowBox[{"a", " ", "f"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"c", "+", 
            RowBox[{"d", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "e"}], "-", 
            RowBox[{"c", " ", "f"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "b"}], " ", "e"}], "+", 
            RowBox[{"a", " ", "f"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"g", "+", 
            RowBox[{"h", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"  ", 
  RowBox[{
   RowBox[{"\[LongRightArrow]", "  ", 
    FractionBox[
     RowBox[{"2", " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]], " ", 
      SqrtBox[
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "e"}], "-", 
           RowBox[{"a", " ", "f"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "e"}], "-", 
           RowBox[{"c", " ", "f"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}]}]]]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"f", " ", "g"}], "-", 
        RowBox[{"e", " ", "h"}]}], ")"}], " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "e"}], "-", 
            RowBox[{"a", " ", "f"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"g", "+", 
            RowBox[{"h", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]}]]}]]}], " ", 
   RowBox[{"Subst", "[", 
    RowBox[{
     RowBox[{"\[Integral]", 
      RowBox[{
       FractionBox["1", 
        RowBox[{
         SqrtBox[
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"b", " ", "c"}], "-", 
               RowBox[{"a", " ", "d"}]}], ")"}], " ", 
             SuperscriptBox["x", "2"]}], 
            RowBox[{
             RowBox[{"d", " ", "e"}], "-", 
             RowBox[{"c", " ", "f"}]}]]}]], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"b", " ", "g"}], "-", 
               RowBox[{"a", " ", "h"}]}], ")"}], " ", 
             SuperscriptBox["x", "2"]}], 
            RowBox[{
             RowBox[{"f", " ", "g"}], "-", 
             RowBox[{"e", " ", "h"}]}]]}]]}]], 
       RowBox[{"\[DifferentialD]", "x"}]}]}], ",", "x", ",", 
     FractionBox[
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]]]}], "]"}]}]}]}], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.7224803930805864`*^9, 
   3.7224804651227074`*^9, {3.7224805221639695`*^9, 3.7224805548348384`*^9}, 
   3.7224806131601744`*^9, {3.722480934292542*^9, 3.7224809675474443`*^9}, {
   3.7224812494545684`*^9, 3.7224812551218925`*^9}, {3.722481286776703*^9, 
   3.7224813150973225`*^9}, {3.722481348597239*^9, 3.722481393962834*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{"1", "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Sqrt", "[", 
        RowBox[{"a_.", "+", 
         RowBox[{"b_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"c_.", "+", 
         RowBox[{"d_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"e_.", "+", 
         RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"g_.", "+", 
         RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}], ",", "x_Symbol"}], 
   "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{"2", "*", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"g", "+", 
      RowBox[{"h", "*", "x"}]}], "]"}], "*", 
    RowBox[{
     RowBox[{"Sqrt", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", "*", "e"}], "-", 
         RowBox[{"a", "*", "f"}]}], ")"}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", "*", "x"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", "*", "e"}], "-", 
            RowBox[{"c", "*", "f"}]}], ")"}], "*", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", "*", "x"}]}], ")"}]}], ")"}]}]}], "]"}], "/", "\n", 
     "    ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"f", "*", "g"}], "-", 
         RowBox[{"e", "*", "h"}]}], ")"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"c", "+", 
         RowBox[{"d", "*", "x"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", "*", "e"}], "-", 
            RowBox[{"a", "*", "f"}]}], ")"}]}], "*", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", "*", "g"}], "-", 
              RowBox[{"e", "*", "h"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"b", "*", "x"}]}], ")"}]}], ")"}]}]}], "]"}]}], ")"}]}],
     "*", "\n", "    ", 
    RowBox[{"Subst", "[", 
     RowBox[{
      RowBox[{"Int", "[", 
       RowBox[{
        RowBox[{"1", "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"b", "*", "c"}], "-", 
                RowBox[{"a", "*", "d"}]}], ")"}], "*", 
              RowBox[{
               RowBox[{"x", "^", "2"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "e"}], "-", 
                 RowBox[{"c", "*", "f"}]}], ")"}]}]}]}], "]"}], "*", 
           RowBox[{"Sqrt", "[", 
            RowBox[{"1", "-", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"b", "*", "g"}], "-", 
                RowBox[{"a", "*", "h"}]}], ")"}], "*", 
              RowBox[{
               RowBox[{"x", "^", "2"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", "*", "g"}], "-", 
                 RowBox[{"e", "*", "h"}]}], ")"}]}]}]}], "]"}]}], ")"}]}], 
        ",", "x"}], "]"}], ",", "x", ",", 
      RowBox[{
       RowBox[{"Sqrt", "[", 
        RowBox[{"e", "+", 
         RowBox[{"f", "*", "x"}]}], "]"}], "/", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"a", "+", 
         RowBox[{"b", "*", "x"}]}], "]"}]}]}], "]"}]}], " ", "/;", "\n", 
   RowBox[{"FreeQ", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
       "h"}], "}"}], ",", "x"}], "]"}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, 3.637524238038328*^9, 
   3.6444425736891794`*^9, {3.690664998252344*^9, 3.690664998422344*^9}, 
   3.6906650477132215`*^9, {3.722481549067705*^9, 3.7224815553240633`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["3:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"3", "/", "2"}]], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, 3.6202339138681226`*^9, {
   3.624745639354846*^9, 3.6247456402468967`*^9}, {3.637522303714407*^9, 
   3.6375223060594115`*^9}, 3.6390669973751264`*^9, {3.6444425214011884`*^9, 
   3.6444425218222127`*^9}, 3.6444425997666707`*^9, 3.6906631382090836`*^9, 
   3.6906631976551685`*^9, {3.6906632334152193`*^9, 3.69066323360522*^9}, {
   3.6908496403632865`*^9, 3.690849646876659*^9}, {3.690918151709073*^9, 
   3.690918174845914*^9}, {3.6909187007528286`*^9, 3.6909187009712296`*^9}, 
   3.6909189261972537`*^9, {3.732752404179737*^9, 3.73275240440375*^9}, 
   3.732752726735186*^9, 3.7329884178578672`*^9, 3.7329918261438103`*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic expansion", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9, {3.620234434581437*^9, 3.6202344396046457`*^9}, {
   3.690664333768237*^9, 3.690664341188247*^9}, {3.6908496587223363`*^9, 
   3.6908496620505266`*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox["1", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"3", "/", "2"}]], " ", 
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]]}]], "\[Equal]", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["d", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", " ", "c"}], "-", 
         RowBox[{"a", " ", "d"}]}], ")"}], " ", 
       SqrtBox[
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]]}]]}], "+", 
    FractionBox[
     RowBox[{"b", " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "c"}], "-", 
        RowBox[{"a", " ", "d"}]}], ")"}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], 
       RowBox[{"3", "/", "2"}]]}]]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}, {3.6908497024188356`*^9, 
   3.6908497024188356`*^9}, {3.6908497702987185`*^9, 
   3.6908497777081423`*^9}, {3.6909182398904285`*^9, 
   3.6909182398904285`*^9}, {3.6909185633818045`*^9, 
   3.6909185633818045`*^9}, {3.6909189061940184`*^9, 3.6909189061940184`*^9}}],

Cell["Rule 1.1.1.4.2.2.1.2.3:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5346428654127264`*^9, 3.5346428654127264`*^9}, {
   3.5346430222260027`*^9, 3.5346430222260027`*^9}, {3.534706547783003*^9, 
   3.534706547783003*^9}, {3.549762992727182*^9, 3.549762992727182*^9}, {
   3.5498518507891617`*^9, 3.5498518507891617`*^9}, {3.5498619240544662`*^9, 
   3.5498619240544662`*^9}, {3.5499243006306405`*^9, 
   3.5499243006306405`*^9}, {3.611357201729041*^9, 3.611357201729041*^9}, {
   3.620233486271372*^9, 3.620233486271372*^9}, 3.644442526707492*^9, 
   3.6501606069260607`*^9, {3.6501608506620016`*^9, 3.650160851202033*^9}, {
   3.6906635832577796`*^9, 3.69066358350778*^9}, {3.6908497163326316`*^9, 
   3.6908497165996466`*^9}, 3.6986840253634567`*^9, 3.732499927600065*^9, {
   3.7333371936905055`*^9, 3.7333371948825736`*^9}, {3.733337532367877*^9, 
   3.7333375349120226`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["1", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], 
       RowBox[{"3", "/", "2"}]], " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{
     "x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"-", 
       FractionBox["d", 
        RowBox[{
         RowBox[{"b", " ", "c"}], "-", 
         RowBox[{"a", " ", "d"}]}]]}]}]}], " ", 
    RowBox[{"\[Integral]", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        SqrtBox[
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}]], 
      RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "+", 
  RowBox[{
   FractionBox["b", 
    RowBox[{
     RowBox[{"b", " ", "c"}], "-", 
     RowBox[{"a", " ", "d"}]}]], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"3", "/", "2"}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906862370138397`*^9, 
   3.690686270846775*^9, 3.6906865143317013`*^9, {3.690686592792189*^9, 
   3.690686597382452*^9}, {3.690849723898064*^9, 3.6908497599941287`*^9}, {
   3.690849801173484*^9, 3.6908499318219566`*^9}, {3.6909182528112516`*^9, 
   3.6909183250141788`*^9}, {3.690918461184822*^9, 3.6909185025804973`*^9}, 
   3.6909189181320395`*^9, {3.690918949379696*^9, 3.690918982967555*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{"1", "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a_.", "+", 
          RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"3", "/", "2"}], ")"}]}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"c_.", "+", 
         RowBox[{"d_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"e_.", "+", 
         RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"g_.", "+", 
         RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}], ",", "x_Symbol"}], 
   "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "d"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "c"}], "-", 
        RowBox[{"a", "*", "d"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{"a", "+", 
            RowBox[{"b", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"c", "+", 
            RowBox[{"d", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"e", "+", 
            RowBox[{"f", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ",", "x"}], "]"}]}], 
    " ", "+", " ", "\n", "  ", 
    RowBox[{
     RowBox[{"b", "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "c"}], "-", 
        RowBox[{"a", "*", "d"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"c", "+", 
          RowBox[{"d", "*", "x"}]}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", "*", "x"}]}], ")"}], "^", 
           RowBox[{"(", 
            RowBox[{"3", "/", "2"}], ")"}]}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"e", "+", 
            RowBox[{"f", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{"FreeQ", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
       "h"}], "}"}], ",", "x"}], "]"}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375238754486885`*^9, 
   3.63752389858753*^9}, 3.6444425309977374`*^9, {3.6906621348624887`*^9, 
   3.6906621495825095`*^9}, {3.6906867607807975`*^9, 3.6906867777757697`*^9}, 
   3.690686824907466*^9, {3.690849985562031*^9, 3.690849989333246*^9}, {
   3.6908500749581437`*^9, 3.6908501341015263`*^9}, {3.6909186460285316`*^9, 
   3.6909186738689814`*^9}, {3.6909190279640346`*^9, 3.6909190372304506`*^9}, 
   3.690919124233404*^9},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["4:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{"m", "\[LessEqual]", 
        RowBox[{"-", "2"}]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, 3.6202339138681226`*^9, {
   3.624745639354846*^9, 3.6247456402468967`*^9}, {3.637522303714407*^9, 
   3.6375223060594115`*^9}, 3.6390669973751264`*^9, {3.6444425214011884`*^9, 
   3.6444425218222127`*^9}, 3.6444425997666707`*^9, 3.6906631382090836`*^9, 
   3.6906631976551685`*^9, {3.6906632334152193`*^9, 3.69066323360522*^9}, {
   3.7327330816756277`*^9, 3.7327330924772453`*^9}, {3.732734032900035*^9, 
   3.7327340368592615`*^9}, {3.732734582462468*^9, 3.7327345828194885`*^9}, 
   3.7327379415195203`*^9, 3.7327405597332735`*^9, {3.732740645977206*^9, 
   3.7327406461742177`*^9}, 3.7327521719874563`*^9, 3.732752727257216*^9, {
   3.7327545912548304`*^9, 3.7327545967611456`*^9}, 3.732988418497904*^9, {
   3.7329915149100084`*^9, 3.732991520063303*^9}, 3.7329918267738457`*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell[TextData[{
 "Rule",
 " 1.1.1.4.2.2.1.2.4",
 ": If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], " ", 
   "\[And]", " ", 
   RowBox[{"m", "\[LessEqual]", 
    RowBox[{"-", "2"}]}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5269270224625387`*^9, 3.5269270224625387`*^9}, {
   3.5305583575562735`*^9, 3.530558360660679*^9}, {3.5347074228665404`*^9, 
   3.5347074228665404`*^9}, {3.549823103506521*^9, 3.549823103506521*^9}, {
   3.611356258837721*^9, 3.611356258837721*^9}, {3.63917293207978*^9, 
   3.63917293208078*^9}, 3.6501606099462337`*^9, 3.650160886705063*^9, {
   3.6906636169318275`*^9, 3.6906636171718283`*^9}, 3.698684025703457*^9, {
   3.7324999650142055`*^9, 3.73249996526722*^9}, {3.7327340558413467`*^9, 
   3.7327340651808815`*^9}, {3.732754601702428*^9, 3.732754601702428*^9}, {
   3.7329915272177124`*^9, 3.7329915272177124`*^9}, 3.7333372025660133`*^9, {
   3.733337546790702*^9, 3.733337548494799*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
     RowBox[{
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{
     "x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{
        SuperscriptBox["b", "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}], 
         RowBox[{"m", "+", "1"}]], " ", 
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "c"}], "-", 
          RowBox[{"a", " ", "d"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "e"}], "-", 
          RowBox[{"a", " ", "f"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "g"}], "-", 
          RowBox[{"a", " ", "h"}]}], ")"}]}]]}]}]}]}], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{"m", "+", "1"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", " ", "c"}], "-", 
       RowBox[{"a", " ", "d"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", " ", "e"}], "-", 
       RowBox[{"a", " ", "f"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", " ", "g"}], "-", 
       RowBox[{"a", " ", "h"}]}], ")"}]}]], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"m", "+", "1"}]], 
       RowBox[{
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}]], "\[CenterDot]", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", 
         SuperscriptBox["a", "2"], " ", "d", " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "-", 
        RowBox[{"2", " ", "a", " ", "b", " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "f", " ", "g"}], "+", 
           RowBox[{"d", " ", "e", " ", "h"}], "+", 
           RowBox[{"c", " ", "f", " ", "h"}]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["b", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "m"}], "+", "3"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "e", " ", "g"}], "+", 
           RowBox[{"c", " ", "f", " ", "g"}], "+", 
           RowBox[{"c", " ", "e", " ", "h"}]}], ")"}]}], "-", 
        RowBox[{"2", " ", "b", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"a", " ", "d", " ", "f", " ", "h", " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "-", 
           RowBox[{"b", " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "2"}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "f", " ", "g"}], "+", 
              RowBox[{"d", " ", "e", " ", "h"}], "+", 
              RowBox[{"c", " ", "f", " ", "h"}]}], ")"}]}]}], ")"}], " ", 
         "x"}], "+", 
        RowBox[{"d", " ", "f", " ", "h", " ", 
         SuperscriptBox["b", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "m"}], "+", "5"}], ")"}], " ", 
         SuperscriptBox["x", "2"]}]}], ")"}]}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906862370138397`*^9, 
   3.690686270846775*^9, 3.6906865143317013`*^9, {3.690686592792189*^9, 
   3.690686597382452*^9}, {3.7327331215549088`*^9, 3.7327331395009356`*^9}, {
   3.7327331887557526`*^9, 3.732733214749239*^9}, {3.732733257841704*^9, 
   3.7327333953595695`*^9}, {3.7327345913469763`*^9, 3.732734696479989*^9}, {
   3.7327347282478065`*^9, 3.732734752345185*^9}, {3.732734822447194*^9, 
   3.732734831705724*^9}, 3.7327359959442396`*^9, {3.7327360341624255`*^9, 
   3.732736042400897*^9}, 3.7328578818496017`*^9},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Sqrt", "[", 
        RowBox[{"c_.", "+", 
         RowBox[{"d_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"e_.", "+", 
         RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"g_.", "+", 
         RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}], ",", "x_Symbol"}], 
   "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"b", "^", "2"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"c", "+", 
       RowBox[{"d", "*", "x"}]}], "]"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"e", "+", 
       RowBox[{"f", "*", "x"}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"g", "+", 
        RowBox[{"h", "*", "x"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "c"}], "-", 
          RowBox[{"a", "*", "d"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "g"}], "-", 
          RowBox[{"a", "*", "h"}]}], ")"}]}], ")"}]}]}], " ", "-", " ", 
    "\[IndentingNewLine]", "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"2", "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "c"}], "-", 
          RowBox[{"a", "*", "d"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "g"}], "-", 
          RowBox[{"a", "*", "h"}]}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", "*", "x"}]}], ")"}], "^", 
           RowBox[{"(", 
            RowBox[{"m", "+", "1"}], ")"}]}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Sqrt", "[", 
             RowBox[{"c", "+", 
              RowBox[{"d", "*", "x"}]}], "]"}], "*", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"e", "+", 
              RowBox[{"f", "*", "x"}]}], "]"}], "*", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"g", "+", 
              RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ")"}], "*", "\n", 
        "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"2", "*", 
            RowBox[{"a", "^", "2"}], "*", "d", "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "-", 
           RowBox[{"2", "*", "a", "*", "b", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", "*", "f", "*", "g"}], "+", 
              RowBox[{"d", "*", "e", "*", "h"}], "+", 
              RowBox[{"c", "*", "f", "*", "h"}]}], ")"}]}], "+", 
           RowBox[{
            RowBox[{"b", "^", "2"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "*", "m"}], "+", "3"}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", "*", "e", "*", "g"}], "+", 
              RowBox[{"c", "*", "f", "*", "g"}], "+", 
              RowBox[{"c", "*", "e", "*", "h"}]}], ")"}]}], " ", "-", " ", 
           "\[IndentingNewLine]", "      ", 
           RowBox[{"2", "*", "b", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"a", "*", "d", "*", "f", "*", "h", "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "1"}], ")"}]}], "-", 
              RowBox[{"b", "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "2"}], ")"}], "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "f", "*", "g"}], "+", 
                 RowBox[{"d", "*", "e", "*", "h"}], "+", 
                 RowBox[{"c", "*", "f", "*", "h"}]}], ")"}]}]}], ")"}], "*", 
            "x"}], " ", "+", " ", 
           RowBox[{"d", "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "*", "m"}], "+", "5"}], ")"}], "*", 
            RowBox[{"b", "^", "2"}], "*", 
            RowBox[{"x", "^", "2"}]}]}], ",", "x"}], "]"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"IntegerQ", "[", 
     RowBox[{"2", "*", "m"}], "]"}], " ", "&&", " ", 
    RowBox[{"LeQ", "[", 
     RowBox[{"m", ",", 
      RowBox[{"-", "2"}]}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375238754486885`*^9, 
   3.63752389858753*^9}, 3.6444425309977374`*^9, {3.6906621348624887`*^9, 
   3.6906621495825095`*^9}, {3.6906867607807975`*^9, 3.6906867777757697`*^9}, 
   3.690686824907466*^9, {3.732733463768482*^9, 3.732733550071419*^9}, {
   3.73273385500686*^9, 3.732733916393371*^9}, {3.7327339528134537`*^9, 
   3.7327339633430567`*^9}, 3.732734128646511*^9, {3.7327342384447913`*^9, 
   3.732734296346103*^9}, {3.732734393919684*^9, 3.7327344161499557`*^9}, {
   3.7327348742871594`*^9, 3.732734945992261*^9}, {3.732734980528236*^9, 
   3.7327349822293334`*^9}, 3.7327360101010494`*^9, {3.732754604639596*^9, 
   3.732754606697714*^9}, {3.732991531148937*^9, 3.732991533907095*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t", 
  RowBox[{Cell[TextData[StyleBox["2.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]]}], 
      RowBox[{
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}]]]], 
      "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.539393717282713*^9, 3.5393937175197268`*^9}, {3.5393939972431717`*^9, 
   3.5393939972431717`*^9}, {3.54976183300485*^9, 3.549761843369443*^9}, 
   3.5497618783514433`*^9, {3.5498272575323367`*^9, 3.5498272577023373`*^9}, {
   3.5498590820409126`*^9, 3.549859083098973*^9}, {3.549861971973207*^9, 
   3.549861974052326*^9}, {3.5499239781513543`*^9, 3.5499239781513543`*^9}, {
   3.5716376069321833`*^9, 3.5716376095821867`*^9}, 3.571704053418295*^9, {
   3.571705098009757*^9, 3.5717051012397614`*^9}, 3.5717051920898886`*^9, 
   3.5758229151368937`*^9, 3.61151142537963*^9, {3.6375210294106445`*^9, 
   3.6375211225176077`*^9}, {3.644442260768281*^9, 3.644442260768281*^9}, {
   3.644442312905263*^9, 3.64444231686749*^9}, 3.647390660600108*^9, {
   3.6473907736905766`*^9, 3.647390819717209*^9}, {3.6473912085964518`*^9, 
   3.647391208843466*^9}, {3.6473912679138446`*^9, 3.6473912679138446`*^9}, {
   3.647396300569696*^9, 3.6473963246130714`*^9}, {3.6906631681351275`*^9, 
   3.6906631683951283`*^9}, {3.6906632461472373`*^9, 
   3.6906632887133045`*^9}, {3.732499894755187*^9, 3.732499895072205*^9}, {
   3.7327608903751197`*^9, 3.732760890625134*^9}, {3.7327722265444784`*^9, 
   3.732772237144493*^9}, {3.7327729017054234`*^9, 3.732772901935424*^9}, 
   3.7329885195756855`*^9, 3.732991827380881*^9, {3.7329919937853985`*^9, 
   3.7329919940294123`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["1.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]]}], 
      RowBox[{
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{"m", ">", "0"}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.539393717282713*^9, 3.5393937175197268`*^9}, {3.5393939972431717`*^9, 
   3.5393939972431717`*^9}, {3.54976183300485*^9, 3.549761843369443*^9}, 
   3.5497618783514433`*^9, {3.5498272575323367`*^9, 3.5498272577023373`*^9}, {
   3.5498590820409126`*^9, 3.549859083098973*^9}, {3.549861971973207*^9, 
   3.549861974052326*^9}, {3.5499239781513543`*^9, 3.5499239781513543`*^9}, {
   3.5716376069321833`*^9, 3.5716376095821867`*^9}, 3.571704053418295*^9, {
   3.571705098009757*^9, 3.5717051012397614`*^9}, 3.5717051920898886`*^9, 
   3.5758229151368937`*^9, 3.61151142537963*^9, {3.6375210294106445`*^9, 
   3.6375211225176077`*^9}, {3.644442260768281*^9, 3.644442260768281*^9}, {
   3.644442312905263*^9, 3.64444231686749*^9}, 3.647390660600108*^9, {
   3.6473907736905766`*^9, 3.647390819717209*^9}, {3.6473912085964518`*^9, 
   3.647391208843466*^9}, {3.6473912679138446`*^9, 3.6473912679138446`*^9}, {
   3.647396300569696*^9, 3.6473963246130714`*^9}, {3.6906631681351275`*^9, 
   3.6906631683951283`*^9}, {3.6906632461472373`*^9, 
   3.6906632887133045`*^9}, {3.732499894755187*^9, 3.732499895072205*^9}, {
   3.7327608903751197`*^9, 3.732760890625134*^9}, {3.7327722265444784`*^9, 
   3.732772237144493*^9}, {3.7327729017054234`*^9, 3.732772901935424*^9}, {
   3.7328536690666447`*^9, 3.732853685840604*^9}, 3.732988520277725*^9, 
   3.7329918279909153`*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["1:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SqrtBox[
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]]}], 
      RowBox[{
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, 3.6202339138681226`*^9, {
   3.624745639354846*^9, 3.6247456402468967`*^9}, {3.637522303714407*^9, 
   3.6375223060594115`*^9}, 3.6390669973751264`*^9, {3.6444425214011884`*^9, 
   3.6444425218222127`*^9}, 3.6444425997666707`*^9, 3.6906631382090836`*^9, 
   3.6906631976551685`*^9, {3.6906632334152193`*^9, 3.69066323360522*^9}, {
   3.6908496403632865`*^9, 3.690849646876659*^9}, {3.6909187075544405`*^9, 
   3.690918707788441*^9}, {3.73275247923503*^9, 3.73275247941304*^9}, {
   3.7327718291239223`*^9, 3.732771829393922*^9}, {3.7327718781639905`*^9, 
   3.732771878453991*^9}, {3.7328064198553925`*^9, 3.732806420453427*^9}, {
   3.732807370646775*^9, 3.7328073709087896`*^9}, 3.7328537085979056`*^9, 
   3.732988535203579*^9, 3.73299182982102*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic expansion", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9, {3.620234434581437*^9, 3.6202344396046457`*^9}, {
   3.690664333768237*^9, 3.690664341188247*^9}, {3.6908496587223363`*^9, 
   3.6908496620505266`*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    RowBox[{
     SqrtBox[
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]]}], 
    RowBox[{
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]]}]], "\[Equal]", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[PartialD]", "x"], 
     FractionBox[
      RowBox[{
       SqrtBox[
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}], 
      RowBox[{"h", " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]]}]]}], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", " ", "e"}], "-", 
        RowBox[{"c", " ", "f"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "f", " ", "g"}], "+", 
        RowBox[{"b", " ", "e", " ", "h"}], "-", 
        RowBox[{"2", " ", "a", " ", "f", " ", "h"}]}], ")"}]}], 
     RowBox[{"2", " ", 
      SuperscriptBox["f", "2"], " ", "h", " ", 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"a", " ", "d", " ", "f", " ", "h"}], "-", 
        RowBox[{"b", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "f", " ", "g"}], "+", 
           RowBox[{"d", " ", "e", " ", "h"}], "-", 
           RowBox[{"c", " ", "f", " ", "h"}]}], ")"}]}]}], ")"}], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]]}], 
     RowBox[{"2", " ", 
      SuperscriptBox["f", "2"], " ", "h", " ", 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]], "-", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", " ", "e"}], "-", 
        RowBox[{"c", " ", "f"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"f", " ", "g"}], "-", 
        RowBox[{"e", " ", "h"}]}], ")"}], " ", 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]]}], 
     RowBox[{"2", " ", "f", " ", "h", " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], 
       RowBox[{"3", "/", "2"}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}, {3.6908497024188356`*^9, 
   3.6908497024188356`*^9}, {3.6908497702987185`*^9, 3.6908497777081423`*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    RowBox[{
     SqrtBox[
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]]}], 
    RowBox[{
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]]}]], "\[Equal]", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[PartialD]", "x"], 
     FractionBox[
      RowBox[{"b", " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}], 
      RowBox[{"f", " ", "h", " ", 
       SqrtBox[
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]]}]]}], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "c"}], "-", 
        RowBox[{"a", " ", "d"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "e"}], "-", 
        RowBox[{"a", " ", "f"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "g"}], "-", 
        RowBox[{"a", " ", "h"}]}], ")"}]}], 
     RowBox[{"2", " ", "b", " ", "f", " ", "h", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], 
       RowBox[{"3", "/", "2"}]], " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]], "-", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "d", " ", "e", " ", "h"}], "+", 
        RowBox[{"f", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "d", " ", "g"}], "-", 
           RowBox[{"b", " ", "c", " ", "h"}], "-", 
           RowBox[{"a", " ", "d", " ", "h"}]}], ")"}]}]}], ")"}], " ", 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]]}], 
     RowBox[{"2", " ", "b", " ", "f", " ", "h", " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}, {3.6908497024188356`*^9, 
   3.6908497024188356`*^9}, {3.6908497702987185`*^9, 
   3.6908497777081423`*^9}, {3.690921574417376*^9, 3.690921574417376*^9}}],

Cell["Rule 1.1.1.4.2.2.2.1.1:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5346428654127264`*^9, 3.5346428654127264`*^9}, {
   3.5346430222260027`*^9, 3.5346430222260027`*^9}, {3.534706547783003*^9, 
   3.534706547783003*^9}, {3.549762992727182*^9, 3.549762992727182*^9}, {
   3.5498518507891617`*^9, 3.5498518507891617`*^9}, {3.5498619240544662`*^9, 
   3.5498619240544662`*^9}, {3.5499243006306405`*^9, 
   3.5499243006306405`*^9}, {3.611357201729041*^9, 3.611357201729041*^9}, {
   3.620233486271372*^9, 3.620233486271372*^9}, 3.644442526707492*^9, 
   3.6501606069260607`*^9, {3.6501608506620016`*^9, 3.650160851202033*^9}, {
   3.6906635832577796`*^9, 3.69066358350778*^9}, {3.6908497163326316`*^9, 
   3.6908497165996466`*^9}, {3.690918716696057*^9, 3.6909187169144573`*^9}, 
   3.698684025433457*^9, 3.7324999287141294`*^9, {3.7333372109484925`*^9, 
   3.7333372131666193`*^9}, {3.733337575041318*^9, 3.733337577570462*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     RowBox[{
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]]}], 
     RowBox[{
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{
     "x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{
        SqrtBox[
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}], 
       RowBox[{"h", " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]]}]]}]}]}]}], "+", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"d", " ", "e"}], "-", 
       RowBox[{"c", " ", "f"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", " ", "f", " ", "g"}], "+", 
       RowBox[{"b", " ", "e", " ", "h"}], "-", 
       RowBox[{"2", " ", "a", " ", "f", " ", "h"}]}], ")"}]}], 
    RowBox[{"2", " ", 
     SuperscriptBox["f", "2"], " ", "h"}]], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       SqrtBox[
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}], "+", "\[IndentingNewLine]", 
  RowBox[{
   FractionBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"a", " ", "d", " ", "f", " ", "h"}], "-", 
      RowBox[{"b", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "f", " ", "g"}], "+", 
         RowBox[{"d", " ", "e", " ", "h"}], "-", 
         RowBox[{"c", " ", "f", " ", "h"}]}], ")"}]}]}], ")"}], 
    RowBox[{"2", " ", 
     SuperscriptBox["f", "2"], " ", "h"}]], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], 
      RowBox[{
       SqrtBox[
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}], "-", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"d", " ", "e"}], "-", 
       RowBox[{"c", " ", "f"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"f", " ", "g"}], "-", 
       RowBox[{"e", " ", "h"}]}], ")"}], " "}], 
    RowBox[{"2", " ", "f", " ", "h"}]], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]], 
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}], 
        RowBox[{"3", "/", "2"}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906862370138397`*^9, 
   3.690686270846775*^9, 3.6906865143317013`*^9, {3.690686592792189*^9, 
   3.690686597382452*^9}, {3.690849723898064*^9, 3.6908497599941287`*^9}, {
   3.690849801173484*^9, 3.6908499318219566`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Sqrt", "[", 
      RowBox[{"a_.", "+", 
       RowBox[{"b_.", "*", "x_"}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"e_.", "+", 
          RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"g_.", "+", 
          RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}]}], ",", "x_Symbol"}],
    "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Sqrt", "[", 
      RowBox[{"a", "+", 
       RowBox[{"b", "*", "x"}]}], "]"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"c", "+", 
       RowBox[{"d", "*", "x"}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"g", "+", 
        RowBox[{"h", "*", "x"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{"h", "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"e", "+", 
          RowBox[{"f", "*", "x"}]}], "]"}]}], ")"}]}]}], " ", "+", " ", 
    "\[IndentingNewLine]", "  ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"d", "*", "e"}], "-", 
       RowBox[{"c", "*", "f"}]}], ")"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "f", "*", "g"}], "+", 
        RowBox[{"b", "*", "e", "*", "h"}], "-", 
        RowBox[{"2", "*", "a", "*", "f", "*", "h"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"2", "*", 
        RowBox[{"f", "^", "2"}], "*", "h"}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{"a", "+", 
            RowBox[{"b", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"c", "+", 
            RowBox[{"d", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"e", "+", 
            RowBox[{"f", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ",", "x"}], "]"}]}], 
    " ", "+", " ", "\n", "  ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"a", "*", "d", "*", "f", "*", "h"}], "-", 
        RowBox[{"b", "*", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", "*", "f", "*", "g"}], "+", 
           RowBox[{"d", "*", "e", "*", "h"}], "-", 
           RowBox[{"c", "*", "f", "*", "h"}]}], ")"}]}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"2", "*", 
        RowBox[{"f", "^", "2"}], "*", "h"}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"e", "+", 
          RowBox[{"f", "*", "x"}]}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{"a", "+", 
            RowBox[{"b", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"c", "+", 
            RowBox[{"d", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ",", "x"}], "]"}]}], 
    " ", "-", " ", "\[IndentingNewLine]", "  ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"d", "*", "e"}], "-", 
       RowBox[{"c", "*", "f"}]}], ")"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"f", "*", "g"}], "-", 
        RowBox[{"e", "*", "h"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"2", "*", "f", "*", "h"}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"a", "+", 
          RowBox[{"b", "*", "x"}]}], "]"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{"c", "+", 
            RowBox[{"d", "*", "x"}]}], "]"}], "*", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"e", "+", 
             RowBox[{"f", "*", "x"}]}], ")"}], "^", 
           RowBox[{"(", 
            RowBox[{"3", "/", "2"}], ")"}]}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{"FreeQ", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
       "h"}], "}"}], ",", "x"}], "]"}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375238754486885`*^9, 
   3.63752389858753*^9}, 3.6444425309977374`*^9, {3.6906621348624887`*^9, 
   3.6906621495825095`*^9}, {3.6906867607807975`*^9, 3.6906867777757697`*^9}, 
   3.690686824907466*^9, {3.690849985562031*^9, 3.690849989333246*^9}, {
   3.6908500749581437`*^9, 3.6908501341015263`*^9}, {3.7327734389261756`*^9, 
   3.732773443266182*^9}, {3.7328073806163454`*^9, 3.732807384302556*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["2:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]]}], 
      RowBox[{
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{"m", ">", "1"}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, 3.6202339138681226`*^9, {
   3.624745639354846*^9, 3.6247456402468967`*^9}, {3.637522303714407*^9, 
   3.6375223060594115`*^9}, 3.6390669973751264`*^9, {3.6444425214011884`*^9, 
   3.6444425218222127`*^9}, 3.6444425997666707`*^9, 3.6906631382090836`*^9, 
   3.6906631976551685`*^9, {3.6906632334152193`*^9, 3.69066323360522*^9}, {
   3.6908496403632865`*^9, 3.690849646876659*^9}, {3.6909187075544405`*^9, 
   3.690918707788441*^9}, {3.73275247923503*^9, 3.73275247941304*^9}, 
   3.7327713308632245`*^9, {3.7327723095445943`*^9, 3.7327723375746336`*^9}, {
   3.7327723773846893`*^9, 3.732772386344702*^9}, {3.7327729837355385`*^9, 
   3.732772983915539*^9}, {3.732807276136369*^9, 3.732807279286549*^9}, {
   3.7328073359837923`*^9, 3.732807338435932*^9}, {3.732853709686968*^9, 
   3.7328537204555836`*^9}, {3.732853855198291*^9, 3.732853855198291*^9}, 
   3.73298853591862*^9, 3.732991830407054*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell[TextData[{
 "Rule",
 " 1.1.1.4.2.2.2.1.2",
 ": If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], " ", 
   "\[And]", " ", 
   RowBox[{"m", ">", "1"}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5269270224625387`*^9, 3.5269270224625387`*^9}, {
   3.5305583575562735`*^9, 3.530558360660679*^9}, {3.5347074228665404`*^9, 
   3.5347074228665404`*^9}, {3.549823103506521*^9, 3.549823103506521*^9}, {
   3.611356258837721*^9, 3.611356258837721*^9}, {3.63917293207978*^9, 
   3.63917293208078*^9}, 3.6501606099462337`*^9, 3.650160886705063*^9, {
   3.6906636169318275`*^9, 3.6906636171718283`*^9}, 3.698684025703457*^9, {
   3.7324999650142055`*^9, 3.73249996526722*^9}, {3.7327340558413467`*^9, 
   3.7327340651808815`*^9}, {3.7327546348363237`*^9, 
   3.7327546348363237`*^9}, {3.732760611532171*^9, 3.732760611532171*^9}, {
   3.732772395564715*^9, 3.732772395564715*^9}, {3.7328072883500676`*^9, 
   3.7328072883500676`*^9}, {3.732807344437276*^9, 3.732807344437276*^9}, {
   3.7328538615616546`*^9, 3.7328538615616546`*^9}, 3.7333372186509333`*^9, {
   3.7333375886080933`*^9, 3.7333375900201745`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]]}], 
     RowBox[{
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{
     "x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{"2", " ", "b", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}], 
         RowBox[{"m", "-", "1"}]], " ", 
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}], 
       RowBox[{"f", " ", "h", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", "m"}], "+", "1"}], ")"}]}]]}]}]}]}], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"f", " ", "h", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "m"}], "+", "1"}], ")"}]}]], 
   RowBox[{"\[Integral]", 
    RowBox[{
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"m", "-", "2"}]], 
       RowBox[{
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}]], "\[CenterDot]", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"a", " ", "b", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "e", " ", "g"}], "+", 
           RowBox[{"c", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", " ", "g"}], "+", 
              RowBox[{"e", " ", "h"}]}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["b", "2"], " ", "c", " ", "e", " ", "g", " ", 
         RowBox[{"(", 
          RowBox[{"m", "-", "1"}], ")"}]}], "-", 
        RowBox[{
         SuperscriptBox["a", "2"], " ", "c", " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "m"}], "+", "1"}], ")"}]}], "+", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "m"}], "-", "1"}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "e", " ", "g"}], "+", 
              RowBox[{"c", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", " ", "g"}], "+", 
                 RowBox[{"e", " ", "h"}]}], ")"}]}]}], ")"}]}], "-", 
           RowBox[{
            SuperscriptBox["a", "2"], " ", "d", " ", "f", " ", "h", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "m"}], "+", "1"}], ")"}]}], "+", 
           RowBox[{"2", " ", "a", " ", "b", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "f", " ", "g"}], "+", 
              RowBox[{"d", " ", "e", " ", "h"}], "-", 
              RowBox[{"2", " ", "c", " ", "f", " ", "h", " ", "m"}]}], 
             ")"}]}]}], ")"}], " ", "x"}], "-", "\[IndentingNewLine]", 
        RowBox[{"b", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"a", " ", "d", " ", "f", " ", "h", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"4", " ", "m"}], "-", "1"}], ")"}]}], "+", 
           RowBox[{"b", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"c", " ", "f", " ", "h"}], "-", 
              RowBox[{"2", " ", "d", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", " ", "g"}], "+", 
                 RowBox[{"e", " ", "h"}]}], ")"}], " ", "m"}]}], ")"}]}]}], 
          ")"}], " ", 
         SuperscriptBox["x", "2"]}]}], ")"}]}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906862370138397`*^9, 
   3.690686270846775*^9, 3.6906865143317013`*^9, {3.690686592792189*^9, 
   3.690686597382452*^9}, {3.690849723898064*^9, 3.6908497599941287`*^9}, {
   3.690849801173484*^9, 3.6908499318219566`*^9}, {3.7327713601732655`*^9, 
   3.7327713689032774`*^9}, {3.7327714316433654`*^9, 3.732771581493575*^9}, {
   3.7327716324936466`*^9, 3.7327716430536613`*^9}, {3.732853807384556*^9, 
   3.7328538276567154`*^9}, 3.73285397005986*^9, {3.732855525607833*^9, 
   3.7328555437148685`*^9}, 3.7328577787617054`*^9},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"e_.", "+", 
          RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"g_.", "+", 
          RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}]}], ",", "x_Symbol"}],
    "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{"2", "*", "b", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "-", "1"}], ")"}]}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"c", "+", 
       RowBox[{"d", "*", "x"}]}], "]"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"e", "+", 
       RowBox[{"f", "*", "x"}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"g", "+", 
        RowBox[{"h", "*", "x"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{"f", "*", "h", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "*", "m"}], "+", "1"}], ")"}]}], ")"}]}]}], " ", "-", 
    " ", "\n", "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"f", "*", "h", "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "*", "m"}], "+", "1"}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", "*", "x"}]}], ")"}], "^", 
           RowBox[{"(", 
            RowBox[{"m", "-", "2"}], ")"}]}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Sqrt", "[", 
             RowBox[{"c", "+", 
              RowBox[{"d", "*", "x"}]}], "]"}], "*", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"e", "+", 
              RowBox[{"f", "*", "x"}]}], "]"}], "*", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"g", "+", 
              RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ")"}], "*", "\n", 
        "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"a", "*", "b", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", "*", "e", "*", "g"}], "+", 
              RowBox[{"c", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", "*", "g"}], "+", 
                 RowBox[{"e", "*", "h"}]}], ")"}]}]}], ")"}]}], "+", 
           RowBox[{"2", "*", 
            RowBox[{"b", "^", "2"}], "*", "c", "*", "e", "*", "g", "*", 
            RowBox[{"(", 
             RowBox[{"m", "-", "1"}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"a", "^", "2"}], "*", "c", "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "*", "m"}], "+", "1"}], ")"}]}], " ", "+", " ", 
           "\n", "    ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"b", "^", "2"}], "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", "*", "m"}], "-", "1"}], ")"}], "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "e", "*", "g"}], "+", 
                 RowBox[{"c", "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"f", "*", "g"}], "+", 
                    RowBox[{"e", "*", "h"}]}], ")"}]}]}], ")"}]}], "-", 
              RowBox[{
               RowBox[{"a", "^", "2"}], "*", "d", "*", "f", "*", "h", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", "*", "m"}], "+", "1"}], ")"}]}], "+", 
              RowBox[{"2", "*", "a", "*", "b", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "f", "*", "g"}], "+", 
                 RowBox[{"d", "*", "e", "*", "h"}], "-", 
                 RowBox[{"2", "*", "c", "*", "f", "*", "h", "*", "m"}]}], 
                ")"}]}]}], ")"}], "*", "x"}], " ", "-", " ", "\n", "    ", 
           RowBox[{"b", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"a", "*", "d", "*", "f", "*", "h", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"4", "*", "m"}], "-", "1"}], ")"}]}], "+", 
              RowBox[{"b", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"c", "*", "f", "*", "h"}], "-", 
                 RowBox[{"2", "*", "d", "*", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"f", "*", "g"}], "+", 
                    RowBox[{"e", "*", "h"}]}], ")"}], "*", "m"}]}], ")"}]}]}],
              ")"}], "*", 
            RowBox[{"x", "^", "2"}]}]}], ",", "x"}], "]"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"IntegerQ", "[", 
     RowBox[{"2", "*", "m"}], "]"}], " ", "&&", " ", 
    RowBox[{"GtQ", "[", 
     RowBox[{"m", ",", "1"}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375238754486885`*^9, 
   3.63752389858753*^9}, 3.6444425309977374`*^9, {3.6906621348624887`*^9, 
   3.6906621495825095`*^9}, {3.6906867607807975`*^9, 3.6906867777757697`*^9}, 
   3.690686824907466*^9, {3.690849985562031*^9, 3.690849989333246*^9}, {
   3.6908500749581437`*^9, 3.6908501341015263`*^9}, {3.7327713881833043`*^9, 
   3.732771418233347*^9}, 3.7327717566238203`*^9, {3.7327725108548765`*^9, 
   3.7327725188748875`*^9}, {3.732806856126346*^9, 3.73280686668495*^9}, {
   3.732807294788436*^9, 3.7328072994647036`*^9}, {3.7328073486815186`*^9, 
   3.732807351821698*^9}, {3.732853872531282*^9, 3.7328538803117275`*^9}, 
   3.7328541182703376`*^9, 3.732855666165872*^9, {3.732860975607555*^9, 
   3.7328609815888968`*^9}, {3.7333352749927626`*^9, 3.7333352818111525`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["2.",
    FontFamily->"Arial"]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]]}], 
      RowBox[{
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{"m", "<", "0"}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.521057461672199*^9, 3.5210574760242243`*^9}, {3.521070822423706*^9, 
   3.5210708246545095`*^9}, {3.5213087709919868`*^9, 
   3.5213087724119887`*^9}, {3.5213088043520336`*^9, 
   3.5213088436920886`*^9}, {3.5213313219253235`*^9, 3.521331332715338*^9}, {
   3.521396649294255*^9, 3.5213966495282555`*^9}, {3.5213967143151693`*^9, 
   3.5213967143151693`*^9}, {3.5214681320328116`*^9, 3.521468132313612*^9}, {
   3.5214681741216855`*^9, 3.5214681744648857`*^9}, {3.521490796034383*^9, 
   3.521490802711195*^9}, {3.521653864765747*^9, 3.5216538678077526`*^9}, {
   3.5233207455376463`*^9, 3.5233207462084475`*^9}, 3.5238128165433874`*^9, {
   3.5238133152240853`*^9, 3.523813315824086*^9}, {3.5238135276743827`*^9, 
   3.523813527914383*^9}, {3.529214229314893*^9, 3.529214229534893*^9}, {
   3.529259385121084*^9, 3.529259385464285*^9}, {3.529624227134743*^9, 
   3.5296242307219486`*^9}, {3.5296244369817457`*^9, 
   3.5296244374697733`*^9}, {3.530384298640394*^9, 3.530384317638481*^9}, {
   3.5317027762887106`*^9, 3.531702795876877*^9}, {3.531942830651599*^9, 
   3.531942831010399*^9}, {3.5319429299613733`*^9, 3.531942935031382*^9}, {
   3.539393717282713*^9, 3.5393937175197268`*^9}, {3.5393939972431717`*^9, 
   3.5393939972431717`*^9}, {3.54976183300485*^9, 3.549761843369443*^9}, 
   3.5497618783514433`*^9, {3.5498272575323367`*^9, 3.5498272577023373`*^9}, {
   3.5498590820409126`*^9, 3.549859083098973*^9}, {3.549861971973207*^9, 
   3.549861974052326*^9}, {3.5499239781513543`*^9, 3.5499239781513543`*^9}, {
   3.5716376069321833`*^9, 3.5716376095821867`*^9}, 3.571704053418295*^9, {
   3.571705098009757*^9, 3.5717051012397614`*^9}, 3.5717051920898886`*^9, 
   3.5758229151368937`*^9, 3.61151142537963*^9, {3.6375210294106445`*^9, 
   3.6375211225176077`*^9}, {3.644442260768281*^9, 3.644442260768281*^9}, {
   3.644442312905263*^9, 3.64444231686749*^9}, 3.647390660600108*^9, {
   3.6473907736905766`*^9, 3.647390819717209*^9}, {3.6473912085964518`*^9, 
   3.647391208843466*^9}, {3.6473912679138446`*^9, 3.6473912679138446`*^9}, {
   3.647396300569696*^9, 3.6473963246130714`*^9}, {3.6906631681351275`*^9, 
   3.6906631683951283`*^9}, {3.6906632461472373`*^9, 
   3.6906632887133045`*^9}, {3.732499894755187*^9, 3.732499895072205*^9}, {
   3.7327608903751197`*^9, 3.732760890625134*^9}, {3.7327722265444784`*^9, 
   3.732772237144493*^9}, {3.7327729017054234`*^9, 3.732772901935424*^9}, {
   3.7328536690666447`*^9, 3.7328537029195805`*^9}, 3.732988520897761*^9, 
   3.7329918315781207`*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["1:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, {3.6202339053349075`*^9, 
   3.620233905600108*^9}, {3.6247456440521145`*^9, 3.624745644897163*^9}, {
   3.6375223073456144`*^9, 3.6375223085186167`*^9}, {3.639067057738579*^9, 
   3.6390670593146687`*^9}, {3.644442565589716*^9, 3.6444425657907276`*^9}, 
   3.644442601309759*^9, 3.69066275588238*^9, 3.6906631460190945`*^9, {
   3.6906632079211836`*^9, 3.690663210381187*^9}, {3.732752475791833*^9, 
   3.7327524760398474`*^9}, {3.7327718803939934`*^9, 
   3.7327718807439938`*^9}, {3.7327729771255293`*^9, 3.732772977315529*^9}, {
   3.7328537337213426`*^9, 3.7328537423778377`*^9}, 3.732988536953679*^9, 
   3.7329918322871614`*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic expansion", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9, {3.620234434581437*^9, 3.6202344396046457`*^9}, {
   3.690664333768237*^9, 3.690664341188247*^9}, {3.732772996435556*^9, 
   3.7327730003955617`*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    SqrtBox[
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "x"}]}]], 
    RowBox[{"a", "+", 
     RowBox[{"b", " ", "x"}]}]], "\[Equal]", 
   RowBox[{
    FractionBox["d", 
     RowBox[{"b", " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]]}]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"b", " ", "c"}], "-", 
      RowBox[{"a", " ", "d"}]}], 
     RowBox[{"b", " ", 
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]]}]]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}, {3.690664586481409*^9, 
   3.690664586481409*^9}, {3.6906647291955585`*^9, 3.6906647291955585`*^9}, {
   3.6906856944818087`*^9, 3.6906856944818087`*^9}, {3.7224690587432995`*^9, 
   3.7224690587432995`*^9}, {3.72246924110073*^9, 3.72246924110073*^9}, {
   3.7327732141258607`*^9, 3.7327732141258607`*^9}}],

Cell["Rule 1.1.1.4.2.2.2.2.1:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5346428654127264`*^9, 3.5346428654127264`*^9}, {
   3.5346430222260027`*^9, 3.5346430222260027`*^9}, {3.534706547783003*^9, 
   3.534706547783003*^9}, {3.549762992727182*^9, 3.549762992727182*^9}, {
   3.5498518507891617`*^9, 3.5498518507891617`*^9}, {3.5498619240544662`*^9, 
   3.5498619240544662`*^9}, {3.5499243006306405`*^9, 
   3.5499243006306405`*^9}, {3.611357201729041*^9, 3.611357201729041*^9}, {
   3.620233486271372*^9, 3.620233486271372*^9}, 3.644442569629947*^9, 
   3.65016060813413*^9, {3.6501608631237144`*^9, 3.6501608639767632`*^9}, {
   3.690663571646763*^9, 3.6906635758967686`*^9}, 3.698684025213456*^9, 
   3.7324999253209352`*^9, {3.733337224467266*^9, 3.7333372264233775`*^9}, {
   3.7333376012518167`*^9, 3.733337602586893*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     SqrtBox[
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], " ", 
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
      FractionBox["d", 
       RowBox[{" ", "b"}]]}]}], " ", 
    RowBox[{"\[Integral]", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}]], 
      RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "+", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"b", " ", "c"}], "-", 
     RowBox[{"a", " ", "d"}]}], "b"], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906850049273686`*^9, 
   3.690685108891315*^9, 3.690685388506308*^9, 3.6906857572033963`*^9, {
   3.690685868239747*^9, 3.690685877258263*^9}, 3.722469002996111*^9, 
   3.722469046621606*^9, {3.7224692662001657`*^9, 3.722469334484071*^9}, {
   3.732773064305651*^9, 3.7327731143457212`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Sqrt", "[", 
      RowBox[{"c_.", "+", 
       RowBox[{"d_.", "*", "x_"}]}], "]"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a_.", "+", 
         RowBox[{"b_.", "*", "x_"}]}], ")"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"e_.", "+", 
         RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"g_.", "+", 
         RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}], ",", "x_Symbol"}], 
   "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"d", "/", "b"}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{"c", "+", 
            RowBox[{"d", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"e", "+", 
            RowBox[{"f", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ",", "x"}], "]"}]}], 
    " ", "+", " ", "\n", "  ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "c"}], "-", 
        RowBox[{"a", "*", "d"}]}], ")"}], "/", "b"}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", "*", "x"}]}], ")"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"c", "+", 
            RowBox[{"d", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"e", "+", 
            RowBox[{"f", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{"FreeQ", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
       "h"}], "}"}], ",", "x"}], "]"}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, 3.637524238038328*^9, 
   3.6444425736891794`*^9, {3.6906619125840034`*^9, 3.6906619265680237`*^9}, {
   3.690662968287841*^9, 3.6906629900678716`*^9}, 3.6906860521482663`*^9, {
   3.6906861039962316`*^9, 3.6906861224202857`*^9}, {3.722469464124486*^9, 
   3.722469479513366*^9}, {3.7327720080741725`*^9, 3.7327720130241795`*^9}, {
   3.732772416274744*^9, 3.732772419864749*^9}, {3.7327732676159353`*^9, 
   3.7327732842859592`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["x:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"3", "/", "2"}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, {3.6202339053349075`*^9, 
   3.620233905600108*^9}, {3.6247456440521145`*^9, 3.624745644897163*^9}, {
   3.6375223073456144`*^9, 3.6375223085186167`*^9}, {3.639067057738579*^9, 
   3.6390670593146687`*^9}, {3.644442565589716*^9, 3.6444425657907276`*^9}, 
   3.644442601309759*^9, 3.69066275588238*^9, 3.6906631460190945`*^9, {
   3.6906632079211836`*^9, 3.690663210381187*^9}, {3.732752475791833*^9, 
   3.7327524760398474`*^9}, {3.7327718803939934`*^9, 
   3.7327718807439938`*^9}, {3.7327729821555357`*^9, 
   3.7327729824155364`*^9}, {3.7328537347193995`*^9, 3.732853740508731*^9}, 
   3.732988537564714*^9, 3.7329918329421988`*^9, {3.73474125323343*^9, 
   3.7347412546885133`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["\<\
Derivation: Piecewise constant extraction and integration by substitution\
\>", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9, {3.620234434581437*^9, 3.6202344396046457`*^9}, {
   3.690664333768237*^9, 3.690664341188247*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["\[PartialD]", "x"], 
    FractionBox[
     RowBox[{
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "g"}], "-", 
           RowBox[{"a", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", " ", "x"}]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", " ", "g"}], "-", 
           RowBox[{"e", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}]}]]]}], 
     RowBox[{
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "g"}], "-", 
           RowBox[{"a", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "g"}], "-", 
           RowBox[{"c", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}]}]]]}]]}], "\[Equal]", "0"}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}, {3.7224689357632656`*^9, 
   3.7224689538262987`*^9}, {3.734661231210103*^9, 3.734661231210103*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    SqrtBox[
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", " ", "g"}], "-", 
         RowBox[{"a", " ", "h"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "g"}], "-", 
         RowBox[{"c", " ", "h"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}]}]]], 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"3", "/", "2"}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]], " ", 
     SqrtBox[
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "g"}], "-", 
          RowBox[{"a", " ", "h"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"f", " ", "g"}], "-", 
          RowBox[{"e", " ", "h"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}]}]]]}]], "\[Equal]", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["2", 
      RowBox[{
       RowBox[{"b", " ", "g"}], "-", 
       RowBox[{"a", " ", "h"}]}]]}], 
    RowBox[{"Subst", "[", 
     RowBox[{
      FractionBox[
       SqrtBox[
        RowBox[{"1", "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"b", " ", "c"}], "-", 
             RowBox[{"a", " ", "d"}]}], ")"}], " ", 
           SuperscriptBox["x", "2"]}], 
          RowBox[{
           RowBox[{"d", " ", "g"}], "-", 
           RowBox[{"c", " ", "h"}]}]]}]], 
       SqrtBox[
        RowBox[{"1", "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"b", " ", "e"}], "-", 
             RowBox[{"a", " ", "f"}]}], ")"}], " ", 
           SuperscriptBox["x", "2"]}], 
          RowBox[{
           RowBox[{"f", " ", "g"}], "-", 
           RowBox[{"e", " ", "h"}]}]]}]]], ",", "x", ",", 
      FractionBox[
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]], 
       SqrtBox[
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]]]}], "]"}], " ", 
    RowBox[{
     SubscriptBox["\[PartialD]", "x"], 
     FractionBox[
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]], 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]]]}]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}, {3.690664586481409*^9, 
   3.690664586481409*^9}, {3.6906647291955585`*^9, 3.6906647291955585`*^9}, {
   3.6906856944818087`*^9, 3.6906856944818087`*^9}, {3.7224690587432995`*^9, 
   3.7224690587432995`*^9}, {3.72246924110073*^9, 3.72246924110073*^9}, {
   3.7346612722164483`*^9, 3.7346612722164483`*^9}, {3.7346613025551834`*^9, 
   3.7346613025551834`*^9}, {3.734661346355689*^9, 3.7346613617775707`*^9}}],

Cell["Rule 1.1.1.4.2.2.2.2.2:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5346428654127264`*^9, 3.5346428654127264`*^9}, {
   3.5346430222260027`*^9, 3.5346430222260027`*^9}, {3.534706547783003*^9, 
   3.534706547783003*^9}, {3.549762992727182*^9, 3.549762992727182*^9}, {
   3.5498518507891617`*^9, 3.5498518507891617`*^9}, {3.5498619240544662`*^9, 
   3.5498619240544662`*^9}, {3.5499243006306405`*^9, 
   3.5499243006306405`*^9}, {3.611357201729041*^9, 3.611357201729041*^9}, {
   3.620233486271372*^9, 3.620233486271372*^9}, 3.644442569629947*^9, 
   3.65016060813413*^9, {3.6501608631237144`*^9, 3.6501608639767632`*^9}, {
   3.690663571646763*^9, 3.6906635758967686`*^9}, 3.698684025213456*^9, 
   3.7324999253209352`*^9, {3.7333372341198177`*^9, 3.733337235995925*^9}, {
   3.7333376111563835`*^9, 3.7333376126104665`*^9}}],

Cell[BoxData[{
 RowBox[{"\[Integral]", 
  RowBox[{
   FractionBox[
    SqrtBox[
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "x"}]}]], 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"3", "/", "2"}]], " ", 
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]]}]], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
     FractionBox[
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"e", "+", 
            RowBox[{"f", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]]}], 
      RowBox[{
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"c", "+", 
            RowBox[{"d", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "g"}], "-", 
            RowBox[{"c", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]]}]]}]}], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SqrtBox[
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "g"}], "-", 
           RowBox[{"a", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "g"}], "-", 
           RowBox[{"c", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}]}]]], 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"3", "/", "2"}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"e", "+", 
            RowBox[{"f", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"  ", 
  RowBox[{
   RowBox[{"\[LongRightArrow]", "  ", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"2", " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"e", "+", 
            RowBox[{"f", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", " ", "g"}], "-", 
         RowBox[{"a", " ", "h"}]}], ")"}], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "g"}], "-", 
            RowBox[{"a", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"c", "+", 
            RowBox[{"d", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "g"}], "-", 
            RowBox[{"c", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]]}]]}]}], " ", 
   RowBox[{"Subst", "[", 
    RowBox[{
     RowBox[{"\[Integral]", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", " ", "c"}], "-", 
              RowBox[{"a", " ", "d"}]}], ")"}], " ", 
            SuperscriptBox["x", "2"]}], 
           RowBox[{
            RowBox[{"d", " ", "g"}], "-", 
            RowBox[{"c", " ", "h"}]}]]}]], 
        SqrtBox[
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", " ", "e"}], "-", 
              RowBox[{"a", " ", "f"}]}], ")"}], " ", 
            SuperscriptBox["x", "2"]}], 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}]]}]]], 
       RowBox[{"\[DifferentialD]", "x"}]}]}], ",", "x", ",", 
     FractionBox[
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]], 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]]]}], "]"}]}]}]}], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906850049273686`*^9, 
   3.690685108891315*^9, 3.690685388506308*^9, 3.6906857572033963`*^9, {
   3.690685868239747*^9, 3.690685877258263*^9}, 3.722469002996111*^9, 
   3.722469046621606*^9, {3.7224692662001657`*^9, 3.722469334484071*^9}, {
   3.7346613821077337`*^9, 3.734661472500904*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Int", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a_.", "+", 
           RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"3", "/", "2"}], ")"}]}], "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"e_.", "+", 
          RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"g_.", "+", 
          RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}], ",", "x_Symbol"}], 
    "]"}], " ", ":=", "\n", "  ", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"c", "+", 
       RowBox[{"d", "*", "x"}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "g"}], "-", 
          RowBox[{"a", "*", "h"}]}], ")"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"f", "*", "g"}], "-", 
             RowBox[{"e", "*", "h"}]}], ")"}], "*", 
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", "*", "x"}]}], ")"}]}], ")"}]}]}], "]"}], "/", "\n", 
      "    ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "g"}], "-", 
          RowBox[{"a", "*", "h"}]}], ")"}], "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"e", "+", 
          RowBox[{"f", "*", "x"}]}], "]"}], "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", "*", "g"}], "-", 
            RowBox[{"a", "*", "h"}]}], ")"}], "*", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"c", "+", 
             RowBox[{"d", "*", "x"}]}], ")"}], "/", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", "*", "g"}], "-", 
               RowBox[{"c", "*", "h"}]}], ")"}], "*", 
             RowBox[{"(", 
              RowBox[{"a", "+", 
               RowBox[{"b", "*", "x"}]}], ")"}]}], ")"}]}]}], "]"}]}], 
       ")"}]}], "*", "\n", "    ", 
     RowBox[{"Subst", "[", 
      RowBox[{
       RowBox[{"Int", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{"1", "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"b", "*", "c"}], "-", 
               RowBox[{"a", "*", "d"}]}], ")"}], "*", 
             RowBox[{
              RowBox[{"x", "^", "2"}], "/", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"d", "*", "g"}], "-", 
                RowBox[{"c", "*", "h"}]}], ")"}]}]}]}], "]"}], "/", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"1", "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"b", "*", "e"}], "-", 
               RowBox[{"a", "*", "f"}]}], ")"}], "*", 
             RowBox[{
              RowBox[{"x", "^", "2"}], "/", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"f", "*", "g"}], "-", 
                RowBox[{"e", "*", "h"}]}], ")"}]}]}]}], "]"}]}], ",", "x"}], 
        "]"}], ",", "x", ",", 
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"g", "+", 
          RowBox[{"h", "*", "x"}]}], "]"}], "/", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"a", "+", 
          RowBox[{"b", "*", "x"}]}], "]"}]}]}], "]"}]}], " ", "/;", "\n", 
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h"}], "}"}], ",", "x"}], "]"}]}]}], " ", "*)"}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, 3.637524238038328*^9, 
   3.6444425736891794`*^9, {3.6906619125840034`*^9, 3.6906619265680237`*^9}, {
   3.690662968287841*^9, 3.6906629900678716`*^9}, 3.6906860521482663`*^9, {
   3.6906861039962316`*^9, 3.6906861224202857`*^9}, {3.722469464124486*^9, 
   3.722469479513366*^9}, {3.7327720080741725`*^9, 3.7327720130241795`*^9}, {
   3.732772416274744*^9, 3.732772419864749*^9}, 3.7346616455788035`*^9, {
   3.7347412826171107`*^9, 3.7347412873703823`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["2:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"3", "/", "2"}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, {3.6202339053349075`*^9, 
   3.620233905600108*^9}, {3.6247456440521145`*^9, 3.624745644897163*^9}, {
   3.6375223073456144`*^9, 3.6375223085186167`*^9}, {3.639067057738579*^9, 
   3.6390670593146687`*^9}, {3.644442565589716*^9, 3.6444425657907276`*^9}, 
   3.644442601309759*^9, 3.69066275588238*^9, 3.6906631460190945`*^9, {
   3.6906632079211836`*^9, 3.690663210381187*^9}, {3.732752475791833*^9, 
   3.7327524760398474`*^9}, {3.7327718803939934`*^9, 
   3.7327718807439938`*^9}, {3.7327729821555357`*^9, 
   3.7327729824155364`*^9}, {3.7328537347193995`*^9, 3.732853740508731*^9}, 
   3.732988537564714*^9, 3.7329918329421988`*^9, {3.7346611279992*^9, 
   3.7346611282742157`*^9}, {3.734741257720687*^9, 3.7347412580067034`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["\<\
Derivation: Piecewise constant extraction and integration by substitution\
\>", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9, {3.620234434581437*^9, 3.6202344396046457`*^9}, {
   3.690664333768237*^9, 3.690664341188247*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["\[PartialD]", "x"], 
    FractionBox[
     RowBox[{
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "e"}], "-", 
            RowBox[{"a", " ", "f"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"g", "+", 
            RowBox[{"h", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]}]]}], 
     RowBox[{" ", 
      RowBox[{
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]], " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"b", " ", "e"}], "-", 
            RowBox[{"a", " ", "f"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"c", "+", 
            RowBox[{"d", " ", "x"}]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"d", " ", "e"}], "-", 
            RowBox[{"c", " ", "f"}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}]}]]]}]}]]}], "\[Equal]", "0"}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}, {3.7224689357632656`*^9, 
   3.7224689538262987`*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    SqrtBox[
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", " ", "e"}], "-", 
         RowBox[{"a", " ", "f"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"d", " ", "e"}], "-", 
         RowBox[{"c", " ", "f"}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}]}]]], 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"3", "/", "2"}]], " ", 
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "e"}], "-", 
           RowBox[{"a", " ", "f"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"g", "+", 
           RowBox[{"h", " ", "x"}]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"f", " ", "g"}], "-", 
           RowBox[{"e", " ", "h"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}]}]]}]]}]], "\[Equal]", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["2", 
      RowBox[{
       RowBox[{"b", " ", "e"}], "-", 
       RowBox[{"a", " ", "f"}]}]]}], 
    RowBox[{"Subst", "[", 
     RowBox[{
      FractionBox[
       SqrtBox[
        RowBox[{"1", "+", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"b", " ", "c"}], "-", 
             RowBox[{"a", " ", "d"}]}], ")"}], " ", 
           SuperscriptBox["x", "2"]}], 
          RowBox[{
           RowBox[{"d", " ", "e"}], "-", 
           RowBox[{"c", " ", "f"}]}]]}]], 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"b", " ", "g"}], "-", 
             RowBox[{"a", " ", "h"}]}], ")"}], " ", 
           SuperscriptBox["x", "2"]}], 
          RowBox[{
           RowBox[{"f", " ", "g"}], "-", 
           RowBox[{"e", " ", "h"}]}]]}]]], ",", "x", ",", 
      FractionBox[
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], 
       SqrtBox[
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]]]}], "]"}], " ", 
    RowBox[{
     SubscriptBox["\[PartialD]", "x"], 
     FractionBox[
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]]]}]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}, {
   3.69066438656732*^9, 3.690664398789342*^9}, {3.690664586481409*^9, 
   3.690664586481409*^9}, {3.6906647291955585`*^9, 3.6906647291955585`*^9}, {
   3.6906856944818087`*^9, 3.6906856944818087`*^9}, {3.7224690587432995`*^9, 
   3.7224690587432995`*^9}, {3.72246924110073*^9, 3.72246924110073*^9}}],

Cell["Rule 1.1.1.4.2.2.2.2.2:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5346428654127264`*^9, 3.5346428654127264`*^9}, {
   3.5346430222260027`*^9, 3.5346430222260027`*^9}, {3.534706547783003*^9, 
   3.534706547783003*^9}, {3.549762992727182*^9, 3.549762992727182*^9}, {
   3.5498518507891617`*^9, 3.5498518507891617`*^9}, {3.5498619240544662`*^9, 
   3.5498619240544662`*^9}, {3.5499243006306405`*^9, 
   3.5499243006306405`*^9}, {3.611357201729041*^9, 3.611357201729041*^9}, {
   3.620233486271372*^9, 3.620233486271372*^9}, 3.644442569629947*^9, 
   3.65016060813413*^9, {3.6501608631237144`*^9, 3.6501608639767632`*^9}, {
   3.690663571646763*^9, 3.6906635758967686`*^9}, 3.698684025213456*^9, 
   3.7324999253209352`*^9, {3.7333372341198177`*^9, 3.733337235995925*^9}, {
   3.7333376111563835`*^9, 3.7333376126104665`*^9}}],

Cell[BoxData[{
 RowBox[{"\[Integral]", 
  RowBox[{
   FractionBox[
    SqrtBox[
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "x"}]}]], 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"3", "/", "2"}]], " ", 
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]]}]], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
     FractionBox[
      RowBox[{
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"b", " ", "e"}], "-", 
             RowBox[{"a", " ", "f"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"g", "+", 
             RowBox[{"h", " ", "x"}]}], ")"}]}], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"f", " ", "g"}], "-", 
             RowBox[{"e", " ", "h"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", " ", "x"}]}], ")"}]}]]}]]}], 
      RowBox[{" ", 
       RowBox[{
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]], " ", 
        SqrtBox[
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"b", " ", "e"}], "-", 
             RowBox[{"a", " ", "f"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"c", "+", 
             RowBox[{"d", " ", "x"}]}], ")"}]}], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "e"}], "-", 
             RowBox[{"c", " ", "f"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", " ", "x"}]}], ")"}]}]]]}]}]]}]}], " ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      SqrtBox[
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", " ", "e"}], "-", 
           RowBox[{"a", " ", "f"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "e"}], "-", 
           RowBox[{"c", " ", "f"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}]}]]], 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"3", "/", "2"}]], " ", 
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"b", " ", "e"}], "-", 
             RowBox[{"a", " ", "f"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"g", "+", 
             RowBox[{"h", " ", "x"}]}], ")"}]}], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"f", " ", "g"}], "-", 
             RowBox[{"e", " ", "h"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", " ", "x"}]}], ")"}]}]]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"  ", 
  RowBox[{
   RowBox[{"\[LongRightArrow]", "  ", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"2", " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"b", " ", "e"}], "-", 
             RowBox[{"a", " ", "f"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"g", "+", 
             RowBox[{"h", " ", "x"}]}], ")"}]}], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"f", " ", "g"}], "-", 
             RowBox[{"e", " ", "h"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", " ", "x"}]}], ")"}]}]]}]]}], 
      RowBox[{" ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "e"}], "-", 
          RowBox[{"a", " ", "f"}]}], ")"}], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]], " ", 
        SqrtBox[
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"b", " ", "e"}], "-", 
             RowBox[{"a", " ", "f"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"c", "+", 
             RowBox[{"d", " ", "x"}]}], ")"}]}], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"d", " ", "e"}], "-", 
             RowBox[{"c", " ", "f"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", " ", "x"}]}], ")"}]}]]]}]}]]}]}], " ", 
   RowBox[{"Subst", "[", 
    RowBox[{
     RowBox[{"\[Integral]", 
      RowBox[{
       FractionBox[
        SqrtBox[
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", " ", "c"}], "-", 
              RowBox[{"a", " ", "d"}]}], ")"}], " ", 
            SuperscriptBox["x", "2"]}], 
           RowBox[{
            RowBox[{"d", " ", "e"}], "-", 
            RowBox[{"c", " ", "f"}]}]]}]], 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", " ", "g"}], "-", 
              RowBox[{"a", " ", "h"}]}], ")"}], " ", 
            SuperscriptBox["x", "2"]}], 
           RowBox[{
            RowBox[{"f", " ", "g"}], "-", 
            RowBox[{"e", " ", "h"}]}]]}]]], 
       RowBox[{"\[DifferentialD]", "x"}]}]}], ",", "x", ",", 
     FractionBox[
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], 
      SqrtBox[
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]]]}], "]"}]}]}]}], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906850049273686`*^9, 
   3.690685108891315*^9, 3.690685388506308*^9, 3.6906857572033963`*^9, {
   3.690685868239747*^9, 3.690685877258263*^9}, 3.722469002996111*^9, 
   3.722469046621606*^9, {3.7224692662001657`*^9, 3.722469334484071*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Sqrt", "[", 
      RowBox[{"c_.", "+", 
       RowBox[{"d_.", "*", "x_"}]}], "]"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a_.", "+", 
          RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"3", "/", "2"}], ")"}]}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"e_.", "+", 
         RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"g_.", "+", 
         RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}], ",", "x_Symbol"}], 
   "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "2"}], "*", 
    RowBox[{"Sqrt", "[", 
     RowBox[{"c", "+", 
      RowBox[{"d", "*", "x"}]}], "]"}], "*", 
    RowBox[{
     RowBox[{"Sqrt", "[", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}]}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"g", "+", 
          RowBox[{"h", "*", "x"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", "*", "g"}], "-", 
            RowBox[{"e", "*", "h"}]}], ")"}], "*", 
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", "*", "x"}]}], ")"}]}], ")"}]}]}], "]"}], "/", "\n", 
     "    ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", "*", "e"}], "-", 
         RowBox[{"a", "*", "f"}]}], ")"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"g", "+", 
         RowBox[{"h", "*", "x"}]}], "]"}], "*", 
       RowBox[{"Sqrt", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"b", "*", "e"}], "-", 
           RowBox[{"a", "*", "f"}]}], ")"}], "*", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"c", "+", 
            RowBox[{"d", "*", "x"}]}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", "*", "e"}], "-", 
              RowBox[{"c", "*", "f"}]}], ")"}], "*", 
            RowBox[{"(", 
             RowBox[{"a", "+", 
              RowBox[{"b", "*", "x"}]}], ")"}]}], ")"}]}]}], "]"}]}], ")"}]}],
     "*", "\n", "    ", 
    RowBox[{"Subst", "[", 
     RowBox[{
      RowBox[{"Int", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Sqrt", "[", 
          RowBox[{"1", "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", "c"}], "-", 
              RowBox[{"a", "*", "d"}]}], ")"}], "*", 
            RowBox[{
             RowBox[{"x", "^", "2"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"d", "*", "e"}], "-", 
               RowBox[{"c", "*", "f"}]}], ")"}]}]}]}], "]"}], "/", 
         RowBox[{"Sqrt", "[", 
          RowBox[{"1", "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"b", "*", "g"}], "-", 
              RowBox[{"a", "*", "h"}]}], ")"}], "*", 
            RowBox[{
             RowBox[{"x", "^", "2"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"f", "*", "g"}], "-", 
               RowBox[{"e", "*", "h"}]}], ")"}]}]}]}], "]"}]}], ",", "x"}], 
       "]"}], ",", "x", ",", 
      RowBox[{
       RowBox[{"Sqrt", "[", 
        RowBox[{"e", "+", 
         RowBox[{"f", "*", "x"}]}], "]"}], "/", 
       RowBox[{"Sqrt", "[", 
        RowBox[{"a", "+", 
         RowBox[{"b", "*", "x"}]}], "]"}]}]}], "]"}]}], " ", "/;", "\n", 
   RowBox[{"FreeQ", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
       "h"}], "}"}], ",", "x"}], "]"}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, 3.637524238038328*^9, 
   3.6444425736891794`*^9, {3.6906619125840034`*^9, 3.6906619265680237`*^9}, {
   3.690662968287841*^9, 3.6906629900678716`*^9}, 3.6906860521482663`*^9, {
   3.6906861039962316`*^9, 3.6906861224202857`*^9}, {3.722469464124486*^9, 
   3.722469479513366*^9}, {3.7327720080741725`*^9, 3.7327720130241795`*^9}, {
   3.732772416274744*^9, 3.732772419864749*^9}, {3.734661133668524*^9, 
   3.734661138018773*^9}, {3.7347412665971947`*^9, 3.734741269823379*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t\t\t\t", 
  RowBox[{Cell[TextData[StyleBox["3:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SqrtBox[
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]]}], 
      RowBox[{
       SqrtBox[
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]], " ", 
       SqrtBox[
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]]}]], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], 
       " ", "\[And]", " ", 
       RowBox[{"m", "\[LessEqual]", 
        RowBox[{"-", "2"}]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.534708039052023*^9, 
   3.534708042047228*^9}, {3.5347082570624056`*^9, 3.534708257296406*^9}, {
   3.5393937231100464`*^9, 3.5393937232640553`*^9}, {3.5497619160626*^9, 
   3.5497619527446985`*^9}, {3.5498517888490753`*^9, 3.549851789079075*^9}, {
   3.5498518292591314`*^9, 3.549851833339137*^9}, 3.549861675894272*^9, {
   3.5498617962671576`*^9, 3.5498618031115484`*^9}, 3.5499241208491735`*^9, {
   3.5499242935570297`*^9, 3.5499242950094323`*^9}, 3.5717051477598267`*^9, 
   3.575822921566903*^9, {3.6113494016079865`*^9, 3.6113494018079863`*^9}, {
   3.611349520488191*^9, 3.6113495207731915`*^9}, {3.61135662216823*^9, 
   3.611356650328269*^9}, {3.611356914378639*^9, 3.611356917328643*^9}, {
   3.611357172009*^9, 3.611357172009*^9}, {3.61151114624172*^9, 
   3.6115111473142214`*^9}, {3.620233067837036*^9, 3.620233086697469*^9}, {
   3.6202333928740077`*^9, 3.6202334642753325`*^9}, 3.6202339138681226`*^9, {
   3.624745639354846*^9, 3.6247456402468967`*^9}, {3.637522303714407*^9, 
   3.6375223060594115`*^9}, 3.6390669973751264`*^9, {3.6444425214011884`*^9, 
   3.6444425218222127`*^9}, 3.6444425997666707`*^9, 3.6906631382090836`*^9, 
   3.6906631976551685`*^9, {3.6906632334152193`*^9, 3.69066323360522*^9}, {
   3.6908496403632865`*^9, 3.690849646876659*^9}, {3.6909187075544405`*^9, 
   3.690918707788441*^9}, {3.73275247923503*^9, 3.73275247941304*^9}, 
   3.7327713308632245`*^9, {3.7327723095445943`*^9, 3.7327723375746336`*^9}, {
   3.7327723773846893`*^9, 3.732772386344702*^9}, {3.7327729837355385`*^9, 
   3.732772983915539*^9}, {3.732807276136369*^9, 3.732807279286549*^9}, {
   3.7328073359837923`*^9, 3.732807338435932*^9}, {3.732853735319434*^9, 
   3.732853737225543*^9}, 3.7329885426420045`*^9, 3.7329918335712347`*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell[TextData[{
 "Rule",
 " 1.1.1.4.2.2.2.2.3",
 ": If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"2", " ", "m"}], "\[Element]", "\[DoubleStruckCapitalZ]"}], " ", 
   "\[And]", " ", 
   RowBox[{"m", "\[LessEqual]", 
    RowBox[{"-", "2"}]}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5269270224625387`*^9, 3.5269270224625387`*^9}, {
   3.5305583575562735`*^9, 3.530558360660679*^9}, {3.5347074228665404`*^9, 
   3.5347074228665404`*^9}, {3.549823103506521*^9, 3.549823103506521*^9}, {
   3.611356258837721*^9, 3.611356258837721*^9}, {3.63917293207978*^9, 
   3.63917293208078*^9}, 3.6501606099462337`*^9, 3.650160886705063*^9, {
   3.6906636169318275`*^9, 3.6906636171718283`*^9}, 3.698684025703457*^9, {
   3.7324999650142055`*^9, 3.73249996526722*^9}, {3.7327340558413467`*^9, 
   3.7327340651808815`*^9}, {3.7327546348363237`*^9, 
   3.7327546348363237`*^9}, {3.732760611532171*^9, 3.732760611532171*^9}, {
   3.732772395564715*^9, 3.732772395564715*^9}, {3.7328072883500676`*^9, 
   3.7328072883500676`*^9}, {3.732807344437276*^9, 3.732807344437276*^9}, 
   3.733337241886262*^9, {3.733337624577151*^9, 3.733337625925228*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
      SqrtBox[
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}]]}], 
     RowBox[{
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{
     "x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      FractionBox[
       RowBox[{"b", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}], 
         RowBox[{"m", "+", "1"}]], " ", 
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "e"}], "-", 
          RowBox[{"a", " ", "f"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", " ", "g"}], "-", 
          RowBox[{"a", " ", "h"}]}], ")"}]}]]}]}]}]}], "+", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{"m", "+", "1"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", " ", "e"}], "-", 
       RowBox[{"a", " ", "f"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"b", " ", "g"}], "-", 
       RowBox[{"a", " ", "h"}]}], ")"}]}]], 
   RowBox[{"\[Integral]", 
    RowBox[{
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"m", "+", "1"}]], 
       RowBox[{
        SqrtBox[
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}]], " ", 
        SqrtBox[
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}]]}]], "\[CenterDot]", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "a", " ", "c", " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "-", 
        RowBox[{"b", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"d", " ", "e", " ", "g"}], "+", 
           RowBox[{"c", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "m"}], "+", "3"}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"f", " ", "g"}], "+", 
              RowBox[{"e", " ", "h"}]}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"a", " ", "d", " ", "f", " ", "h", " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "-", 
           RowBox[{"b", " ", 
            RowBox[{"(", 
             RowBox[{"m", "+", "2"}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", " ", "f", " ", "g"}], "+", 
              RowBox[{"d", " ", "e", " ", "h"}], "+", 
              RowBox[{"c", " ", "f", " ", "h"}]}], ")"}]}]}], ")"}], " ", 
         "x"}], "-", 
        RowBox[{"b", " ", "d", " ", "f", " ", "h", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "m"}], "+", "5"}], ")"}], " ", 
         SuperscriptBox["x", "2"]}]}], ")"}]}], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.534708153634224*^9, 3.5347081639146423`*^9}, {3.5497629011259427`*^9, 
   3.5497629233702154`*^9}, {3.5498616853938155`*^9, 3.549861721713893*^9}, 
   3.611357133818946*^9, {3.620233165820808*^9, 3.620233188472048*^9}, {
   3.620233238230936*^9, 3.6202333387107124`*^9}, 3.6375239409018044`*^9, {
   3.63752401787834*^9, 3.637524038427576*^9}, 3.6375241001492853`*^9, {
   3.690664422109374*^9, 3.690664434984393*^9}, 3.690664511648303*^9, {
   3.690664767891613*^9, 3.6906648342781105`*^9}, 3.6906862370138397`*^9, 
   3.690686270846775*^9, 3.6906865143317013`*^9, {3.690686592792189*^9, 
   3.690686597382452*^9}, {3.690849723898064*^9, 3.6908497599941287`*^9}, {
   3.690849801173484*^9, 3.6908499318219566`*^9}, {3.7327713601732655`*^9, 
   3.7327713689032774`*^9}, {3.7327714316433654`*^9, 3.732771581493575*^9}, {
   3.7327716324936466`*^9, 3.7327716430536613`*^9}, 3.732857804979205*^9},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"e_.", "+", 
          RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"g_.", "+", 
          RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}]}], ",", "x_Symbol"}],
    "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{"b", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", "*", "x"}]}], ")"}], "^", 
      RowBox[{"(", 
       RowBox[{"m", "+", "1"}], ")"}]}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"c", "+", 
       RowBox[{"d", "*", "x"}]}], "]"}], "*", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"e", "+", 
       RowBox[{"f", "*", "x"}]}], "]"}], "*", 
     RowBox[{
      RowBox[{"Sqrt", "[", 
       RowBox[{"g", "+", 
        RowBox[{"h", "*", "x"}]}], "]"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "g"}], "-", 
          RowBox[{"a", "*", "h"}]}], ")"}]}], ")"}]}]}], " ", "+", " ", "\n", 
    "  ", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{"2", "*", 
        RowBox[{"(", 
         RowBox[{"m", "+", "1"}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "e"}], "-", 
          RowBox[{"a", "*", "f"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"b", "*", "g"}], "-", 
          RowBox[{"a", "*", "h"}]}], ")"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", "*", "x"}]}], ")"}], "^", 
           RowBox[{"(", 
            RowBox[{"m", "+", "1"}], ")"}]}], "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Sqrt", "[", 
             RowBox[{"c", "+", 
              RowBox[{"d", "*", "x"}]}], "]"}], "*", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"e", "+", 
              RowBox[{"f", "*", "x"}]}], "]"}], "*", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"g", "+", 
              RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ")"}], "*", "\n", 
        "    ", 
        RowBox[{"Simp", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"2", "*", "a", "*", "c", "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{"m", "+", "1"}], ")"}]}], "-", 
           RowBox[{"b", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"d", "*", "e", "*", "g"}], "+", 
              RowBox[{"c", "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", "*", "m"}], "+", "3"}], ")"}], "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"f", "*", "g"}], "+", 
                 RowBox[{"e", "*", "h"}]}], ")"}]}]}], ")"}]}], "+", 
           RowBox[{"2", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"a", "*", "d", "*", "f", "*", "h", "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "1"}], ")"}]}], "-", 
              RowBox[{"b", "*", 
               RowBox[{"(", 
                RowBox[{"m", "+", "2"}], ")"}], "*", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"d", "*", "f", "*", "g"}], "+", 
                 RowBox[{"d", "*", "e", "*", "h"}], "+", 
                 RowBox[{"c", "*", "f", "*", "h"}]}], ")"}]}]}], ")"}], "*", 
            "x"}], "-", 
           RowBox[{"b", "*", "d", "*", "f", "*", "h", "*", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "*", "m"}], "+", "5"}], ")"}], "*", 
            RowBox[{"x", "^", "2"}]}]}], ",", "x"}], "]"}]}], ",", "x"}], 
      "]"}]}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"IntegerQ", "[", 
     RowBox[{"2", "*", "m"}], "]"}], " ", "&&", " ", 
    RowBox[{"LeQ", "[", 
     RowBox[{"m", ",", 
      RowBox[{"-", "2"}]}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.534708187158683*^9, 3.5347082005279064`*^9}, {3.5422497179341545`*^9, 
   3.542249729168797*^9}, {3.5497629393551292`*^9, 3.5497629835886593`*^9}, {
   3.549851858039172*^9, 3.5498518680891857`*^9}, {3.5498618249998007`*^9, 
   3.5498618692023287`*^9}, 3.5499088165801616`*^9, 3.5499243027778444`*^9, {
   3.6113571393689537`*^9, 3.6113571439789605`*^9}, 3.6113571955290327`*^9, 
   3.611357234189087*^9, {3.620233638449639*^9, 3.620233652786064*^9}, {
   3.6202337399590173`*^9, 3.6202338180527544`*^9}, {3.6202340275611224`*^9, 
   3.620234033723133*^9}, 3.620234190987009*^9, {3.6375238754486885`*^9, 
   3.63752389858753*^9}, 3.6444425309977374`*^9, {3.6906621348624887`*^9, 
   3.6906621495825095`*^9}, {3.6906867607807975`*^9, 3.6906867777757697`*^9}, 
   3.690686824907466*^9, {3.690849985562031*^9, 3.690849989333246*^9}, {
   3.6908500749581437`*^9, 3.6908501341015263`*^9}, {3.7327713881833043`*^9, 
   3.732771418233347*^9}, 3.7327717566238203`*^9, {3.7327725108548765`*^9, 
   3.7327725188748875`*^9}, {3.732806856126346*^9, 3.73280686668495*^9}, {
   3.732807294788436*^9, 3.7328072994647036`*^9}, {3.7328073486815186`*^9, 
   3.732807351821698*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{Cell[TextData[StyleBox["3:",
   FontFamily->"Arial",
   FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}], ")"}], "q"]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}]}]], 
    RowBox[{"\[DifferentialD]", "x"}], "  ", 
    StyleBox["when",
     FontFamily->"Arial",
     FontWeight->"Plain"], 
    StyleBox["  ",
     FontFamily->"Arial",
     FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
     RowBox[{"0", "<", "p", "<", "1"}]]]], "None"]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767437792873`*^9}, {
   3.526877146135194*^9, 3.5268771603156185`*^9}, {3.5269176575336895`*^9, 
   3.526917673757718*^9}, 3.526917875278872*^9, {3.5269238483809633`*^9, 
   3.5269238905010376`*^9}, {3.526924565420223*^9, 3.526924565420223*^9}, {
   3.5305584520300393`*^9, 3.530558453792842*^9}, 3.534642640217794*^9, {
   3.5346427618058662`*^9, 3.534642770032271*^9}, {3.5346429890251036`*^9, 
   3.5346430159696445`*^9}, {3.5346430990603423`*^9, 
   3.5346431040603495`*^9}, {3.534706430158797*^9, 3.5347064517804346`*^9}, {
   3.5347066724272223`*^9, 3.5347066749388266`*^9}, {3.539393721147934*^9, 
   3.5393937213329444`*^9}, {3.5497618913221855`*^9, 3.549761909115203*^9}, {
   3.5498502762269573`*^9, 3.5498502777469597`*^9}, {3.5498503089070034`*^9, 
   3.5498503099570045`*^9}, 3.549850383817108*^9, {3.54992331236633*^9, 
   3.549923339378771*^9}, 3.575787109967823*^9, 3.611684542918018*^9, {
   3.624745003956503*^9, 3.624745009690831*^9}, 3.624745044053797*^9, {
   3.6247452054360275`*^9, 3.6247452054360275`*^9}, {3.6247452574350014`*^9, 
   3.6247452631943307`*^9}, {3.624745633200494*^9, 3.6247456341445475`*^9}, {
   3.6247595329735284`*^9, 3.6247595353296633`*^9}, {3.644442227090355*^9, 
   3.644442227090355*^9}, {3.733334089427952*^9, 3.733334089627963*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic expansion", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.52692391485268*^9, 
   3.5269239214514923`*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    RowBox[{"e", "+", 
     RowBox[{"f", " ", "x"}]}], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}]}]], "\[Equal]", 
   RowBox[{
    FractionBox[
     RowBox[{
      RowBox[{"b", " ", "e"}], "-", 
      RowBox[{"a", " ", "f"}]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "c"}], "-", 
        RowBox[{"a", " ", "d"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}]}]], "-", 
    FractionBox[
     RowBox[{
      RowBox[{"d", " ", "e"}], "-", 
      RowBox[{"c", " ", "f"}]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", " ", "c"}], "-", 
        RowBox[{"a", " ", "d"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}]}]]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5305579596307745`*^9, 3.5305579676023884`*^9}, {
   3.5346427869652395`*^9, 3.534642792293544*^9}, {3.534706470110467*^9, 
   3.534706470110467*^9}, {3.549762031180185*^9, 3.549762031180185*^9}, {
   3.549762081730076*^9, 3.549762098991063*^9}}],

Cell[TextData[{
 "Rule 1.1.1.4.3: If  ",
 Cell[BoxData[
  RowBox[{"0", "<", "p", "<", "1"}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5346428654127264`*^9, 3.5346428654127264`*^9}, {
   3.5346430222260027`*^9, 3.5346430222260027`*^9}, {3.534706547783003*^9, 
   3.534706547783003*^9}, {3.5497627390176706`*^9, 3.5497627390176706`*^9}, {
   3.549850317497015*^9, 3.549850317497015*^9}, {3.549923374569626*^9, 
   3.549923374569626*^9}, {3.6247452296214104`*^9, 3.6247452296214104`*^9}, {
   3.624745286470662*^9, 3.624745286470662*^9}, {3.6247595454992447`*^9, 
   3.6247595454992447`*^9}, {3.6444422348798003`*^9, 3.6444422348798003`*^9}, 
   3.650160604516923*^9, 3.650160826719632*^9, 3.698684024853456*^9, {
   3.7333372629924693`*^9, 3.733337263473497*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}], ")"}], "q"]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}]}]], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"x", "  ", "\[LongRightArrow]", "   ", 
      FractionBox[
       RowBox[{
        RowBox[{"b", " ", "e"}], "-", 
        RowBox[{"a", " ", "f"}]}], 
       RowBox[{
        RowBox[{"b", " ", "c"}], "-", 
        RowBox[{"a", " ", "d"}]}]]}]}], 
    RowBox[{"\[Integral]", 
     RowBox[{
      FractionBox[
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", " ", "x"}]}], ")"}], 
         RowBox[{"p", "-", "1"}]], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"g", "+", 
           RowBox[{"h", " ", "x"}]}], ")"}], "q"]}], 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]], 
      RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "-", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"d", " ", "e"}], "-", 
     RowBox[{"c", " ", "f"}]}], 
    RowBox[{
     RowBox[{"b", " ", "c"}], "-", 
     RowBox[{"a", " ", "d"}]}]], 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}], 
        RowBox[{"p", "-", "1"}]], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}], ")"}], "q"]}], 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, 3.526916903567412*^9, {3.5269170340875945`*^9, 
   3.526917062747635*^9}, {3.5269171093677*^9, 3.526917128097726*^9}, {
   3.526917461098192*^9, 3.5269174768182144`*^9}, {3.5269178784300776`*^9, 
   3.5269179471169987`*^9}, {3.5269246553387814`*^9, 
   3.5269247386273274`*^9}, {3.5305579040634766`*^9, 3.530557922315509*^9}, {
   3.5346428097875443`*^9, 3.534642846565648*^9}, 3.534643065883975*^9, 
   3.5346431768148212`*^9, {3.5347064789712825`*^9, 3.5347065323233757`*^9}, {
   3.5497621170410957`*^9, 3.549762150241995*^9}, {3.6247450971088314`*^9, 
   3.624745106689379*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}, {3.5269182420823164`*^9, 3.5269182473239255`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"g_.", "+", 
         RowBox[{"h_.", "*", "x_"}]}], ")"}], "^", "q_"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a_.", "+", 
          RowBox[{"b_.", "*", "x_"}]}], ")"}], "*", 
        RowBox[{"(", 
         RowBox[{"c_.", "+", 
          RowBox[{"d_.", "*", "x_"}]}], ")"}]}], ")"}]}]}], ",", "x_Symbol"}],
    "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "e"}], "-", 
        RowBox[{"a", "*", "f"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "c"}], "-", 
        RowBox[{"a", "*", "d"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"p", "-", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], ")"}], "^", "q"}], "/", 
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}]}]}], ",", "x"}], "]"}]}], " ", 
    "-", " ", "\n", "  ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"d", "*", "e"}], "-", 
        RowBox[{"c", "*", "f"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "c"}], "-", 
        RowBox[{"a", "*", "d"}]}], ")"}]}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"p", "-", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], ")"}], "^", "q"}], "/", 
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}]}]}], ",", "x"}], "]"}]}]}], " ", "/;",
    "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "q"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"LtQ", "[", 
     RowBox[{"0", ",", "p", ",", "1"}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.526917395788101*^9, 
   3.5269174003281074`*^9}, 3.5269176224804277`*^9, {3.526917704130972*^9, 
   3.5269177333186226`*^9}, 3.5269182671359606`*^9, 3.5269185743061*^9, {
   3.5269223222770834`*^9, 3.526922336395108*^9}, 3.526924992377373*^9, {
   3.5269250542470818`*^9, 3.5269250628738966`*^9}, 3.526925331163168*^9, {
   3.5305580438865223`*^9, 3.530558049206132*^9}, {3.5346428823552604`*^9, 
   3.534642883418321*^9}, {3.534642915328889*^9, 3.5346429770874205`*^9}, {
   3.5346430349337296`*^9, 3.534643069272169*^9}, {3.534706561869828*^9, 
   3.5347065627434297`*^9}, {3.5347065963926888`*^9, 3.534706652069186*^9}, {
   3.5422496922666864`*^9, 3.542249714546961*^9}, {3.5497627485022135`*^9, 
   3.549762823505503*^9}, {3.549850325277026*^9, 3.54985032801703*^9}, {
   3.5499133380558195`*^9, 3.5499133444234285`*^9}, {3.549913627024246*^9, 
   3.5499136325498543`*^9}, {3.549923369924418*^9, 3.54992337094442*^9}, {
   3.624745331409232*^9, 3.624745426022644*^9}, 3.624759548397411*^9, 
   3.633809111840438*^9, 3.6444422434972935`*^9, {3.707703515878764*^9, 
   3.7077035239595785`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{Cell[TextData[StyleBox["4:",
   FontFamily->"Arial",
   FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}], ")"}], "n"]}], 
     RowBox[{
      SqrtBox[
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}]], " ", 
      SqrtBox[
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}]]}]], 
    RowBox[{"\[DifferentialD]", "x"}], "  ", 
    StyleBox["when",
     FontFamily->"Arial",
     FontWeight->"Plain"], 
    StyleBox["  ",
     FontFamily->"Arial",
     FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
     RowBox[{
      RowBox[{"m", "\[Element]", "\[DoubleStruckCapitalZ]"}], " ", "\[And]", 
      " ", 
      RowBox[{
       RowBox[{"n", "+", 
        FractionBox["1", "2"]}], "\[Element]", 
       "\[DoubleStruckCapitalZ]"}]}]]]], "None"]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, 3.52105258275843*^9, 3.5210531741726685`*^9, {
   3.5210546076123867`*^9, 3.521054608501588*^9}, 3.521054662493283*^9, {
   3.5210553949769697`*^9, 3.5210554022309823`*^9}, {3.5210583222165103`*^9, 
   3.5210583230121117`*^9}, {3.5210583941170363`*^9, 3.5210584063318577`*^9}, 
   3.5210584790747857`*^9, {3.521060064957971*^9, 3.521060072757985*^9}, {
   3.521082260616851*^9, 3.5210822614904523`*^9}, {3.52113009847786*^9, 
   3.521130100847863*^9}, 3.521130270398101*^9, {3.521130707230714*^9, 
   3.5211307101207175`*^9}, {3.5211323369604993`*^9, 
   3.5211323372304993`*^9}, {3.521132896251282*^9, 3.521132896251282*^9}, {
   3.5211385329591737`*^9, 3.5211385474591937`*^9}, {3.5211385966992626`*^9, 
   3.5211385969392633`*^9}, {3.5213461542484126`*^9, 
   3.5213461684912376`*^9}, {3.5213462773638287`*^9, 
   3.5213462971914635`*^9}, {3.5213463292807198`*^9, 
   3.5213463294679203`*^9}, {3.5214702740491323`*^9, 3.521470274267533*^9}, {
   3.52165788792388*^9, 3.521657888743881*^9}, {3.523320835657395*^9, 
   3.523320835657395*^9}, {3.5233209134427214`*^9, 3.523320916089926*^9}, 
   3.523813150843855*^9, 3.5238138348548126`*^9, {3.5238290713201065`*^9, 
   3.523829099056955*^9}, {3.5238296649479485`*^9, 3.5238297067404222`*^9}, {
   3.523829934937623*^9, 3.523829934937623*^9}, {3.52383055375951*^9, 
   3.5238305545395117`*^9}, {3.523830634427252*^9, 3.523830634427252*^9}, {
   3.5238309055401278`*^9, 3.523830923121359*^9}, {3.5244196681994047`*^9, 
   3.5244196695894065`*^9}, {3.5244206800108213`*^9, 3.524420680240821*^9}, {
   3.524421241961608*^9, 3.524421248151616*^9}, {3.5244212963816843`*^9, 
   3.5244212963816843`*^9}, {3.524421345161752*^9, 3.524421345161752*^9}, {
   3.524444503850075*^9, 3.524444503850075*^9}, {3.5246998933411775`*^9, 
   3.524699893606378*^9}, {3.52812891856019*^9, 3.528128919120191*^9}, {
   3.5281294232008967`*^9, 3.5281294232008967`*^9}, {3.5281383473892374`*^9, 
   3.528138348467299*^9}, {3.529195256236579*^9, 3.52919525645498*^9}, {
   3.5306505719866905`*^9, 3.530650572270707*^9}, {3.5306637995800953`*^9, 
   3.530663799985696*^9}, {3.531839634027977*^9, 3.53183963425299*^9}, {
   3.542257933737274*^9, 3.5422579339556746`*^9}, 3.5694336147966413`*^9, 
   3.5694675015899763`*^9, {3.5694675665300674`*^9, 3.5694675666400676`*^9}, {
   3.569467740720311*^9, 3.569467740720311*^9}, 3.5695117310754433`*^9, {
   3.5695279924340324`*^9, 3.5695279924340324`*^9}, {3.5706815657019615`*^9, 
   3.570681565881962*^9}, {3.571538998405705*^9, 3.5715390130541306`*^9}, {
   3.571539381074377*^9, 3.5715394245672536`*^9}, {3.5715396513448515`*^9, 
   3.5715396591136656`*^9}, {3.571540576712477*^9, 3.5715405769152775`*^9}, 
   3.575835115124937*^9, {3.575842574132574*^9, 3.575842574512575*^9}, {
   3.575909478521679*^9, 3.575909478521679*^9}, {3.647383080784568*^9, 
   3.6473831132804265`*^9}, {3.647385179974634*^9, 3.6473852096983347`*^9}, {
   3.6473852653615184`*^9, 3.6473852751380777`*^9}, {3.647388644762809*^9, 
   3.6473886976868362`*^9}, {3.6473908844129095`*^9, 
   3.6473909253772526`*^9}, {3.647391276152316*^9, 3.647391276152316*^9}, {
   3.6473962765513225`*^9, 3.647396276948345*^9}, 3.647396316836626*^9, 
   3.732499299739154*^9, 3.732499409841451*^9, 3.7324995147814536`*^9, {
   3.732752448795289*^9, 3.732752450648395*^9}, 3.7328276533234763`*^9, {
   3.7328277218803973`*^9, 3.7328277221674137`*^9}, {3.732905441301149*^9, 
   3.7329054736279984`*^9}, {3.7329055176485157`*^9, 3.732905547884245*^9}, 
   3.7329886243366776`*^9, 3.7329918352063284`*^9, {3.7329920207779427`*^9, 
   3.732992020987954*^9}, {3.7330250864556894`*^9, 3.733025086729705*^9}, {
   3.7333340176338453`*^9, 3.7333340180708704`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic expansion", "Subsubsection",
 CellChangeTimes->{
  3.4953915070313115`*^9, 3.495840214754669*^9, {3.4958483177760134`*^9, 
   3.495848318886015*^9}, {3.495925911922002*^9, 3.495925920122013*^9}, 
   3.4961847242848682`*^9, 3.496184957525194*^9, 3.4961852577556148`*^9, 
   3.496185323645707*^9, {3.5185620328669024`*^9, 3.5185620358269067`*^9}, {
   3.7315212574568486`*^9, 3.7315212589229326`*^9}}],

Cell[TextData[{
 "Rule 1.1.1.4.4: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"m", "\[Element]", "\[DoubleStruckCapitalZ]"}], " ", "\[And]", " ", 
   RowBox[{
    RowBox[{"n", "+", 
     FractionBox["1", "2"]}], "\[Element]", "\[DoubleStruckCapitalZ]"}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.495391630941485*^9, 3.4953916682515373`*^9}, 
   3.495398892616804*^9, {3.4958401634645977`*^9, 3.4958401857746286`*^9}, {
   3.4958473680146837`*^9, 3.4958473796147003`*^9}, {3.4958475485149364`*^9, 
   3.4958475521949415`*^9}, 3.4958479936355596`*^9, {3.4958482113158646`*^9, 
   3.4958482413759065`*^9}, {3.4959266074329753`*^9, 3.4959266080829763`*^9}, 
   3.495926756033183*^9, {3.495926787613228*^9, 3.495926807093255*^9}, {
   3.496184862055061*^9, 3.496184906005122*^9}, {3.496185249265603*^9, 
   3.4961852497756033`*^9}, {3.496185408715826*^9, 3.496185414315834*^9}, {
   3.4962675483036656`*^9, 3.4962675483036656`*^9}, 3.51856219488713*^9, {
   3.5185626450277596`*^9, 3.518562650177767*^9}, {3.523829912832384*^9, 
   3.523829912832384*^9}, {3.5244212724516506`*^9, 3.5244213334417357`*^9}, {
   3.5244444234399624`*^9, 3.524444425759966*^9}, {3.5281294731909666`*^9, 
   3.5281294731909666`*^9}, {3.5694678292804356`*^9, 
   3.5694678292904353`*^9}, {3.5695279931860757`*^9, 
   3.5695279931860757`*^9}, {3.57153945699971*^9, 3.57153945699971*^9}, {
   3.5715397267709846`*^9, 3.5715397267709846`*^9}, {3.575842577812579*^9, 
   3.57584257814258*^9}, {3.5759095154817305`*^9, 3.5759095154817305`*^9}, {
   3.6473831650743885`*^9, 3.6473831650743885`*^9}, {3.6473840523621387`*^9, 
   3.6473840721682715`*^9}, {3.6473852934591255`*^9, 
   3.6473852948292036`*^9}, {3.6473887336558933`*^9, 
   3.6473887336558933`*^9}, {3.6473911089667535`*^9, 
   3.6473911089667535`*^9}, {3.6473912863448987`*^9, 
   3.6473912863448987`*^9}, {3.6473962845257783`*^9, 3.647396284856797*^9}, 
   3.6501606057169914`*^9, {3.650160840173402*^9, 3.6501608408304396`*^9}, 
   3.698684024993456*^9, {3.7324998425352*^9, 3.732499846715439*^9}, {
   3.7329057687398777`*^9, 3.7329057687398777`*^9}, {3.7333372732340555`*^9, 
   3.733337275296173*^9}}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   FractionBox[
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"]}], 
    RowBox[{
     SqrtBox[
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}]], " ", 
     SqrtBox[
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}]]}]], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
     RowBox[{"\[Integral]", 
      RowBox[{
       FractionBox["1", 
        RowBox[{
         SqrtBox[
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}]], " ", 
         SqrtBox[
          RowBox[{"e", "+", 
           RowBox[{"f", " ", "x"}]}]], " ", 
         SqrtBox[
          RowBox[{"g", "+", 
           RowBox[{"h", " ", "x"}]}]]}]], " ", 
       RowBox[{"ExpandIntegrand", "[", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"c", "+", 
             RowBox[{"d", " ", "x"}]}], ")"}], 
           RowBox[{"n", "+", 
            FractionBox["1", "2"]}]]}], ",", "x"}], "]"}], 
       RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, 3.4958399855843487`*^9, 3.495840155344586*^9, 
   3.495840624735243*^9, {3.4958474296047697`*^9, 3.495847433754776*^9}, {
   3.4958476539050837`*^9, 3.495847660315093*^9}, {3.4958482220958796`*^9, 
   3.4958482231858807`*^9}, {3.495848257515929*^9, 3.4958482607459335`*^9}, 
   3.4959261390123196`*^9, 3.4959262745925093`*^9, 3.4959264909328117`*^9, 
   3.4959265843129425`*^9, 3.495926967463479*^9, {3.496184978535224*^9, 
   3.496185020185282*^9}, {3.4961852001955347`*^9, 3.4961852261055703`*^9}, {
   3.4961852728856363`*^9, 3.496185277225642*^9}, 3.4961853904358006`*^9, {
   3.4961889798108253`*^9, 3.4961889815208282`*^9}, {3.518562046756922*^9, 
   3.518562110697012*^9}, {3.5185622764272437`*^9, 3.5185622785272465`*^9}, 
   3.518562355887355*^9, {3.518562398697415*^9, 3.518562404537423*^9}, {
   3.5238131517038565`*^9, 3.5238131525238576`*^9}, 3.523813835494814*^9, 
   3.5238142237653575`*^9, {3.5238297867841625`*^9, 3.523829803132992*^9}, {
   3.5238298429286613`*^9, 3.523829898433559*^9}, {3.5244196709694085`*^9, 
   3.52441967207941*^9}, 3.5715390328037653`*^9, {3.5715392069468713`*^9, 
   3.5715393068806467`*^9}, {3.6473831330625577`*^9, 
   3.6473831536377344`*^9}, {3.647383322693404*^9, 3.647383331695919*^9}, {
   3.6473834661376085`*^9, 3.6473835081600122`*^9}, 3.6473839773168464`*^9, {
   3.6473840853690267`*^9, 3.647384135527896*^9}, 3.6473852842405977`*^9, {
   3.647385583229699*^9, 3.64738564880345*^9}, {3.647388742987427*^9, 
   3.6473887462626143`*^9}, {3.6473887773903947`*^9, 
   3.6473888247961063`*^9}, {3.6473888574429736`*^9, 
   3.6473888820583816`*^9}, {3.6473909370609207`*^9, 
   3.6473909979844055`*^9}, {3.6473913110993147`*^9, 
   3.6473913213629017`*^9}, {3.732905707895397*^9, 3.732905739500205*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_."}], "*", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"c_.", "+", 
         RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Sqrt", "[", 
         RowBox[{"e_.", "+", 
          RowBox[{"f_.", "*", "x_"}]}], "]"}], "*", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"g_.", "+", 
          RowBox[{"h_.", "*", "x_"}]}], "]"}]}], ")"}]}]}], ",", "x_Symbol"}],
    "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{"Int", "[", 
    RowBox[{
     RowBox[{"ExpandIntegrand", "[", 
      RowBox[{
       RowBox[{"1", "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Sqrt", "[", 
           RowBox[{"c", "+", 
            RowBox[{"d", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"e", "+", 
            RowBox[{"f", "*", "x"}]}], "]"}], "*", 
          RowBox[{"Sqrt", "[", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], "]"}]}], ")"}]}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", "m"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"n", "+", 
           RowBox[{"1", "/", "2"}]}], ")"}]}]}], ",", "x"}], "]"}], ",", 
     "x"}], "]"}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"IntegerQ", "[", "m", "]"}], " ", "&&", " ", 
    RowBox[{"IntegerQ", "[", 
     RowBox[{"n", "+", 
      RowBox[{"1", "/", "2"}]}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495839738475589*^9, 3.4958405008250694`*^9, {3.495847490784856*^9, 
   3.4958474999948683`*^9}, {3.4958477172451725`*^9, 3.495847721615179*^9}, {
   3.495848224085882*^9, 3.4958482277058873`*^9}, {3.4958482626259365`*^9, 
   3.4958482686359444`*^9}, 3.4959261054722724`*^9, {3.4959262905725317`*^9, 
   3.4959262958725395`*^9}, 3.495926443222745*^9, 3.4961849395451694`*^9, 
   3.4961850632853427`*^9, 3.4961853185857*^9, 3.4961888959707084`*^9, {
   3.496188982370829*^9, 3.496188986330835*^9}, 3.496192048577755*^9, 
   3.4962675676636925`*^9, {3.5185624885675406`*^9, 3.518562496237551*^9}, {
   3.518562547487623*^9, 3.5185626097977104`*^9}, {3.523813158043865*^9, 
   3.5238131614338703`*^9}, 3.5238139584449863`*^9, 3.523813999365043*^9, 
   3.5238142291353645`*^9, {3.5238299636104736`*^9, 3.5238301675184317`*^9}, 
   3.52383067334932*^9, {3.5244213477317557`*^9, 3.524421368161784*^9}, {
   3.524443220744276*^9, 3.524443224704282*^9}, {3.5244444335499763`*^9, 
   3.5244444796100407`*^9}, 3.526581658278122*^9, {3.5281294508309355`*^9, 
   3.5281294540409403`*^9}, 3.5293663075774918`*^9, {3.542258370114113*^9, 
   3.5422583804941273`*^9}, {3.5694677548103313`*^9, 3.569467756710334*^9}, 
   3.569528092536758*^9, {3.5715394712737355`*^9, 3.571539483301357*^9}, {
   3.5715395655291014`*^9, 3.5715396219856005`*^9}, {3.571539689689719*^9, 
   3.5715396972089324`*^9}, 3.5718730606903872`*^9, {3.575842464902421*^9, 
   3.575842470422429*^9}, {3.5759095227217407`*^9, 3.575909564601799*^9}, {
   3.6473831982872887`*^9, 3.6473832479261274`*^9}, {3.6473838685646257`*^9, 
   3.6473839443979635`*^9}, {3.647384150313741*^9, 3.6473841690638137`*^9}, {
   3.647384231464383*^9, 3.6473842797691455`*^9}, {3.647384830810663*^9, 
   3.647384831123681*^9}, {3.647385727092928*^9, 3.647385738954606*^9}, {
   3.6473889412687683`*^9, 3.6473889744566665`*^9}, {3.6473890059994707`*^9, 
   3.6473890084686117`*^9}, {3.64738941632994*^9, 3.6473894252324495`*^9}, {
   3.6473910393337708`*^9, 3.647391100593274*^9}, 3.6473911552283993`*^9, {
   3.6473913436661777`*^9, 3.6473913999983997`*^9}, {3.6473919863549376`*^9, 
   3.6473919903991685`*^9}, {3.647395990760976*^9, 3.6473959928420954`*^9}, {
   3.732827688573492*^9, 3.7328276942698183`*^9}, {3.732905662884823*^9, 
   3.732905667131066*^9}, {3.7329058250190964`*^9, 3.7329058784831543`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{Cell[TextData[StyleBox["5:",
   FontFamily->"Arial",
   FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], "q"], 
    RowBox[{"\[DifferentialD]", "x"}], "  ", 
    StyleBox["when",
     FontFamily->"Arial",
     FontWeight->"Plain"], " ", Cell[TextData[Cell[BoxData[
     RowBox[{
      RowBox[{"(", 
       RowBox[{"p", "|", "q"}], ")"}], "\[Element]", 
      "\[DoubleStruckCapitalZ]"}]]]], "None"]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, 
   3.5239334940268483`*^9, {3.524105742828332*^9, 3.524105745433536*^9}, {
   3.524105783326003*^9, 3.5241058043704395`*^9}, {3.524167197804468*^9, 
   3.524167275274576*^9}, {3.5241673584446926`*^9, 3.5241673584446926`*^9}, {
   3.5241684217861814`*^9, 3.5241684663262434`*^9}, {3.5241684966162863`*^9, 
   3.5241685133463097`*^9}, {3.524168558706373*^9, 3.524168575716397*^9}, {
   3.5242542194504414`*^9, 3.5242543397578526`*^9}, {3.5242543718471093`*^9, 
   3.5242544424216332`*^9}, {3.524254478910097*^9, 3.5242545759266677`*^9}, {
   3.5242546436307864`*^9, 3.5242546436307864`*^9}, {3.5242547267009325`*^9, 
   3.5242547400857563`*^9}, {3.5242771462350645`*^9, 
   3.5242771465938654`*^9}, {3.5304877376854625`*^9, 3.530487831775594*^9}, {
   3.5305002113339696`*^9, 3.53050021156397*^9}, {3.531256229526664*^9, 
   3.5312562621635933`*^9}, 3.5312563043041887`*^9, 3.5312565353964834`*^9, 
   3.5312718541780033`*^9, {3.531272022680298*^9, 3.531272043970912*^9}, 
   3.5312721159644337`*^9, {3.531286527477171*^9, 3.53128654727564*^9}, {
   3.53133653657067*^9, 3.5313365374719667`*^9}, {3.5332481026588316`*^9, 
   3.5332481046588345`*^9}, {3.533940608115779*^9, 3.5339406083757796`*^9}, {
   3.533940643135828*^9, 3.533940671755868*^9}, {3.53394080166605*^9, 
   3.53394080166605*^9}, {3.5339408897661734`*^9, 3.5339408897661734`*^9}, {
   3.5340308298369713`*^9, 3.534030830046972*^9}, {3.5346431179954567`*^9, 
   3.534643118292474*^9}, {3.5347066963108644`*^9, 3.5347066964980645`*^9}, {
   3.534708277732442*^9, 3.5347082781536427`*^9}, {3.535151707447782*^9, 
   3.5351517076977825`*^9}, 3.535151798067909*^9, {3.5351519292380924`*^9, 
   3.535151929478093*^9}, {3.5351519735681543`*^9, 3.5351519759881577`*^9}, {
   3.5356775270969605`*^9, 3.5356775274089613`*^9}, {3.539393933879423*^9, 
   3.539393934044432*^9}, 3.5498225109556913`*^9, {3.549822628955857*^9, 
   3.549822647825883*^9}, {3.549822827116134*^9, 3.549822827116134*^9}, {
   3.549823176416623*^9, 3.549823176416623*^9}, {3.557036998713605*^9, 
   3.557037010133621*^9}, {3.5717047240392337`*^9, 3.571704765779292*^9}, {
   3.571705008649632*^9, 3.571705008649632*^9}, {3.571705176359867*^9, 
   3.571705176569867*^9}, 3.575822927156911*^9, {3.6202330879142714`*^9, 
   3.6202330880858717`*^9}, {3.620234233465884*^9, 3.6202342336218843`*^9}, {
   3.6247454341601095`*^9, 3.6247454345181303`*^9}, {3.644442350360406*^9, 
   3.644442350539416*^9}, {3.6444426202188406`*^9, 3.6444426204158516`*^9}, {
   3.6473907052756634`*^9, 3.6473907054156713`*^9}, {3.649721000824097*^9, 
   3.6497210010424976`*^9}, {3.690663546440727*^9, 3.6906635466807275`*^9}, {
   3.732499903189669*^9, 3.732499903418682*^9}, {3.7327608944663534`*^9, 
   3.732760894705367*^9}, {3.7333340918660913`*^9, 3.7333340920811033`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic expansion", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9}],

Cell[TextData[{
 "Rule 1.1.1.4.5: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"(", 
    RowBox[{"p", "|", "q"}], ")"}], "\[Element]", 
   "\[DoubleStruckCapitalZ]"}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4957339078770905`*^9, 
   3.495733966267172*^9}, {3.495734148157427*^9, 3.4957341584974413`*^9}, {
   3.4957346698781567`*^9, 3.495734670108157*^9}, {3.4957347778783083`*^9, 
   3.4957348688784356`*^9}, {3.5182850739057484`*^9, 
   3.5182850817837625`*^9}, {3.5193219410789022`*^9, 
   3.5193219437309074`*^9}, {3.5193301726195183`*^9, 
   3.5193301738595195`*^9}, {3.5199710233740273`*^9, 3.519971026084031*^9}, {
   3.519971058314076*^9, 3.519971083934112*^9}, {3.523219270157716*^9, 
   3.523219270157716*^9}, {3.523924231484662*^9, 3.523924232592264*^9}, {
   3.523930223132303*^9, 3.5239302243647056`*^9}, {3.523933687825989*^9, 
   3.523933687825989*^9}, {3.5241691044427414`*^9, 3.5241691044427414`*^9}, {
   3.530487866440643*^9, 3.530487866440643*^9}, 3.5312563413574686`*^9, 
   3.531272069487603*^9, 3.531272113390733*^9, {3.5339408766961555`*^9, 
   3.5339408833261642`*^9}, {3.535151983378168*^9, 3.535151983378168*^9}, {
   3.549822632795862*^9, 3.5498226330958624`*^9}, {3.549822682015931*^9, 
   3.54982272404599*^9}, {3.5498232150566773`*^9, 3.5498232150566773`*^9}, {
   3.557037022373638*^9, 3.557037022373638*^9}, {3.5717049817995944`*^9, 
   3.5717049913396077`*^9}, 3.6501606093421993`*^9, 3.65016088280084*^9, {
   3.6906636087198153`*^9, 3.6906636089898157`*^9}, 3.698684025583457*^9, {
   3.7324999607159595`*^9, 3.732499960956973*^9}}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"a", "+", 
      RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"e", "+", 
      RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], "q"], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
     RowBox[{"\[Integral]", 
      RowBox[{
       RowBox[{"ExpandIntegrand", "[", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"a", "+", 
             RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"c", "+", 
             RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"e", "+", 
             RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"g", "+", 
             RowBox[{"h", " ", "x"}]}], ")"}], "q"]}], ",", "x"}], "]"}], 
       RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, {3.4954224033621993`*^9, 3.495422429782236*^9}, {
   3.4962830099393682`*^9, 3.496283015729377*^9}, {3.5241060284804335`*^9, 
   3.5241060764193172`*^9}, {3.524167368204706*^9, 3.5241674428548107`*^9}, {
   3.524168833516758*^9, 3.5241688560167894`*^9}, {3.53038360604578*^9, 
   3.530383613747221*^9}, 3.530383659086814*^9, {3.5312563478167567`*^9, 
   3.5312563530442734`*^9}, {3.531271888617525*^9, 3.5312718914516*^9}, {
   3.533940690055894*^9, 3.533940693145898*^9}, 3.535151793377902*^9, 
   3.5351518250179462`*^9, 3.536688185927653*^9, {3.549822542075735*^9, 
   3.54982254557574*^9}, {3.5717048603194246`*^9, 3.571704873449443*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"g_.", "+", 
        RowBox[{"h_.", "*", "x_"}]}], ")"}], "^", "q_"}]}], ",", "x_Symbol"}],
    "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{"Int", "[", 
    RowBox[{
     RowBox[{"ExpandIntegrand", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", "m"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"g", "+", 
           RowBox[{"h", "*", "x"}]}], ")"}], "^", "q"}]}], ",", "x"}], "]"}], 
     ",", "x"}], "]"}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m", ",", "n"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"IntegersQ", "[", 
     RowBox[{"p", ",", "q"}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.495422238811969*^9, 3.5239327382679205`*^9, {3.5241061049829674`*^9, 
   3.5241061158093867`*^9}, {3.5241061634986706`*^9, 3.524106178100296*^9}, {
   3.5241522039971824`*^9, 3.5241522138657465`*^9}, {3.524167459434834*^9, 
   3.524167501524893*^9}, 3.5241675598849745`*^9, {3.5241689646025457`*^9, 
   3.524169057582676*^9}, {3.5241694886052837`*^9, 3.5241694922252893`*^9}, {
   3.5241697349256287`*^9, 3.524169770915679*^9}, {3.524169890175846*^9, 
   3.52416989278585*^9}, {3.5241699517859325`*^9, 3.524169977745969*^9}, {
   3.5241702075262904`*^9, 3.5241702284463196`*^9}, {3.5241703474164867`*^9, 
   3.5241703535564947`*^9}, {3.5241704168565836`*^9, 
   3.5241704281665993`*^9}, {3.5241707090069923`*^9, 3.5241707118469963`*^9}, 
   3.5241707660170727`*^9, {3.5241735897163877`*^9, 3.524173666646496*^9}, {
   3.524173777586651*^9, 3.5241738523767557`*^9}, {3.5241739428768826`*^9, 
   3.524173979156933*^9}, 3.524174297647379*^9, {3.524185483815135*^9, 
   3.524185485365137*^9}, {3.524185602895302*^9, 3.5241856035153027`*^9}, {
   3.5241856771854057`*^9, 3.5241856830554132`*^9}, {3.524185838105631*^9, 
   3.5241858734356804`*^9}, {3.5241859285057573`*^9, 3.524185944045779*^9}, {
   3.524186003185862*^9, 3.524186038265911*^9}, {3.52418611602602*^9, 
   3.5241861192260246`*^9}, 3.524186217346162*^9, 3.5241863019362803`*^9, {
   3.5241863667163706`*^9, 3.5241863784563875`*^9}, {3.52418651596658*^9, 
   3.5241865406766143`*^9}, {3.5241867699369354`*^9, 
   3.5241868085469894`*^9}, {3.5241868836270943`*^9, 3.5241869237971506`*^9}, 
   3.5241869873472395`*^9, {3.5241870885173817`*^9, 3.524187101037399*^9}, {
   3.5241871740575013`*^9, 3.5241871912575254`*^9}, {3.524187306817687*^9, 
   3.5241873162877*^9}, {3.5241873622777643`*^9, 3.524187409757831*^9}, 
   3.524187460357902*^9, {3.5241874977879543`*^9, 3.524187498347955*^9}, {
   3.524187557468038*^9, 3.5241875586680393`*^9}, {3.524187589468083*^9, 
   3.5241875901780834`*^9}, {3.5241876610181828`*^9, 
   3.5241876929782276`*^9}, {3.524187781768352*^9, 3.524187783788355*^9}, {
   3.5241896786382575`*^9, 3.524189683318266*^9}, {3.524234559451813*^9, 
   3.5242346007294855`*^9}, {3.524238368588504*^9, 3.5242383752965155`*^9}, {
   3.5242384122217803`*^9, 3.524238419928194*^9}, {3.5242393344018*^9, 
   3.524239346819422*^9}, {3.5242394127451377`*^9, 3.5242394565500145`*^9}, {
   3.52423959033585*^9, 3.524239629803919*^9}, {3.524239671487192*^9, 
   3.5242397220468807`*^9}, {3.524239788190997*^9, 3.5242398647715316`*^9}, {
   3.5242437175850987`*^9, 3.5242437668343854`*^9}, {3.524244465247612*^9, 
   3.5242444873372507`*^9}, {3.524244751882516*^9, 3.524244753208518*^9}, {
   3.524245115768755*^9, 3.524245137000392*^9}, {3.5242452528149953`*^9, 
   3.5242452554826*^9}, {3.5242456723777323`*^9, 3.5242456731889334`*^9}, {
   3.524245869936479*^9, 3.5242459980595045`*^9}, {3.5242461068384953`*^9, 
   3.5242461450273623`*^9}, {3.524246187958638*^9, 3.52424618922224*^9}, {
   3.5242462316543145`*^9, 3.524246267690378*^9}, {3.5242463181564665`*^9, 
   3.5242463224620743`*^9}, {3.5242485499936485`*^9, 3.524248561823665*^9}, {
   3.524248621593749*^9, 3.5242486251937537`*^9}, {3.5242487642059507`*^9, 
   3.5242487732359633`*^9}, {3.5242532845563993`*^9, 
   3.5242532909524107`*^9}, {3.52425347849594*^9, 3.5242535106475964`*^9}, {
   3.524253596868948*^9, 3.5242536191613874`*^9}, {3.5242537436028056`*^9, 
   3.5242537593588333`*^9}, 3.5242539276207285`*^9, {3.524254113276655*^9, 
   3.5242541142126565`*^9}, {3.5242547334245443`*^9, 3.5242547363105493`*^9}, 
   3.5249480328482866`*^9, 3.5249480870383625`*^9, 3.530383624409831*^9, 
   3.5303836572717104`*^9, {3.5304855821174417`*^9, 3.5304855869274483`*^9}, {
   3.530486056548106*^9, 3.530486059638111*^9}, {3.5304860949231606`*^9, 
   3.5304860971731634`*^9}, {3.530486238303361*^9, 3.530486240243364*^9}, {
   3.530486952589362*^9, 3.5304870139844484`*^9}, {3.5304870692495255`*^9, 
   3.5304871419796276`*^9}, 3.530487215744731*^9, {3.530487355799927*^9, 
   3.5304873566799283`*^9}, {3.5304874052599964`*^9, 3.530487445625053*^9}, {
   3.530487479950101*^9, 3.5304874842801075`*^9}, {3.5304875702952275`*^9, 
   3.5304875724102306`*^9}, {3.5304876163102922`*^9, 
   3.5304876315153136`*^9}, {3.5312563706495886`*^9, 3.531256451626027*^9}, 
   3.531256559250784*^9, {3.5312719121413507`*^9, 3.5312719878001423`*^9}, {
   3.5312755920427885`*^9, 3.5312755952874546`*^9}, {3.5312856302770605`*^9, 
   3.531285654712197*^9}, {3.53128571933512*^9, 3.531285787002421*^9}, {
   3.5312858245464067`*^9, 3.53128595057763*^9}, {3.5312865586519985`*^9, 
   3.5312865654417615`*^9}, 3.5312884106750765`*^9, 3.5312884470173345`*^9, {
   3.5312884901092978`*^9, 3.5312885050908403`*^9}, {3.5312897715218782`*^9, 
   3.531289778872448*^9}, {3.531289921757907*^9, 3.531289929969715*^9}, {
   3.5312899831061215`*^9, 3.531289984918728*^9}, {3.5312906523184013`*^9, 
   3.5312906554428945`*^9}, {3.5313272051827936`*^9, 
   3.5313272099296193`*^9}, {3.531327286489707*^9, 3.5313272948817744`*^9}, {
   3.531328437394627*^9, 3.5313284476694016`*^9}, {3.531328488668355*^9, 
   3.5313284899702272`*^9}, {3.5313285673514957`*^9, 
   3.5313285721283646`*^9}, {3.531328972333832*^9, 3.5313290468309536`*^9}, 
   3.5313291984689984`*^9, 3.5313298886113744`*^9, {3.5313316869672832`*^9, 
   3.5313316871876*^9}, {3.531333470732211*^9, 3.531333473936819*^9}, {
   3.531334503567355*^9, 3.5313345333702097`*^9}, {3.531334712117235*^9, 
   3.531334724334803*^9}, {3.5313353872780685`*^9, 3.531335388289523*^9}, 
   3.531335434696253*^9, {3.5313387527874336`*^9, 3.5313387613597603`*^9}, {
   3.531339025249214*^9, 3.5313390434353647`*^9}, 3.531341876639312*^9, {
   3.5313421989627905`*^9, 3.531342251227944*^9}, {3.531346616364702*^9, 
   3.531346616715206*^9}, {3.5313466656655936`*^9, 3.5313466801764593`*^9}, {
   3.5315136290734544`*^9, 3.531513629934693*^9}, {3.531605034435397*^9, 
   3.5316050365784783`*^9}, {3.5316052098275986`*^9, 
   3.5316052120307665`*^9}, {3.531605458364978*^9, 3.531605459536662*^9}, {
   3.531699937927347*^9, 3.531699949764368*^9}, {3.531700346314579*^9, 
   3.531700368586605*^9}, {3.533937757524288*^9, 3.5339377669843016`*^9}, {
   3.5339377979043446`*^9, 3.533937819634375*^9}, {3.533938179374879*^9, 
   3.5339381969849033`*^9}, {3.5339382401149635`*^9, 3.533938297835045*^9}, {
   3.533938343125108*^9, 3.53393834467511*^9}, {3.533940711115923*^9, 
   3.533940734385956*^9}, {3.533940828086087*^9, 3.533940838736102*^9}, {
   3.5339509493977776`*^9, 3.533950953016984*^9}, {3.5339537404454803`*^9, 
   3.533953741022681*^9}, {3.535149061766073*^9, 3.5351490873961086`*^9}, 
   3.53515177762788*^9, {3.535151835707961*^9, 3.535151875438017*^9}, 
   3.536688185946654*^9, {3.5498225630257645`*^9, 3.549822615605838*^9}, {
   3.5498226665359097`*^9, 3.549822670285915*^9}, {3.5498227309059997`*^9, 
   3.549822731346*^9}, 3.549823269906754*^9, 3.5498566016258125`*^9, 
   3.5570370288136473`*^9, {3.5717047996193395`*^9, 3.5717048127093573`*^9}, {
   3.5717048993794794`*^9, 3.5717049319795246`*^9}, {3.6113494776206117`*^9, 
   3.6113494821581182`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{Cell[TextData[StyleBox["6:",
   FontFamily->"Arial",
   FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], "p"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], "q"], 
    RowBox[{"\[DifferentialD]", "x"}], "  ", 
    StyleBox["when",
     FontFamily->"Arial",
     FontWeight->"Plain"], 
    StyleBox["  ",
     FontFamily->"Arial",
     FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
     RowBox[{"q", "\[Element]", 
      SuperscriptBox["\[DoubleStruckCapitalZ]", "+"]}]]]], 
     "None"]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767252620544`*^9}, {
   3.526876907329974*^9, 3.5268769569848614`*^9}, {3.5269242339668407`*^9, 
   3.5269242339668407`*^9}, 3.5269267394468417`*^9, {3.526927027594948*^9, 
   3.526927035675762*^9}, {3.530558366526289*^9, 3.5305583787255106`*^9}, {
   3.5305584367264123`*^9, 3.5305584385984154`*^9}, {3.531942849761632*^9, 
   3.531942849917632*^9}, {3.5339406784958773`*^9, 3.5339406791758785`*^9}, {
   3.5341185863023334`*^9, 3.5341185863023334`*^9}, {3.534126360463763*^9, 
   3.534126361033764*^9}, {3.5347073402331953`*^9, 3.5347073404671955`*^9}, {
   3.534707390340483*^9, 3.534707390340483*^9}, {3.5393939323303337`*^9, 
   3.5393939325113444`*^9}, {3.5498230222764077`*^9, 3.5498230222764077`*^9}, 
   3.5717051155797815`*^9, 3.5758229229669046`*^9, {3.611349524660698*^9, 
   3.611349524893198*^9}, {3.6113560726974607`*^9, 3.611356089987485*^9}, {
   3.611510728968608*^9, 3.611510728968608*^9}, {3.6115112953519373`*^9, 
   3.611511295611938*^9}, {3.6314138645722046`*^9, 3.631413864872222*^9}, {
   3.6379383894122734`*^9, 3.6379383896322737`*^9}, 3.6379584590480404`*^9, 
   3.6379585599736185`*^9, {3.6391728226255198`*^9, 3.6391728396364927`*^9}, {
   3.639172884834078*^9, 3.6391729208191357`*^9}, {3.6391730966401925`*^9, 
   3.6391730998323746`*^9}, {3.6444423527025394`*^9, 
   3.6444423529075513`*^9}, {3.6444426224379673`*^9, 3.644442622688982*^9}, {
   3.6473907075427933`*^9, 3.6473907077218037`*^9}, {3.649721005238905*^9, 
   3.649721005441705*^9}, {3.69066354856073*^9, 3.6906635487407303`*^9}, {
   3.732499905420797*^9, 3.7324999056638107`*^9}, {3.732760896742484*^9, 
   3.732760896976497*^9}, {3.7333341203847227`*^9, 3.7333341205807333`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic expansion", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"g", "+", 
    RowBox[{"h", " ", "x"}]}], "\[Equal]", 
   RowBox[{
    FractionBox[
     RowBox[{"h", " ", 
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}]}], "b"], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"b", " ", "g"}], "-", 
      RowBox[{"a", " ", "h"}]}], "b"]}]}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}}],

Cell[TextData[{
 "Rule 1.1.1.4.6: If  ",
 Cell[BoxData[
  RowBox[{"q", "\[Element]", 
   SuperscriptBox["\[DoubleStruckCapitalZ]", "+"]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5269270224625387`*^9, 3.5269270224625387`*^9}, {
   3.5305583575562735`*^9, 3.530558360660679*^9}, {3.5347074228665404`*^9, 
   3.5347074228665404`*^9}, {3.549823103506521*^9, 3.549823103506521*^9}, {
   3.611356258837721*^9, 3.611356258837721*^9}, {3.63917293207978*^9, 
   3.63917293208078*^9}, 3.6501606099462337`*^9, 3.650160886705063*^9, {
   3.6906636169318275`*^9, 3.6906636171718283`*^9}, 3.698684025703457*^9, {
   3.7324999650142055`*^9, 3.73249996526722*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], "p"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], "q"], 
    RowBox[{"\[DifferentialD]", 
     RowBox[{"x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
      FractionBox["h", "b"]}]}], 
    RowBox[{"\[Integral]", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], 
       RowBox[{"m", "+", "1"}]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], "p"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}], ")"}], 
       RowBox[{"q", "-", "1"}]], 
      RowBox[{"\[DifferentialD]", "x"}]}]}]}]}], "+", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"b", " ", "g"}], "-", 
     RowBox[{"a", " ", "h"}]}], "b"], 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}], ")"}], "p"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}], ")"}], 
      RowBox[{"q", "-", "1"}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, {3.526876998184534*^9, 3.526877026217783*^9}, {
   3.5269267437524495`*^9, 3.5269267730181007`*^9}, {3.526927247898535*^9, 
   3.5269273030134315`*^9}, {3.5305581442882986`*^9, 
   3.5305581869543734`*^9}, {3.611356104997506*^9, 3.6113561134475174`*^9}, {
   3.611356245767703*^9, 3.6113562484177065`*^9}, 3.6115107423236275`*^9, {
   3.611510804573718*^9, 3.611510839793771*^9}, {3.6115109977190027`*^9, 
   3.611511008154019*^9}, {3.6314127071020007`*^9, 3.631412710136174*^9}, {
   3.63795846466405*^9, 3.6379584653972516`*^9}, {3.637958565355628*^9, 
   3.63795856660363*^9}, 3.6379592397895403`*^9, 3.639172945063523*^9, {
   3.639173067893548*^9, 3.6391730944800687`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"g_.", "+", 
        RowBox[{"h_.", "*", "x_"}]}], ")"}], "^", "q_"}]}], ",", "x_Symbol"}],
    "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"h", "/", "b"}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"m", "+", "1"}], ")"}]}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"g", "+", 
           RowBox[{"h", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"q", "-", "1"}], ")"}]}]}], ",", "x"}], "]"}]}], " ", "+", 
    " ", "\n", "  ", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"b", "*", "g"}], "-", 
        RowBox[{"a", "*", "h"}]}], ")"}], "/", "b"}], "*", 
     RowBox[{"Int", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", "m"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"g", "+", 
           RowBox[{"h", "*", "x"}]}], ")"}], "^", 
         RowBox[{"(", 
          RowBox[{"q", "-", "1"}], ")"}]}]}], ",", "x"}], "]"}]}]}], " ", "/;",
    "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m", ",", "n", ",", "p"}], "}"}], ",", "x"}], "]"}], " ", "&&",
     " ", 
    RowBox[{"IGtQ", "[", 
     RowBox[{"q", ",", "0"}], "]"}], " ", "&&", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SumSimplerQ", "[", 
       RowBox[{"m", ",", "1"}], "]"}], " ", "||", " ", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{"SumSimplerQ", "[", 
         RowBox[{"n", ",", "1"}], "]"}], "]"}], " ", "&&", " ", 
       RowBox[{"Not", "[", 
        RowBox[{"SumSimplerQ", "[", 
         RowBox[{"p", ",", "1"}], "]"}], "]"}]}]}], ")"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.5268770685406575`*^9, 
   3.526877093875102*^9}, 3.5268771340139728`*^9, {3.5268772574725895`*^9, 
   3.5268772665362053`*^9}, 3.526918736047184*^9, {3.5269248094046516`*^9, 
   3.5269248214790726`*^9}, {3.5269273228098664`*^9, 3.526927337832693*^9}, 
   3.5269274194832363`*^9, 3.5269274496068892`*^9, {3.530558205830407*^9, 
   3.5305582319292526`*^9}, {3.5305584134979715`*^9, 3.530558416742777*^9}, {
   3.530558496131316*^9, 3.530558497223318*^9}, 3.53470741696973*^9, {
   3.542249963774038*^9, 3.542249976738779*^9}, 3.54982311701654*^9, {
   3.6104719528423166`*^9, 3.6104720245024166`*^9}, {3.611356300147779*^9, 
   3.6113563823778944`*^9}, {3.611356434467967*^9, 3.6113564361279697`*^9}, 
   3.611511110881668*^9, 3.61152794381289*^9, {3.611542003192854*^9, 
   3.611542057370434*^9}, 3.6115422634207416`*^9, {3.6115425950312333`*^9, 
   3.611542608601253*^9}, {3.63141271425541*^9, 3.6314127182346373`*^9}, 
   3.637938298965144*^9, {3.637958468236457*^9, 3.637958469500059*^9}, {
   3.637958569817236*^9, 3.6379585715332384`*^9}, 3.637959278622408*^9, {
   3.639173251380043*^9, 3.639173252292095*^9}, {3.6391733341737785`*^9, 
   3.639173358750184*^9}, {3.639173388782902*^9, 3.6391733952732735`*^9}, {
   3.7075935059091597`*^9, 3.7075935183358707`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{Cell[TextData[StyleBox["C:",
   FontFamily->"Arial",
   FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "x"}]}], ")"}], "q"], 
    RowBox[{"\[DifferentialD]", "x"}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519247363296011*^9, 3.519247363796012*^9}, 3.519258420199427*^9, 
   3.5192584863895197`*^9, {3.519320760160028*^9, 3.519320767367241*^9}, 
   3.5193299099191504`*^9, {3.5193300315093203`*^9, 3.519330031709321*^9}, {
   3.5193323099968634`*^9, 3.5193324414114943`*^9}, {3.5193327317904043`*^9, 
   3.519332762148057*^9}, {3.519340455685931*^9, 3.519340463318947*^9}, 
   3.519340635545749*^9, {3.5193422478304834`*^9, 3.519342248704085*^9}, {
   3.519342492766513*^9, 3.519342493156514*^9}, {3.519345750301442*^9, 
   3.5193457505978427`*^9}, 3.519346263464343*^9, {3.519349307658399*^9, 
   3.519349310965605*^9}, {3.519352294781488*^9, 3.5193522950014887`*^9}, {
   3.5194134359455075`*^9, 3.519413446054325*^9}, {3.5194134908888044`*^9, 
   3.5194134927764077`*^9}, {3.5194141847624226`*^9, 
   3.5194142323581066`*^9}, {3.519414342899901*^9, 3.519414474720132*^9}, {
   3.5197939535480833`*^9, 3.5197939539380836`*^9}, {3.5197940297698174`*^9, 
   3.5197940299726176`*^9}, 3.519795153580191*^9, {3.5200103027397947`*^9, 
   3.5200103044997973`*^9}, {3.5232186878169007`*^9, 
   3.5232186881569014`*^9}, {3.5232193955778913`*^9, 
   3.5232193955778913`*^9}, {3.5233166487845354`*^9, 
   3.5233166487845354`*^9}, {3.5233167010346084`*^9, 
   3.5233167010346084`*^9}, {3.523318546315711*^9, 3.523318573368556*^9}, {
   3.5239220709492664`*^9, 3.5239220924617043`*^9}, {3.5239221279205666`*^9, 
   3.5239221365629816`*^9}, {3.523930270899587*^9, 3.523930270899587*^9}, {
   3.5240761703528385`*^9, 3.5240761703528385`*^9}, {3.52407843124921*^9, 
   3.5240784332304134`*^9}, {3.5240784932749186`*^9, 
   3.5240784932749186`*^9}, {3.524079230095413*^9, 3.524079246553442*^9}, {
   3.5240858499762287`*^9, 3.524085860178646*^9}, {3.524085945261196*^9, 
   3.524085945261196*^9}, {3.5242763399632483`*^9, 3.5242763411488504`*^9}, {
   3.5242771575294847`*^9, 3.5242771578102846`*^9}, {3.530500224433988*^9, 
   3.530500225113989*^9}, {3.5313467876910577`*^9, 3.5313467883119507`*^9}, {
   3.5332231066826243`*^9, 3.5332231066826243`*^9}, {3.5332248881251183`*^9, 
   3.533224890245121*^9}, {3.5361011385491977`*^9, 3.5361011394332485`*^9}, {
   3.5363501469745007`*^9, 3.5363501506345057`*^9}, {3.5363502763646817`*^9, 
   3.5363502830146914`*^9}, {3.5363561865629625`*^9, 
   3.5363562041629868`*^9}, {3.5393939393314066`*^9, 3.5393939395234175`*^9}, 
   3.549823343986858*^9, {3.54982348831706*^9, 3.5498234885570602`*^9}, {
   3.557037002843611*^9, 3.5570370030836115`*^9}, {3.5717045988390584`*^9, 
   3.571704605189067*^9}, {3.5717051775898685`*^9, 3.571705177769869*^9}, 
   3.5758229279769115`*^9, {3.6113565063380675`*^9, 3.611356507208069*^9}, {
   3.7224748903528485`*^9, 3.722474893021001*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Rule 1.1.1.4.C:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.495391630941485*^9, 3.4953916682515373`*^9}, 
   3.495398892616804*^9, {3.495402251391507*^9, 3.4954022711315346`*^9}, {
   3.495488783827441*^9, 3.4954888500775337`*^9}, {3.4954889799777155`*^9, 
   3.495489009627757*^9}, {3.495489141407942*^9, 3.495489151717956*^9}, {
   3.495489235178073*^9, 3.495489239268079*^9}, {3.495489386068284*^9, 
   3.4954894212383337`*^9}, {3.495489464438394*^9, 3.4954894647383947`*^9}, {
   3.495489500148444*^9, 3.4954895034984484`*^9}, {3.4954897331687703`*^9, 
   3.495489780118836*^9}, {3.495493913565876*^9, 3.495493935715907*^9}, {
   3.495494084919718*^9, 3.4954941083997507`*^9}, 3.495494511560315*^9, {
   3.495494580840412*^9, 3.4954945834404163`*^9}, {3.495494615970462*^9, 
   3.495494740200636*^9}, {3.495494880710832*^9, 3.4954948880508423`*^9}, {
   3.4954949819649754`*^9, 3.495494999445*^9}, {3.495495046515066*^9, 
   3.495495072875103*^9}, {3.4954951239351745`*^9, 3.4954951241651745`*^9}, {
   3.4954953673051157`*^9, 3.4954953726551237`*^9}, {3.495495450474448*^9, 
   3.495495453173253*^9}, {3.495495542140209*^9, 3.495495583792282*^9}, {
   3.4954957431465626`*^9, 3.4954957746118174`*^9}, {3.495495914419263*^9, 
   3.495495917804469*^9}, {3.495495955322535*^9, 3.4954960459586945`*^9}, {
   3.495496189588146*^9, 3.4954961923181515`*^9}, {3.4954973384365644`*^9, 
   3.495497357577798*^9}, {3.5240858715198665`*^9, 3.52408591925595*^9}, {
   3.5331536712917595`*^9, 3.5331536971617956`*^9}, {3.533223063022563*^9, 
   3.5332230658125668`*^9}, {3.533224894045127*^9, 3.5332248954551287`*^9}, 
   3.5363501685345306`*^9, 3.6501606105412674`*^9, 3.6501608939834795`*^9, 
   3.6986840257734575`*^9, {3.733337286936839*^9, 3.7333372871848536`*^9}}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"a", "+", 
      RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"e", "+", 
      RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "x"}]}], ")"}], "q"], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
     RowBox[{"\[Integral]", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}], ")"}], "q"], 
       RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, {3.495401987881138*^9, 3.49540199674115*^9}, {
   3.495402119591322*^9, 3.4954021482513623`*^9}, {3.4954887467773895`*^9, 
   3.4954887749874287`*^9}, 3.495488944397666*^9, 3.495489263778113*^9, 
   3.4954893636582527`*^9, 3.4954898177188883`*^9, 3.495489875358969*^9, 
   3.495493833545764*^9, 3.495493864175807*^9, 3.4954940303560395`*^9, 
   3.4954941516698112`*^9, 3.4954942700599775`*^9, 3.4954948473707857`*^9, {
   3.495495264965372*^9, 3.4954952782653904`*^9}, {3.4954956850364604`*^9, 
   3.4954957088577023`*^9}, {3.495495865341577*^9, 3.4954958884920177`*^9}, {
   3.495496084225561*^9, 3.4954961029143944`*^9}, {3.495496211459385*^9, 
   3.4954962213810024`*^9}, 3.495496440218187*^9, {3.495497026732417*^9, 
   3.4954970596328745`*^9}, {3.495497256957621*^9, 3.495497302338101*^9}, 
   3.533151648818928*^9, 3.5331516797189713`*^9, 3.533151717349024*^9, {
   3.5331518776292486`*^9, 3.533151970249378*^9}, {3.5331520176994443`*^9, 
   3.5331520227894516`*^9}, {3.533152054329496*^9, 3.5331520626995077`*^9}, 
   3.533152270349798*^9, {3.533153065130911*^9, 3.5331530971109557`*^9}, 
   3.53315335008131*^9, {3.5331535194015465`*^9, 3.5331535356615696`*^9}, 
   3.5331536017616625`*^9, {3.533221927890974*^9, 3.533221930830978*^9}, {
   3.533222264011444*^9, 3.533222283731472*^9}, {3.5332223304615374`*^9, 
   3.5332223353515444`*^9}, 3.5363501604045196`*^9, {3.536350289934701*^9, 
   3.5363502917847033`*^9}, {3.5363562133929996`*^9, 3.5363562161430035`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_."}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_."}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_."}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"g_.", "+", 
        RowBox[{"h_.", "*", "x_"}]}], ")"}], "^", "q_."}]}], ",", 
    "x_Symbol"}], "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{"CannotIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", "*", "x"}]}], ")"}], "^", "m"}], "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"g", "+", 
         RowBox[{"h", "*", "x"}]}], ")"}], "^", "q"}]}], ",", "x"}], "]"}], 
   " ", "/;", "\n", 
   RowBox[{"FreeQ", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
       "h", ",", "m", ",", "n", ",", "p", ",", "q"}], "}"}], ",", "x"}], 
    "]"}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.4954018196509027`*^9, {3.495401867050969*^9, 3.4954018672609687`*^9}, {
   3.4954022872215567`*^9, 3.4954022882115583`*^9}, 3.495488713187342*^9, 
   3.4954889210576334`*^9, 3.4954892270180616`*^9, 3.4954893399982195`*^9, {
   3.4954894833184204`*^9, 3.495489485938424*^9}, 3.4954897194087505`*^9, 
   3.495493755131653*^9, {3.4954938826158323`*^9, 3.495493884975836*^9}, 
   3.4954939962159915`*^9, {3.4954942766399865`*^9, 3.4954942945800114`*^9}, 
   3.4954948208307486`*^9, {3.495495087335123*^9, 3.495495087705124*^9}, 
   3.4954951805652537`*^9, 3.495495346275087*^9, 3.495495665489626*^9, 
   3.4954958533919563`*^9, {3.49549609483358*^9, 3.495496110792408*^9}, 
   3.4954961789333277`*^9, 3.495497173544275*^9, {3.495681286888199*^9, 
   3.4956812892482023`*^9}, {3.5240859566180162`*^9, 3.52408598201486*^9}, {
   3.524086057533393*^9, 3.524086058937395*^9}, {3.5242757161181526`*^9, 
   3.5242757216717625`*^9}, {3.5242763445964565`*^9, 
   3.5242763477320623`*^9}, {3.5331525961202545`*^9, 3.533152618700286*^9}, {
   3.5331527018704023`*^9, 3.5331528058905478`*^9}, {3.533153282981216*^9, 
   3.5331533342812877`*^9}, {3.533153565251611*^9, 3.533153599281659*^9}, {
   3.5332224159616575`*^9, 3.533222435081684*^9}, {3.5332224656717267`*^9, 
   3.533222494301767*^9}, {3.533223281652869*^9, 3.53322331799292*^9}, {
   3.5332234651831264`*^9, 3.5332234684731307`*^9}, {3.533223854473671*^9, 
   3.5332238609936805`*^9}, {3.5332239572838154`*^9, 3.5332239599938188`*^9}, 
   3.533224847425061*^9, {3.5332249144151554`*^9, 3.533224915905157*^9}, 
   3.533246982034763*^9, 3.5332605459462523`*^9, {3.536350185774555*^9, 
   3.536350207334585*^9}, {3.5363503391647696`*^9, 3.5363503561347933`*^9}, 
   3.5363547917810035`*^9, {3.536356222123012*^9, 3.5363562784930906`*^9}, {
   3.5366027450457973`*^9, 3.536602758434563*^9}, {3.549823364656887*^9, 
   3.549823390716923*^9}, {3.5717046194190874`*^9, 3.57170467112916*^9}, {
   3.712259996332083*^9, 3.7122600074147167`*^9}, 3.7155405931007204`*^9, {
   3.722474879386221*^9, 3.7224748839204807`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{Cell[TextData[StyleBox["S:",
   FontFamily->"Arial",
   FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a", "+", 
       RowBox[{"b", " ", "u"}]}], ")"}], "m"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"c", "+", 
       RowBox[{"d", " ", "u"}]}], ")"}], "n"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"e", "+", 
       RowBox[{"f", " ", "u"}]}], ")"}], "p"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"g", "+", 
       RowBox[{"h", " ", "u"}]}], ")"}], "q"], 
    RowBox[{"\[DifferentialD]", "x"}], "  ", 
    StyleBox["when",
     FontFamily->"Arial",
     FontWeight->"Plain"], 
    StyleBox["  ",
     FontFamily->"Arial",
     FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
     RowBox[{"u", "\[Equal]", 
      RowBox[{"i", "+", 
       RowBox[{"j", " ", "x"}]}]}]]]], "None"]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519247363296011*^9, 3.519247363796012*^9}, 3.519258420199427*^9, 
   3.5192584863895197`*^9, {3.519320760160028*^9, 3.519320767367241*^9}, 
   3.5193299099191504`*^9, {3.5193300315093203`*^9, 3.519330031709321*^9}, {
   3.5193323099968634`*^9, 3.5193324414114943`*^9}, {3.5193327317904043`*^9, 
   3.519332762148057*^9}, {3.519340455685931*^9, 3.519340463318947*^9}, 
   3.519340635545749*^9, {3.5193422478304834`*^9, 3.519342248704085*^9}, {
   3.519342492766513*^9, 3.519342493156514*^9}, {3.519345750301442*^9, 
   3.5193457505978427`*^9}, 3.519346263464343*^9, {3.519349307658399*^9, 
   3.519349310965605*^9}, {3.519352294781488*^9, 3.5193522950014887`*^9}, {
   3.5194134359455075`*^9, 3.519413446054325*^9}, {3.5194134908888044`*^9, 
   3.5194134927764077`*^9}, {3.5194141847624226`*^9, 
   3.5194142323581066`*^9}, {3.519414342899901*^9, 3.519414474720132*^9}, {
   3.5197939535480833`*^9, 3.5197939539380836`*^9}, {3.5197940297698174`*^9, 
   3.5197940299726176`*^9}, 3.519795153580191*^9, {3.5200103027397947`*^9, 
   3.5200103044997973`*^9}, {3.5232186878169007`*^9, 
   3.5232186881569014`*^9}, {3.5232193955778913`*^9, 
   3.5232193955778913`*^9}, {3.5233166487845354`*^9, 
   3.5233166487845354`*^9}, {3.5233167010346084`*^9, 
   3.5233167010346084`*^9}, {3.523318546315711*^9, 3.523318573368556*^9}, {
   3.5239220709492664`*^9, 3.5239220924617043`*^9}, {3.5239221279205666`*^9, 
   3.5239221365629816`*^9}, {3.523930270899587*^9, 3.523930270899587*^9}, {
   3.5240761703528385`*^9, 3.5240761703528385`*^9}, {3.52407843124921*^9, 
   3.5240784332304134`*^9}, {3.5240784932749186`*^9, 
   3.5240784932749186`*^9}, {3.524079230095413*^9, 3.524079246553442*^9}, {
   3.5240858499762287`*^9, 3.524085860178646*^9}, {3.524085945261196*^9, 
   3.524085945261196*^9}, {3.5242763399632483`*^9, 3.5242763411488504`*^9}, {
   3.5242771575294847`*^9, 3.5242771578102846`*^9}, {3.530500224433988*^9, 
   3.530500225113989*^9}, {3.5313467876910577`*^9, 3.5313467883119507`*^9}, {
   3.5332231066826243`*^9, 3.5332231066826243`*^9}, {3.5332248881251183`*^9, 
   3.533224890245121*^9}, {3.5361011385491977`*^9, 3.5361011394332485`*^9}, {
   3.5363501469745007`*^9, 3.5363501506345057`*^9}, {3.5363617411167684`*^9, 
   3.5363617534067855`*^9}, {3.536366615151597*^9, 3.5363666230616083`*^9}, {
   3.5363667754518213`*^9, 3.5363667821318307`*^9}, {3.536366906722005*^9, 
   3.536366922022027*^9}, {3.536596861742076*^9, 3.5365968701504908`*^9}, {
   3.5366042542749715`*^9, 3.536604254462172*^9}, {3.536625554425806*^9, 
   3.536625554775807*^9}, {3.5366276426139326`*^9, 3.536627642853933*^9}, {
   3.536629402336396*^9, 3.536629402746397*^9}, {3.5366940603006477`*^9, 
   3.536694061273703*^9}, {3.5366943323932104`*^9, 3.536694332661226*^9}, {
   3.536694390476533*^9, 3.536694402176202*^9}, {3.5368634751022315`*^9, 
   3.5368634756170325`*^9}, {3.536980474148706*^9, 3.5369804925387316`*^9}, {
   3.536980525228778*^9, 3.5369805352787914`*^9}, 3.5494761927292957`*^9, {
   3.5693730855884085`*^9, 3.5693730964320283`*^9}, {3.5694290956203146`*^9, 
   3.569429097200317*^9}, {3.5694291331103673`*^9, 3.56942920669047*^9}, {
   3.5694293707907*^9, 3.5694293730307035`*^9}, {3.569429982301556*^9, 
   3.569429987871564*^9}, {3.5694301212017508`*^9, 3.5694301233417535`*^9}, {
   3.569430236001911*^9, 3.5694302386819153`*^9}, {3.5694309150328617`*^9, 
   3.5694309390328956`*^9}, {3.569431575043786*^9, 3.569431600073821*^9}, {
   3.569431653683896*^9, 3.569431665973913*^9}, {3.569431856014179*^9, 
   3.5694318653441925`*^9}, {3.57170412131839*^9, 3.5717041338284073`*^9}, {
   3.5717041715784597`*^9, 3.571704174558464*^9}, {3.571705179229871*^9, 
   3.571705179409871*^9}, 3.5758229287369127`*^9, {3.6202342354626875`*^9, 
   3.620234235649888*^9}, {3.6247455513198104`*^9, 3.62474555183784*^9}, {
   3.637901250721244*^9, 3.637901250721244*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Integration by substitution", "Subsubsection",
 CellChangeTimes->{
  3.4953915070313115`*^9, 3.495840214754669*^9, {3.4958483177760134`*^9, 
   3.495848318886015*^9}, {3.495925911922002*^9, 3.495925920122013*^9}, 
   3.4961847242848682`*^9, 3.496184957525194*^9, 3.496188449500083*^9, 
   3.4961908979261436`*^9, 3.4961924998683863`*^9, 3.4961928754389124`*^9, {
   3.51849075797458*^9, 3.5184907698562593`*^9}, {3.56937339612417*^9, 
   3.569373402061509*^9}}],

Cell[TextData[{
 "Rule 1.1.1.4",
 ".S: If  ",
 Cell[BoxData[
  RowBox[{"u", "\[Equal]", 
   RowBox[{"i", "+", 
    RowBox[{"j", " ", "x"}]}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.495391630941485*^9, 3.4953916682515373`*^9}, 
   3.495398892616804*^9, {3.495402251391507*^9, 3.4954022711315346`*^9}, {
   3.495488783827441*^9, 3.4954888500775337`*^9}, {3.4954889799777155`*^9, 
   3.495489009627757*^9}, {3.495489141407942*^9, 3.495489151717956*^9}, {
   3.495489235178073*^9, 3.495489239268079*^9}, {3.495489386068284*^9, 
   3.4954894212383337`*^9}, {3.495489464438394*^9, 3.4954894647383947`*^9}, {
   3.495489500148444*^9, 3.4954895034984484`*^9}, {3.4954897331687703`*^9, 
   3.495489780118836*^9}, {3.495493913565876*^9, 3.495493935715907*^9}, {
   3.495494084919718*^9, 3.4954941083997507`*^9}, 3.495494511560315*^9, {
   3.495494580840412*^9, 3.4954945834404163`*^9}, {3.495494615970462*^9, 
   3.495494740200636*^9}, {3.495494880710832*^9, 3.4954948880508423`*^9}, {
   3.4954949819649754`*^9, 3.495494999445*^9}, {3.495495046515066*^9, 
   3.495495072875103*^9}, {3.4954951239351745`*^9, 3.4954951241651745`*^9}, {
   3.4954953673051157`*^9, 3.4954953726551237`*^9}, {3.495495450474448*^9, 
   3.495495453173253*^9}, {3.495495542140209*^9, 3.495495583792282*^9}, {
   3.4954957431465626`*^9, 3.4954957746118174`*^9}, {3.495495914419263*^9, 
   3.495495917804469*^9}, {3.495495955322535*^9, 3.4954960459586945`*^9}, {
   3.495496189588146*^9, 3.4954961923181515`*^9}, {3.4954973384365644`*^9, 
   3.495497357577798*^9}, {3.5240858715198665`*^9, 3.52408591925595*^9}, {
   3.5331536712917595`*^9, 3.5331536971617956`*^9}, {3.533223063022563*^9, 
   3.5332230658125668`*^9}, {3.533224894045127*^9, 3.5332248954551287`*^9}, 
   3.5363501685345306`*^9, {3.538444353705845*^9, 3.5384443676658645`*^9}, {
   3.5499343655595293`*^9, 3.549934366379531*^9}, {3.5693429326149015`*^9, 
   3.5693429326149015`*^9}, {3.5693448172975397`*^9, 
   3.5693448172975397`*^9}, {3.5693533761948233`*^9, 
   3.5693533761948233`*^9}, {3.5694292380705137`*^9, 
   3.5694292380705137`*^9}, {3.5694293798207126`*^9, 
   3.5694293798207126`*^9}, {3.569430135641771*^9, 3.569430135641771*^9}, {
   3.56943096378293*^9, 3.56943096378293*^9}, {3.571704183918477*^9, 
   3.571704183918477*^9}, 3.6501606111683035`*^9, 3.650160897918705*^9, 
   3.698684025843457*^9}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"a", "+", 
      RowBox[{"b", " ", "u"}]}], ")"}], "m"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"c", "+", 
      RowBox[{"d", " ", "u"}]}], ")"}], "n"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"e", "+", 
      RowBox[{"f", " ", "u"}]}], ")"}], "p"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"g", "+", 
      RowBox[{"h", " ", "u"}]}], ")"}], "q"], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
     FractionBox["1", "j"]}]}], 
   RowBox[{"Subst", "[", 
    RowBox[{
     RowBox[{"\[Integral]", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}], ")"}], "q"], 
       RowBox[{"\[DifferentialD]", "x"}]}]}], ",", "x", ",", "u"}], 
    "]"}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, {3.495401987881138*^9, 3.49540199674115*^9}, {
   3.495402119591322*^9, 3.4954021482513623`*^9}, {3.4954887467773895`*^9, 
   3.4954887749874287`*^9}, 3.495488944397666*^9, 3.495489263778113*^9, 
   3.4954893636582527`*^9, 3.4954898177188883`*^9, 3.495489875358969*^9, 
   3.495493833545764*^9, 3.495493864175807*^9, 3.4954940303560395`*^9, 
   3.4954941516698112`*^9, 3.4954942700599775`*^9, 3.4954948473707857`*^9, {
   3.495495264965372*^9, 3.4954952782653904`*^9}, {3.4954956850364604`*^9, 
   3.4954957088577023`*^9}, {3.495495865341577*^9, 3.4954958884920177`*^9}, {
   3.495496084225561*^9, 3.4954961029143944`*^9}, {3.495496211459385*^9, 
   3.4954962213810024`*^9}, 3.495496440218187*^9, {3.495497026732417*^9, 
   3.4954970596328745`*^9}, {3.495497256957621*^9, 3.495497302338101*^9}, 
   3.533151648818928*^9, 3.5331516797189713`*^9, 3.533151717349024*^9, {
   3.5331518776292486`*^9, 3.533151970249378*^9}, {3.5331520176994443`*^9, 
   3.5331520227894516`*^9}, {3.533152054329496*^9, 3.5331520626995077`*^9}, 
   3.533152270349798*^9, {3.533153065130911*^9, 3.5331530971109557`*^9}, 
   3.53315335008131*^9, {3.5331535194015465`*^9, 3.5331535356615696`*^9}, 
   3.5331536017616625`*^9, {3.533221927890974*^9, 3.533221930830978*^9}, {
   3.533222264011444*^9, 3.533222283731472*^9}, {3.5332223304615374`*^9, 
   3.5332223353515444`*^9}, 3.5363501604045196`*^9, {3.536361767566806*^9, 
   3.5363617697768087`*^9}, {3.5363666287016163`*^9, 
   3.5363666313816195`*^9}, {3.536366784271834*^9, 3.5363667868618374`*^9}, {
   3.536366923782029*^9, 3.5363669254320316`*^9}, {3.5365968786057057`*^9, 
   3.536596881944112*^9}, {3.5366940930205193`*^9, 3.53669410440917*^9}, {
   3.5366942507975435`*^9, 3.536694251403578*^9}, {3.536694493325415*^9, 
   3.536694495295528*^9}, 3.536980387788585*^9, 3.536980543328803*^9, {
   3.536980609078895*^9, 3.536980616128905*^9}, 3.569373228563586*^9, {
   3.5693732781084194`*^9, 3.5693732838917503`*^9}, {3.569373320190827*^9, 
   3.569373349338494*^9}, 3.5694292616405473`*^9, {3.56942930674061*^9, 
   3.56942932830064*^9}, 3.569430028661621*^9, {3.5694301049017277`*^9, 
   3.569430127381759*^9}, {3.5694309709229403`*^9, 3.569430981322955*^9}, {
   3.5694316008538218`*^9, 3.5694316119038377`*^9}, {3.569431654423897*^9, 
   3.5694316877239437`*^9}, {3.569431880124213*^9, 3.5694318876942234`*^9}, {
   3.5717041456984243`*^9, 3.5717041574384403`*^9}, 3.5717041954584937`*^9},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"a_.", "+", 
        RowBox[{"b_.", "*", "u_"}]}], ")"}], "^", "m_."}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_.", "+", 
        RowBox[{"d_.", "*", "u_"}]}], ")"}], "^", "n_."}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"e_.", "+", 
        RowBox[{"f_.", "*", "u_"}]}], ")"}], "^", "p_."}], "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"g_.", "+", 
        RowBox[{"h_.", "*", "u_"}]}], ")"}], "^", "q_."}]}], ",", 
    "x_Symbol"}], "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{"1", "/", 
     RowBox[{"Coefficient", "[", 
      RowBox[{"u", ",", "x", ",", "1"}], "]"}]}], "*", 
    RowBox[{"Subst", "[", 
     RowBox[{
      RowBox[{"Int", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", "*", "x"}]}], ")"}], "^", "m"}], "*", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"c", "+", 
            RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"e", "+", 
            RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "*", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"g", "+", 
            RowBox[{"h", "*", "x"}]}], ")"}], "^", "q"}]}], ",", "x"}], "]"}],
       ",", "x", ",", "u"}], "]"}]}], " ", "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
        "h", ",", "m", ",", "n", ",", "p", ",", "q"}], "}"}], ",", "x"}], 
     "]"}], " ", "&&", " ", 
    RowBox[{"LinearQ", "[", 
     RowBox[{"u", ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"NeQ", "[", 
     RowBox[{"u", ",", "x"}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.4954018196509027`*^9, {3.495401867050969*^9, 3.4954018672609687`*^9}, {
   3.4954022872215567`*^9, 3.4954022882115583`*^9}, 3.495488713187342*^9, 
   3.4954889210576334`*^9, 3.4954892270180616`*^9, 3.4954893399982195`*^9, {
   3.4954894833184204`*^9, 3.495489485938424*^9}, 3.4954897194087505`*^9, 
   3.495493755131653*^9, {3.4954938826158323`*^9, 3.495493884975836*^9}, 
   3.4954939962159915`*^9, {3.4954942766399865`*^9, 3.4954942945800114`*^9}, 
   3.4954948208307486`*^9, {3.495495087335123*^9, 3.495495087705124*^9}, 
   3.4954951805652537`*^9, 3.495495346275087*^9, 3.495495665489626*^9, 
   3.4954958533919563`*^9, {3.49549609483358*^9, 3.495496110792408*^9}, 
   3.4954961789333277`*^9, 3.495497173544275*^9, {3.495681286888199*^9, 
   3.4956812892482023`*^9}, {3.5240859566180162`*^9, 3.52408598201486*^9}, {
   3.524086057533393*^9, 3.524086058937395*^9}, {3.5242757161181526`*^9, 
   3.5242757216717625`*^9}, {3.5242763445964565`*^9, 
   3.5242763477320623`*^9}, {3.5331525961202545`*^9, 3.533152618700286*^9}, {
   3.5331527018704023`*^9, 3.5331528058905478`*^9}, {3.533153282981216*^9, 
   3.5331533342812877`*^9}, {3.533153565251611*^9, 3.533153599281659*^9}, {
   3.5332224159616575`*^9, 3.533222435081684*^9}, {3.5332224656717267`*^9, 
   3.533222494301767*^9}, {3.533223281652869*^9, 3.53322331799292*^9}, {
   3.5332234651831264`*^9, 3.5332234684731307`*^9}, {3.533223854473671*^9, 
   3.5332238609936805`*^9}, {3.5332239572838154`*^9, 3.5332239599938188`*^9}, 
   3.533224847425061*^9, {3.5332249144151554`*^9, 3.533224915905157*^9}, 
   3.533246982034763*^9, 3.5332605459462523`*^9, {3.536350185774555*^9, 
   3.536350207334585*^9}, {3.5363506584052167`*^9, 3.5363506914352627`*^9}, {
   3.5363508662655077`*^9, 3.5363509090255675`*^9}, {3.5363510097557087`*^9, 
   3.5363510569557743`*^9}, {3.5363512834660916`*^9, 3.536351309536128*^9}, {
   3.5363515550764723`*^9, 3.5363516176765594`*^9}, {3.5363516722566357`*^9, 
   3.5363516724366364`*^9}, {3.536356352083194*^9, 3.536356353383196*^9}, {
   3.5363617881968346`*^9, 3.536361833056897*^9}, {3.536366667801671*^9, 
   3.5363667247217503`*^9}, {3.5363667904918423`*^9, 3.536366799971856*^9}, {
   3.536366941382054*^9, 3.536366980882109*^9}, {3.5365968943773336`*^9, 
   3.536596936123007*^9}, {3.536596976558278*^9, 3.536597025589164*^9}, 
   3.536602461258152*^9, {3.5366940777176437`*^9, 3.5366940881722417`*^9}, 
   3.5366943020244737`*^9, {3.536694516327731*^9, 3.5366945346767807`*^9}, {
   3.5369801281282215`*^9, 3.5369801381582355`*^9}, 3.536980329338503*^9, {
   3.53698041236862*^9, 3.5369804166186256`*^9}, {3.5369806567789617`*^9, 
   3.536980699209021*^9}, 3.5494761881292896`*^9, {3.5693731131899867`*^9, 
   3.569373146310881*^9}, {3.5693734415897703`*^9, 3.5693734426378303`*^9}, 
   3.5693734893805037`*^9, 3.569377788480149*^9, {3.569429350000671*^9, 
   3.5694293589406834`*^9}, {3.569429389420726*^9, 3.569429457880822*^9}, 
   3.5694296610911064`*^9, {3.5694300098115945`*^9, 3.569430015461602*^9}, {
   3.5694301856318407`*^9, 3.5694302169718847`*^9}, {3.569431005722989*^9, 
   3.5694310577030616`*^9}, {3.569431619283848*^9, 3.5694316704439197`*^9}, {
   3.5694319118042574`*^9, 3.5694319573943214`*^9}, 3.5694395225239153`*^9, {
   3.571704209298513*^9, 3.5717043494887094`*^9}, {3.6853202350039897`*^9, 
   3.685320244693607*^9}, 3.706112995550887*^9, 3.706113060211585*^9, {
   3.7077038116942935`*^9, 3.7077038134882965`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{
  3.4796643211106243`*^9, {3.536351324436149*^9, 3.536351326496152*^9}, {
   3.5363515481064625`*^9, 3.536351548866463*^9}}]
}, Closed]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}],

Cell[BoxData[
 StyleBox[
  RowBox[{Cell[TextData[StyleBox["Rules for integrands of the form",
    FontFamily->"Arial",
    FontSize->16]], "None"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], "p"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}], ")"}], "q"]}], ")"}], "r"]}],
  FontSize->16]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.519247079685614*^9, {3.5193208582062006`*^9, 3.5193208612170057`*^9}, 
   3.5193325694253187`*^9, {3.5193415004828687`*^9, 3.5193415113404875`*^9}, {
   3.5193513965602303`*^9, 3.519351397420232*^9}, {3.5194037839416766`*^9, 
   3.5194037847117205`*^9}, {3.5233155055329347`*^9, 3.523315506402936*^9}, {
   3.523318726949605*^9, 3.5233187276796064`*^9}, {3.523920400879534*^9, 
   3.5239204094439487`*^9}, 3.52392096260852*^9, 3.523921038171853*^9, 
   3.5340477459008017`*^9, 3.5340515540554085`*^9, {3.536542511100503*^9, 
   3.53654251626051*^9}, {3.536775961244521*^9, 3.5367759616145215`*^9}, {
   3.544373142375139*^9, 3.5443731599851637`*^9}, {3.5721095751430073`*^9, 
   3.5721095751430073`*^9}, {3.57578648209792*^9, 3.575786503859958*^9}, 
   3.575786540270422*^9, {3.5757866379421935`*^9, 3.5757866609522343`*^9}, 
   3.5758298890420465`*^9, 3.5758300610323486`*^9, 3.575830332613226*^9, 
   3.575830509377136*^9, {3.6343218027393775`*^9, 3.6343218080186796`*^9}, {
   3.634684934180332*^9, 3.634684950884288*^9}, 3.6353563928995934`*^9, {
   3.6353568667056932`*^9, 3.6353569109942265`*^9}, 3.650739000214118*^9, {
   3.6507390957005796`*^9, 3.6507391875088305`*^9}, {3.690663882690395*^9, 
   3.6906638904504056`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{Cell[TextData[StyleBox["1:",
   FontFamily->"Arial",
   FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}], "p"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}], ")"}], "q"]}], ")"}], "r"], 
    RowBox[{"\[DifferentialD]", "x"}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519250976620308*^9, 3.5192509795375133`*^9}, 3.5192520188581386`*^9, {
   3.5193215829334736`*^9, 3.519321595725496*^9}, {3.5194112531544743`*^9, 
   3.5194112537784753`*^9}, 3.5194115106017265`*^9, {3.519411582829853*^9, 
   3.5194116058086934`*^9}, {3.5194117949434257`*^9, 
   3.5194118041006413`*^9}, {3.519412000598587*^9, 3.5194120130942087`*^9}, {
   3.5197938929263773`*^9, 3.5197938931447773`*^9}, {3.521473804992657*^9, 
   3.521473829412691*^9}, {3.5214741072930803`*^9, 3.521474108863083*^9}, {
   3.523316613544486*^9, 3.523316613544486*^9}, {3.5233184952952356`*^9, 
   3.5233184952952356`*^9}, {3.523318653417488*^9, 3.523318653417488*^9}, 
   3.5239324213533645`*^9, {3.5239326372733436`*^9, 3.523932666538995*^9}, {
   3.523933074292511*^9, 3.523933086226532*^9}, {3.5239331696710787`*^9, 
   3.523933181121499*^9}, 3.5239335006568604`*^9, {3.5239355418736453`*^9, 
   3.5239355418736453`*^9}, {3.5268693631599226`*^9, 
   3.5268693782607493`*^9}, {3.526876698258407*^9, 3.5268767252620544`*^9}, {
   3.526876907329974*^9, 3.5268769569848614`*^9}, {3.5269242339668407`*^9, 
   3.5269242339668407`*^9}, 3.5269267394468417`*^9, {3.526927027594948*^9, 
   3.526927035675762*^9}, {3.530558366526289*^9, 3.5305583787255106`*^9}, {
   3.5305584367264123`*^9, 3.5305584385984154`*^9}, {3.531942849761632*^9, 
   3.531942849917632*^9}, {3.5339406784958773`*^9, 3.5339406791758785`*^9}, {
   3.5341185863023334`*^9, 3.5341185863023334`*^9}, {3.534126360463763*^9, 
   3.534126361033764*^9}, {3.5347073402331953`*^9, 3.5347073404671955`*^9}, {
   3.534707390340483*^9, 3.534707390340483*^9}, {3.5393939323303337`*^9, 
   3.5393939325113444`*^9}, {3.5498230222764077`*^9, 3.5498230222764077`*^9}, 
   3.5717051155797815`*^9, 3.5758229229669046`*^9, {3.611349524660698*^9, 
   3.611349524893198*^9}, {3.6113560726974607`*^9, 3.611356089987485*^9}, {
   3.611510728968608*^9, 3.611510728968608*^9}, {3.6115112953519373`*^9, 
   3.611511295611938*^9}, {3.6314138645722046`*^9, 3.631413864872222*^9}, {
   3.6379383894122734`*^9, 3.6379383896322737`*^9}, 3.6379584590480404`*^9, 
   3.6379585599736185`*^9, {3.6391728226255198`*^9, 3.6391728396364927`*^9}, {
   3.639172884834078*^9, 3.6391729208191357`*^9}, {3.6391730966401925`*^9, 
   3.6391730998323746`*^9}, {3.6444423527025394`*^9, 
   3.6444423529075513`*^9}, {3.6444426224379673`*^9, 3.644442622688982*^9}, {
   3.6473907075427933`*^9, 3.6473907077218037`*^9}, {3.649721005238905*^9, 
   3.649721005441705*^9}, {3.690663484093639*^9, 3.6906634987376604`*^9}, {
   3.6906638980204163`*^9, 3.690663898232417*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Piecewise constant extraction", "Subsubsection",
 CellChangeTimes->{
  3.4964418130913677`*^9, {3.496442428087432*^9, 3.4964424330170403`*^9}, 
   3.52393166160083*^9, {3.620234434581437*^9, 3.6202344396046457`*^9}}],

Cell[TextData[{
 "Basis: ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["\[PartialD]", "x"], 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"i", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", " ", "x"}]}], ")"}], "p"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"g", "+", 
           RowBox[{"h", " ", "x"}]}], ")"}], "q"]}], ")"}], "r"], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], 
       RowBox[{"m", " ", "r"}]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}], ")"}], 
       RowBox[{"n", " ", "r"}]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], 
       RowBox[{"p", " ", "r"}]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}], ")"}], 
       RowBox[{"q", " ", "r"}]]}]]}], "\[Equal]", "0"}]],
  CellChangeTimes->{{3.5269175004282475`*^9, 3.5269175168882704`*^9}}]
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269172489578953`*^9, 3.526917257517907*^9}, {3.526917494228239*^9, 
   3.52691749506824*^9}, {3.526917525398282*^9, 3.5269175286682873`*^9}, {
   3.5269179749474473`*^9, 3.5269179749474473`*^9}, {3.526918042245965*^9, 
   3.5269180502799797`*^9}, {3.5269241102586236`*^9, 
   3.5269241142210307`*^9}, {3.5269243887811127`*^9, 3.526924423569174*^9}, {
   3.5269245010233097`*^9, 3.5269245182769403`*^9}, {3.526924588165063*^9, 
   3.526924604576292*^9}, {3.5269269991092978`*^9, 3.526927020247335*^9}, {
   3.5269270953146667`*^9, 3.526927101585878*^9}, {3.5269271749372067`*^9, 
   3.5269271749372067`*^9}, {3.5269272281645*^9, 3.526927235699313*^9}, {
   3.5305582449552755`*^9, 3.5305582820209403`*^9}, {3.530558343672249*^9, 
   3.53055834446785*^9}, {3.5341264961539536`*^9, 3.5341264961539536`*^9}, {
   3.6115109793039756`*^9, 3.6115109793039756`*^9}, {3.6379584629324474`*^9, 
   3.637958463712449*^9}, {3.637958563592825*^9, 3.6379585645288267`*^9}, {
   3.6379592395243397`*^9, 3.6379592395243397`*^9}, {3.639173010663275*^9, 
   3.639173010663275*^9}, {3.6906638130112953`*^9, 3.6906638130112953`*^9}}],

Cell["Rule:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.48070534977779*^9, {3.4928296953212276`*^9, 3.492829707041244*^9}, {
   3.495391733731629*^9, 3.495391739521637*^9}, {3.4954223457721186`*^9, 
   3.4954223698921523`*^9}, {3.495422809672768*^9, 3.4954228678728495`*^9}, {
   3.495422999683034*^9, 3.4954230032130384`*^9}, {3.4954233713935547`*^9, 
   3.495423398813593*^9}, {3.4954234509036655`*^9, 3.4954234541136703`*^9}, {
   3.4954236049638815`*^9, 3.4954236208939037`*^9}, {3.4954236729139767`*^9, 
   3.4954236833239913`*^9}, {3.4955919592566047`*^9, 
   3.4955919596310053`*^9}, {3.5239355316244273`*^9, 
   3.5239355316244273`*^9}, {3.5268695545566587`*^9, 
   3.5268695582538657`*^9}, {3.526877275568621*^9, 3.5268773333199224`*^9}, {
   3.5269176967365584`*^9, 3.5269176967365584`*^9}, {3.526924612610306*^9, 
   3.526924612610306*^9}, {3.5269270224625387`*^9, 3.5269270224625387`*^9}, {
   3.5305583575562735`*^9, 3.530558360660679*^9}, {3.5347074228665404`*^9, 
   3.5347074228665404`*^9}, {3.549823103506521*^9, 3.549823103506521*^9}, {
   3.611356258837721*^9, 3.611356258837721*^9}, {3.63917293207978*^9, 
   3.63917293208078*^9}, 3.6501606099462337`*^9, 3.650160886705063*^9, {
   3.6906639035624247`*^9, 3.6906639092424326`*^9}}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"i", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}], ")"}], "p"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}], ")"}], "q"]}], ")"}], "r"], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", "\[IndentingNewLine]", 
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"i", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"a", "+", 
            RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"c", "+", 
            RowBox[{"d", " ", "x"}]}], ")"}], "n"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"e", "+", 
            RowBox[{"f", " ", "x"}]}], ")"}], "p"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"g", "+", 
            RowBox[{"h", " ", "x"}]}], ")"}], "q"]}], ")"}], "r"], 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], 
        RowBox[{"m", " ", "r"}]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}], ")"}], 
        RowBox[{"n", " ", "r"}]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}], 
        RowBox[{"p", " ", "r"}]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}], ")"}], 
        RowBox[{"q", " ", "r"}]]}]]}]}], 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}], ")"}], 
      RowBox[{"m", " ", "r"}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"c", "+", 
        RowBox[{"d", " ", "x"}]}], ")"}], 
      RowBox[{"n", " ", "r"}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"e", "+", 
        RowBox[{"f", " ", "x"}]}], ")"}], 
      RowBox[{"p", " ", "r"}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"g", "+", 
        RowBox[{"h", " ", "x"}]}], ")"}], 
      RowBox[{"q", " ", "r"}]], 
     RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579732027807`*^9, 3.479658002474872*^9}, {
   3.4796580599975853`*^9, 3.4796580609489536`*^9}, {3.479658295195784*^9, 
   3.47965829684816*^9}, 3.4796611938939075`*^9, 3.4796613924794593`*^9, {
   3.479661443342597*^9, 3.479661446647349*^9}, {3.479661576554146*^9, 
   3.479661589302477*^9}, 3.479661847553824*^9, {3.4796622294729967`*^9, 
   3.4796622450654173`*^9}, {3.479686720424531*^9, 3.4796867204345455`*^9}, {
   3.4796874646646957`*^9, 3.4796874745589232`*^9}, {3.492826573513727*^9, 
   3.492826578630536*^9}, {3.4928267070863624`*^9, 3.492826707460763*^9}, 
   3.4928267903497095`*^9, {3.492829799151373*^9, 3.4928299617216005`*^9}, {
   3.4940972077187414`*^9, 3.4940972347887793`*^9}, 3.495391718911608*^9, 
   3.495391753851657*^9, 3.495422441222252*^9, 3.4954224733722973`*^9, 
   3.49542261091249*^9, {3.4954226829125905`*^9, 3.4954226975926113`*^9}, {
   3.495423050323105*^9, 3.4954231021331778`*^9}, 3.4954233506135254`*^9, 
   3.495423494923727*^9, 3.4954235863638554`*^9, 3.4954237215540447`*^9, {
   3.4955917301078024`*^9, 3.495591759061453*^9}, {3.5268693941259775`*^9, 
   3.5268694010835896`*^9}, {3.526876998184534*^9, 3.526877026217783*^9}, {
   3.5269267437524495`*^9, 3.5269267730181007`*^9}, {3.526927247898535*^9, 
   3.5269273030134315`*^9}, {3.5305581442882986`*^9, 
   3.5305581869543734`*^9}, {3.611356104997506*^9, 3.6113561134475174`*^9}, {
   3.611356245767703*^9, 3.6113562484177065`*^9}, 3.6115107423236275`*^9, {
   3.611510804573718*^9, 3.611510839793771*^9}, {3.6115109977190027`*^9, 
   3.611511008154019*^9}, {3.6314127071020007`*^9, 3.631412710136174*^9}, {
   3.63795846466405*^9, 3.6379584653972516`*^9}, {3.637958565355628*^9, 
   3.63795856660363*^9}, 3.6379592397895403`*^9, 3.639172945063523*^9, {
   3.639173067893548*^9, 3.6391730944800687`*^9}, 3.6906635172506866`*^9, {
   3.6906636502768755`*^9, 3.6906636506168756`*^9}, {3.690663822781309*^9, 
   3.6906638385853324`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"i_.", "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a_.", "+", 
          RowBox[{"b_.", "*", "x_"}]}], ")"}], "^", "m_"}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"c_.", "+", 
          RowBox[{"d_.", "*", "x_"}]}], ")"}], "^", "n_"}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"e_.", "+", 
          RowBox[{"f_.", "*", "x_"}]}], ")"}], "^", "p_"}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"g_.", "+", 
          RowBox[{"h_.", "*", "x_"}]}], ")"}], "^", "q_"}]}], ")"}], "^", 
     "r_"}], ",", "x_Symbol"}], "]"}], " ", ":=", "\n", "  ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"i", "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "+", 
           RowBox[{"b", "*", "x"}]}], ")"}], "^", "m"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"c", "+", 
           RowBox[{"d", "*", "x"}]}], ")"}], "^", "n"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"e", "+", 
           RowBox[{"f", "*", "x"}]}], ")"}], "^", "p"}], "*", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"g", "+", 
           RowBox[{"h", "*", "x"}]}], ")"}], "^", "q"}]}], ")"}], "^", "r"}], 
     "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", "*", "x"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"m", "*", "r"}], ")"}]}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", "*", "x"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"n", "*", "r"}], ")"}]}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", "*", "x"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"p", "*", "r"}], ")"}]}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"g", "+", 
          RowBox[{"h", "*", "x"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"q", "*", "r"}], ")"}]}]}], ")"}]}], "*", "\n", "    ", 
    RowBox[{"Int", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", "*", "x"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"m", "*", "r"}], ")"}]}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", "*", "x"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"n", "*", "r"}], ")"}]}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", "*", "x"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"p", "*", "r"}], ")"}]}], "*", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"g", "+", 
          RowBox[{"h", "*", "x"}]}], ")"}], "^", 
        RowBox[{"(", 
         RowBox[{"q", "*", "r"}], ")"}]}]}], ",", "x"}], "]"}]}], " ", "/;", 
   "\n", 
   RowBox[{"FreeQ", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
       "h", ",", "i", ",", "m", ",", "n", ",", "p", ",", "q", ",", "r"}], 
      "}"}], ",", "x"}], "]"}]}]}]], "Code",
 CellChangeTimes->{{3.494097279728842*^9, 3.494097309778884*^9}, 
   3.495391490771289*^9, 3.4954222457419786`*^9, 3.49542257518244*^9, {
   3.4954226384825287`*^9, 3.495422640262531*^9}, {3.495422979083005*^9, 
   3.495422986193015*^9}, {3.4954232118433313`*^9, 3.4954232206733437`*^9}, {
   3.4954234342736425`*^9, 3.495423439223649*^9}, {3.4954235290337753`*^9, 
   3.495423538163788*^9}, {3.4954236436039357`*^9, 3.4954236484739428`*^9}, {
   3.495591711278569*^9, 3.4955917121833706`*^9}, {3.4955917741778793`*^9, 
   3.4955918058771353`*^9}, {3.4955918501188126`*^9, 3.4955918540032196`*^9}, 
   3.5239355527624645`*^9, {3.5268694242028303`*^9, 3.52686942994364*^9}, {
   3.526869510876582*^9, 3.5268695702814865`*^9}, {3.5268770685406575`*^9, 
   3.526877093875102*^9}, 3.5268771340139728`*^9, {3.5268772574725895`*^9, 
   3.5268772665362053`*^9}, 3.526918736047184*^9, {3.5269248094046516`*^9, 
   3.5269248214790726`*^9}, {3.5269273228098664`*^9, 3.526927337832693*^9}, 
   3.5269274194832363`*^9, 3.5269274496068892`*^9, {3.530558205830407*^9, 
   3.5305582319292526`*^9}, {3.5305584134979715`*^9, 3.530558416742777*^9}, {
   3.530558496131316*^9, 3.530558497223318*^9}, 3.53470741696973*^9, {
   3.542249963774038*^9, 3.542249976738779*^9}, 3.54982311701654*^9, {
   3.6104719528423166`*^9, 3.6104720245024166`*^9}, {3.611356300147779*^9, 
   3.6113563823778944`*^9}, {3.611356434467967*^9, 3.6113564361279697`*^9}, 
   3.611511110881668*^9, 3.61152794381289*^9, {3.611542003192854*^9, 
   3.611542057370434*^9}, 3.6115422634207416`*^9, {3.6115425950312333`*^9, 
   3.611542608601253*^9}, {3.63141271425541*^9, 3.6314127182346373`*^9}, 
   3.637938298965144*^9, {3.637958468236457*^9, 3.637958469500059*^9}, {
   3.637958569817236*^9, 3.6379585715332384`*^9}, 3.637959278622408*^9, {
   3.639173251380043*^9, 3.639173252292095*^9}, {3.6391733341737785`*^9, 
   3.639173358750184*^9}, {3.639173388782902*^9, 3.6391733952732735`*^9}, {
   3.6906639298374624`*^9, 3.690663973933524*^9}, {3.6906640158635836`*^9, 
   3.6906640460106263`*^9}, {3.6906641502897744`*^9, 3.690664150499775*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{3.4796643211106243`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{Cell[TextData[StyleBox["",
   FontFamily->"Arial"]], "None"], 
  StyleBox["Normalize",
   FontFamily->"Arial Narrow"], 
  StyleBox[" ",
   FontFamily->"Arial Narrow"], 
  StyleBox["linear",
   FontFamily->"Arial Narrow"], 
  StyleBox[" ",
   FontFamily->"Arial Narrow"], 
  StyleBox["products",
   FontFamily->"Arial Narrow"]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.496521708137803*^9, {
   3.4965218981240697`*^9, 3.49652189838407*^9}, 3.4965229070755*^9, 
   3.4965234353062396`*^9, 3.51924711947567*^9, {3.5193215073045406`*^9, 
   3.519321519472562*^9}, {3.5194132787596316`*^9, 3.519413279118432*^9}, {
   3.5197939240328317`*^9, 3.5197939245788326`*^9}, {3.519795179101836*^9, 
   3.519795258755576*^9}, {3.523218681536892*^9, 3.523218681796892*^9}, {
   3.5232190395273933`*^9, 3.5232190407773952`*^9}, {3.523316531694371*^9, 
   3.523316531694371*^9}, {3.523316570214425*^9, 3.523316570214425*^9}, {
   3.5233184747028017`*^9, 3.5233184747028017`*^9}, {3.5233185389908996`*^9, 
   3.5233185389908996`*^9}, {3.5273599529628296`*^9, 3.527359956426036*^9}, {
   3.5326632346071796`*^9, 3.5326632404415903`*^9}, {3.5327265364715433`*^9, 
   3.532726536991544*^9}, {3.5327554222003174`*^9, 3.532755422897358*^9}, {
   3.532830668754084*^9, 3.532830668754084*^9}, {3.53283070883414*^9, 
   3.532830709704141*^9}, {3.532877863833888*^9, 3.5328778643642893`*^9}, {
   3.532884490579273*^9, 3.532884491399274*^9}, {3.5329004320430803`*^9, 
   3.532900432479881*^9}, {3.533075861537225*^9, 3.5330758627272263`*^9}, {
   3.534975116908698*^9, 3.5349751172286987`*^9}, {3.535673068091245*^9, 
   3.535673101911292*^9}, {3.5356731799314013`*^9, 3.535673187101412*^9}, {
   3.535673408481722*^9, 3.5356734123017273`*^9}, {3.535674574003353*^9, 
   3.535674581613364*^9}, {3.5356751007940907`*^9, 3.5356751013440914`*^9}, 
   3.5356755763247566`*^9, {3.535676041495408*^9, 3.53567605013542*^9}, 
   3.535676208055641*^9, {3.5356779056628256`*^9, 3.5356779068796277`*^9}, {
   3.5357369718729916`*^9, 3.5357369755929966`*^9}, {3.5357385435291944`*^9, 
   3.535738543909195*^9}, 3.5373200176720495`*^9, 3.538499171949587*^9, {
   3.538586890089458*^9, 3.538586899168674*^9}, {3.5723050145984774`*^9, 
   3.572305039018512*^9}, {3.572715287384226*^9, 3.5727152875442266`*^9}, {
   3.576195990305285*^9, 3.576195990495285*^9}, {3.5763556740989313`*^9, 
   3.576355674278932*^9}, {3.581549584198557*^9, 3.5815495843985567`*^9}, 
   3.593125928075842*^9, {3.5931259790644336`*^9, 3.593125979267234*^9}, {
   3.5931904312794275`*^9, 3.5931904314198275`*^9}, {3.5952189672039676`*^9, 
   3.595218986521496*^9}, {3.5952768741408854`*^9, 3.595276904770928*^9}, {
   3.5958810939733863`*^9, 3.595881094153386*^9}, {3.596048278860134*^9, 
   3.5960482789901342`*^9}, {3.6112350703783875`*^9, 3.611235070549988*^9}, {
   3.6112434512429314`*^9, 3.6112434513989315`*^9}, {3.6129953181018195`*^9, 
   3.61299531843182*^9}, {3.613062040346569*^9, 3.613062040686569*^9}, {
   3.6150594992675605`*^9, 3.615059500697562*^9}, {3.6390655437249823`*^9, 
   3.639065553339532*^9}, {3.650303499210075*^9, 3.650303499210075*^9}, {
   3.6503265194990034`*^9, 3.6503265199580293`*^9}, {3.6503876972605*^9, 
   3.650387697438501*^9}, {3.701662025371807*^9, 3.7016620702683744`*^9}},
 FontSize->12,
 FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{Cell[TextData[StyleBox["1:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox["u", "m"], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{"u", "\[Equal]", 
       RowBox[{"a", "+", 
        RowBox[{"b", " ", "x"}]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519247363296011*^9, 3.519247363796012*^9}, 3.519258420199427*^9, 
   3.5192584863895197`*^9, {3.519320760160028*^9, 3.519320767367241*^9}, 
   3.5193299099191504`*^9, {3.5193300315093203`*^9, 3.519330031709321*^9}, {
   3.5193323099968634`*^9, 3.5193324414114943`*^9}, {3.5193327317904043`*^9, 
   3.519332762148057*^9}, {3.519340455685931*^9, 3.519340463318947*^9}, 
   3.519340635545749*^9, {3.5193422478304834`*^9, 3.519342248704085*^9}, {
   3.519342492766513*^9, 3.519342493156514*^9}, {3.519345750301442*^9, 
   3.5193457505978427`*^9}, 3.519346263464343*^9, {3.519349307658399*^9, 
   3.519349310965605*^9}, {3.519352294781488*^9, 3.5193522950014887`*^9}, {
   3.5194134359455075`*^9, 3.519413446054325*^9}, {3.5194134908888044`*^9, 
   3.5194134927764077`*^9}, {3.5194141847624226`*^9, 
   3.5194142323581066`*^9}, {3.519414342899901*^9, 3.519414474720132*^9}, {
   3.5197939535480833`*^9, 3.5197939539380836`*^9}, {3.5197940297698174`*^9, 
   3.5197940299726176`*^9}, 3.519795153580191*^9, {3.5200103027397947`*^9, 
   3.5200103044997973`*^9}, {3.5232186878169007`*^9, 
   3.5232186881569014`*^9}, {3.5232193955778913`*^9, 
   3.5232193955778913`*^9}, {3.5233166487845354`*^9, 
   3.5233166487845354`*^9}, {3.5233167010346084`*^9, 
   3.5233167010346084`*^9}, {3.523318546315711*^9, 3.523318573368556*^9}, {
   3.5239220709492664`*^9, 3.5239220924617043`*^9}, {3.5239221279205666`*^9, 
   3.5239221365629816`*^9}, {3.523930270899587*^9, 3.523930270899587*^9}, {
   3.5240761703528385`*^9, 3.5240761703528385`*^9}, {3.52407843124921*^9, 
   3.5240784332304134`*^9}, {3.5240784932749186`*^9, 
   3.5240784932749186`*^9}, {3.524079230095413*^9, 3.524079246553442*^9}, {
   3.5240858499762287`*^9, 3.524085860178646*^9}, {3.524085945261196*^9, 
   3.524085945261196*^9}, {3.5242763399632483`*^9, 3.5242763411488504`*^9}, {
   3.5242771575294847`*^9, 3.5242771578102846`*^9}, {3.530500224433988*^9, 
   3.530500225113989*^9}, {3.5313467876910577`*^9, 3.5313467883119507`*^9}, {
   3.5332231066826243`*^9, 3.5332231066826243`*^9}, {3.5332248881251183`*^9, 
   3.533224890245121*^9}, {3.5361011385491977`*^9, 3.5361011394332485`*^9}, {
   3.5363501469745007`*^9, 3.5363501506345057`*^9}, {3.5363617411167684`*^9, 
   3.5363617534067855`*^9}, {3.536366615151597*^9, 3.5363666230616083`*^9}, {
   3.5363667754518213`*^9, 3.5363667821318307`*^9}, {3.536366906722005*^9, 
   3.536366922022027*^9}, {3.536596861742076*^9, 3.5365968701504908`*^9}, {
   3.5366042542749715`*^9, 3.536604254462172*^9}, {3.536625554425806*^9, 
   3.536625554775807*^9}, {3.5366276426139326`*^9, 3.536627642853933*^9}, {
   3.536629402336396*^9, 3.536629402746397*^9}, {3.5366940603006477`*^9, 
   3.536694061273703*^9}, {3.5366943323932104`*^9, 3.536694332661226*^9}, {
   3.536694390476533*^9, 3.536694402176202*^9}, {3.5368634751022315`*^9, 
   3.5368634756170325`*^9}, {3.536980474148706*^9, 3.5369804925387316`*^9}, {
   3.5369807910591497`*^9, 3.5369808136991816`*^9}, 3.538443999546241*^9, {
   3.538444040229568*^9, 3.5384440801737804`*^9}, {3.544471201864182*^9, 
   3.5444712020241823`*^9}, {3.5499343621399236`*^9, 
   3.5499343628887253`*^9}, {3.5693429012648573`*^9, 3.569342923814889*^9}, {
   3.5693432071452856`*^9, 3.5693432074652863`*^9}, {3.569351915062778*^9, 
   3.569351927142795*^9}, {3.569431211483277*^9, 3.569431211683277*^9}, 
   3.5757865832172976`*^9, {3.639064842139854*^9, 3.639064843080908*^9}, {
   3.6390655182895274`*^9, 3.6390655185325413`*^9}, 3.639065671059265*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic normalization", "Subsubsection",
 CellChangeTimes->{
  3.4953915070313115`*^9, 3.495840214754669*^9, {3.4958483177760134`*^9, 
   3.495848318886015*^9}, {3.495925911922002*^9, 3.495925920122013*^9}, 
   3.4961847242848682`*^9, 3.496184957525194*^9, 3.496188449500083*^9, 
   3.4961908979261436`*^9, 3.4961924998683863`*^9, 3.4961928754389124`*^9, {
   3.51849075797458*^9, 3.5184907698562593`*^9}, {3.574710513759987*^9, 
   3.5747105160099897`*^9}}],

Cell[TextData[{
 "Rule: If  ",
 Cell[BoxData[
  RowBox[{"u", "\[Equal]", 
   RowBox[{"a", "+", 
    RowBox[{"b", " ", "x"}]}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.495391630941485*^9, 3.4953916682515373`*^9}, 
   3.495398892616804*^9, {3.495402251391507*^9, 3.4954022711315346`*^9}, {
   3.495488783827441*^9, 3.4954888500775337`*^9}, {3.4954889799777155`*^9, 
   3.495489009627757*^9}, {3.495489141407942*^9, 3.495489151717956*^9}, {
   3.495489235178073*^9, 3.495489239268079*^9}, {3.495489386068284*^9, 
   3.4954894212383337`*^9}, {3.495489464438394*^9, 3.4954894647383947`*^9}, {
   3.495489500148444*^9, 3.4954895034984484`*^9}, {3.4954897331687703`*^9, 
   3.495489780118836*^9}, {3.495493913565876*^9, 3.495493935715907*^9}, {
   3.495494084919718*^9, 3.4954941083997507`*^9}, 3.495494511560315*^9, {
   3.495494580840412*^9, 3.4954945834404163`*^9}, {3.495494615970462*^9, 
   3.495494740200636*^9}, {3.495494880710832*^9, 3.4954948880508423`*^9}, {
   3.4954949819649754`*^9, 3.495494999445*^9}, {3.495495046515066*^9, 
   3.495495072875103*^9}, {3.4954951239351745`*^9, 3.4954951241651745`*^9}, {
   3.4954953673051157`*^9, 3.4954953726551237`*^9}, {3.495495450474448*^9, 
   3.495495453173253*^9}, {3.495495542140209*^9, 3.495495583792282*^9}, {
   3.4954957431465626`*^9, 3.4954957746118174`*^9}, {3.495495914419263*^9, 
   3.495495917804469*^9}, {3.495495955322535*^9, 3.4954960459586945`*^9}, {
   3.495496189588146*^9, 3.4954961923181515`*^9}, {3.4954973384365644`*^9, 
   3.495497357577798*^9}, {3.5240858715198665`*^9, 3.52408591925595*^9}, {
   3.5331536712917595`*^9, 3.5331536971617956`*^9}, {3.533223063022563*^9, 
   3.5332230658125668`*^9}, {3.533224894045127*^9, 3.5332248954551287`*^9}, 
   3.5363501685345306`*^9, {3.538444353705845*^9, 3.5384443676658645`*^9}, {
   3.5499343655595293`*^9, 3.549934366379531*^9}, {3.5693429326149015`*^9, 
   3.5693429326149015`*^9}, {3.5693520880530205`*^9, 3.5693520882530203`*^9}}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   SuperscriptBox["u", "m"], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
     RowBox[{"\[Integral]", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], 
       RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, {3.495401987881138*^9, 3.49540199674115*^9}, {
   3.495402119591322*^9, 3.4954021482513623`*^9}, {3.4954887467773895`*^9, 
   3.4954887749874287`*^9}, 3.495488944397666*^9, 3.495489263778113*^9, 
   3.4954893636582527`*^9, 3.4954898177188883`*^9, 3.495489875358969*^9, 
   3.495493833545764*^9, 3.495493864175807*^9, 3.4954940303560395`*^9, 
   3.4954941516698112`*^9, 3.4954942700599775`*^9, 3.4954948473707857`*^9, {
   3.495495264965372*^9, 3.4954952782653904`*^9}, {3.4954956850364604`*^9, 
   3.4954957088577023`*^9}, {3.495495865341577*^9, 3.4954958884920177`*^9}, {
   3.495496084225561*^9, 3.4954961029143944`*^9}, {3.495496211459385*^9, 
   3.4954962213810024`*^9}, 3.495496440218187*^9, {3.495497026732417*^9, 
   3.4954970596328745`*^9}, {3.495497256957621*^9, 3.495497302338101*^9}, 
   3.533151648818928*^9, 3.5331516797189713`*^9, 3.533151717349024*^9, {
   3.5331518776292486`*^9, 3.533151970249378*^9}, {3.5331520176994443`*^9, 
   3.5331520227894516`*^9}, {3.533152054329496*^9, 3.5331520626995077`*^9}, 
   3.533152270349798*^9, {3.533153065130911*^9, 3.5331530971109557`*^9}, 
   3.53315335008131*^9, {3.5331535194015465`*^9, 3.5331535356615696`*^9}, 
   3.5331536017616625`*^9, {3.533221927890974*^9, 3.533221930830978*^9}, {
   3.533222264011444*^9, 3.533222283731472*^9}, {3.5332223304615374`*^9, 
   3.5332223353515444`*^9}, 3.5363501604045196`*^9, {3.536361767566806*^9, 
   3.5363617697768087`*^9}, {3.5363666287016163`*^9, 
   3.5363666313816195`*^9}, {3.536366784271834*^9, 3.5363667868618374`*^9}, {
   3.536366923782029*^9, 3.5363669254320316`*^9}, {3.5365968786057057`*^9, 
   3.536596881944112*^9}, {3.5366940930205193`*^9, 3.53669410440917*^9}, {
   3.5366942507975435`*^9, 3.536694251403578*^9}, {3.536694493325415*^9, 
   3.536694495295528*^9}, 3.536980387788585*^9, {3.5384441491255584`*^9, 
   3.538444158185571*^9}, 3.5384445157160716`*^9, {3.5693429405449123`*^9, 
   3.569342962434943*^9}, {3.5693520924330263`*^9, 3.5693520926030264`*^9}, {
   3.5693527582739587`*^9, 3.569352760173961*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{"u_", "^", "m_"}], ",", "x_Symbol"}], "]"}], " ", ":=", "\n", 
  "  ", 
  RowBox[{
   RowBox[{"Int", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"ExpandToSum", "[", 
       RowBox[{"u", ",", "x"}], "]"}], "^", "m"}], ",", "x"}], "]"}], " ", "/;",
    "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{"m", ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"LinearQ", "[", 
     RowBox[{"u", ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"Not", "[", 
     RowBox[{"LinearMatchQ", "[", 
      RowBox[{"u", ",", "x"}], "]"}], "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.4954018196509027`*^9, {3.495401867050969*^9, 3.4954018672609687`*^9}, {
   3.4954022872215567`*^9, 3.4954022882115583`*^9}, 3.495488713187342*^9, 
   3.4954889210576334`*^9, 3.4954892270180616`*^9, 3.4954893399982195`*^9, {
   3.4954894833184204`*^9, 3.495489485938424*^9}, 3.4954897194087505`*^9, 
   3.495493755131653*^9, {3.4954938826158323`*^9, 3.495493884975836*^9}, 
   3.4954939962159915`*^9, {3.4954942766399865`*^9, 3.4954942945800114`*^9}, 
   3.4954948208307486`*^9, {3.495495087335123*^9, 3.495495087705124*^9}, 
   3.4954951805652537`*^9, 3.495495346275087*^9, 3.495495665489626*^9, 
   3.4954958533919563`*^9, {3.49549609483358*^9, 3.495496110792408*^9}, 
   3.4954961789333277`*^9, 3.495497173544275*^9, {3.495681286888199*^9, 
   3.4956812892482023`*^9}, {3.5240859566180162`*^9, 3.52408598201486*^9}, {
   3.524086057533393*^9, 3.524086058937395*^9}, {3.5242757161181526`*^9, 
   3.5242757216717625`*^9}, {3.5242763445964565`*^9, 
   3.5242763477320623`*^9}, {3.5331525961202545`*^9, 3.533152618700286*^9}, {
   3.5331527018704023`*^9, 3.5331528058905478`*^9}, {3.533153282981216*^9, 
   3.5331533342812877`*^9}, {3.533153565251611*^9, 3.533153599281659*^9}, {
   3.5332224159616575`*^9, 3.533222435081684*^9}, {3.5332224656717267`*^9, 
   3.533222494301767*^9}, {3.533223281652869*^9, 3.53322331799292*^9}, {
   3.5332234651831264`*^9, 3.5332234684731307`*^9}, {3.533223854473671*^9, 
   3.5332238609936805`*^9}, {3.5332239572838154`*^9, 3.5332239599938188`*^9}, 
   3.533224847425061*^9, {3.5332249144151554`*^9, 3.533224915905157*^9}, 
   3.533246982034763*^9, 3.5332605459462523`*^9, {3.536350185774555*^9, 
   3.536350207334585*^9}, {3.5363506584052167`*^9, 3.5363506914352627`*^9}, {
   3.5363508662655077`*^9, 3.5363509090255675`*^9}, {3.5363510097557087`*^9, 
   3.5363510569557743`*^9}, {3.5363512834660916`*^9, 3.536351309536128*^9}, {
   3.5363515550764723`*^9, 3.5363516176765594`*^9}, {3.5363516722566357`*^9, 
   3.5363516724366364`*^9}, {3.536356352083194*^9, 3.536356353383196*^9}, {
   3.5363617881968346`*^9, 3.536361833056897*^9}, {3.536366667801671*^9, 
   3.5363667247217503`*^9}, {3.5363667904918423`*^9, 3.536366799971856*^9}, {
   3.536366941382054*^9, 3.536366980882109*^9}, {3.5365968943773336`*^9, 
   3.536596936123007*^9}, {3.536596976558278*^9, 3.536597025589164*^9}, 
   3.536602461258152*^9, {3.5366940777176437`*^9, 3.5366940881722417`*^9}, 
   3.5366943020244737`*^9, {3.536694516327731*^9, 3.5366945346767807`*^9}, {
   3.5369801281282215`*^9, 3.5369801381582355`*^9}, 3.536980329338503*^9, {
   3.53698041236862*^9, 3.5369804166186256`*^9}, {3.5369807322990675`*^9, 
   3.536980746969088*^9}, 3.538444106556738*^9, {3.5384444438259706`*^9, 
   3.5384444863560305`*^9}, 3.544471282097495*^9, {3.549934369376335*^9, 
   3.549934370546336*^9}, {3.555274643817338*^9, 3.555274658697359*^9}, {
   3.5693429690149527`*^9, 3.569343004485002*^9}, {3.569343115935158*^9, 
   3.5693431274951744`*^9}, {3.5693438869262376`*^9, 
   3.5693438923862453`*^9}, {3.5693452399481316`*^9, 
   3.5693452412481337`*^9}, {3.5693495213494267`*^9, 
   3.5693495533094716`*^9}, {3.5693499264999943`*^9, 3.569349931960002*^9}, {
   3.569351944542819*^9, 3.5693519905128837`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{
  3.4796643211106243`*^9, {3.536351324436149*^9, 3.536351326496152*^9}, {
   3.5363515481064625`*^9, 3.536351548866463*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{Cell[TextData[StyleBox["2:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox["u", "m"], 
     SuperscriptBox["v", "n"], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"u", "\[Equal]", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]}], " ", "\[And]", " ", 
       RowBox[{"v", "\[Equal]", 
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519247363296011*^9, 3.519247363796012*^9}, 3.519258420199427*^9, 
   3.5192584863895197`*^9, {3.519320760160028*^9, 3.519320767367241*^9}, 
   3.5193299099191504`*^9, {3.5193300315093203`*^9, 3.519330031709321*^9}, {
   3.5193323099968634`*^9, 3.5193324414114943`*^9}, {3.5193327317904043`*^9, 
   3.519332762148057*^9}, {3.519340455685931*^9, 3.519340463318947*^9}, 
   3.519340635545749*^9, {3.5193422478304834`*^9, 3.519342248704085*^9}, {
   3.519342492766513*^9, 3.519342493156514*^9}, {3.519345750301442*^9, 
   3.5193457505978427`*^9}, 3.519346263464343*^9, {3.519349307658399*^9, 
   3.519349310965605*^9}, {3.519352294781488*^9, 3.5193522950014887`*^9}, {
   3.5194134359455075`*^9, 3.519413446054325*^9}, {3.5194134908888044`*^9, 
   3.5194134927764077`*^9}, {3.5194141847624226`*^9, 
   3.5194142323581066`*^9}, {3.519414342899901*^9, 3.519414474720132*^9}, {
   3.5197939535480833`*^9, 3.5197939539380836`*^9}, {3.5197940297698174`*^9, 
   3.5197940299726176`*^9}, 3.519795153580191*^9, {3.5200103027397947`*^9, 
   3.5200103044997973`*^9}, {3.5232186878169007`*^9, 
   3.5232186881569014`*^9}, {3.5232193955778913`*^9, 
   3.5232193955778913`*^9}, {3.5233166487845354`*^9, 
   3.5233166487845354`*^9}, {3.5233167010346084`*^9, 
   3.5233167010346084`*^9}, {3.523318546315711*^9, 3.523318573368556*^9}, {
   3.5239220709492664`*^9, 3.5239220924617043`*^9}, {3.5239221279205666`*^9, 
   3.5239221365629816`*^9}, {3.523930270899587*^9, 3.523930270899587*^9}, {
   3.5240761703528385`*^9, 3.5240761703528385`*^9}, {3.52407843124921*^9, 
   3.5240784332304134`*^9}, {3.5240784932749186`*^9, 
   3.5240784932749186`*^9}, {3.524079230095413*^9, 3.524079246553442*^9}, {
   3.5240858499762287`*^9, 3.524085860178646*^9}, {3.524085945261196*^9, 
   3.524085945261196*^9}, {3.5242763399632483`*^9, 3.5242763411488504`*^9}, {
   3.5242771575294847`*^9, 3.5242771578102846`*^9}, {3.530500224433988*^9, 
   3.530500225113989*^9}, {3.5313467876910577`*^9, 3.5313467883119507`*^9}, {
   3.5332231066826243`*^9, 3.5332231066826243`*^9}, {3.5332248881251183`*^9, 
   3.533224890245121*^9}, {3.5361011385491977`*^9, 3.5361011394332485`*^9}, {
   3.5363501469745007`*^9, 3.5363501506345057`*^9}, {3.5363617411167684`*^9, 
   3.5363617534067855`*^9}, {3.536366615151597*^9, 3.5363666230616083`*^9}, {
   3.5363667754518213`*^9, 3.5363667821318307`*^9}, {3.536366906722005*^9, 
   3.536366922022027*^9}, {3.536596861742076*^9, 3.5365968701504908`*^9}, {
   3.5366042542749715`*^9, 3.536604254462172*^9}, {3.536625554425806*^9, 
   3.536625554775807*^9}, {3.5366276426139326`*^9, 3.536627642853933*^9}, {
   3.536629402336396*^9, 3.536629402746397*^9}, {3.5366940603006477`*^9, 
   3.536694061273703*^9}, {3.5366943323932104`*^9, 3.536694332661226*^9}, {
   3.536694390476533*^9, 3.536694402176202*^9}, {3.5368634751022315`*^9, 
   3.5368634756170325`*^9}, {3.536980474148706*^9, 3.5369804925387316`*^9}, {
   3.5369807910591497`*^9, 3.5369808136991816`*^9}, 3.538443999546241*^9, {
   3.538444040229568*^9, 3.5384440801737804`*^9}, {3.544471201864182*^9, 
   3.5444712020241823`*^9}, {3.5499343621399236`*^9, 
   3.5499343628887253`*^9}, {3.5693429012648573`*^9, 3.569342923814889*^9}, {
   3.5693432071452856`*^9, 3.5693432074652863`*^9}, {3.569351915062778*^9, 
   3.569351927142795*^9}, {3.569352555713675*^9, 3.569352597773734*^9}, {
   3.5694315155137024`*^9, 3.569431516203704*^9}, 3.5757869394127235`*^9, {
   3.5757872067971926`*^9, 3.575787207062393*^9}, {3.5954790191892796`*^9, 
   3.59547901934928*^9}, {3.6112382875558305`*^9, 3.6112382876858306`*^9}, {
   3.6341484807394247`*^9, 3.6341484808954334`*^9}, {3.636056914499009*^9, 
   3.6360569156730766`*^9}, {3.6390649694651365`*^9, 
   3.6390649700201683`*^9}, {3.6390655591288633`*^9, 3.6390655593148737`*^9}, 
   3.6390656718803124`*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic normalization", "Subsubsection",
 CellChangeTimes->{
  3.4953915070313115`*^9, 3.495840214754669*^9, {3.4958483177760134`*^9, 
   3.495848318886015*^9}, {3.495925911922002*^9, 3.495925920122013*^9}, 
   3.4961847242848682`*^9, 3.496184957525194*^9, 3.496188449500083*^9, 
   3.4961908979261436`*^9, 3.4961924998683863`*^9, 3.4961928754389124`*^9, {
   3.51849075797458*^9, 3.5184907698562593`*^9}, 3.574710542770027*^9}],

Cell[TextData[{
 "Rule: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"u", "\[Equal]", 
    RowBox[{"a", "+", 
     RowBox[{"b", " ", "x"}]}]}], " ", "\[And]", " ", 
   RowBox[{"v", "\[Equal]", 
    RowBox[{"c", "+", 
     RowBox[{"d", " ", "x"}]}]}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.495391630941485*^9, 3.4953916682515373`*^9}, 
   3.495398892616804*^9, {3.495402251391507*^9, 3.4954022711315346`*^9}, {
   3.495488783827441*^9, 3.4954888500775337`*^9}, {3.4954889799777155`*^9, 
   3.495489009627757*^9}, {3.495489141407942*^9, 3.495489151717956*^9}, {
   3.495489235178073*^9, 3.495489239268079*^9}, {3.495489386068284*^9, 
   3.4954894212383337`*^9}, {3.495489464438394*^9, 3.4954894647383947`*^9}, {
   3.495489500148444*^9, 3.4954895034984484`*^9}, {3.4954897331687703`*^9, 
   3.495489780118836*^9}, {3.495493913565876*^9, 3.495493935715907*^9}, {
   3.495494084919718*^9, 3.4954941083997507`*^9}, 3.495494511560315*^9, {
   3.495494580840412*^9, 3.4954945834404163`*^9}, {3.495494615970462*^9, 
   3.495494740200636*^9}, {3.495494880710832*^9, 3.4954948880508423`*^9}, {
   3.4954949819649754`*^9, 3.495494999445*^9}, {3.495495046515066*^9, 
   3.495495072875103*^9}, {3.4954951239351745`*^9, 3.4954951241651745`*^9}, {
   3.4954953673051157`*^9, 3.4954953726551237`*^9}, {3.495495450474448*^9, 
   3.495495453173253*^9}, {3.495495542140209*^9, 3.495495583792282*^9}, {
   3.4954957431465626`*^9, 3.4954957746118174`*^9}, {3.495495914419263*^9, 
   3.495495917804469*^9}, {3.495495955322535*^9, 3.4954960459586945`*^9}, {
   3.495496189588146*^9, 3.4954961923181515`*^9}, {3.4954973384365644`*^9, 
   3.495497357577798*^9}, {3.5240858715198665`*^9, 3.52408591925595*^9}, {
   3.5331536712917595`*^9, 3.5331536971617956`*^9}, {3.533223063022563*^9, 
   3.5332230658125668`*^9}, {3.533224894045127*^9, 3.5332248954551287`*^9}, 
   3.5363501685345306`*^9, {3.538444353705845*^9, 3.5384443676658645`*^9}, {
   3.5499343655595293`*^9, 3.549934366379531*^9}, {3.5693429326149015`*^9, 
   3.5693429326149015`*^9}, {3.5693520880530205`*^9, 
   3.5693520882530203`*^9}, {3.5693526036737423`*^9, 3.5693526036737423`*^9}}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   SuperscriptBox["u", "m"], 
   SuperscriptBox["v", "n"], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
     RowBox[{"\[Integral]", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
       RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, {3.495401987881138*^9, 3.49540199674115*^9}, {
   3.495402119591322*^9, 3.4954021482513623`*^9}, {3.4954887467773895`*^9, 
   3.4954887749874287`*^9}, 3.495488944397666*^9, 3.495489263778113*^9, 
   3.4954893636582527`*^9, 3.4954898177188883`*^9, 3.495489875358969*^9, 
   3.495493833545764*^9, 3.495493864175807*^9, 3.4954940303560395`*^9, 
   3.4954941516698112`*^9, 3.4954942700599775`*^9, 3.4954948473707857`*^9, {
   3.495495264965372*^9, 3.4954952782653904`*^9}, {3.4954956850364604`*^9, 
   3.4954957088577023`*^9}, {3.495495865341577*^9, 3.4954958884920177`*^9}, {
   3.495496084225561*^9, 3.4954961029143944`*^9}, {3.495496211459385*^9, 
   3.4954962213810024`*^9}, 3.495496440218187*^9, {3.495497026732417*^9, 
   3.4954970596328745`*^9}, {3.495497256957621*^9, 3.495497302338101*^9}, 
   3.533151648818928*^9, 3.5331516797189713`*^9, 3.533151717349024*^9, {
   3.5331518776292486`*^9, 3.533151970249378*^9}, {3.5331520176994443`*^9, 
   3.5331520227894516`*^9}, {3.533152054329496*^9, 3.5331520626995077`*^9}, 
   3.533152270349798*^9, {3.533153065130911*^9, 3.5331530971109557`*^9}, 
   3.53315335008131*^9, {3.5331535194015465`*^9, 3.5331535356615696`*^9}, 
   3.5331536017616625`*^9, {3.533221927890974*^9, 3.533221930830978*^9}, {
   3.533222264011444*^9, 3.533222283731472*^9}, {3.5332223304615374`*^9, 
   3.5332223353515444`*^9}, 3.5363501604045196`*^9, {3.536361767566806*^9, 
   3.5363617697768087`*^9}, {3.5363666287016163`*^9, 
   3.5363666313816195`*^9}, {3.536366784271834*^9, 3.5363667868618374`*^9}, {
   3.536366923782029*^9, 3.5363669254320316`*^9}, {3.5365968786057057`*^9, 
   3.536596881944112*^9}, {3.5366940930205193`*^9, 3.53669410440917*^9}, {
   3.5366942507975435`*^9, 3.536694251403578*^9}, {3.536694493325415*^9, 
   3.536694495295528*^9}, 3.536980387788585*^9, {3.5384441491255584`*^9, 
   3.538444158185571*^9}, 3.5384445157160716`*^9, {3.5693429405449123`*^9, 
   3.569342962434943*^9}, {3.5693520924330263`*^9, 3.5693520926030264`*^9}, {
   3.5693526191837635`*^9, 3.569352629573778*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"u_", "^", "m_."}], "*", 
     RowBox[{"v_", "^", "n_."}]}], ",", "x_Symbol"}], "]"}], " ", ":=", "\n", 
  "  ", 
  RowBox[{
   RowBox[{"Int", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ExpandToSum", "[", 
        RowBox[{"u", ",", "x"}], "]"}], "^", "m"}], "*", 
      RowBox[{
       RowBox[{"ExpandToSum", "[", 
        RowBox[{"v", ",", "x"}], "]"}], "^", "n"}]}], ",", "x"}], "]"}], " ", 
   "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"m", ",", "n"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"LinearQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"u", ",", "v"}], "}"}], ",", "x"}], "]"}], " ", "&&", " ", 
    RowBox[{"Not", "[", 
     RowBox[{"LinearMatchQ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"u", ",", "v"}], "}"}], ",", "x"}], "]"}], 
     "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.4954018196509027`*^9, {3.495401867050969*^9, 3.4954018672609687`*^9}, {
   3.4954022872215567`*^9, 3.4954022882115583`*^9}, 3.495488713187342*^9, 
   3.4954889210576334`*^9, 3.4954892270180616`*^9, 3.4954893399982195`*^9, {
   3.4954894833184204`*^9, 3.495489485938424*^9}, 3.4954897194087505`*^9, 
   3.495493755131653*^9, {3.4954938826158323`*^9, 3.495493884975836*^9}, 
   3.4954939962159915`*^9, {3.4954942766399865`*^9, 3.4954942945800114`*^9}, 
   3.4954948208307486`*^9, {3.495495087335123*^9, 3.495495087705124*^9}, 
   3.4954951805652537`*^9, 3.495495346275087*^9, 3.495495665489626*^9, 
   3.4954958533919563`*^9, {3.49549609483358*^9, 3.495496110792408*^9}, 
   3.4954961789333277`*^9, 3.495497173544275*^9, {3.495681286888199*^9, 
   3.4956812892482023`*^9}, {3.5240859566180162`*^9, 3.52408598201486*^9}, {
   3.524086057533393*^9, 3.524086058937395*^9}, {3.5242757161181526`*^9, 
   3.5242757216717625`*^9}, {3.5242763445964565`*^9, 
   3.5242763477320623`*^9}, {3.5331525961202545`*^9, 3.533152618700286*^9}, {
   3.5331527018704023`*^9, 3.5331528058905478`*^9}, {3.533153282981216*^9, 
   3.5331533342812877`*^9}, {3.533153565251611*^9, 3.533153599281659*^9}, {
   3.5332224159616575`*^9, 3.533222435081684*^9}, {3.5332224656717267`*^9, 
   3.533222494301767*^9}, {3.533223281652869*^9, 3.53322331799292*^9}, {
   3.5332234651831264`*^9, 3.5332234684731307`*^9}, {3.533223854473671*^9, 
   3.5332238609936805`*^9}, {3.5332239572838154`*^9, 3.5332239599938188`*^9}, 
   3.533224847425061*^9, {3.5332249144151554`*^9, 3.533224915905157*^9}, 
   3.533246982034763*^9, 3.5332605459462523`*^9, {3.536350185774555*^9, 
   3.536350207334585*^9}, {3.5363506584052167`*^9, 3.5363506914352627`*^9}, {
   3.5363508662655077`*^9, 3.5363509090255675`*^9}, {3.5363510097557087`*^9, 
   3.5363510569557743`*^9}, {3.5363512834660916`*^9, 3.536351309536128*^9}, {
   3.5363515550764723`*^9, 3.5363516176765594`*^9}, {3.5363516722566357`*^9, 
   3.5363516724366364`*^9}, {3.536356352083194*^9, 3.536356353383196*^9}, {
   3.5363617881968346`*^9, 3.536361833056897*^9}, {3.536366667801671*^9, 
   3.5363667247217503`*^9}, {3.5363667904918423`*^9, 3.536366799971856*^9}, {
   3.536366941382054*^9, 3.536366980882109*^9}, {3.5365968943773336`*^9, 
   3.536596936123007*^9}, {3.536596976558278*^9, 3.536597025589164*^9}, 
   3.536602461258152*^9, {3.5366940777176437`*^9, 3.5366940881722417`*^9}, 
   3.5366943020244737`*^9, {3.536694516327731*^9, 3.5366945346767807`*^9}, {
   3.5369801281282215`*^9, 3.5369801381582355`*^9}, 3.536980329338503*^9, {
   3.53698041236862*^9, 3.5369804166186256`*^9}, {3.5369807322990675`*^9, 
   3.536980746969088*^9}, 3.538444106556738*^9, {3.5384444438259706`*^9, 
   3.5384444863560305`*^9}, 3.544471282097495*^9, {3.549934369376335*^9, 
   3.549934370546336*^9}, {3.555274643817338*^9, 3.555274658697359*^9}, {
   3.5693429690149527`*^9, 3.569343004485002*^9}, {3.569343115935158*^9, 
   3.5693431274951744`*^9}, {3.5693438869262376`*^9, 
   3.5693438923862453`*^9}, {3.5693452399481316`*^9, 
   3.5693452412481337`*^9}, {3.5693495213494267`*^9, 
   3.5693495533094716`*^9}, {3.5693499264999943`*^9, 3.569349931960002*^9}, {
   3.569351944542819*^9, 3.5693519905128837`*^9}, {3.569352647183803*^9, 
   3.5693527140438967`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{
  3.4796643211106243`*^9, {3.536351324436149*^9, 3.536351326496152*^9}, {
   3.5363515481064625`*^9, 3.536351548866463*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{Cell[TextData[StyleBox["3:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox["u", "m"], 
     SuperscriptBox["v", "n"], 
     SuperscriptBox["w", "p"], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"u", "\[Equal]", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]}], " ", "\[And]", " ", 
       RowBox[{"v", "\[Equal]", 
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]}], " ", "\[And]", " ", 
       RowBox[{"w", "\[Equal]", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519247363296011*^9, 3.519247363796012*^9}, 3.519258420199427*^9, 
   3.5192584863895197`*^9, {3.519320760160028*^9, 3.519320767367241*^9}, 
   3.5193299099191504`*^9, {3.5193300315093203`*^9, 3.519330031709321*^9}, {
   3.5193323099968634`*^9, 3.5193324414114943`*^9}, {3.5193327317904043`*^9, 
   3.519332762148057*^9}, {3.519340455685931*^9, 3.519340463318947*^9}, 
   3.519340635545749*^9, {3.5193422478304834`*^9, 3.519342248704085*^9}, {
   3.519342492766513*^9, 3.519342493156514*^9}, {3.519345750301442*^9, 
   3.5193457505978427`*^9}, 3.519346263464343*^9, {3.519349307658399*^9, 
   3.519349310965605*^9}, {3.519352294781488*^9, 3.5193522950014887`*^9}, {
   3.5194134359455075`*^9, 3.519413446054325*^9}, {3.5194134908888044`*^9, 
   3.5194134927764077`*^9}, {3.5194141847624226`*^9, 
   3.5194142323581066`*^9}, {3.519414342899901*^9, 3.519414474720132*^9}, {
   3.5197939535480833`*^9, 3.5197939539380836`*^9}, {3.5197940297698174`*^9, 
   3.5197940299726176`*^9}, 3.519795153580191*^9, {3.5200103027397947`*^9, 
   3.5200103044997973`*^9}, {3.5232186878169007`*^9, 
   3.5232186881569014`*^9}, {3.5232193955778913`*^9, 
   3.5232193955778913`*^9}, {3.5233166487845354`*^9, 
   3.5233166487845354`*^9}, {3.5233167010346084`*^9, 
   3.5233167010346084`*^9}, {3.523318546315711*^9, 3.523318573368556*^9}, {
   3.5239220709492664`*^9, 3.5239220924617043`*^9}, {3.5239221279205666`*^9, 
   3.5239221365629816`*^9}, {3.523930270899587*^9, 3.523930270899587*^9}, {
   3.5240761703528385`*^9, 3.5240761703528385`*^9}, {3.52407843124921*^9, 
   3.5240784332304134`*^9}, {3.5240784932749186`*^9, 
   3.5240784932749186`*^9}, {3.524079230095413*^9, 3.524079246553442*^9}, {
   3.5240858499762287`*^9, 3.524085860178646*^9}, {3.524085945261196*^9, 
   3.524085945261196*^9}, {3.5242763399632483`*^9, 3.5242763411488504`*^9}, {
   3.5242771575294847`*^9, 3.5242771578102846`*^9}, {3.530500224433988*^9, 
   3.530500225113989*^9}, {3.5313467876910577`*^9, 3.5313467883119507`*^9}, {
   3.5332231066826243`*^9, 3.5332231066826243`*^9}, {3.5332248881251183`*^9, 
   3.533224890245121*^9}, {3.5361011385491977`*^9, 3.5361011394332485`*^9}, {
   3.5363501469745007`*^9, 3.5363501506345057`*^9}, {3.5363617411167684`*^9, 
   3.5363617534067855`*^9}, {3.536366615151597*^9, 3.5363666230616083`*^9}, {
   3.5363667754518213`*^9, 3.5363667821318307`*^9}, {3.536366906722005*^9, 
   3.536366922022027*^9}, {3.536596861742076*^9, 3.5365968701504908`*^9}, {
   3.5366042542749715`*^9, 3.536604254462172*^9}, {3.536625554425806*^9, 
   3.536625554775807*^9}, {3.5366276426139326`*^9, 3.536627642853933*^9}, {
   3.536629402336396*^9, 3.536629402746397*^9}, {3.5366940603006477`*^9, 
   3.536694061273703*^9}, {3.5366943323932104`*^9, 3.536694332661226*^9}, {
   3.536694390476533*^9, 3.536694402176202*^9}, {3.5368634751022315`*^9, 
   3.5368634756170325`*^9}, {3.536980474148706*^9, 3.5369804925387316`*^9}, {
   3.5369807910591497`*^9, 3.5369808136991816`*^9}, 3.538443999546241*^9, {
   3.538444040229568*^9, 3.5384440801737804`*^9}, {3.544471201864182*^9, 
   3.5444712020241823`*^9}, {3.5499343621399236`*^9, 
   3.5499343628887253`*^9}, {3.5693429012648573`*^9, 3.569342923814889*^9}, {
   3.5693432071452856`*^9, 3.5693432074652863`*^9}, {3.569351915062778*^9, 
   3.569351927142795*^9}, {3.569352555713675*^9, 3.569352597773734*^9}, {
   3.5693528018640194`*^9, 3.5693528240640507`*^9}, {3.5694315791237917`*^9, 
   3.569431579433792*^9}, 3.5757871382506723`*^9, {3.6107813787244835`*^9, 
   3.610781380072561*^9}, {3.611360929934261*^9, 3.6113609310242624`*^9}, {
   3.6115418017950525`*^9, 3.6115418019550524`*^9}, {3.6116858798549385`*^9, 
   3.6116858799749384`*^9}, {3.625956200345699*^9, 3.625956200525699*^9}, {
   3.630806409552518*^9, 3.6308064097553177`*^9}, {3.6310317599921007`*^9, 
   3.631031760812147*^9}, {3.6310675211570253`*^9, 3.6310675215520477`*^9}, {
   3.6312944582066207`*^9, 3.6312944584846363`*^9}, {3.63130962077887*^9, 
   3.631309620974881*^9}, {3.6390651136183815`*^9, 3.639065114220416*^9}, {
   3.639065561132978*^9, 3.6390655613169885`*^9}, 3.639065672419343*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic normalization", "Subsubsection",
 CellChangeTimes->{
  3.4953915070313115`*^9, 3.495840214754669*^9, {3.4958483177760134`*^9, 
   3.495848318886015*^9}, {3.495925911922002*^9, 3.495925920122013*^9}, 
   3.4961847242848682`*^9, 3.496184957525194*^9, 3.496188449500083*^9, 
   3.4961908979261436`*^9, 3.4961924998683863`*^9, 3.4961928754389124`*^9, {
   3.51849075797458*^9, 3.5184907698562593`*^9}, 3.574710562450055*^9}],

Cell[TextData[{
 "Rule: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"u", "\[Equal]", 
    RowBox[{"a", "+", 
     RowBox[{"b", " ", "x"}]}]}], " ", "\[And]", " ", 
   RowBox[{"v", "\[Equal]", 
    RowBox[{"c", "+", 
     RowBox[{"d", " ", "x"}]}]}], " ", "\[And]", " ", 
   RowBox[{"w", "\[Equal]", 
    RowBox[{"e", "+", 
     RowBox[{"f", " ", "x"}]}]}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.495391630941485*^9, 3.4953916682515373`*^9}, 
   3.495398892616804*^9, {3.495402251391507*^9, 3.4954022711315346`*^9}, {
   3.495488783827441*^9, 3.4954888500775337`*^9}, {3.4954889799777155`*^9, 
   3.495489009627757*^9}, {3.495489141407942*^9, 3.495489151717956*^9}, {
   3.495489235178073*^9, 3.495489239268079*^9}, {3.495489386068284*^9, 
   3.4954894212383337`*^9}, {3.495489464438394*^9, 3.4954894647383947`*^9}, {
   3.495489500148444*^9, 3.4954895034984484`*^9}, {3.4954897331687703`*^9, 
   3.495489780118836*^9}, {3.495493913565876*^9, 3.495493935715907*^9}, {
   3.495494084919718*^9, 3.4954941083997507`*^9}, 3.495494511560315*^9, {
   3.495494580840412*^9, 3.4954945834404163`*^9}, {3.495494615970462*^9, 
   3.495494740200636*^9}, {3.495494880710832*^9, 3.4954948880508423`*^9}, {
   3.4954949819649754`*^9, 3.495494999445*^9}, {3.495495046515066*^9, 
   3.495495072875103*^9}, {3.4954951239351745`*^9, 3.4954951241651745`*^9}, {
   3.4954953673051157`*^9, 3.4954953726551237`*^9}, {3.495495450474448*^9, 
   3.495495453173253*^9}, {3.495495542140209*^9, 3.495495583792282*^9}, {
   3.4954957431465626`*^9, 3.4954957746118174`*^9}, {3.495495914419263*^9, 
   3.495495917804469*^9}, {3.495495955322535*^9, 3.4954960459586945`*^9}, {
   3.495496189588146*^9, 3.4954961923181515`*^9}, {3.4954973384365644`*^9, 
   3.495497357577798*^9}, {3.5240858715198665`*^9, 3.52408591925595*^9}, {
   3.5331536712917595`*^9, 3.5331536971617956`*^9}, {3.533223063022563*^9, 
   3.5332230658125668`*^9}, {3.533224894045127*^9, 3.5332248954551287`*^9}, 
   3.5363501685345306`*^9, {3.538444353705845*^9, 3.5384443676658645`*^9}, {
   3.5499343655595293`*^9, 3.549934366379531*^9}, {3.5693429326149015`*^9, 
   3.5693429326149015`*^9}, {3.5693520880530205`*^9, 
   3.5693520882530203`*^9}, {3.5693526036737423`*^9, 
   3.5693526036737423`*^9}, {3.5693528326040626`*^9, 3.5693528326040626`*^9}}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   SuperscriptBox["u", "m"], 
   SuperscriptBox["v", "n"], 
   SuperscriptBox["w", "p"], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
     RowBox[{"\[Integral]", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
       RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, {3.495401987881138*^9, 3.49540199674115*^9}, {
   3.495402119591322*^9, 3.4954021482513623`*^9}, {3.4954887467773895`*^9, 
   3.4954887749874287`*^9}, 3.495488944397666*^9, 3.495489263778113*^9, 
   3.4954893636582527`*^9, 3.4954898177188883`*^9, 3.495489875358969*^9, 
   3.495493833545764*^9, 3.495493864175807*^9, 3.4954940303560395`*^9, 
   3.4954941516698112`*^9, 3.4954942700599775`*^9, 3.4954948473707857`*^9, {
   3.495495264965372*^9, 3.4954952782653904`*^9}, {3.4954956850364604`*^9, 
   3.4954957088577023`*^9}, {3.495495865341577*^9, 3.4954958884920177`*^9}, {
   3.495496084225561*^9, 3.4954961029143944`*^9}, {3.495496211459385*^9, 
   3.4954962213810024`*^9}, 3.495496440218187*^9, {3.495497026732417*^9, 
   3.4954970596328745`*^9}, {3.495497256957621*^9, 3.495497302338101*^9}, 
   3.533151648818928*^9, 3.5331516797189713`*^9, 3.533151717349024*^9, {
   3.5331518776292486`*^9, 3.533151970249378*^9}, {3.5331520176994443`*^9, 
   3.5331520227894516`*^9}, {3.533152054329496*^9, 3.5331520626995077`*^9}, 
   3.533152270349798*^9, {3.533153065130911*^9, 3.5331530971109557`*^9}, 
   3.53315335008131*^9, {3.5331535194015465`*^9, 3.5331535356615696`*^9}, 
   3.5331536017616625`*^9, {3.533221927890974*^9, 3.533221930830978*^9}, {
   3.533222264011444*^9, 3.533222283731472*^9}, {3.5332223304615374`*^9, 
   3.5332223353515444`*^9}, 3.5363501604045196`*^9, {3.536361767566806*^9, 
   3.5363617697768087`*^9}, {3.5363666287016163`*^9, 
   3.5363666313816195`*^9}, {3.536366784271834*^9, 3.5363667868618374`*^9}, {
   3.536366923782029*^9, 3.5363669254320316`*^9}, {3.5365968786057057`*^9, 
   3.536596881944112*^9}, {3.5366940930205193`*^9, 3.53669410440917*^9}, {
   3.5366942507975435`*^9, 3.536694251403578*^9}, {3.536694493325415*^9, 
   3.536694495295528*^9}, 3.536980387788585*^9, {3.5384441491255584`*^9, 
   3.538444158185571*^9}, 3.5384445157160716`*^9, {3.5693429405449123`*^9, 
   3.569342962434943*^9}, {3.5693520924330263`*^9, 3.5693520926030264`*^9}, {
   3.5693526191837635`*^9, 3.569352629573778*^9}, {3.5693528385140705`*^9, 
   3.5693528438740788`*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"u_", "^", "m_."}], "*", 
     RowBox[{"v_", "^", "n_."}], "*", 
     RowBox[{"w_", "^", "p_."}]}], ",", "x_Symbol"}], "]"}], " ", ":=", "\n", 
  "  ", 
  RowBox[{
   RowBox[{"Int", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ExpandToSum", "[", 
        RowBox[{"u", ",", "x"}], "]"}], "^", "m"}], "*", 
      RowBox[{
       RowBox[{"ExpandToSum", "[", 
        RowBox[{"v", ",", "x"}], "]"}], "^", "n"}], "*", 
      RowBox[{
       RowBox[{"ExpandToSum", "[", 
        RowBox[{"w", ",", "x"}], "]"}], "^", "p"}]}], ",", "x"}], "]"}], " ", 
   "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"m", ",", "n", ",", "p"}], "}"}], ",", "x"}], "]"}], " ", "&&",
     " ", 
    RowBox[{"LinearQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"u", ",", "v", ",", "w"}], "}"}], ",", "x"}], "]"}], " ", "&&",
     " ", 
    RowBox[{"Not", "[", 
     RowBox[{"LinearMatchQ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"u", ",", "v", ",", "w"}], "}"}], ",", "x"}], "]"}], 
     "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.4954018196509027`*^9, {3.495401867050969*^9, 3.4954018672609687`*^9}, {
   3.4954022872215567`*^9, 3.4954022882115583`*^9}, 3.495488713187342*^9, 
   3.4954889210576334`*^9, 3.4954892270180616`*^9, 3.4954893399982195`*^9, {
   3.4954894833184204`*^9, 3.495489485938424*^9}, 3.4954897194087505`*^9, 
   3.495493755131653*^9, {3.4954938826158323`*^9, 3.495493884975836*^9}, 
   3.4954939962159915`*^9, {3.4954942766399865`*^9, 3.4954942945800114`*^9}, 
   3.4954948208307486`*^9, {3.495495087335123*^9, 3.495495087705124*^9}, 
   3.4954951805652537`*^9, 3.495495346275087*^9, 3.495495665489626*^9, 
   3.4954958533919563`*^9, {3.49549609483358*^9, 3.495496110792408*^9}, 
   3.4954961789333277`*^9, 3.495497173544275*^9, {3.495681286888199*^9, 
   3.4956812892482023`*^9}, {3.5240859566180162`*^9, 3.52408598201486*^9}, {
   3.524086057533393*^9, 3.524086058937395*^9}, {3.5242757161181526`*^9, 
   3.5242757216717625`*^9}, {3.5242763445964565`*^9, 
   3.5242763477320623`*^9}, {3.5331525961202545`*^9, 3.533152618700286*^9}, {
   3.5331527018704023`*^9, 3.5331528058905478`*^9}, {3.533153282981216*^9, 
   3.5331533342812877`*^9}, {3.533153565251611*^9, 3.533153599281659*^9}, {
   3.5332224159616575`*^9, 3.533222435081684*^9}, {3.5332224656717267`*^9, 
   3.533222494301767*^9}, {3.533223281652869*^9, 3.53322331799292*^9}, {
   3.5332234651831264`*^9, 3.5332234684731307`*^9}, {3.533223854473671*^9, 
   3.5332238609936805`*^9}, {3.5332239572838154`*^9, 3.5332239599938188`*^9}, 
   3.533224847425061*^9, {3.5332249144151554`*^9, 3.533224915905157*^9}, 
   3.533246982034763*^9, 3.5332605459462523`*^9, {3.536350185774555*^9, 
   3.536350207334585*^9}, {3.5363506584052167`*^9, 3.5363506914352627`*^9}, {
   3.5363508662655077`*^9, 3.5363509090255675`*^9}, {3.5363510097557087`*^9, 
   3.5363510569557743`*^9}, {3.5363512834660916`*^9, 3.536351309536128*^9}, {
   3.5363515550764723`*^9, 3.5363516176765594`*^9}, {3.5363516722566357`*^9, 
   3.5363516724366364`*^9}, {3.536356352083194*^9, 3.536356353383196*^9}, {
   3.5363617881968346`*^9, 3.536361833056897*^9}, {3.536366667801671*^9, 
   3.5363667247217503`*^9}, {3.5363667904918423`*^9, 3.536366799971856*^9}, {
   3.536366941382054*^9, 3.536366980882109*^9}, {3.5365968943773336`*^9, 
   3.536596936123007*^9}, {3.536596976558278*^9, 3.536597025589164*^9}, 
   3.536602461258152*^9, {3.5366940777176437`*^9, 3.5366940881722417`*^9}, 
   3.5366943020244737`*^9, {3.536694516327731*^9, 3.5366945346767807`*^9}, {
   3.5369801281282215`*^9, 3.5369801381582355`*^9}, 3.536980329338503*^9, {
   3.53698041236862*^9, 3.5369804166186256`*^9}, {3.5369807322990675`*^9, 
   3.536980746969088*^9}, 3.538444106556738*^9, {3.5384444438259706`*^9, 
   3.5384444863560305`*^9}, 3.544471282097495*^9, {3.549934369376335*^9, 
   3.549934370546336*^9}, {3.555274643817338*^9, 3.555274658697359*^9}, {
   3.5693429690149527`*^9, 3.569343004485002*^9}, {3.569343115935158*^9, 
   3.5693431274951744`*^9}, {3.5693438869262376`*^9, 
   3.5693438923862453`*^9}, {3.5693452399481316`*^9, 
   3.5693452412481337`*^9}, {3.5693495213494267`*^9, 
   3.5693495533094716`*^9}, {3.5693499264999943`*^9, 3.569349931960002*^9}, {
   3.569351944542819*^9, 3.5693519905128837`*^9}, {3.569352647183803*^9, 
   3.5693527140438967`*^9}, {3.5693528513940887`*^9, 3.5693528811441307`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{
  3.4796643211106243`*^9, {3.536351324436149*^9, 3.536351326496152*^9}, {
   3.5363515481064625`*^9, 3.536351548866463*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\t", 
  RowBox[{Cell[TextData[StyleBox["4:",
    FontFamily->"Arial",
    FontColor->RGBColor[1, 0, 0]]], "None"], "  ", 
   RowBox[{"\[Integral]", 
    RowBox[{
     SuperscriptBox["u", "m"], 
     SuperscriptBox["v", "n"], 
     SuperscriptBox["w", "p"], 
     SuperscriptBox["z", "q"], 
     RowBox[{"\[DifferentialD]", "x"}], "  ", 
     StyleBox["when",
      FontFamily->"Arial",
      FontWeight->"Plain"], 
     StyleBox["  ",
      FontFamily->"Arial",
      FontWeight->"Plain"], Cell[TextData[Cell[BoxData[
      RowBox[{
       RowBox[{"u", "\[Equal]", 
        RowBox[{"a", "+", 
         RowBox[{"b", " ", "x"}]}]}], " ", "\[And]", " ", 
       RowBox[{"v", "\[Equal]", 
        RowBox[{"c", "+", 
         RowBox[{"d", " ", "x"}]}]}], " ", "\[And]", " ", 
       RowBox[{"w", "\[Equal]", 
        RowBox[{"e", "+", 
         RowBox[{"f", " ", "x"}]}]}], " ", "\[And]", " ", 
       RowBox[{"z", "\[Equal]", 
        RowBox[{"g", "+", 
         RowBox[{"h", " ", "x"}]}]}]}]]]], "None"]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{
  3.477935275784027*^9, {3.477935350060832*^9, 3.477935352384173*^9}, {
   3.477935393803731*^9, 3.477935400102789*^9}, {3.477935515378547*^9, 
   3.47793552034569*^9}, 3.478120029940968*^9, {3.479318860690858*^9, 
   3.47931886615872*^9}, {3.4794185033278093`*^9, 3.479418503918659*^9}, 
   3.4795122294117584`*^9, {3.479615913307893*^9, 3.4796159352794867`*^9}, 
   3.4796160386581373`*^9, 3.4796867204045024`*^9, {3.4928025699585147`*^9, 
   3.492802570130115*^9}, 3.492822274480175*^9, 3.492825822242408*^9, {
   3.4940970615585365`*^9, 3.494097062168537*^9}, {3.496441349250718*^9, 
   3.496441349830719*^9}, 3.4964414848609076`*^9, 3.4964645213514385`*^9, 
   3.5192470594155855`*^9, {3.519247288125906*^9, 3.5192473207459517`*^9}, {
   3.519247363296011*^9, 3.519247363796012*^9}, 3.519258420199427*^9, 
   3.5192584863895197`*^9, {3.519320760160028*^9, 3.519320767367241*^9}, 
   3.5193299099191504`*^9, {3.5193300315093203`*^9, 3.519330031709321*^9}, {
   3.5193323099968634`*^9, 3.5193324414114943`*^9}, {3.5193327317904043`*^9, 
   3.519332762148057*^9}, {3.519340455685931*^9, 3.519340463318947*^9}, 
   3.519340635545749*^9, {3.5193422478304834`*^9, 3.519342248704085*^9}, {
   3.519342492766513*^9, 3.519342493156514*^9}, {3.519345750301442*^9, 
   3.5193457505978427`*^9}, 3.519346263464343*^9, {3.519349307658399*^9, 
   3.519349310965605*^9}, {3.519352294781488*^9, 3.5193522950014887`*^9}, {
   3.5194134359455075`*^9, 3.519413446054325*^9}, {3.5194134908888044`*^9, 
   3.5194134927764077`*^9}, {3.5194141847624226`*^9, 
   3.5194142323581066`*^9}, {3.519414342899901*^9, 3.519414474720132*^9}, {
   3.5197939535480833`*^9, 3.5197939539380836`*^9}, {3.5197940297698174`*^9, 
   3.5197940299726176`*^9}, 3.519795153580191*^9, {3.5200103027397947`*^9, 
   3.5200103044997973`*^9}, {3.5232186878169007`*^9, 
   3.5232186881569014`*^9}, {3.5232193955778913`*^9, 
   3.5232193955778913`*^9}, {3.5233166487845354`*^9, 
   3.5233166487845354`*^9}, {3.5233167010346084`*^9, 
   3.5233167010346084`*^9}, {3.523318546315711*^9, 3.523318573368556*^9}, {
   3.5239220709492664`*^9, 3.5239220924617043`*^9}, {3.5239221279205666`*^9, 
   3.5239221365629816`*^9}, {3.523930270899587*^9, 3.523930270899587*^9}, {
   3.5240761703528385`*^9, 3.5240761703528385`*^9}, {3.52407843124921*^9, 
   3.5240784332304134`*^9}, {3.5240784932749186`*^9, 
   3.5240784932749186`*^9}, {3.524079230095413*^9, 3.524079246553442*^9}, {
   3.5240858499762287`*^9, 3.524085860178646*^9}, {3.524085945261196*^9, 
   3.524085945261196*^9}, {3.5242763399632483`*^9, 3.5242763411488504`*^9}, {
   3.5242771575294847`*^9, 3.5242771578102846`*^9}, {3.530500224433988*^9, 
   3.530500225113989*^9}, {3.5313467876910577`*^9, 3.5313467883119507`*^9}, {
   3.5332231066826243`*^9, 3.5332231066826243`*^9}, {3.5332248881251183`*^9, 
   3.533224890245121*^9}, {3.5361011385491977`*^9, 3.5361011394332485`*^9}, {
   3.5363501469745007`*^9, 3.5363501506345057`*^9}, {3.5363617411167684`*^9, 
   3.5363617534067855`*^9}, {3.536366615151597*^9, 3.5363666230616083`*^9}, {
   3.5363667754518213`*^9, 3.5363667821318307`*^9}, {3.536366906722005*^9, 
   3.536366922022027*^9}, {3.536596861742076*^9, 3.5365968701504908`*^9}, {
   3.5366042542749715`*^9, 3.536604254462172*^9}, {3.536625554425806*^9, 
   3.536625554775807*^9}, {3.5366276426139326`*^9, 3.536627642853933*^9}, {
   3.536629402336396*^9, 3.536629402746397*^9}, {3.5366940603006477`*^9, 
   3.536694061273703*^9}, {3.5366943323932104`*^9, 3.536694332661226*^9}, {
   3.536694390476533*^9, 3.536694402176202*^9}, {3.5368634751022315`*^9, 
   3.5368634756170325`*^9}, {3.536980474148706*^9, 3.5369804925387316`*^9}, {
   3.5369807910591497`*^9, 3.5369808136991816`*^9}, 3.538443999546241*^9, {
   3.538444040229568*^9, 3.5384440801737804`*^9}, {3.544471201864182*^9, 
   3.5444712020241823`*^9}, {3.5499343621399236`*^9, 
   3.5499343628887253`*^9}, {3.5693429012648573`*^9, 3.569342923814889*^9}, {
   3.5693432071452856`*^9, 3.5693432074652863`*^9}, {3.569351915062778*^9, 
   3.569351927142795*^9}, {3.569352555713675*^9, 3.569352597773734*^9}, {
   3.5693528018640194`*^9, 3.5693528240640507`*^9}, {3.5693529494042263`*^9, 
   3.5693529852842765`*^9}, {3.5694318607141857`*^9, 3.569431861934188*^9}, {
   3.5717043891487646`*^9, 3.571704424478814*^9}, {3.571705180629873*^9, 
   3.5717051811498737`*^9}, 3.575822929516914*^9, {3.6202342373658905`*^9, 
   3.620234237599891*^9}, {3.6247455583342113`*^9, 3.6247455642605505`*^9}, {
   3.6379012654470863`*^9, 3.637901266488146*^9}, {3.6390655626170626`*^9, 
   3.639065562800073*^9}, 3.639065672954374*^9},
 FontSize->12,
 FontWeight->"Bold"],

Cell["Derivation: Algebraic normalization", "Subsubsection",
 CellChangeTimes->{
  3.4953915070313115`*^9, 3.495840214754669*^9, {3.4958483177760134`*^9, 
   3.495848318886015*^9}, {3.495925911922002*^9, 3.495925920122013*^9}, 
   3.4961847242848682`*^9, 3.496184957525194*^9, 3.496188449500083*^9, 
   3.4961908979261436`*^9, 3.4961924998683863`*^9, 3.4961928754389124`*^9, {
   3.51849075797458*^9, 3.5184907698562593`*^9}, 3.574710579500079*^9}],

Cell[TextData[{
 "Rule: If  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"u", "\[Equal]", 
    RowBox[{"a", "+", 
     RowBox[{"b", " ", "x"}]}]}], " ", "\[And]", " ", 
   RowBox[{"v", "\[Equal]", 
    RowBox[{"c", "+", 
     RowBox[{"d", " ", "x"}]}]}], " ", "\[And]", " ", 
   RowBox[{"w", "\[Equal]", 
    RowBox[{"e", "+", 
     RowBox[{"f", " ", "x"}]}]}], " ", "\[And]", " ", 
   RowBox[{"z", "\[Equal]", 
    RowBox[{"g", "+", 
     RowBox[{"h", " ", "x"}]}]}]}]]],
 ", then"
}], "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.495391630941485*^9, 3.4953916682515373`*^9}, 
   3.495398892616804*^9, {3.495402251391507*^9, 3.4954022711315346`*^9}, {
   3.495488783827441*^9, 3.4954888500775337`*^9}, {3.4954889799777155`*^9, 
   3.495489009627757*^9}, {3.495489141407942*^9, 3.495489151717956*^9}, {
   3.495489235178073*^9, 3.495489239268079*^9}, {3.495489386068284*^9, 
   3.4954894212383337`*^9}, {3.495489464438394*^9, 3.4954894647383947`*^9}, {
   3.495489500148444*^9, 3.4954895034984484`*^9}, {3.4954897331687703`*^9, 
   3.495489780118836*^9}, {3.495493913565876*^9, 3.495493935715907*^9}, {
   3.495494084919718*^9, 3.4954941083997507`*^9}, 3.495494511560315*^9, {
   3.495494580840412*^9, 3.4954945834404163`*^9}, {3.495494615970462*^9, 
   3.495494740200636*^9}, {3.495494880710832*^9, 3.4954948880508423`*^9}, {
   3.4954949819649754`*^9, 3.495494999445*^9}, {3.495495046515066*^9, 
   3.495495072875103*^9}, {3.4954951239351745`*^9, 3.4954951241651745`*^9}, {
   3.4954953673051157`*^9, 3.4954953726551237`*^9}, {3.495495450474448*^9, 
   3.495495453173253*^9}, {3.495495542140209*^9, 3.495495583792282*^9}, {
   3.4954957431465626`*^9, 3.4954957746118174`*^9}, {3.495495914419263*^9, 
   3.495495917804469*^9}, {3.495495955322535*^9, 3.4954960459586945`*^9}, {
   3.495496189588146*^9, 3.4954961923181515`*^9}, {3.4954973384365644`*^9, 
   3.495497357577798*^9}, {3.5240858715198665`*^9, 3.52408591925595*^9}, {
   3.5331536712917595`*^9, 3.5331536971617956`*^9}, {3.533223063022563*^9, 
   3.5332230658125668`*^9}, {3.533224894045127*^9, 3.5332248954551287`*^9}, 
   3.5363501685345306`*^9, {3.538444353705845*^9, 3.5384443676658645`*^9}, {
   3.5499343655595293`*^9, 3.549934366379531*^9}, {3.5693429326149015`*^9, 
   3.5693429326149015`*^9}, {3.5693520880530205`*^9, 
   3.5693520882530203`*^9}, {3.5693526036737423`*^9, 
   3.5693526036737423`*^9}, {3.5693528326040626`*^9, 
   3.5693528326040626`*^9}, {3.5693531936545677`*^9, 
   3.5693531936545677`*^9}, {3.5717044375688324`*^9, 3.5717044375688324`*^9}}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   SuperscriptBox["u", "m"], 
   SuperscriptBox["v", "n"], 
   SuperscriptBox["w", "p"], 
   SuperscriptBox["z", "q"], 
   RowBox[{"\[DifferentialD]", 
    RowBox[{"x", "  ", "\[LongRightArrow]", "  ", 
     RowBox[{"\[Integral]", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"b", " ", "x"}]}], ")"}], "m"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"c", "+", 
          RowBox[{"d", " ", "x"}]}], ")"}], "n"], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"e", "+", 
          RowBox[{"f", " ", "x"}]}], ")"}], "p"], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"g", "+", 
          RowBox[{"h", " ", "x"}]}], ")"}], "q"], 
       RowBox[{"\[DifferentialD]", "x"}]}]}]}]}]}]}]], "Subsubtitle",
 CellDingbat->None,
 CellChangeTimes->{{3.4796579723816*^9, 3.4796580261689425`*^9}, 
   3.479661191290163*^9, {3.479686720164157*^9, 3.479686720204214*^9}, {
   3.479686831554328*^9, 3.479686834819022*^9}, {3.4940970712485504`*^9, 
   3.4940971130286083`*^9}, 3.4940971455886545`*^9, 3.4953915848214207`*^9, 
   3.495391696001576*^9, {3.495401987881138*^9, 3.49540199674115*^9}, {
   3.495402119591322*^9, 3.4954021482513623`*^9}, {3.4954887467773895`*^9, 
   3.4954887749874287`*^9}, 3.495488944397666*^9, 3.495489263778113*^9, 
   3.4954893636582527`*^9, 3.4954898177188883`*^9, 3.495489875358969*^9, 
   3.495493833545764*^9, 3.495493864175807*^9, 3.4954940303560395`*^9, 
   3.4954941516698112`*^9, 3.4954942700599775`*^9, 3.4954948473707857`*^9, {
   3.495495264965372*^9, 3.4954952782653904`*^9}, {3.4954956850364604`*^9, 
   3.4954957088577023`*^9}, {3.495495865341577*^9, 3.4954958884920177`*^9}, {
   3.495496084225561*^9, 3.4954961029143944`*^9}, {3.495496211459385*^9, 
   3.4954962213810024`*^9}, 3.495496440218187*^9, {3.495497026732417*^9, 
   3.4954970596328745`*^9}, {3.495497256957621*^9, 3.495497302338101*^9}, 
   3.533151648818928*^9, 3.5331516797189713`*^9, 3.533151717349024*^9, {
   3.5331518776292486`*^9, 3.533151970249378*^9}, {3.5331520176994443`*^9, 
   3.5331520227894516`*^9}, {3.533152054329496*^9, 3.5331520626995077`*^9}, 
   3.533152270349798*^9, {3.533153065130911*^9, 3.5331530971109557`*^9}, 
   3.53315335008131*^9, {3.5331535194015465`*^9, 3.5331535356615696`*^9}, 
   3.5331536017616625`*^9, {3.533221927890974*^9, 3.533221930830978*^9}, {
   3.533222264011444*^9, 3.533222283731472*^9}, {3.5332223304615374`*^9, 
   3.5332223353515444`*^9}, 3.5363501604045196`*^9, {3.536361767566806*^9, 
   3.5363617697768087`*^9}, {3.5363666287016163`*^9, 
   3.5363666313816195`*^9}, {3.536366784271834*^9, 3.5363667868618374`*^9}, {
   3.536366923782029*^9, 3.5363669254320316`*^9}, {3.5365968786057057`*^9, 
   3.536596881944112*^9}, {3.5366940930205193`*^9, 3.53669410440917*^9}, {
   3.5366942507975435`*^9, 3.536694251403578*^9}, {3.536694493325415*^9, 
   3.536694495295528*^9}, 3.536980387788585*^9, {3.5384441491255584`*^9, 
   3.538444158185571*^9}, 3.5384445157160716`*^9, {3.5693429405449123`*^9, 
   3.569342962434943*^9}, {3.5693520924330263`*^9, 3.5693520926030264`*^9}, {
   3.5693526191837635`*^9, 3.569352629573778*^9}, {3.5693528385140705`*^9, 
   3.5693528438740788`*^9}, {3.5693531825645523`*^9, 
   3.5693532004045773`*^9}, {3.5717044451788435`*^9, 3.57170446433887*^9}},
 TextAlignment->Center,
 FontSize->12,
 FontWeight->"Bold"],

Cell["Program code:", "Subsubsection",
 CellDingbat->"\[FilledSmallSquare]",
 CellChangeTimes->{{3.4794189093216*^9, 3.479418932274605*^9}, {
   3.479418981395237*^9, 3.4794189822564754`*^9}, {3.4794192068193808`*^9, 
   3.4794192077607346`*^9}, 3.479420089138093*^9, {3.479420130978256*^9, 
   3.4794201410627565`*^9}, {3.479420560345656*^9, 3.479420578171288*^9}, {
   3.479420683943381*^9, 3.4794206847645617`*^9}, {3.4794210347678413`*^9, 
   3.4794210503903055`*^9}, 3.4803613662913427`*^9, {3.480361406058525*^9, 
   3.48036141974821*^9}, {3.4803614672865667`*^9, 3.480361474717252*^9}, 
   3.4807050675119123`*^9, {3.492804314166378*^9, 3.4928043441496305`*^9}, {
   3.4928044532166224`*^9, 3.492804453513023*^9}, {3.492805162266266*^9, 
   3.492805165713872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"u_", "^", "m_."}], "*", 
     RowBox[{"v_", "^", "n_."}], "*", 
     RowBox[{"w_", "^", "p_."}], "*", 
     RowBox[{"z_", "^", "q_."}]}], ",", "x_Symbol"}], "]"}], " ", ":=", "\n", 
  "  ", 
  RowBox[{
   RowBox[{"Int", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ExpandToSum", "[", 
        RowBox[{"u", ",", "x"}], "]"}], "^", "m"}], "*", 
      RowBox[{
       RowBox[{"ExpandToSum", "[", 
        RowBox[{"v", ",", "x"}], "]"}], "^", "n"}], "*", 
      RowBox[{
       RowBox[{"ExpandToSum", "[", 
        RowBox[{"w", ",", "x"}], "]"}], "^", "p"}], "*", 
      RowBox[{
       RowBox[{"ExpandToSum", "[", 
        RowBox[{"z", ",", "x"}], "]"}], "^", "q"}]}], ",", "x"}], "]"}], " ", 
   "/;", "\n", 
   RowBox[{
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"m", ",", "n", ",", "p", ",", "q"}], "}"}], ",", "x"}], "]"}], 
    " ", "&&", " ", 
    RowBox[{"LinearQ", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"u", ",", "v", ",", "w", ",", "z"}], "}"}], ",", "x"}], "]"}], 
    " ", "&&", " ", 
    RowBox[{"Not", "[", 
     RowBox[{"LinearMatchQ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"u", ",", "v", ",", "w", ",", "z"}], "}"}], ",", "x"}], "]"}],
      "]"}]}]}]}]], "Code",
 CellChangeTimes->{{3.494097165958683*^9, 3.4940971894087152`*^9}, {
   3.4940972668388243`*^9, 3.4940972723188314`*^9}, 3.49539148440128*^9, 
   3.4954018196509027`*^9, {3.495401867050969*^9, 3.4954018672609687`*^9}, {
   3.4954022872215567`*^9, 3.4954022882115583`*^9}, 3.495488713187342*^9, 
   3.4954889210576334`*^9, 3.4954892270180616`*^9, 3.4954893399982195`*^9, {
   3.4954894833184204`*^9, 3.495489485938424*^9}, 3.4954897194087505`*^9, 
   3.495493755131653*^9, {3.4954938826158323`*^9, 3.495493884975836*^9}, 
   3.4954939962159915`*^9, {3.4954942766399865`*^9, 3.4954942945800114`*^9}, 
   3.4954948208307486`*^9, {3.495495087335123*^9, 3.495495087705124*^9}, 
   3.4954951805652537`*^9, 3.495495346275087*^9, 3.495495665489626*^9, 
   3.4954958533919563`*^9, {3.49549609483358*^9, 3.495496110792408*^9}, 
   3.4954961789333277`*^9, 3.495497173544275*^9, {3.495681286888199*^9, 
   3.4956812892482023`*^9}, {3.5240859566180162`*^9, 3.52408598201486*^9}, {
   3.524086057533393*^9, 3.524086058937395*^9}, {3.5242757161181526`*^9, 
   3.5242757216717625`*^9}, {3.5242763445964565`*^9, 
   3.5242763477320623`*^9}, {3.5331525961202545`*^9, 3.533152618700286*^9}, {
   3.5331527018704023`*^9, 3.5331528058905478`*^9}, {3.533153282981216*^9, 
   3.5331533342812877`*^9}, {3.533153565251611*^9, 3.533153599281659*^9}, {
   3.5332224159616575`*^9, 3.533222435081684*^9}, {3.5332224656717267`*^9, 
   3.533222494301767*^9}, {3.533223281652869*^9, 3.53322331799292*^9}, {
   3.5332234651831264`*^9, 3.5332234684731307`*^9}, {3.533223854473671*^9, 
   3.5332238609936805`*^9}, {3.5332239572838154`*^9, 3.5332239599938188`*^9}, 
   3.533224847425061*^9, {3.5332249144151554`*^9, 3.533224915905157*^9}, 
   3.533246982034763*^9, 3.5332605459462523`*^9, {3.536350185774555*^9, 
   3.536350207334585*^9}, {3.5363506584052167`*^9, 3.5363506914352627`*^9}, {
   3.5363508662655077`*^9, 3.5363509090255675`*^9}, {3.5363510097557087`*^9, 
   3.5363510569557743`*^9}, {3.5363512834660916`*^9, 3.536351309536128*^9}, {
   3.5363515550764723`*^9, 3.5363516176765594`*^9}, {3.5363516722566357`*^9, 
   3.5363516724366364`*^9}, {3.536356352083194*^9, 3.536356353383196*^9}, {
   3.5363617881968346`*^9, 3.536361833056897*^9}, {3.536366667801671*^9, 
   3.5363667247217503`*^9}, {3.5363667904918423`*^9, 3.536366799971856*^9}, {
   3.536366941382054*^9, 3.536366980882109*^9}, {3.5365968943773336`*^9, 
   3.536596936123007*^9}, {3.536596976558278*^9, 3.536597025589164*^9}, 
   3.536602461258152*^9, {3.5366940777176437`*^9, 3.5366940881722417`*^9}, 
   3.5366943020244737`*^9, {3.536694516327731*^9, 3.5366945346767807`*^9}, {
   3.5369801281282215`*^9, 3.5369801381582355`*^9}, 3.536980329338503*^9, {
   3.53698041236862*^9, 3.5369804166186256`*^9}, {3.5369807322990675`*^9, 
   3.536980746969088*^9}, 3.538444106556738*^9, {3.5384444438259706`*^9, 
   3.5384444863560305`*^9}, 3.544471282097495*^9, {3.549934369376335*^9, 
   3.549934370546336*^9}, {3.555274643817338*^9, 3.555274658697359*^9}, {
   3.5693429690149527`*^9, 3.569343004485002*^9}, {3.569343115935158*^9, 
   3.5693431274951744`*^9}, {3.5693438869262376`*^9, 
   3.5693438923862453`*^9}, {3.5693452399481316`*^9, 
   3.5693452412481337`*^9}, {3.5693495213494267`*^9, 
   3.5693495533094716`*^9}, {3.5693499264999943`*^9, 3.569349931960002*^9}, {
   3.569351944542819*^9, 3.5693519905128837`*^9}, {3.569352647183803*^9, 
   3.5693527140438967`*^9}, {3.5693528513940887`*^9, 
   3.5693528811441307`*^9}, {3.569353149974507*^9, 3.569353162904525*^9}, {
   3.5693532245746117`*^9, 3.569353227784616*^9}, {3.5717044754788857`*^9, 
   3.5717045491389885`*^9}},
 Background->GrayLevel[0.85]],

Cell["", "Subsubsection",
 CellDingbat->None,
 CellChangeTimes->{
  3.4796643211106243`*^9, {3.536351324436149*^9, 3.536351326496152*^9}, {
   3.5363515481064625`*^9, 3.536351548866463*^9}}]
}, Closed]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
CellGrouping->Manual,
WindowSize->{1908, 946},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingStartingPageNumber->1,
PrintingPageRange->{1, 32000},
PageHeaders->{{
   Cell[
    TextData[{
      StyleBox[
       CounterBox["Page"], "PageNumber"], " ", "|", " ", 
      StyleBox[
       ValueBox["FileName"], "Header"]}], "Header", 
    CellMargins -> {{0, Inherited}, {Inherited, Inherited}}], None, None}, {
   Cell[
    TextData[{
     "Rules", " ", "for", " ", "integrands", " ", "of", " ", "the", " ", 
      "form", " ", "(", "a", "+", "b", " ", "x", ")", "^", "m", " ", "(", "c",
       "+", "d", " ", "x", ")", "^", "n", " ", "(", "e", "+", "f", " ", "x", 
      ")", "^", "p", " ", "(", "g", "+", "h", " ", "x", ")", "^", "q"}], 
    "Header", CellMargins -> {{0, Inherited}, {Inherited, Inherited}}], None, 
   Cell[
    TextData[
     CounterBox["Page", CounterFunction :> Identity]], "Header", 
    CellMargins -> {{Inherited, 0}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {None, None, None}},
PageHeaderLines->{False, False},
PageFooterLines->{False, False},
PrintingOptions->{"FacingPages"->False,
"FirstPageFace"->Right,
"FirstPageFooter"->False,
"FirstPageHeader"->False,
"Magnification"->1.,
"PaperOrientation"->"Landscape",
"PaperSize"->{792, 612},
"PrintCellBrackets"->False,
"PrintMultipleHorizontalPages"->False,
"PrintRegistrationMarks"->False,
"PrintingMargins"->28.8},
Magnification->1.399999976158142,
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (October 6, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 4440, 137, 67, "Subsubtitle"],
Cell[CellGroupData[{
Cell[5010, 161, 3700, 65, 53, "Subsubtitle"],
Cell[CellGroupData[{
Cell[8735, 230, 4010, 69, 53, "Subsubtitle"],
Cell[CellGroupData[{
Cell[12770, 303, 5427, 95, 2108, "Subsubtitle"],
Cell[18200, 400, 176, 3, 1355, "Subsubsection"],
Cell[18379, 405, 2431, 42, 1355, "Subsubsection"],
Cell[20813, 449, 2405, 57, 4034, "Subsubtitle"],
Cell[23221, 508, 771, 11, 1355, "Subsubsection"],
Cell[23995, 521, 9378, 159, 4141, "Code"],
Cell[33376, 682, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[33502, 689, 7029, 116, 2108, "Subsubtitle"],
Cell[40534, 807, 808, 11, 1355, "Subsubsection"],
Cell[41345, 820, 4046, 63, 998, "Subsubsection"],
Cell[45394, 885, 7402, 157, 9200, "Subsubtitle"],
Cell[52799, 1044, 869, 12, 1355, "Subsubsection"],
Cell[53671, 1058, 10841, 215, 6161, "Code"],
Cell[64515, 1275, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[64641, 1282, 4418, 79, 2108, "Subsubtitle"],
Cell[CellGroupData[{
Cell[69084, 1365, 6288, 105, 2108, "Subsubtitle"],
Cell[75375, 1472, 808, 11, 1355, "Subsubsection"],
Cell[76186, 1485, 3816, 60, 998, "Subsubsection"],
Cell[80005, 1547, 10065, 242, 15196, "Subsubtitle"],
Cell[90073, 1791, 869, 12, 1355, "Subsubsection"],
Cell[90945, 1805, 13430, 292, 9200, "Code"],
Cell[104378, 2099, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[104504, 2106, 4500, 82, 2108, "Subsubtitle"],
Cell[CellGroupData[{
Cell[109029, 2192, 6784, 110, 2108, "Subsubtitle"],
Cell[115816, 2304, 808, 11, 1355, "Subsubsection"],
Cell[116627, 2317, 3833, 59, 998, "Subsubsection"],
Cell[120463, 2378, 10254, 239, 11807, "Subsubtitle"],
Cell[130720, 2619, 869, 12, 1355, "Subsubsection"],
Cell[131592, 2633, 14061, 302, 9200, "Code"],
Cell[145656, 2937, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[145782, 2944, 6815, 111, 2108, "Subsubtitle"],
Cell[152600, 3057, 808, 11, 1355, "Subsubsection"],
Cell[153411, 3070, 3920, 60, 998, "Subsubsection"],
Cell[157334, 3132, 8999, 205, 10634, "Subsubtitle"],
Cell[166336, 3339, 869, 12, 1355, "Subsubsection"],
Cell[167208, 3353, 12887, 271, 8194, "Code"],
Cell[180098, 3626, 89, 2, 1355, "Subsubsection"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[180248, 3635, 6430, 109, 2108, "Subsubtitle"],
Cell[186681, 3746, 808, 11, 1355, "Subsubsection"],
Cell[187492, 3759, 3845, 62, 998, "Subsubsection"],
Cell[191340, 3823, 7774, 178, 9413, "Subsubtitle"],
Cell[199117, 4003, 869, 12, 1355, "Subsubsection"],
Cell[199989, 4017, 11152, 232, 8194, "Code"],
Cell[211144, 4251, 89, 2, 1355, "Subsubsection"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[211282, 4259, 5238, 95, 53, "Subsubtitle"],
Cell[216523, 4356, 176, 3, 1355, "Subsubsection"],
Cell[216702, 4361, 2362, 42, 1355, "Subsubsection"],
Cell[219067, 4405, 2420, 59, 4034, "Subsubtitle"],
Cell[221490, 4466, 771, 11, 1355, "Subsubsection"],
Cell[222264, 4479, 9262, 160, 4141, "Code"],
Cell[231529, 4641, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[231655, 4648, 4369, 79, 53, "Subsubtitle"],
Cell[CellGroupData[{
Cell[236049, 4731, 5876, 98, 2108, "Subsubtitle"],
Cell[241928, 4831, 739, 10, 1355, "Subsubsection"],
Cell[242670, 4843, 3689, 57, 998, "Subsubsection"],
Cell[246362, 4902, 7436, 169, 8096, "Subsubtitle"],
Cell[253801, 5073, 819, 11, 1355, "Subsubsection"],
Cell[254623, 5086, 10984, 224, 6161, "Code"],
Cell[265610, 5312, 11131, 228, 6572, "Code"],
Cell[276744, 5542, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[276870, 5549, 6219, 104, 2108, "Subsubtitle"],
Cell[283092, 5655, 839, 11, 1355, "Subsubsection"],
Cell[283934, 5668, 3742, 58, 998, "Subsubsection"],
Cell[287679, 5728, 7370, 172, 8096, "Subsubtitle"],
Cell[295052, 5902, 869, 12, 1355, "Subsubsection"],
Cell[295924, 5916, 10789, 223, 6161, "Code"],
Cell[306716, 6141, 10851, 226, 6572, "Code"],
Cell[317570, 6369, 89, 2, 1355, "Subsubsection"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[317708, 6377, 6301, 105, 53, "Subsubtitle"],
Cell[324012, 6484, 791, 11, 1355, "Subsubsection"],
Cell[324806, 6497, 3718, 58, 998, "Subsubsection"],
Cell[328527, 6557, 6848, 151, 8096, "Subsubtitle"],
Cell[335378, 6710, 869, 12, 1355, "Subsubsection"],
Cell[336250, 6724, 10641, 210, 6161, "Code"],
Cell[346894, 6936, 10785, 214, 6572, "Code"],
Cell[357682, 7152, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[357808, 7159, 6535, 108, 53, "Subsubtitle"],
Cell[364346, 7269, 839, 11, 35, "Subsubsection"],
Cell[365188, 7282, 4065, 75, 30, "Subsubsection"],
Cell[369256, 7359, 4037, 62, 26, "Subsubsection"],
Cell[373296, 7423, 7394, 172, 201, "Subsubtitle"],
Cell[380693, 7597, 869, 12, 35, "Subsubsection"],
Cell[381565, 7611, 11708, 247, 179, "Code"],
Cell[393276, 7860, 89, 2, 35, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[393402, 7867, 4187, 72, 62, "Subsubtitle"],
Cell[CellGroupData[{
Cell[397614, 7943, 4097, 72, 2539, "Subsubtitle"],
Cell[401714, 8017, 1411, 20, 1355, "Subsubsection"],
Cell[403128, 8039, 3320, 71, 1510, "Subsubsection"],
Cell[406451, 8112, 1987, 28, 929, "Subsubsection"],
Cell[408441, 8142, 3673, 87, 2539, "Subsubtitle"],
Cell[412117, 8231, 821, 11, 1355, "Subsubsection"],
Cell[412941, 8244, 4054, 98, 5161, "Code"],
Cell[416998, 8344, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[417124, 8351, 3752, 66, 2448, "Subsubtitle"],
Cell[420879, 8419, 176, 3, 1355, "Subsubsection"],
Cell[421058, 8424, 2925, 53, 1510, "Subsubsection"],
Cell[423986, 8479, 1822, 25, 929, "Subsubsection"],
Cell[425811, 8506, 3402, 81, 2448, "Subsubtitle"],
Cell[429216, 8589, 771, 11, 1355, "Subsubsection"],
Cell[429990, 8602, 3655, 88, 4141, "Code"],
Cell[433648, 8692, 89, 2, 1355, "Subsubsection"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[433786, 8700, 3737, 66, 53, "Subsubtitle"],
Cell[437526, 8768, 176, 3, 1355, "Subsubsection"],
Cell[437705, 8773, 2800, 50, 1443, "Subsubsection"],
Cell[440508, 8825, 5423, 89, 1546, "Subsubsection"],
Cell[445934, 8916, 1871, 26, 929, "Subsubsection"],
Cell[447808, 8944, 3508, 85, 4275, "Subsubtitle"],
Cell[451319, 9031, 771, 11, 1355, "Subsubsection"],
Cell[452093, 9044, 4628, 108, 4141, "Code"],
Cell[456724, 9154, 4396, 109, 4555, "Code"],
Cell[461123, 9265, 89, 2, 1355, "Subsubsection"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[461261, 9273, 5298, 98, 53, "Subsubtitle"],
Cell[CellGroupData[{
Cell[466584, 9375, 4953, 89, 74, "Subsubtitle"],
Cell[CellGroupData[{
Cell[471562, 9468, 4682, 83, 201, "Subsubtitle"],
Cell[CellGroupData[{
Cell[476269, 9555, 5285, 93, 201, "Subsubtitle"],
Cell[481557, 9650, 2040, 28, 253, "Subsubsection"],
Cell[483600, 9680, 3307, 71, 326, "Subsubsection"],
Cell[486910, 9753, 2429, 41, 187, "Subsubsection"],
Cell[489342, 9796, 5122, 117, 1282, "Subsubtitle"],
Cell[494467, 9915, 821, 11, 253, "Subsubsection"],
Cell[495291, 9928, 6053, 136, 1147, "Code"],
Cell[501347, 10066, 89, 2, 253, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[501473, 10073, 5346, 94, 201, "Subsubtitle"],
Cell[506822, 10169, 2618, 43, 261, "Subsubsection"],
Cell[509443, 10214, 6279, 145, 1531, "Subsubtitle"],
Cell[515725, 10361, 821, 11, 253, "Subsubsection"],
Cell[516549, 10374, 7295, 164, 1147, "Code"],
Cell[523847, 10540, 89, 2, 253, "Subsubsection"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[523985, 10548, 4573, 83, 281, "Subsubtitle"],
Cell[CellGroupData[{
Cell[528583, 10635, 5369, 95, 281, "Subsubtitle"],
Cell[533955, 10732, 2573, 44, 187, "Subsubsection"],
Cell[536531, 10778, 6973, 169, 1402, "Subsubtitle"],
Cell[543507, 10949, 821, 11, 181, "Subsubsection"],
Cell[544331, 10962, 7921, 185, 1090, "Code"],
Cell[552255, 11149, 89, 2, 181, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[552381, 11156, 4700, 86, 281, "Subsubtitle"],
Cell[CellGroupData[{
Cell[557106, 11246, 4597, 79, 282, "Subsubtitle"],
Cell[561706, 11327, 176, 3, 181, "Subsubsection"],
Cell[561885, 11332, 1724, 56, 242, "Subsubsection"],
Cell[563612, 11390, 2108, 29, 125, "Subsubsection"],
Cell[565723, 11421, 4356, 104, 394, "Subsubtitle"],
Cell[570082, 11527, 821, 11, 181, "Subsubsection"],
Cell[570906, 11540, 4861, 113, 687, "Code"],
Cell[575770, 11655, 89, 2, 181, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[575896, 11662, 5391, 96, 281, "Subsubtitle"],
Cell[581290, 11760, 2591, 45, 187, "Subsubsection"],
Cell[583884, 11807, 5838, 142, 1114, "Subsubtitle"],
Cell[589725, 11951, 821, 11, 181, "Subsubsection"],
Cell[590549, 11964, 6629, 157, 820, "Code"],
Cell[597181, 12123, 89, 2, 181, "Subsubsection"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[597343, 12133, 5027, 92, 97, "Subsubtitle"],
Cell[CellGroupData[{
Cell[602395, 12229, 4707, 85, 97, "Subsubtitle"],
Cell[CellGroupData[{
Cell[607127, 12318, 4728, 86, 97, "Subsubtitle"],
Cell[CellGroupData[{
Cell[611880, 12408, 4502, 77, 104, "Subsubtitle"],
Cell[616385, 12487, 324, 6, 67, "Subsubsection"],
Cell[616712, 12495, 4030, 89, 132, "Subsubsection"],
Cell[620745, 12586, 5431, 134, 132, "Subsubsection"],
Cell[626179, 12722, 2159, 30, 47, "Subsubsection"],
Cell[628341, 12754, 8501, 241, 540, "Subsubtitle"],
Cell[636845, 12997, 821, 11, 67, "Subsubsection"],
Cell[637669, 13010, 6120, 153, 251, "Code"],
Cell[643792, 13165, 89, 2, 67, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[643918, 13172, 4726, 81, 100, "Subsubtitle"],
Cell[648647, 13255, 328, 5, 1355, "Subsubsection"],
Cell[648978, 13262, 3637, 74, 1814, "Subsubsection"],
Cell[652618, 13338, 2311, 32, 929, "Subsubsection"],
Cell[654932, 13372, 4279, 101, 2958, "Subsubtitle"],
Cell[659214, 13475, 821, 11, 1355, "Subsubsection"],
Cell[660038, 13488, 4692, 107, 5161, "Code"],
Cell[664733, 13597, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[664859, 13604, 5233, 94, 97, "Subsubtitle"],
Cell[670095, 13700, 2323, 40, 998, "Subsubsection"],
Cell[672421, 13742, 7125, 169, 7596, "Subsubtitle"],
Cell[679549, 13913, 821, 11, 968, "Subsubsection"],
Cell[680373, 13926, 8016, 184, 5853, "Code"],
Cell[688392, 14112, 89, 2, 968, "Subsubsection"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[688530, 14120, 4728, 86, 97, "Subsubtitle"],
Cell[CellGroupData[{
Cell[693283, 14210, 4659, 79, 95, "Subsubtitle"],
Cell[697945, 14291, 457, 6, 1355, "Subsubsection"],
Cell[698405, 14299, 1454, 38, 1814, "Subsubsection"],
Cell[699862, 14339, 2370, 33, 929, "Subsubsection"],
Cell[702235, 14374, 3995, 88, 4034, "Subsubtitle"],
Cell[706233, 14464, 821, 11, 1355, "Subsubsection"],
Cell[707057, 14477, 5147, 114, 4141, "Code"],
Cell[712207, 14593, 5358, 120, 4555, "Code"],
Cell[717568, 14715, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[717694, 14722, 4454, 76, 95, "Subsubtitle"],
Cell[722151, 14800, 324, 6, 48, "Subsubsection"],
Cell[722478, 14808, 4085, 88, 125, "Subsubsection"],
Cell[726566, 14898, 5701, 140, 95, "Subsubsection"],
Cell[732270, 15040, 2156, 30, 34, "Subsubsection"],
Cell[734429, 15072, 9004, 248, 386, "Subsubtitle"],
Cell[743436, 15322, 821, 11, 48, "Subsubsection"],
Cell[744260, 15335, 6332, 155, 215, "Code"],
Cell[750595, 15492, 89, 2, 48, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[750721, 15499, 4402, 75, 95, "Subsubtitle"],
Cell[755126, 15576, 324, 6, 48, "Subsubsection"],
Cell[755453, 15584, 4071, 88, 125, "Subsubsection"],
Cell[759527, 15674, 5674, 140, 96, "Subsubsection"],
Cell[765204, 15816, 2156, 30, 34, "Subsubsection"],
Cell[767363, 15848, 9026, 251, 389, "Subsubtitle"],
Cell[776392, 16101, 821, 11, 48, "Subsubsection"],
Cell[777216, 16114, 6004, 150, 215, "Code"],
Cell[783223, 16266, 89, 2, 48, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[783349, 16273, 4630, 79, 95, "Subsubtitle"],
Cell[787982, 16354, 328, 5, 67, "Subsubsection"],
Cell[788313, 16361, 3889, 82, 89, "Subsubsection"],
Cell[792205, 16445, 2217, 31, 47, "Subsubsection"],
Cell[794425, 16478, 4553, 107, 328, "Subsubtitle"],
Cell[798981, 16587, 821, 11, 67, "Subsubsection"],
Cell[799805, 16600, 4984, 115, 251, "Code"],
Cell[804792, 16717, 89, 2, 67, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[804918, 16724, 5149, 92, 97, "Subsubtitle"],
Cell[810070, 16818, 2344, 41, 998, "Subsubsection"],
Cell[812417, 16861, 7144, 177, 5930, "Subsubtitle"],
Cell[819564, 17040, 821, 11, 968, "Subsubsection"],
Cell[820388, 17053, 8119, 194, 5137, "Code"],
Cell[828510, 17249, 89, 2, 968, "Subsubsection"]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[828660, 17258, 4572, 84, 104, "Subsubtitle"],
Cell[CellGroupData[{
Cell[833257, 17346, 4645, 86, 104, "Subsubtitle"],
Cell[CellGroupData[{
Cell[837927, 17436, 4689, 80, 2958, "Subsubtitle"],
Cell[842619, 17518, 328, 5, 1355, "Subsubsection"],
Cell[842950, 17525, 5765, 148, 1814, "Subsubsection"],
Cell[848718, 17675, 5190, 127, 1814, "Subsubsection"],
Cell[853911, 17804, 2263, 31, 929, "Subsubsection"],
Cell[856177, 17837, 6099, 165, 10114, "Subsubtitle"],
Cell[862279, 18004, 821, 11, 1355, "Subsubsection"],
Cell[863103, 18017, 6965, 174, 7191, "Code"],
Cell[870071, 18193, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[870197, 18200, 5252, 94, 2958, "Subsubtitle"],
Cell[875452, 18296, 2521, 43, 1397, "Subsubsection"],
Cell[877976, 18341, 7281, 177, 10805, "Subsubtitle"],
Cell[885260, 18520, 821, 11, 1355, "Subsubsection"],
Cell[886084, 18533, 8289, 193, 8194, "Code"],
Cell[894376, 18728, 89, 2, 1355, "Subsubsection"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[894514, 18736, 4647, 86, 104, "Subsubtitle"],
Cell[CellGroupData[{
Cell[899186, 18826, 4563, 78, 104, "Subsubtitle"],
Cell[903752, 18906, 326, 5, 1355, "Subsubsection"],
Cell[904081, 18913, 3478, 66, 1814, "Subsubsection"],
Cell[907562, 18981, 2161, 30, 929, "Subsubsection"],
Cell[909726, 19013, 4090, 94, 2958, "Subsubtitle"],
Cell[913819, 19109, 821, 11, 1355, "Subsubsection"],
Cell[914643, 19122, 4471, 100, 5161, "Code"],
Cell[919117, 19224, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[919243, 19231, 4675, 81, 104, "Subsubtitle"],
Cell[923921, 19314, 324, 6, 48, "Subsubsection"],
Cell[924248, 19322, 4036, 87, 125, "Subsubsection"],
Cell[928287, 19411, 5666, 139, 125, "Subsubsection"],
Cell[933956, 19552, 2163, 30, 34, "Subsubsection"],
Cell[936122, 19584, 8594, 241, 386, "Subsubtitle"],
Cell[944719, 19827, 821, 11, 48, "Subsubsection"],
Cell[945543, 19840, 6392, 156, 215, "Code"],
Cell[951938, 19998, 89, 2, 48, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[952064, 20005, 4722, 81, 104, "Subsubtitle"],
Cell[956789, 20088, 324, 6, 48, "Subsubsection"],
Cell[957116, 20096, 4073, 89, 125, "Subsubsection"],
Cell[961192, 20187, 5549, 138, 125, "Subsubsection"],
Cell[966744, 20327, 2163, 30, 34, "Subsubsection"],
Cell[968910, 20359, 8757, 245, 386, "Subsubtitle"],
Cell[977670, 20606, 821, 11, 48, "Subsubsection"],
Cell[978494, 20619, 6280, 156, 215, "Code"],
Cell[984777, 20777, 89, 2, 48, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[984903, 20784, 5240, 94, 104, "Subsubtitle"],
Cell[990146, 20880, 2492, 43, 1397, "Subsubsection"],
Cell[992641, 20925, 6407, 159, 8434, "Subsubtitle"],
Cell[999051, 21086, 821, 11, 1355, "Subsubsection"],
Cell[999875, 21099, 7297, 176, 6161, "Code"],
Cell[1007175, 21277, 89, 2, 1355, "Subsubsection"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1007349, 21288, 4025, 75, 64, "Subsubtitle"],
Cell[1011377, 21365, 1411, 20, 1355, "Subsubsection"],
Cell[1012791, 21387, 3066, 68, 1510, "Subsubsection"],
Cell[1015860, 21457, 2111, 33, 998, "Subsubsection"],
Cell[1017974, 21492, 3785, 97, 2622, "Subsubtitle"],
Cell[1021762, 21591, 821, 11, 1355, "Subsubsection"],
Cell[1022586, 21604, 4506, 115, 5161, "Code"],
Cell[1027095, 21721, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[1027221, 21728, 5859, 104, 70, "Subsubtitle"],
Cell[1033083, 21834, 427, 6, 67, "Subsubsection"],
Cell[1033513, 21842, 2714, 44, 75, "Subsubsection"],
Cell[1036230, 21888, 3590, 81, 135, "Subsubtitle"],
Cell[1039823, 21971, 771, 11, 67, "Subsubsection"],
Cell[1040597, 21984, 4531, 97, 202, "Code"],
Cell[1045131, 22083, 89, 2, 67, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[1045257, 22090, 5258, 90, 53, "Subsubtitle"],
Cell[1050518, 22182, 176, 3, 35, "Subsubsection"],
Cell[1050697, 22187, 2241, 37, 29, "Subsubsection"],
Cell[1052941, 22226, 2356, 59, 53, "Subsubtitle"],
Cell[1055300, 22287, 771, 11, 35, "Subsubsection"],
Cell[1056074, 22300, 8946, 153, 104, "Code"],
Cell[1065023, 22455, 89, 2, 35, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[1065149, 22462, 4469, 81, 53, "Subsubtitle"],
Cell[1069621, 22545, 176, 3, 1355, "Subsubsection"],
Cell[1069800, 22550, 2800, 50, 1443, "Subsubsection"],
Cell[1072603, 22602, 2000, 32, 998, "Subsubsection"],
Cell[1074606, 22636, 3947, 97, 4275, "Subsubtitle"],
Cell[1078556, 22735, 771, 11, 1355, "Subsubsection"],
Cell[1079330, 22748, 5078, 126, 5161, "Code"],
Cell[1084411, 22876, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[1084537, 22883, 4196, 74, 53, "Subsubtitle"],
Cell[1088736, 22959, 2327, 31, 1355, "Subsubsection"],
Cell[1091066, 22992, 3044, 67, 2108, "Subsubtitle"],
Cell[1094113, 23061, 771, 11, 1355, "Subsubsection"],
Cell[1094887, 23074, 3722, 80, 4141, "Code"],
Cell[1098612, 23156, 89, 2, 1355, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[1098738, 23163, 5637, 98, 53, "Subsubtitle"],
Cell[1104378, 23263, 479, 7, 1355, "Subsubsection"],
Cell[1104860, 23272, 2925, 47, 998, "Subsubsection"],
Cell[1107788, 23321, 4107, 84, 2448, "Subsubtitle"],
Cell[1111898, 23407, 771, 11, 1355, "Subsubsection"],
Cell[1112672, 23420, 5522, 109, 4141, "Code"],
Cell[1118197, 23531, 190, 4, 1355, "Subsubsection"]
}, Closed]],
Cell[1118402, 23538, 89, 2, 25, "Subsubsection"],
Cell[1118494, 23542, 2812, 56, 42, "Subsubtitle"],
Cell[CellGroupData[{
Cell[1121331, 23602, 4198, 74, 53, "Subsubtitle"],
Cell[1125532, 23678, 234, 3, 14265, "Subsubsection"],
Cell[1125769, 23683, 3839, 81, 18422, "Subsubsection"],
Cell[1129611, 23766, 1786, 25, 9777, "Subsubsection"],
Cell[1131400, 23793, 4750, 118, 49737, "Subsubtitle"],
Cell[1136153, 23913, 771, 11, 14265, "Subsubsection"],
Cell[1136927, 23926, 5422, 136, 54388, "Code"],
Cell[1142352, 24064, 89, 2, 14265, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[1142478, 24071, 3965, 63, 33, "Subsubtitle"],
Cell[CellGroupData[{
Cell[1146468, 24138, 4876, 79, 53, "Subsubtitle"],
Cell[1151347, 24219, 478, 7, 45843916, "Subsubsection"],
Cell[1151828, 24228, 2528, 39, 33764762, "Subsubsection"],
Cell[1154359, 24269, 2827, 48, 71394051, "Subsubtitle"],
Cell[1157189, 24319, 771, 11, 45843916, "Subsubsection"],
Cell[1157963, 24332, 4012, 67, 140248863, "Code"],
Cell[1161978, 24401, 190, 4, 45843916, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[1162205, 24410, 5364, 89, 53, "Subsubtitle"],
Cell[1167572, 24501, 448, 6, 45843916, "Subsubsection"],
Cell[1168023, 24509, 2705, 44, 33764762, "Subsubsection"],
Cell[1170731, 24555, 2986, 53, 71394051, "Subsubtitle"],
Cell[1173720, 24610, 771, 11, 45843916, "Subsubsection"],
Cell[1174494, 24623, 4421, 81, 140248863, "Code"],
Cell[1178918, 24706, 190, 4, 45843916, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[1179145, 24715, 5811, 96, 53, "Subsubtitle"],
Cell[1184959, 24813, 448, 6, 45843916, "Subsubsection"],
Cell[1185410, 24821, 2866, 48, 33764762, "Subsubsection"],
Cell[1188279, 24871, 3194, 59, 71394051, "Subsubtitle"],
Cell[1191476, 24932, 771, 11, 45843916, "Subsubsection"],
Cell[1192250, 24945, 4659, 87, 140248863, "Code"],
Cell[1196912, 25034, 190, 4, 45843916, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[1197139, 25043, 5709, 97, 53, "Subsubtitle"],
Cell[1202851, 25142, 448, 6, 45843916, "Subsubsection"],
Cell[1203302, 25150, 3081, 53, 33764762, "Subsubsection"],
Cell[1206386, 25205, 3449, 65, 71394051, "Subsubtitle"],
Cell[1209838, 25272, 771, 11, 45843916, "Subsubsection"],
Cell[1210612, 25285, 4993, 94, 140248863, "Code"],
Cell[1215608, 25381, 190, 4, 45843916, "Subsubsection"]
}, Closed]]
}, Closed]]
}
]
*)

(* End of internal cache information *)
